Introduction
------------

'Traits' is a Python package for creating 'strongly-typed' Python attributes.

Installation
------------

The 'traits' package is installed using the standard Python 'distutils' package.

Enter the following command in the 'traits-1.0' directory:

   python setup.py install
   
This will perform a normal install of the 'traits' package into your Python
installation. Refer to the Python 'distutils' documentation for more
installation options.

Download
--------

The most recent version of the 'traits' package can be downloaded from:

   http://www.scipy.org/site_content/traits
   
License
-------

The 'traits' package is available under a BSD style license. 

Contact
-------

If you encounter any problems using the 'traits' package, or have any comments
or suggestions about the package, please contact the author:

   David C. Morrill
   dmorrill@enthought.com

Prerequisites
-------------

The base 'traits' package should work on any platform supporting Python >= 1.5.2.
   
The user interface capabilities of the traits package require additional
Python packages to be installed.

If you wish to use traits with wxPython, you must also install:
   - wxPython >= 2.3.3.1 (available from: http://www.wxpython.org)
   
If you wish to use traits with Tkinter, you must also install:
   - Tkinter (usually installed as part of your Python distribution)
   - PMW (Python MegaWidgets) (available from: http://pmw.sourceforge.net)

C ii_bieval:  Evaluation routines for interpolation kernels.
C             Called by 'mrievl' from INTER2D.F
C
C All routines converted from SPP to Fortran using 'xc -f' then hand
C  edited to include all comments and to use F77 constructs.
C  Warren Hack, 15 June 2004
C
C
C II_BINEAREST -- Procedure to evaluate the nearest neighbour interpolant.
C The real array coeff contains the coefficients of the 2D interpolant.
C The procedure assumes that 1 <= x <= nxpix and 1 <= y <= nypix and that
C coeff(1+first_point) = datain(1,1).
C
      subroutine iibint (coeff, firstt, lencof, x, y, zfit, npts)
C
C real  coeff[ARB]   # 1D coefficient array
C int   firstt       # offset of first data point
C int   lencof       # row length of coeff
C real  x[npts]      # array of x values
C real  y[npts]      # array of y values
C real  zfit[npts]	# array of interpolated values
C int	  npts		   # number of points to be evaluated
C
      integer firstt
      integer lencof
      integer npts
      real coeff(*)
      real x(npts), y(npts), zfit(npts)
      integer nx, ny
      integer index, i
      save

      do i = 1, npts 
         nx = int(x(i) + 0.5)
         ny = int(y(i) + 0.5)

C	      define pointer to data[nx,ny]
         index = firstt + (ny - 1) * lencof + nx
         zfit(i) = coeff(index)
      ENDDO

      return
      end
      
C II_BILINEAR -- Procedure to evaluate the bilinear interpolant.
C The real array coeff contains the coefficients of the 2D interpolant.
C The procedure assumes that 1 <= x <= nxpix and 1 <= y <= nypix
C and that coeff(1+first_point) = datain(1,1).
C
      subroutine iibilr (coeff, firstt, lencof, x, y, zfit, npts)

C real   coeff[ARB]     # 1D array of coefficients
C int    firstt         # offset of first data point
C int    lencof         # row length of coeff
C real   x[npts]        # array of x values
C real   y[npts]        # array of y values
C real   zfit[npts]	   # array of interpolated values
C int	   npts		      # number of data points

      integer firstt
      integer lencof
      integer npts
      real coeff(*)
      real x(npts), y(npts), zfit(npts) 
      integer nx, ny 
      integer index, i
      real sx, sy, tx, ty

      save
      do i = 1, npts 
         nx = int(x(i))
         ny = int(y(i))
         sx = x(i) - nx
         tx = 1. - sx
         sy = y(i) - ny
         ty = 1. - sy
         index = firstt + (ny - 1) * lencof + nx
         zfit(i) = tx * ty * coeff(index) + sx * ty * 
     *      coeff(index + 1) + sy * tx * coeff(index+lencof) +  
     *      sx * sy * coeff(index+lencof+1)
      ENDDO

      return
      end


C II_BIPOLY3 -- Procedure to evaluate the bicubic polynomial interpolant.
C The real array coeff contains the coefficients of the 2D interpolant.
C The procedure assumes that 1 <= x <= nxpix and  1 <= y <= nypix
C and that coeff[1+first_point] = datain[1,1]. The interpolant is
C evaluated using Everett's central difference formula.

      subroutine iibip3 (coeff, firstt, lencof, x, y, zfit, npts)

C real   coeff[ARB]     # 1D array of coefficients
C int    firstt         # offset of first data point
C int    lencof         # row length of coeff
C real   x[npts]        # array of x values
C real   y[npts]        # array of y values
C real   zfit[npts]	   # array of interpolated values
C int	   npts		      # number of data points
      integer firstt
      integer lencof
      integer npts
      real coeff(*)
      real x(npts), y(npts), zfit(npts)  
      integer nxold, nyold
      integer nx, ny
      integer firstw
      integer index
      integer i, j
      real sx, sy, tx, ty

      real sx2m1, tx2m1
      real cd20(4), cd21(4)
      real ztemp(4)
      real cd20y, cd21y
      save

      nxold = -1
      nyold = -1
      do i = 1, npts 
         nx = int(x(i))
         sx = x(i) - nx
         tx = 1. - sx
         sx2m1 = sx * sx - 1.
         tx2m1 = tx * tx - 1.

         ny = int(y(i))
         sy = y(i) - ny
         ty = 1. - sy

C	         define pointer to datain[nx,ny-1]
         firstw = firstt + (ny - 2) * lencof + nx

C	         loop over the 4 surrounding rows of data
C	         calculate the  central differences at each value of y
C
C	         if new data point caculate the central differnences in x
C	         for each y

         index = firstw
         if (nx .ne. nxold .or. ny .ne. nyold) THEN
            do j = 1, 4 
               cd20(j) = 1./6. * (coeff(index+1) -  
     *            2. * coeff(index) + coeff(index-1))
               cd21(j) = 1./6. * (coeff(index+2) -  
     *            2. * coeff(index+1) + coeff(index))
               index = index + lencof
            ENDDO
         ENDIF

C	         interpolate in x at each value of y
         index = firstw
         do j = 1, 4 
            ztemp(j) = sx * (coeff(index+1) + sx2m1 * cd21(j)) + 
     *          tx * (coeff(index) + tx2m1 * cd20(j))
            index = index + lencof
         ENDDO

C  	      calculate y central differences
         cd20y = 1./6. * (ztemp(3) - 2. * ztemp(2) + ztemp(1))
         cd21y = 1./6. * (ztemp(4) - 2. * ztemp(3) + ztemp(2))

C	         interpolate in y
         zfit(i) = sy * (ztemp(3) + (sy * sy - 1.) * cd21y) +  
     *      ty * ( ztemp(2) + (ty * ty - 1.) * cd20y)

         nxold = nx
         nyold = ny
      ENDDO

      return
      end

C II_BIPOLY5 -- Procedure to evaluate a biquintic polynomial.
C The real array coeff contains the coefficents of the 2D interpolant.
C The routine assumes that 1 <= x <= nxpix and 1 <= y <= nypix
C and that coeff[1+first_point] = datain[1,1]. The interpolant is evaluated
C using Everett's central difference formula.
C
      subroutine iibip5 (coeff, firstt, lencof, x, y, zfit, npts)
C real   coeff[ARB]     # 1D array of coefficients
C int    firstt         # offset of first data point
C int    lencof         # row length of coeff
C real   x[npts]        # array of x values
C real   y[npts]        # array of y values
C real   zfit[npts]	   # array of interpolated values
C int	   npts		      # number of data points

      integer firstt
      integer lencof
      integer npts
      real coeff(*)
      real x(npts),y(npts), zfit(npts) 
      integer nxold, nyold
      integer nx, ny
      integer firstw
      integer index
      integer i, j
      real sx, sx2, tx, tx2, sy, sy2, ty, ty2
      real sx2m1, sx2m4, tx2m1, tx2m4
      real cd20(6), cd21(6)
      real cd40(6), cd41(6)
      real ztemp(6)
      real cd20y, cd21y
      real cd40y, cd41y
      save
      
      nxold = -1
      nyold = -1
      do 110 i = 1, npts 
         nx = int(x(i))
         sx = x(i) - nx
         sx2 = sx * sx
         sx2m1 = sx2 - 1.
         sx2m4 = sx2 - 4.
         tx = 1. - sx
         tx2 = tx * tx
         tx2m1 = tx2 - 1.
         tx2m4 = tx2 - 4.

         ny = int(y(i))
         sy = y(i) - ny
         sy2 = sy * sy
         ty = 1. - sy
         ty2 = ty * ty
         
C	      calculate value of pointer to data[nx,ny-2]
         
         firstw = firstt + (ny - 3) * lencof + nx

C	      calculate the central differences in x at each value of y
         index = firstw
         if (nx .ne. nxold .or. ny .ne. nyold) THEN
            do 200 j = 1, 6 
               cd20(j) = 1./6. * (coeff(index+1) -  
     *            2. * coeff(index) + coeff(index-1))
               cd21(j) = 1./6. * (coeff(index+2) - 
     *            2. * coeff(index+1) + coeff(index))
               cd40(j) = 1./120. * (coeff(index-2) - 
     *            4. * coeff(index-1) + 6. * coeff(index) - 
     *            4. * coeff(index+1) + coeff(index+2))
               cd41(j) = 1./120. * (coeff(index-1) - 
     *            4. * coeff(index)   + 6. * coeff(index+1) - 
     *            4. * coeff(index+2) + coeff(index+3))
               index = index + lencof
200         ENDDO
         ENDIF

C	      interpolate in x at each value of y
         index = firstw
         do 300 j = 1, 6 
            ztemp(j) = sx * (coeff(index+1) + sx2m1 * (cd21(j) + 
     *         sx2m4 * cd41(j))) + tx * (coeff(index) + 
     *         tx2m1 * (cd20(j) + tx2m4 * cd40(j)))
            index = index + lencof
300      ENDDO
C	      central differences in y
         cd20y = 1./6. * (ztemp(4) - 2. * ztemp(3) + ztemp(2))
         cd21y = 1./6. * (ztemp(5) - 2. * ztemp(4) + ztemp(3))
         cd40y = 1./120. * (ztemp(1) - 4. * ztemp(2) +  
     *      6. * ztemp(3) - 4. * ztemp(4) + ztemp(5))
         cd41y = 1./120. * (ztemp(2) - 4. * ztemp(3) +  
     *      6. * ztemp(4) - 4. * ztemp(5) + ztemp(6))


C	      interpolate in y
         zfit(i) = sy * (ztemp(4) + (sy2 - 1.) * (cd21y + (sy2 - 4.) 
     *      * cd41y)) + ty * (ztemp(3) + (ty2 - 1.) * (cd20y + 
     *      (ty2 - 4.) * cd40y))
         nxold = nx
         nyold = ny
110      ENDDO
      
      return
      end

C II_BISPLINE3 -- Procedure to evaluate a bicubic spline.
C The real array coeff contains the B-spline coefficients.
C The procedure assumes that 1 <= x <= nxpix and 1 <= y <= nypix
C and that coeff[1+first_point] = B-spline[2].
C
      subroutine iibis3 (coeff, firstt, lencof, x, y, zfit, npts)
C real   coeff[ARB]     # 1D array of coefficients
C int    firstt         # offset of first data point
C int    lencof         # row length of coeff
C real   x[npts]        # array of x values
C real   y[npts]        # array of y values
C real   zfit[npts]	   # array of interpolated values
C int	   npts		      # number of data points

      integer firstt
      integer lencof
      integer npts
      real coeff(*)
      real x(npts), y(npts)
      real zfit(npts)
      integer nx, ny
      integer firstw
      integer index
      integer i, j
      real sx, tx, sy, ty
      real bx(4), by(4)
      real accum
      real sum
      save
      do i = 1, npts 
         nx = int(x(i))
         sx = x(i) - nx
         tx = 1. - sx

         ny = int(y(i))
         sy = y(i) - ny
         ty = 1. - sy

C        calculate the x B-splines
         bx(1) = tx ** 3
         bx(2) = 1. + tx * (3. + tx * (3. - 3. * tx))
         bx(3) = 1. + sx * (3. + sx * (3. - 3. * sx))
         bx(4) = sx ** 3

C        calculate the y B-splines
         by(1) = ty ** 3
         by(2) = 1. + ty * (3. + ty * (3. - 3. * ty))
         by(3) = 1. + sy * (3. + sy * (3. - 3. * sy))
         by(4) = sy ** 3

C	      calculate the pointer to data[nx,ny-1]
         firstw = firstt + (ny - 2) * lencof + nx
         accum = 0.
         index = firstw
         do j = 1, 4 
            sum = coeff(index-1) * bx(1) + coeff(index) * bx(2) + 
     *         coeff(index+1) * bx(3) + coeff(index+2) * bx(4)
            accum = accum + sum * by(j)
            index = index + lencof
         ENDDO
         zfit(i) = accum
      ENDDO
      return
      end
      
      
C II_NISINC -- Procedure to evaluate the 2D sinc function.  The real array
C coeff contains the data. The procedure assumes that 1 <= x <= nxpix and
C 1 <= y <= nypix and that coeff[1+first_point] = datain[1,1]. The since
C truncation length is nsinc. The taper is a cosbell function which is
C valid for 0 <= x <= PI / 2 (Abramowitz and Stegun, 1972, Dover Publications,
C p 76). If the point to be interpolated is less than mindx and mindy from
C a data point no interpolation is done and the data point is returned. This
C routine does not use precomputed arrays.
C
C This version, renamed II_NISINC allows for a scaling of the
C interpolations array.
C 
C Interface modified to accept pre-initialized arrays for taper, ac, ar.
C   Original version dynamically allocated these arrays in the code.
C  WJH, 15 June 2004
C
      subroutine iinisc (coeff, firstt, lencof, lenary, x, y, zfit, 
     *npts, nconv, taper, ac, ar, mindx, mindy, scale)

C real   coeff[ARB]     # 1D array of coefficients
C int    first_point    # offset to first data point
C int    len_coeff      # row length of coeff
C int    len_array      # column length of coeff
C real   x[npts]        # array of x values
C real   y[npts]        # array of y values
C real   zfit[npts]     # array of interpolated values
C real   scale          # stretch factor
C int    npts           # the number of input points.
C int    nconv          # number of points in interpolation arrays
C          where nconv = 2 * nsinc + 1 and nsinc = sinc truncation length
C real   taper[NCONV]   # taper array
C real   ac[NCONV]      # ac array
C real   ar[NCONV]      # ar array
C real   mindx          # interpolation minimum in x
C real   mindy		      # interpolation minimum in y
C
      integer firstt
      integer lencof
      integer lenary
      integer npts
      integer nsinc
      real mindx, mindy
      real scale
      real coeff(*)
      real x(npts), y(npts)
      real zfit(npts)
      integer i, j, k
      integer nx, ny
      integer index
      integer mink, maxk, offk
      integer minj, maxj, offj
      integer lastpt
      integer nconv
      real taper(nconv), ac(nconv), ar(nconv) 

      real sconst
      real a2, a4
      real sdx, dx, dy, dxn, dyn
      real ax, ay, px, py
      real sum, sumx, sumy
      real dx2
      real halfpi

      save
C     Compute original sinc truncation length
      nsinc = (nconv - 1) / 2
      
C     Compute the constants for the cosine bell taper.
      halfpi = 1.5707963267948966192
      sconst = ( halfpi / nsinc) ** 2
      a2 = -0.49670
      a4 = 0.03705

C	   Precompute the taper array. Incorporate the sign change portion
C	   of the sinc interpolator into the taper array.

      if (mod (nsinc, 2) .eq. 0) THEN
         sdx = 1.0
      ELSE
         sdx = -1.0
         do j = -nsinc, nsinc 
            dx2 = sconst * j * j
            taper(j+nsinc+1) = sdx * (1.0 + a2 * dx2 + 
     *      a4 * dx2 * dx2) ** 2
            sdx = -sdx
         ENDDO
      ENDIF
   
      do i = 1, npts 
C     	   define the fractional pixel interpolation.
         nx = nint (x(i))
         ny = nint (y(i))
         if (nx .lt. 1 .or. nx .gt. lencof .or. ny .lt. 1 .or. 
     *      ny .gt. lenary) THEN
            zfit(i) = 0.0
C              go onto next point
            GOTO 130
         ENDIF

C ### Scale the offset
         dx = (x(i) - nx)*scale
         dy = (y(i) - ny)*scale

C	         define pointer to data[nx,ny]
         if (abs (dx) .lt. mindx .and. abs (dy) .lt. mindy) THEN 
            index = firstt + (ny - 1) * lencof + nx
            zfit(i) = coeff(index)
            goto 130
         ENDIF

C 	         Compute the x and y sinc arrays using a cosbell taper.
         dxn = 1 + nsinc + dx
         dyn = 1 + nsinc + dy
         sumx = 0.0
         sumy = 0.0
         do j = 1, nconv 
            ax = dxn - j
            ay = dyn - j
            if (ax .eq. 0.0) THEN
               px = 1.0
            ELSE if (dx .eq. 0.0) THEN
               px = 0.0
            ELSE
               px = taper(j-1) / ax
            ENDIF

            if (ay .eq. 0.0) THEN
               py = 1.0
            ELSE if (dy .eq. 0.0) THEN
               py = 0.0
            ELSE
               py = taper(j-1) / ay
            ENDIF

            ac(j-1) = px
            ar(j-1) = py
            sumx = sumx + px
            sumy = sumy + py
         ENDDO

C	         Compute the limits of the convolution.
         minj = max (1, ny - nsinc)
         maxj = min (lenary, ny + nsinc)
C           Get the index into ar
         offj = nsinc - ny

         mink = max (1, nx - nsinc)
         maxk = min (lencof, nx + nsinc)
C           Get the index into ac
         offk = nsinc - nx

C	         Do the convolution.
         zfit(i) = 0.0
         do 210 j = ny - nsinc, minj - 1 
            sum = 0.0
            do 220 k = nx - nsinc, mink - 1
               sum = sum + ac(k+offk) * coeff(firstt+1)
220            continue
            do 230 k = mink, maxk
               sum = sum + ac(k+offk) * coeff(firstt+k)
230            continue
            do 240 k = maxk + 1, nx + nsinc
               sum = sum + ac(k+offk) * coeff(firstt+lencof)
240            continue
            zfit(i) = zfit(i) + ar(j+offj) * sum
210         continue

         do 250 j = minj, maxj 
            index = firstt + (j - 1) * lencof
            sum = 0.0
            do 260 k = nx - nsinc, mink - 1
               sum = sum + ac(k+offk) * coeff(index+1)
260            continue

            do 270 k = mink, maxk
               sum = sum + ac(k+offk) * coeff(index+k)
270            continue
            do 280 k = maxk + 1, nx + nsinc
               sum = sum + ac(k+offk) * coeff(index+lencof)
280            continue
            zfit(i) = zfit(i) + ar(j+offj) * sum
250         continue

         do 290 j = maxj + 1, ny + nsinc 
            lastpt = firstt + (lenary - 1) * lencof
            sum = 0.0
            do 300 k = nx - nsinc, mink - 1
               sum = sum + ac(k+offk) * coeff(lastpt+1)
300            continue
            do 310 k = mink, maxk
               sum = sum + ac(k+offk) * coeff(lastpt+k)
310            continue
            do 320 k = maxk + 1, nx + nsinc
               sum = sum + ac(k+offk) * coeff(lastpt+lencof)
320            continue
            zfit(i) = zfit(i) + ar(j+offj) * sum
290         continue

         zfit(i) = zfit(i) / sumx / sumy

130   ENDDO
131   continue

      return
      end


C II_NILSINC -- Procedure to evaluate the 2D sinc function.  The real array
C coeff contains the data. The procedure assumes that 1 <= x <= nxpix and
C 1 <= y <= nypix and that coeff[1+first_point] = datain[1,1]. The since
C truncation length is nsinc. The taper is a cosbell function which is
C valid for 0 <= x <= PI / 2 (Abramowitz and Stegun, 1972, Dover Publications,
C p 76). If the point to be interpolated is less than mindx and mindy from
C a data point no interpolation is done and the data point is returned. This
C routine does use precomputed arrays.
C
C Renamed II_NILSINC when scale was added,
C  Richard Hook, ST-ECF/STScI, December 2003
      subroutine iinilc (coeff, firstt, lencof, lenary, x, y, zfit, npts
     *, ltable, nconv, nxincr, nyincr, mindx, mindy, scale)

C real   coeff[ARB]           # 1D array of coefficients
C int    first_point          # offset to first data point
C int    len_coeff            # row length of coeff
C int    len_array            # column length of coeff
C real   x[npts]              # array of x values
C real   y[npts]              # array of y values
C real   zfit[npts]           # array of interpolated values
C real   scale                # scale for offset
C int    npts                 # the number of input points.
C real   ltable[nconv,nconv,nxincr,nyincr]  # the pre-computed look-up table
C int    nconv                # the sinc truncation full width
C int	   nxincr				   # the interpolation resolution in x
C int	   nyincr				   # the interpolation resolution in y
C real	mindx				      # interpolation mininmum in x
C real	mindy				      # interpolation mininmum in y
      integer firstt
      integer lencof
      integer lenary
      integer npts
      integer nconv, nxincr, nyincr
      real mindx, mindy
      real scale
      real coeff(*)
      real x(npts), y(npts)
      real zfit(npts)
      real ltable(nconv,nconv,nxincr,nyincr)
      integer i, j, k
      integer nsinc
      integer xc, yc
      integer lutx, luty
      integer minj, maxj, offj
      integer mink, maxk, offk
      integer index
      integer lastpt
      real dx, dy, sum
      save

      nsinc = (nconv - 1) / 2
      do 110 i = 1, npts 

C	      Return zero outside of data.
         xc = nint (x(i))
         yc = nint (y(i))
         if (xc .lt. 1 .or. xc .gt. lencof .or. yc .lt. 1 .or. 
     *      yc .gt. lenary) THEN
            zfit(i) = 0.0
            goto 110
         ENDIF

         dx = (x(i) - xc)*scale
         dy = (y(i) - yc)*scale
         if (abs(dx) .lt. mindx .and. abs(dy) .lt. mindy) THEN
            index = firstt + (yc - 1) * lencof + xc
            zfit(i) = coeff(index)
         ENDIF

         if (nxincr .eq. 1) THEN
            lutx = 1
         ELSE
            lutx = nint ((-dx + 0.5) * (nxincr - 1)) + 1
         ENDIF

         if (nyincr .eq. 1) THEN
            luty = 1
         ELSE
            luty = nint ((-dy + 0.5) * (nyincr - 1)) + 1
         ENDIF

C	         Compute the convolution limits.
         minj = max (1, yc - nsinc)
         maxj = min (lenary, yc + nsinc)
         offj = 1 - yc + nsinc
         mink = max (1, xc - nsinc)
         maxk = min (lencof, xc + nsinc)
         offk = 1 - xc + nsinc

C	         Initialize
         zfit(i) = 0.0

C	         Do the convolution.
         do 160 j = yc - nsinc, minj - 1 
            sum = 0.0
            do 170 k = xc - nsinc, mink - 1
               sum = sum + ltable(k+offk,j+offj,lutx,luty) * 
     *            coeff(firstt+1)
170            continue
            do 180 k = mink, maxk
               sum = sum + ltable(k+offk,j+offj,lutx,luty) * 
     *            coeff(firstt+k)
180            continue
            do 190 k = maxk + 1, xc + nsinc
               sum = sum + ltable(k+offk,j+offj,lutx,luty) * 
     *            coeff(firstt+lencof)
190            continue
            zfit(i) = zfit(i) + sum
160         continue

         do 200 j = minj, maxj 
            index = firstt + (j - 1) * lencof
            sum = 0.0
            do 210 k = xc - nsinc, mink - 1
               sum = sum + ltable(k+offk,j+offj,lutx,luty) * 
     *            coeff(index+1)
210            continue
            do 220 k = mink, maxk
               sum = sum + ltable(k+offk,j+offj,lutx,luty) * 
     *            coeff(index+k)
220            continue
            do 230 k = maxk + 1, xc + nsinc
               sum = sum + ltable(k+offk,j+offj,lutx,luty) * 
     *            coeff(index+lencof)
230            continue
            zfit(i) = zfit(i) + sum
200         continue

         do 240 j = maxj + 1, yc + nsinc 
            lastpt = firstt + (lenary - 1) * lencof
            sum = 0.0
            do 250 k = xc - nsinc, mink - 1
               sum = sum + ltable(k+offk,j+offj,lutx,luty) * 
     *            coeff(lastpt+1)
250            continue
            do 260 k = mink, maxk
               sum = sum + ltable(k+offk,j+offj,lutx,luty) * 
     *            coeff(lastpt+k)
260            continue
            do 270 k = maxk + 1, xc + nsinc
               sum = sum + ltable(k+offk,j+offj,lutx,luty) * 
     *            coeff(lastpt+lencof)
270            continue
            zfit(i) = zfit(i) + sum
240         continue

110      continue
111      continue
      return
      end
c     firstw  first_row
c     iinisc  ii_nisinc
c     iibidz  ii_bidriz
c     dhxfrc  dhxfrac
c     iibis3  ii_bispline3
c     dhyfrc  dhyfrac
c     iibid0  ii_bidriz0
c     boundy  boundary
c     iibid1  ii_bidriz1
c     lastpt  last_point
c     lenary  len_array
c     iibint  ii_binearest
c     iibip3  ii_bipoly3
c     iibip5  ii_bipoly5
c     iibilr  ii_bilinear
c     iinilc  ii_nilsinc
c     lencof  len_coeff
c     firstt  first_point

      SUBROUTINE DR2GEO
C
C Convert a drizzle format distortion coefficients file
C to an image distortion file.
C
C This is a utility for tests.
C
C    Richard Hook, ST-ECF/STScI, September 2003
C
C Converted to double precision,
C    Richard Hook, ST-ECF/STScI, October 2003
C
      IMPLICIT NONE

      INTEGER IDD,ISTAT,NX,NY
      INTEGER COTY,COMAX,CONUM,PXG,PYG,DIMS(7)
      PARAMETER (COMAX=100)
      DOUBLE PRECISION LAM,XCO(COMAX),YCO(COMAX)
      CHARACTER*80 COEFFS
      DOUBLE PRECISION WCSIN(8),WCSOUT(8)

C Geometrical parameters, the standard set
      DOUBLE PRECISION SCALE,ROT,XSH,YSH,LAM
      DOUBLE PRECISION ALPHA, BETA
      DOUBLE PRECISION XSH2,YSH2,ROT2,XSCALE,YSCALE
      CHARACTER*80 XGEOIM,YGEOIM
      INTEGER XGDIM,YGDIM
      CHARACTER*8 SHFR2,ALIGN

      INTEGER MAXLEN
      PARAMETER (MAXLEN=100000)

      INTEGER I,J,IXG,IYG
      DOUBLE PRECISION XIN(MAXLEN),YIN(MAXLEN),XOUT(MAXLEN),YOUT(MAXLEN)

      REAL MEMR(1)
      COMMON /MEM/MEMR

      LOGICAL DISIM,SECPAR,USEWCS,ROTFIR,ROTF2

      XGEOIM=' '
      YGEOIM=' '
      PXG=0
      PYG=0
      XSH=0.0
      YSH=0.0
      ALPHA = 0.0
      BETA = 0.0
      ROT=0.0
      SCALE=1.0
      DISIM=.FALSE.
      SECPAR=.FALSE.
      USEWCS=.FALSE.
      ROTFIR=.FALSE.
      IDD=0

C Get the geometric flags
      CALL UCLGST('align',ALIGN,ISTAT)

C Get the wavelength (Trauger only)
      CALL UCLGSD('lambda',LAM,ISTAT)

C Get the geometric distortion file parameters:
      CALL UCLGST('coeffs',COEFFS,ISTAT)

      CALL GETGEO(COEFFS,IDD,LAM,
     :            COTY,COMAX,CONUM,XCO,YCO,ISTAT)
      IF(ISTAT.NE.0) THEN
         CALL UMSPUT(
     :  '! Error, failed to get geometric distortion coefficients',
     :  1,0,ISTAT)
          GO TO 99
      ENDIF

C  Read in any distortion image corrections, if specified
C  PXG,PYG will default to 2x2 arrays when DISIM returns as FALSE.
C 
      CALL GGEOIM(XGEOIM,YGEOIM,PXG,PYG,XGDIM,YGDIM,DISIM)

C Get the name of the output images and create them
      CALL UCLGST('xgeoim',XGEOIM,ISTAT)
      CALL UCLGST('ygeoim',YGEOIM,ISTAT)
      CALL UCLGSI('nxgeo',NX,ISTAT)
      CALL UCLGSI('nygeo',NY,ISTAT)

      DIMS(1)=NX
      DIMS(2)=NY
      CALL UIMCRE(XGEOIM,6,2,DIMS,IXG,ISTAT)
      CALL UIMCRE(YGEOIM,6,2,DIMS,IYG,ISTAT)

      DO I=1,NX
         XIN(I)=DBLE(I)
      ENDDO 
     
C Loop through the output image
      DO J=1,NY

         DO I=1,NX
            YIN(I)=DBLE(J)
         ENDDO

C Convert the positions
         CALL DRIVAL(XIN,YIN,NX,NX,NY,NX,NY,.FALSE.,
     :            XSH,YSH,ROT,SCALE,ALIGN,ROTFIR,
     :            SECPAR,XSH2,YSH2,ROT2,XSCALE,YSCALE,SHFR2,ROTF2,
     :            USEWCS,WCSIN,WCSOUT,
     :            COTY,CONUM,XCO,YCO,DISIM,
     :            MEMR(PXG),MEMR(PYG),XGDIM,YGDIM,XOUT,YOUT, ALPHA, BETA)

         DO I=1,NX
            XOUT(I)=XOUT(I)-XIN(I)
            YOUT(I)=YOUT(I)-YIN(I)
         ENDDO

C Write out the lines
         CALL UIPL2R(IXG,J,XOUT,ISTAT)
         CALL UIPL2R(IYG,J,YOUT,ISTAT)
      ENDDO

      CALL UIMCLO(IXG,ISTAT)
      CALL UIMCLO(IYG,ISTAT)

 99   CONTINUE

C If allocated, free the distortion image memory
      IF(PXG.NE.0) CALL UDMFRE(PXG,6,ISTAT)
      IF(PYG.NE.0) CALL UDMFRE(PYG,6,ISTAT)

      END

      SUBROUTINE TBLOT(DATA,NDAT,XMIN,XMAX,YMIN,YMAX,
     :                  DNX,DNY,ONX,ONY,XSH,YSH,DROT, SCALE,KSCALE,
     :                 XSH2,YSH2,XSCALE,YSCALE,ROT2, SHFR2,  
     :                 PXG,PYG,XGDIM,YGDIM,
     :                 ALIGN,INTERP,COEFFS,EF,MISVAL,SINSCL,CLEN,VFLAG,
     :                 ALPHA,BETA)
C++
C
C TBLOT.F "Reverse drizzling" 
C IDL-callable version.
C
C   Richard Hook, ST-ECF/STScI, 23rd September 2002
C
C Added MISVAL parameter - September 2003
C--
C F2PY control codes added by WJH, 22 Nov 2002
C
Cf2py intent(in,c) data
Cf2py intent(in,out) ndat
Cf2py real intent(in) :: xsh, ysh, drot, scale
Cf2py character*8 intent(in) :: align
Cf2py character*7 intent(in) :: interp
Cf2py character*80 :: coeffs
Cf2py real intent(in) :: misval
Cf2py integer intent(in) :: vflag
Cf2py integer intent(hide),depend(data) :: dnx = shape(data,0)
Cf2py integer intent(hide),depend(data) :: dny = shape(data,1)
Cf2py integer intent(hide),depend(ndat) :: onx = shape(ndat,0)
Cf2py integer intent(hide),depend(ndat) :: ony = shape(ndat,1)
C
      IMPLICIT NONE

C Local variables
      INTEGER ISTAT,VFLAG
      INTEGER DNX,DNY,ONX,ONY
      INTEGER XMIN,XMAX,YMIN,YMAX
      INTEGER IDD
      INTEGER INTYPE
      REAL SINSCL, KSCALE
      REAL EF

C The main data and output arrays
      REAL DATA(XMAX-XMIN+1,YMAX-YMIN+1),NDAT(ONX,ONY)

C The distortion image arrays, and their size
C These arrays should be 2x2 blank arrays if no images are used
      REAL PXG(XGDIM,YGDIM), PYG(XGDIM,YGDIM)
      INTEGER XGDIM,YGDIM
      LOGICAL DISIM
      
C Buffers
      INTEGER MAXNX
      PARAMETER (MAXNX=10000)

      DOUBLE PRECISION XIN(MAXNX),XOUT(MAXNX),YIN(MAXNX),YOUT(MAXNX)

      DOUBLE PRECISION WCSIN(8),WCSOUT(8)
      CHARACTER*45 VERS
      CHARACTER*7 INTERP
      INTEGER COTY,COMAX,CONUM
      PARAMETER (COMAX=100)
      DOUBLE PRECISION  XCO(COMAX),YCO(COMAX)
      REAL MISVAL

C Geometrical parameters, the standard set
      DOUBLE PRECISION  SCALE,DROT,ROT,XSH,YSH,LAM
      DOUBLE PRECISION  XSH2,YSH2,ROT2,XSCALE,YSCALE,ALPHA,BETA
      CHARACTER*80 COEFFS
      CHARACTER*8 SHFR2,ALIGN,GEOMOD
      INTEGER CLEN

C Constants
      REAL PI
      PARAMETER (PI=3.1415926536)

C Logical flags
      LOGICAL VERBOSE
      LOGICAL ROTFIR
      LOGICAL INCPS
      LOGICAL USEWCS
      LOGICAL ROTF2
      LOGICAL SECPAR

C Verbose common
      COMMON /VERBOSE/VERBOSE

C-- Start of executable code

C Keep quiet
      IF(VFLAG.EQ.1) THEN
         VERBOSE=.TRUE.
      ELSE
         VERBOSE=.FALSE.
      ENDIF

C First announce the version
      VERS='Callable BLOT Version 0.6 (1st Nov 2005)'

      CALL UMSPUT('+ '//VERS,1,0,ISTAT)

      USEWCS=.FALSE.
C      ROTFIR=.FALSE.
      ROTFIR=.TRUE.
      SECPAR=.FALSE.
      INCPS=.TRUE.
C      EF=1.0

C Convert the rotation to radians
      ROT=DROT*PI/180.0
    
C Convert the secondary parameters into suitable units
      ROT2=ROT2*PI/180.0D0
      IF(SHFR2.EQ.'input') THEN
         ROTF2=.FALSE.
      ELSE
         ROTF2=.TRUE.
      ENDIF

C Give a warning message if secondary parameters will have an effect
      IF(XSCALE.NE.1.0D0 .OR. YSCALE.NE.1.0D0 .OR.
     :   XSH2.NE.0.0D0 .OR. YSH2.NE.0.0D0 .OR. ROT2.NE.0.0D0) THEN
       CALL UMSPUT(
     : '! Warning, secondary geometric transform is being used',
     :               1,0,ISTAT)
        SECPAR=.TRUE.
      ELSE
        SECPAR=.FALSE.
      ENDIF


C Check for invalid scale
      IF(SCALE.EQ.0.0) THEN
         CALL UMSPUT('! Invalid scale',1,0,ISTAT)
         GO TO 99
      ENDIF

C Get the geometric distortion coefficient information
C 
      CALL GETGEO(COEFFS,IDD,LAM,COTY,COMAX,CONUM,
     :                  XCO,YCO,CLEN,ISTAT)
      IF(ISTAT.NE.0) THEN
         CALL UMSPUT(
     :  '! Error, failed to get geometric distortion coefficients',
     :  1,0,ISTAT)
          GO TO 99
      ENDIF

C Set DISIM logical based on whether distortion images have
C  been passed in for use or not.
      IF (XGDIM .EQ. 2 .AND. YGDIM .EQ. 2) THEN
         DISIM = .FALSE.
      ELSE
         DISIM = .TRUE.
      ENDIF
      
C Before we start also get the interpolation type and convert
C to a numerical code
      IF(INTERP(1:7).EQ.'nearest') THEN
         INTYPE=1
      ELSE IF(INTERP(1:6).EQ.'linear') THEN
         INTYPE=2
      ELSE IF(INTERP(1:5).EQ.'poly3') THEN
         INTYPE=3
      ELSE IF(INTERP(1:5).EQ.'poly5') THEN
         INTYPE=4
C      ELSE IF(INTERP(1:7).EQ.'spline3') THEN
C         INTYPE=5
      ELSE IF(INTERP(1:4).EQ.'sinc') THEN
         INTYPE=6
      ELSE IF(INTERP(1:5).EQ.'lsinc') THEN
         INTYPE=7
      ELSE IF(INTERP(1:4).EQ.'lan3') THEN
         INTYPE=100
      ELSE IF(INTERP(1:4).EQ.'lan5') THEN
         INTYPE=105
      ELSE 
         CALL UMSPUT('! Invalid interpolant specified',
     :               1,0,ISTAT)
          CALL UMSPUT(INTERP,1,0,ISTAT)
         GO TO 99
      ENDIF  

C Now do the actual combination using interpolation
      CALL DOBLOT(DATA,NDAT,INTYPE,SINSCL,KSCALE,MISVAL,
     :      XMIN,XMAX,YMIN,YMAX,
     :      DNX,DNY,ROTFIR,EF,ALIGN,
     :      ONX,ONY,COTY,CONUM,XCO,YCO,
     :      DISIM, PXG,PYG,XGDIM,YGDIM,
     :      XIN,YIN,XOUT,YOUT,
     :      SCALE,ROT,XSH,YSH,USEWCS,WCSIN,WCSOUT,GEOMOD,
     :      SECPAR,XSH2,YSH2,ROT2,XSCALE,YSCALE,SHFR2,ROTF2,
     :      ALPHA,BETA)

 99   CONTINUE
      END

      SUBROUTINE WCS2DR
C
C WCS2DR - use the WCS in the header of two images to deduce the
C          drizzle parameters (rot,scale,xsh,ysh) needed to map one
C          onto the other.
C
C Description:
C
C The 8 linear WCS values (CRVAL1/2, CRPIX1/2, CD1/2_1/2) are read from
C the headers of two images. One is regarded as the reference. The drizzle
C parameters which are needed to transform the image supplied so that it
C is registered with the reference image is written to the screen in a
C form suitable for feeding directly to the IRAF cl.
C
C Some checks that the scales are the same in X and Y and that there isn't
C excessive skew are made.
C
C It is assumed that the input images are both TAN projection (although not
C necessarily the same TAN projection).
C
C History:
C
C First try, 10th January 2000, Richard Hook
C Added support for multiple input images, Richard Hook, STScI, 13th January 2000
C Small changes for release with Drizzle 2.6, December 2001
C
C Fixed bug for larger angles and also added comment (#) character
C in version announcement string. V1.1, January 2002
C
C Modified to apply distortions to input and output WCS where needed.
C   Richard Hook & Andy Fruchter, STScI, May 2002
C
C Modifications for distortion images etc,
C   Richard Hook, ST-ECF/STScI, September 2003
C
C Double precision version,
C   Richard Hook, ST-ECF/STScI, October 2003
C
C Version 1.9, with refpix support,
C   Richard Hook, ST-ECF/STScI, 5th December 2003
C
      IMPLICIT NONE

      CHARACTER*80 COEFFS,IMAGES,IMAGE,REFIM
      CHARACTER*80 XGEOIM,YGEOIM
      CHARACTER*8 CTYPE1,CTYPE2
      CHARACTER*12 CHARS
      CHARACTER*132 LINE
      CHARACTER*4 STYLE
      INTEGER I,ID,IDR,ISTAT,NDIMS,DIMS(7),DATTYP,IMLD,I1,I2
      INTEGER PXG,PYG
      DOUBLE PRECISION XOUT,YOUT,XCEN,YCEN,XCENR,YCENR
      DOUBLE PRECISION XROT,YROT,ROT,XSCALE,YSCALE,SCALE,XSH,YSH
      DOUBLE PRECISION WCS(8),WCSR(8),X(4),Y(4),R,D
      CHARACTER*40 VERS

      INTEGER USEOF
      PARAMETER (USEOF=-2)

      DOUBLE PRECISION PIBY
      PARAMETER (PIBY=3.141592653/180.0D0)

      VERS='WCS2DR Version 1.9 (5th December 2003)'

C Announce the version
      CALL UMSPUT('#+ '//VERS,1,0,ISTAT)

C Get the names of the input and reference images
      CALL UCLGST('images',IMAGES,ISTAT)
      CALL UCLGST('refim',REFIM,ISTAT)

C Get the style of the output list
      CALL UCLGST('style',STYLE,ISTAT)

C Open image template processing
      CALL TIMOTP(IMAGES,IMLD,ISTAT)

C Before starting open the single reference image
      CALL UIMOPN(REFIM,1,IDR,ISTAT)
      IF(ISTAT.NE.0) THEN
         CALL UMSPUT('! Error: unable to open reference image',
     :               1,0,ISTAT)
         GO TO 99
      ENDIF

C and get its size
      CALL UIMGID(IDR,DATTYP,NDIMS,DIMS,ISTAT)
      IF(NDIMS.NE.2) THEN
         CALL UMSPUT(
     : '! Error: reference image is not two dimensional',
     :               1,0,ISTAT)
         GO TO 99
      ENDIF

      XCENR=DBLE(DIMS(1)/2)+1.0D0
      YCENR=DBLE(DIMS(2)/2)+1.0D0

C Finally we can read the WCS from the reference as this only has to be 
C done once
      CALL GETWCS(IDR,WCSR,CTYPE1,CTYPE2,ISTAT)
      IF(ISTAT.NE.0) THEN
         CALL UMSPUT(
     : '! Error: unable to read WCS from reference image header',
     :               1,0,ISTAT)
         GO TO 99
      ENDIF
      IF(CTYPE1.NE.'RA---TAN' .OR. CTYPE2.NE.'DEC--TAN') THEN
         CALL UMSPUT('! Projection of reference image is not TAN',
     :               1,0,ISTAT)
         CALL UMSPUT('! (assuming it is anyway)',1,0,ISTAT)
      ENDIF

C Update the WCS to allow for the coefficients file
      CALL UCLGST('refcoefs',COEFFS,ISTAT)
      CALL UCLGST('refxgeo',XGEOIM,ISTAT)
      CALL UCLGST('refygeo',YGEOIM,ISTAT)

      CALL DUPWCS(WCSR,WCSR,DIMS(1),DIMS(2),COEFFS,XGEOIM,YGEOIM,
     :            PXG,PYG,IDR,ISTAT)
      IF(ISTAT.NE.0) THEN
         CALL UMSPUT('! Failed to update WCS of reference image',
     :               1,0,ISTAT)
         GO TO 99
      ENDIF

C We can close the reference image at this point
      CALL UIMCLO(IDR,ISTAT)

C If style=line we can write the header
      IF(STYLE.EQ.'line') THEN
         CALL UMSPUT(
     : '# Image             xsh     ysh        scale        rot',
     :               1,0,ISTAT)
         CALL UMSPUT(
     : '# Note: shft_fr="output" shft_un="output" align="center"',
     :   1,0,ISTAT)
      ENDIF

C Loop around until the list of images is exhausted
      DO WHILE(.TRUE.)

C Get image name from list
         CALL TIMXTP(IMLD,IMAGE,ISTAT)
         IF(ISTAT.EQ.USEOF) GO TO 99

C Try to open it (readonly)
      CALL UIMOPN(IMAGE,1,ID,ISTAT)
      IF(ISTAT.NE.0) THEN
         CALL UMSPUT('! Error: unable to open image: '//IMAGE(1:20),
     :               1,0,ISTAT)
         GO TO 99
      ENDIF

C Get the dimensions of the input image and deduce its centre
C We assume align=center here
      CALL UIMGID(ID,DATTYP,NDIMS,DIMS,ISTAT)
      IF(NDIMS.NE.2) THEN
         CALL UMSPUT('! Error: image is not two dimensional',
     :               1,0,ISTAT)
         GO TO 99
      ENDIF

      XCEN=DBLE(DIMS(1)/2)+1.0D0
      YCEN=DBLE(DIMS(2)/2)+1.0D0

C Get the WCS from the headers. We just use the 8 standard values:
C CRVAL1/2, CRPIX1/2, CD_1/2_1/2
C
C If the projection isn't TAN we assume it is anyway, but tell the user
      CALL GETWCS(ID,WCS,CTYPE1,CTYPE2,ISTAT)
      IF(ISTAT.NE.0) THEN
         CALL UMSPUT('! Error: unable to read WCS from image header',
     :               1,0,ISTAT)
         GO TO 99
      ENDIF
      IF(CTYPE1.NE.'RA---TAN' .OR. CTYPE2.NE.'DEC--TAN') THEN
         CALL UMSPUT('! Projection of image is not TAN',1,0,ISTAT)
         CALL UMSPUT('! (assuming it is anyway)',1,0,ISTAT)
      ENDIF

C We have what we need from the image header so we can close it
      CALL UIMCLO(ID,ISTAT)

C Again update the WCS to allow for the coefficients
      CALL UCLGST('coeffs',COEFFS,ISTAT)
      CALL UCLGST('xgeoim',XGEOIM,ISTAT)
      CALL UCLGST('ygeoim',YGEOIM,ISTAT)

      CALL DUPWCS(WCS,WCS,DIMS(1),DIMS(2),COEFFS,XGEOIM,YGEOIM,
     :            PXG,PYG,ID,ISTAT)
      IF(ISTAT.NE.0) THEN
         CALL UMSPUT('! Failed to update WCS of reference image',
     :               1,0,ISTAT)
         GO TO 99
      ENDIF

C Transform the corners of a unit square at the centre of the input
C image onto the reference
      X(1)=XCEN-0.5D0
      X(2)=XCEN+0.5D0
      X(3)=XCEN+0.5D0
      X(4)=XCEN-0.5D0
      Y(1)=YCEN-0.5D0
      Y(2)=YCEN-0.5D0
      Y(3)=YCEN+0.5D0
      Y(4)=YCEN+0.5D0

      DO I=1,4
         CALL XY2RD(X(I),Y(I),R,D,WCS)
         CALL RD2XY(R,D,X(I),Y(I),WCSR,ISTAT)
      ENDDO

C Calculate the shifts and X and Y rotations
      XOUT=0.0D0
      YOUT=0.0D0

      DO I=1,4
         XOUT=XOUT+X(I)
         YOUT=YOUT+Y(I)
      ENDDO

      XOUT=XOUT/4.0D0
      YOUT=YOUT/4.0D0

      XSH=XOUT-XCENR
      YSH=YOUT-YCENR

      XSCALE=SQRT((X(2)-X(1))**2 + (Y(2)-Y(1))**2)
      YSCALE=SQRT((X(3)-X(2))**2 + (Y(3)-Y(2))**2)

      IF(ABS(XSCALE/YSCALE-1.0) .GT. 0.001D0) THEN
         CALL UMSPUT(
     : '! Warning, X and Y scales differ by more than 0.1%',
     :   1,0,ISTAT)
      ENDIF

C Use the geometric mean scale
      SCALE=1.0D0/SQRT(XSCALE*YSCALE)

      XROT=ATAN2(Y(2)-Y(1),X(2)-X(1))/PIBY
      YROT=ATAN2(Y(3)-Y(2),X(3)-X(2))/PIBY-90.0D0
      
C Check the angle is in the right range
      IF(YROT.LT.-180.0D0) YROT=YROT+360.0D0

      IF(ABS(XROT-YROT) .GT. 0.1D0) THEN
         CALL UMSPUT(
     : '! Warning, X and Y rotation angles differ by more than 0.1deg',
     :   1,0,ISTAT)
      ENDIF

C Use the mean rotation angle      
      ROT=(XROT+YROT)/2.0D0

C Write out the results in a format suitable for drizzle
      IF(STYLE.EQ.'para') THEN
         CALL UMSPUT('#',1,0,ISTAT)
         CALL LENSTR(IMAGE,I1,I2)
         CALL UMSPUT('drizzle.data="'//IMAGE(I1:I2)//'"',1,0,ISTAT)
         CALL UMSPUT('drizzle.shft_fr="output"',1,0,ISTAT)
         CALL UMSPUT('drizzle.shft_un="output"',1,0,ISTAT)
         CALL UMSPUT('drizzle.align="center"',1,0,ISTAT)
         WRITE(CHARS,'(F12.5)') XSH
         CALL UMSPUT('drizzle.xsh='//CHARS,1,0,ISTAT)
         WRITE(CHARS,'(F12.5)') YSH
         CALL UMSPUT('drizzle.ysh='//CHARS,1,0,ISTAT)
         WRITE(CHARS,'(F12.5)') SCALE
         CALL UMSPUT('drizzle.scale='//CHARS,1,0,ISTAT)
         WRITE(CHARS,'(F12.5)') ROT
         CALL UMSPUT('drizzle.rot='//CHARS,1,0,ISTAT)
      ELSE IF(STYLE.EQ.'line') THEN
         WRITE(LINE,'(A15,4F12.5)') IMAGE(1:15),XSH,YSH,SCALE,ROT
         CALL UMSPUT(LINE,1,0,ISTAT)
      ELSE
         WRITE(LINE,'(A25,'' xsh='',F10.5,'' ysh='',F10.5,
     :    '' scale='',F10.5,'' rot='',F10.5,
     :    '' shft_fr="output" shft_un="output" align="center"'')')
     :    IMAGE(1:25),XSH,YSH,SCALE,ROT
         CALL UMSPUT(LINE,1,0,ISTAT)
        ENDIF
      ENDDO

 99   CONTINUE
      CALL TIMCTP(IMLD,ISTAT)

C If allocated, free the distortion image memory
      IF(PXG.NE.0) CALL UDMFRE(PXG,6,ISTAT)
      IF(PYG.NE.0) CALL UDMFRE(PYG,6,ISTAT)

      RETURN
      END

      SUBROUTINE SATMAK
C
C SATMASK - make a satellite mask from parameters of a line
C
C The output is an integer*2 image with weights (1 for good and 0 for bad).
C
C Richard Hook, for the GOODS project, ST-ECF, STScI, October 2002
C
      IMPLICIT NONE

      DOUBLE PRECISION X1,Y1,X2,Y2,M,C,WIDTH,HWID,F,X,Y,D
      INTEGER I,J,ISTAT,DIMS(7),ID,NX,NY
      INTEGER MAXNX
      PARAMETER (MAXNX=100000)
      INTEGER BUFFER(MAXNX)
      CHARACTER*80 MASK
      LOGICAL VERTICAL

C Get the name and dimensions of the output
      CALL UCLGST('mask',MASK,ISTAT)
      CALL UCLGSI('nx',NX,ISTAT)
      CALL UCLGSI('ny',NY,ISTAT)

C Get the line parameters - positions of two points
      CALL UCLGSD('x1',X1,ISTAT)
      CALL UCLGSD('y1',Y1,ISTAT)
      CALL UCLGSD('x2',X2,ISTAT)
      CALL UCLGSD('y2',Y2,ISTAT)

C and the width of the band
      CALL UCLGSD('width',WIDTH,ISTAT)
      HWID=WIDTH/2.0

C Check for special case of vertical line
      IF(X1.EQ.X2) THEN
         VERTICAL=.TRUE.

      ELSE

C Work out equation of line
         M=(Y2-Y1)/(X2-X1)
         C=Y1-M*X1
         F=1.0/SQRT(1.0D0+M*M)
         VERTICAL=.FALSE.
      ENDIF

C Check for meaningless case
      IF(X1.EQ.Y1 .AND. X2.EQ.Y2) THEN
         CALL UMSPUT('! Points are coincident',1,0,ISTAT)
         GO TO 99
      ENDIF

      DIMS(1)=NX
      DIMS(2)=NY

C Create the image
      CALL UIMCRE(MASK,4,2,DIMS,ID,ISTAT)
      IF(ISTAT.NE.0) THEN
         CALL UMSPUT('! Unable to create mask image',1,0,ISTAT)
         GO TO 99
      ENDIF

C Write out the image, line by line
      DO J=1,NY
         Y=DBLE(J)

C File buffer with 1 or 0
         DO I=1,NX
            X=DBLE(I)

            IF(VERTICAL) THEN
               D=ABS(X-X1)
            ELSE
               D=ABS(F*(M*X+C-Y))
            ENDIF

            IF(D.LE.HWID) THEN
               BUFFER(I)=0
            ELSE
               BUFFER(I)=1
            ENDIF
         ENDDO

C Write line of buffer
         CALL UIPL2I(ID,J,BUFFER,ISTAT)
      ENDDO

C Close
      CALL UIMCLO(ID,ISTAT)

 99   CONTINUE

      RETURN
      END

      SUBROUTINE WTRAXY  
C++
C
C WTRAXY.F V2.41 Convert X,Y pixel position to drizzle output position
C
C This task uses coefficients held in a text file to define
C geometrical distortions.
C
C This code uses the F77/VOS for IRAF i/o.
C It may be compiled and linked using a command like:
C
C xc -p stsdas tranback.f drutil.f x_tranback.x <dir>libiraf77.a
C
C History:
C
C First quick version, 17th April 1997
C
C V0.2 modified to have the centre position as parameters, 4th Sept 97
C
C V0.3 added a rotation around the centre, 19th August 1998, STScI
C      also specified "align" and chip size.
C
C V0.31 possibility to have coeffs="" for simple linear case, 25th August 98
C
C V0.4 with full set of drizzle parameter for compatibility with
C      TRANBACK and release of STECF IRAF package. 17th December 1999
C
C V0.5 modified to use new calling sequences for some DRUTIL routines
C      and hence fix bugs, November 2001
C
C V1.0 using the full geometrical possibilities available in Drizzle V2.6.
C      December 2001
C
C V1.1 return to 3 decimal places and small code tinyup
C      January 2002
C
C V1.2 using new DRIVAL call
C      Richard Hook, ST-ECF, 27th February 2002
C
C V1.3 using packaged coefficient file access and hence fixing bug
C      Richard Hook, ST-ECF, 11th March 2002
C
C V1.4 write out results to IRAF parameters and added silent flag
C      for more convenient scripting application
C      Richard Hook, ST-ECF/STScI, 4th September 2002
C
C V1.5 WTRAXY version for WCS tests,
C      Richard Hook, ST-ECF/STScI, 19th March 2003
C
C V1.6 include distortion image support,,
C      Richard Hook, ST-ECF/STScI, 26th August 2003
C
C V1.7 using double precision for almost everything
C      Richard Hook, ST-ECF/STScI, 21st October 2003
C
C V1.8 added PREFIX parameter
C       Richard Hook, ST-ECF/STScI, 23rd October 2003
C
C V1.9 added refpix support
C       Richard Hook, ST-ECF/STScI, 5th December 2003
C
C V2.0 added pixel-area output
C       Richard Hook, ST-ECF/STScI, 12th March 2004
C
C V2.1 allowed the input image header to be passed to
C      GETCOE to read coefficients, if appropriate. This is
C      part of Spitzer support.
C       Richard Hook, ST-ECF/STScI, 26th March 2004
C
C V2.2 add xylist input option.
C       Richard Hook, ST-ECF/STScI, April 2004
C
C V2.3 add output X,Y image support.
C       Richard Hook, ST-ECF/STScI, April 12th 2004.
C
C V2.4 modified to work with common callable code
C       Warren Hack, STScI, June 25th 2004.
C
C--
      IMPLICIT NONE

C Local variables
      INTEGER ISTAT,NXIN,NYIN,NXOUT,NYOUT
      INTEGER COTY,CONUM,COMAX
      PARAMETER (COMAX=100)

      DOUBLE PRECISION XCO(COMAX),YCO(COMAX)
      DOUBLE PRECISION XIN,YIN,XOUT,YOUT,X(4),Y(4),YO(4),XO(4)
      DOUBLE PRECISION RA,DEC
      INTEGER IID,IRD,DATTYP,NDIMS,DDIMS(7)
      CHARACTER*80 INIM,OUTIM
      CHARACTER*1 PREFIX
      CHARACTER*132 CHARS
      CHARACTER*45 VERS
      CHARACTER*8 CTYPE1,CTYPE2

      CHARACTER*80 OUTXIM,OUTYIM
      INTEGER MAXBUF,I,J,IDX,IDY
      PARAMETER (MAXBUF=100000)
      DOUBLE PRECISION XIA(2),YIA(2),XOA(MAXBUF),YOA(MAXBUF)
      REAL XOAS(MAXBUF),YOAS(MAXBUF)

C Geometrical parameters, the standard set
      DOUBLE PRECISION SCALE,ROT,XSH,YSH,LAM
      DOUBLE PRECISION XSH2,YSH2,ROT2,XSCALE,YSCALE,ALPHA,BETA
      DOUBLE PRECISION RACEN,DECCEN,XREFP,YREFP,WCSIN(8),WCSOUT(8)
      DOUBLE PRECISION ORIENT,OUTSCL,PAM
      CHARACTER*80 COEFFS,SHFTUN,XGEOIM,YGEOIM,XYLIST,LINE
      CHARACTER*8 SHFR2,SHFTFR,ALIGN,GEOMOD
      INTEGER PXG,PYG,LUN,XGDIM,YGDIM
      LOGICAL DISIM

      REAL MEMR(1)
      COMMON /MEM/MEMR

      DOUBLE PRECISION PI
      PARAMETER (PI=3.141592653589793D0)

      LOGICAL ROTFIR
      LOGICAL USEWCS
      LOGICAL ROTF2
      LOGICAL SECPAR
      LOGICAL SILENT

C-- Start of executable code
      VERS='WTRAXY Version 2.41 (10th February 2005)'

C Get the noise flag
      CALL UCLGSB('silent',SILENT,ISTAT)

C First announce the version
      IF(.NOT.SILENT) CALL UMSPUT('+ '//VERS,1,0,ISTAT)

C Allow WCS mode
      CALL UCLGST('geomode',GEOMOD,ISTAT)

C Get all the geometrical parameters
      CALL GTGEPA(GEOMOD,COEFFS,LAM,XGEOIM,YGEOIM,
     :             SCALE,ROT,XSH,YSH,SHFTFR,SHFTUN,ALIGN,
     :             XSCALE,YSCALE,XSH2,YSH2,ROT2,SHFR2,
     :             OUTSCL,RACEN,DECCEN,XREFP,YREFP,ORIENT)

C If so, check for image names (output is optional)
      CALL UCLGST('inimage',INIM,ISTAT)
      CALL UCLGST('refim',OUTIM,ISTAT)

      IF(GEOMOD.EQ.'wcs') THEN
         USEWCS=.TRUE.
      ELSE
         USEWCS=.FALSE.
      ENDIF   

C Open the files and read the WCS from the headers
      IF(USEWCS .OR. COEFFS.EQ.'wcs') THEN
         IF(INIM.EQ.' ') THEN
            CALL UMSPUT('! No input image specified',
     :                  1,0,ISTAT)
            GO TO 99
         ELSE
            CALL UIMOPN(INIM,1,IID,ISTAT)
            IF(ISTAT.NE.0) THEN
               CALL UMSPUT('! Unable to open input image',
     :                     1,0,ISTAT)
               GO TO 99
            ELSE
               CALL UMSPUT('-Reading WCS from '//INIM,1,0,ISTAT)
            ENDIF

            CALL GETWCS(IID,WCSIN,CTYPE1,CTYPE2,ISTAT)
            IF(ISTAT.NE.0) THEN
               CALL UMSPUT(
     : '! Unable to get WCS from reference image',
     :                     1,0,ISTAT)
               GO TO 99
            ENDIF

C Get the dimensions and use them
            CALL UIMGID(IID,DATTYP,NDIMS,DDIMS,ISTAT)
            IF(NDIMS.NE.2) THEN
               CALL UMSPUT(
     :   '! Input image is not two dimensional',
     :                          1,0,ISTAT)
               GO TO 99
            ELSE
               NXIN=DDIMS(1)
               NYIN=DDIMS(2)
            ENDIF
         ENDIF
      ENDIF

      IF(USEWCS) THEN

C If we have a reference image we need to try to get its WCS for
C use as the output
C
C Note that this can have a prefix (CCCD1_1 etc)
         IF(OUTIM.NE.' ') THEN

C Get the prefix character
            CALL UCLGST('refpref',PREFIX,ISTAT)

            CALL UIMOPN(OUTIM,1,IRD,ISTAT)
            IF(ISTAT.NE.0) THEN
               CALL UMSPUT('! Unable to open output image',
     :                     1,0,ISTAT)
               GO TO 99
            ELSE
               CALL UMSPUT('-Reading WCS from '//OUTIM,1,0,ISTAT)
               IF(PREFIX.NE.' ') THEN
                  CALL UMSPUT('-Using prefix: '//PREFIX,1,0,ISTAT)
               ENDIF
            ENDIF

            IF(PREFIX.NE.' ') THEN
               CALL GTPWCS(IRD,PREFIX,WCSOUT,CTYPE1,CTYPE2,ISTAT)
            ELSE
               CALL GETWCS(IRD,WCSOUT,CTYPE1,CTYPE2,ISTAT)
            ENDIF

            IF(ISTAT.NE.0) THEN
               CALL UMSPUT(
     : '! Unable to get WCS from reference image',
     :                     1,0,ISTAT)
               GO TO 99
            ENDIF

C Get the dimensions and use them
            CALL UIMGID(IRD,DATTYP,NDIMS,DDIMS,ISTAT)
            IF(NDIMS.NE.2) THEN
               CALL UMSPUT(
     :   '! Reference image is not two dimensional',
     :                          1,0,ISTAT)
               GO TO 99
            ELSE
               NXOUT=DDIMS(1)
               NYOUT=DDIMS(2)
            ENDIF
         ELSE

C If there is no output image then we read the output WCS from the
C user supplied values and convert to a WCS representation
            CALL SETWCS(OUTSCL,ORIENT,XREFP,RACEN,
     :                  YREFP,DECCEN,WCSOUT)
            CALL UMSPUT(
     : '-Defining output WCS from user-specified parameters',
     :      1,0,ISTAT)

         ENDIF
      ENDIF
      
C Convert the secondary parameters into suitable units
      ROT2=ROT2*PI/180.0

      IF(SHFR2.eq.'input') THEN
         ROTF2=.FALSE.
      ELSE
         ROTF2=.TRUE.
      ENDIF

C Give a warning message if secondary parameters will have an effect
      IF(XSCALE.NE.1.0D0 .OR. YSCALE.NE.1.0D0 .OR.
     :   XSH2.NE.0.0D0 .OR. YSH2.NE.0.0D0 .OR. ROT2.NE.0.0D0) THEN
       IF(.NOT.SILENT) CALL UMSPUT(
     : '! Warning, secondary geometric transform is being used',
     :               1,0,ISTAT)
        SECPAR=.TRUE.
      ELSE
        SECPAR=.FALSE.
      ENDIF

      IF(SHFTFR.EQ.'input') THEN
         ROTFIR=.FALSE.
      ELSE
         ROTFIR=.TRUE.
      ENDIF

      IF(SHFTUN.EQ.'output') THEN
         XSH=XSH*SCALE
         YSH=YSH*SCALE
      ENDIF

C Get the geometric distortion coefficient information
C Note that an input image is not always available so 
C coeffs="header"  or coeffs="wcs" may fail
      CALL GETGEO(COEFFS,IRD,LAM,
     :            COTY,COMAX,CONUM,XCO,YCO,ISTAT)
      IF(ISTAT.NE.0) THEN
         CALL UMSPUT(
     :  '! WTRAXY: Error, failed to get distortion coefficients',
     :  1,0,ISTAT)
          GO TO 99
      ENDIF

C  Read in any distortion image corrections, if specified
C  PXG,PYG will default to 2x2 arrays when DISIM returns as FALSE.
C 
      CALL GGEOIM(XGEOIM,YGEOIM,PXG,PYG,XGDIM,YGDIM,DISIM)

C Also get the chip size - in and out
C Not needed for GEOMOD='wcs'
      IF(.NOT.USEWCS) THEN
         CALL UCLGSI('nxin',NXIN,ISTAT)
         CALL UCLGSI('nyin',NYIN,ISTAT)
      ENDIF

      IF(.NOT.USEWCS .AND. OUTIM.EQ.' ') THEN
         CALL UCLGSI('nxout',NXOUT,ISTAT)
         CALL UCLGSI('nyout',NYOUT,ISTAT)
      ENDIF

C Convert to radians
      ROT=ROT*PI/180.0D0

C Either we have a list of X,Y positions or a single one
      CALL UCLGST('xylist',XYLIST,ISTAT)
      IF(XYLIST.NE.' ') THEN
         CALL UFOPEN(XYLIST,1,LUN,ISTAT)
         IF(ISTAT.NE.0) THEN
            CALL UMSPUT('! Unable to open xylist file',1,0,
     :                  ISTAT)
            ISTAT=1
            RETURN
         ELSE
            CALL UMSPUT('-Opening xylist file: '//XYLIST,
     :                      1,0,ISTAT)
         ENDIF
      ENDIF

C Get the X,Y pixel position to be transformed 
      IF(XYLIST.EQ.' ') THEN
         CALL UCLGSD('xin',XIN,ISTAT)
         CALL UCLGSD('yin',YIN,ISTAT)
      ENDIF

C Transform the position
C Note that this is exactly the same as that in Drizzle
C Double precision version
      DO WHILE(.TRUE.)

         IF(XYLIST.NE.' ') THEN
            CALL UFGLIN(LUN,LINE,ISTAT)
            IF(ISTAT.NE.0) GO TO 88
            READ(LINE,*) XIN,YIN
         ENDIF
         
         IF(NINT(XIN).GT.1 .AND. NINT(XIN).LT.NXIN-1 .AND.
     :         NINT(YIN).GT.1 .AND. NINT(YIN).LT.NYIN-1) THEN

            CALL DRIVAL(XIN,YIN,1,NXIN,NYIN,NXOUT,NYOUT,.FALSE.,
     :            XSH,YSH,ROT,SCALE,ALIGN,ROTFIR,
     :            SECPAR,XSH2,YSH2,ROT2,XSCALE,YSCALE,SHFR2,ROTF2,
     :            USEWCS,WCSIN,WCSOUT,
     :            COTY,CONUM,XCO,YCO,
     :            DISIM,MEMR(PXG),MEMR(PYG),XGDIM,YGDIM,XOUT,YOUT,
     :            ALPHA,BETA)
         ELSE 
            CALL DRIVAL(XIN,YIN,1,NXIN,NYIN,NXOUT,NYOUT,.FALSE.,
     :            XSH,YSH,ROT,SCALE,ALIGN,ROTFIR,
     :            SECPAR,XSH2,YSH2,ROT2,XSCALE,YSCALE,SHFR2,ROTF2,
     :            USEWCS,WCSIN,WCSOUT,
     :            COTY,CONUM,XCO,YCO,
     :            .FALSE.,MEMR(PXG),MEMR(PYG),XGDIM,YGDIM,XOUT,YOUT,
     :            ALPHA,BETA)
         ENDIF

C Transform a unit square to calculate the pixel area
         X(1)=XIN-0.5D0
         X(2)=XIN+0.5D0
         X(3)=XIN+0.5D0
         X(4)=XIN-0.5D0
         Y(1)=YIN-0.5D0
         Y(2)=YIN-0.5D0
         Y(3)=YIN+0.5D0
         Y(4)=YIN+0.5D0

         CALL DRIVAL(X,Y,4,NXIN,NYIN,NXOUT,NYOUT,.FALSE.,
     :            0.0D0,0.0D0,0.0D0,1.0D0,ALIGN,ROTFIR,
     :            .FALSE.,0.0D0,0.0D0,0.0D0,1.0D0,1.0D0,SHFR2,ROTF2,
     :            .FALSE.,WCSIN,WCSOUT,
     :            COTY,CONUM,XCO,YCO,
     :            .FALSE.,MEMR(PXG),MEMR(PYG),XGDIM,YGDIM,XO,YO,
     :            ALPHA,BETA)

         PAM=DABS(0.5*((XO(2)-XO(4))*(YO(1)-YO(3)) -
     :              (XO(1)-XO(3))*(YO(2)-YO(4))))

C Write out the result
         IF(.NOT.SILENT) THEN
            WRITE(CHARS,
     :  '('' Xin,Yin: '',2F12.5'' Xout,Yout: '',2F12.5,
     :    '' PAM: '',F12.5)')
     : XIN,YIN,XOUT,YOUT,PAM
            CALL UMSPUT(CHARS,1,0,ISTAT)

C If in WCS mode also report the sky position
            IF(USEWCS) THEN
               CALL XY2RD(XOUT,YOUT,RA,DEC,WCSOUT)
               WRITE(CHARS,
     : '('' RA: '',F12.7,'' Dec: '',F12.7,'' (deg)'')')
     :    RA,DEC
               CALL UMSPUT(CHARS,1,0,ISTAT)
            ENDIF
         ENDIF

         IF(XYLIST.EQ.' ') GO TO 88
      ENDDO

 88   CONTINUE

C Also write the result to the CL
      IF(XYLIST.EQ.' ') THEN
         CALL UCLPSD('xout',XOUT,ISTAT)
         CALL UCLPSD('yout',YOUT,ISTAT)
      ELSE
         CALL UFCLOS(LUN,ISTAT)
      ENDIF

C Image creation support
      CALL UCLGST('outxim',OUTXIM,ISTAT)
      CALL UCLGST('outyim',OUTYIM,ISTAT)

C Skip this if not image option
      IF(OUTXIM.EQ.' ' .AND. OUTYIM.EQ.' ') GO TO 99

      DDIMS(1)=NXIN
      DDIMS(2)=NYIN

C Check for huge images
      IF(NXIN.GT.MAXBUF .OR. NYIN.GT.MAXBUF) THEN
         CALL UMSPUT('! Image too large for output image option',
     :               1,0,ISTAT)
         GO TO 99
      ENDIF

C Create images if not null
      IF(OUTXIM.NE.' ') THEN
         CALL UIMCRE(OUTXIM,6,2,DDIMS,IDX,ISTAT)
         IF(ISTAT.NE.0) THEN
            CALL UMSPUT('! Failed to created output X image',
     :                  1,0,ISTAT)
            GO TO 99
         ELSE
            CALL UMSPUT('-Created output X position image: '//
     :                  OUTXIM,1,0,ISTAT)
         ENDIF
      ENDIF

      IF(OUTYIM.NE.' ') THEN
         CALL UIMCRE(OUTYIM,6,2,DDIMS,IDY,ISTAT)
         IF(ISTAT.NE.0) THEN
            CALL UMSPUT('! Failed to created output Y image',
     :                  1,0,ISTAT)
            GO TO 99
         ELSE
            CALL UMSPUT('-Created output Y position image: '//
     :                  OUTYIM,1,0,ISTAT)
         ENDIF
      ENDIF

C Loop over the input image grid
C We are going to use the "regular" feature so need to
C initialise some things
      XIA(1)=1.0D0
      XIA(2)=0.0D0
      YIA(2)=0.0D0

      DO J=1,NYIN
         YIA(1)=DBLE(J)

         CALL DRIVAL(XIA,YIA,NXIN,NXIN,NYIN,NXOUT,NYOUT,.TRUE.,
     :            XSH,YSH,ROT,SCALE,ALIGN,ROTFIR,
     :            SECPAR,XSH2,YSH2,ROT2,XSCALE,YSCALE,SHFR2,ROTF2,
     :            USEWCS,WCSIN,WCSOUT,
     :            COTY,CONUM,XCO,YCO,
     :            DISIM,MEMR(PXG),MEMR(PYG),XGDIM,YGDIM,XOA,YOA,
     :            ALPHA,BETA)

C Copy to single precision
         DO I=1,NXIN
            XOAS(I)=SNGL(XOA(I))
            YOAS(I)=SNGL(YOA(I))
         ENDDO

C Write out the lines
         IF(OUTXIM.NE.' ') CALL UIPL2R(IDX,J,XOAS,ISTAT)
         IF(OUTYIM.NE.' ') CALL UIPL2R(IDY,J,YOAS,ISTAT)
      ENDDO

C Close the files
      IF(OUTXIM.NE.' ') CALL UIMCLO(IDX,ISTAT)
      IF(OUTYIM.NE.' ') CALL UIMCLO(IDY,ISTAT)

C End of main TRAXY module
 99   CONTINUE

C If allocated, free the distortion image memory
      IF(PXG.NE.0) CALL UDMFRE(PXG,6,ISTAT)
      IF(PYG.NE.0) CALL UDMFRE(PYG,6,ISTAT)

      RETURN
      END

      SUBROUTINE DOBLOT(DATA,NDAT,INTYPE,SINSCL,KSCALE,MISVAL,
     :     XMIN,XMAX,YMIN,YMAX,DNX,DNY,
     :     ROTFIR,EF,ALIGN,ONX,ONY,COTY,CONUM,XCO,YCO,
     :     DISIM,PXG,PYG,PXDIM,PYDIM,
     :     XIN,YIN,XOUT,YOUT,
     :     SCALE,ROT,XSH,YSH,USEWCS,WCSIN,WCSOUT,
     :     GEOMOD,SECPAR,XSH2,YSH2,ROT2,XSCALE,YSCALE,SHFR2,ROTF2, 
     :     ALPHA,BETA)
C
C This routine does the interpolation of the input array
C In version 1.0 and later this is done using the standard DRIVAL
C routine in drutil.f.
C
C Note - when running in WBLOT mode this routine uses the WCS
C        values but has to supply them the other way around to DRIVAL.
C
      IMPLICIT NONE

      INTEGER DNX,DNY,ONX,ONY
      INTEGER I,J,NMISS,ISTAT
      INTEGER LX,LY,INTYPE
      INTEGER XMAX,XMIN,YMAX,YMIN
      REAL DATA(XMAX-XMIN+1,YMAX-YMIN+1),V
      REAL NDAT(ONX,ONY)
      DOUBLE PRECISION XCEN,YCEN,DX,DY
      INTEGER COTY,CONUM
      DOUBLE PRECISION XCO(CONUM),YCO(CONUM)
      DOUBLE PRECISION WCSIN(8),WCSOUT(8)
      DOUBLE PRECISION XOUT(ONX),YOUT(ONX),XIN(ONX),YIN(ONX),YV
      DOUBLE PRECISION ALPHA, BETA
      REAL XO,YO
      REAL MISVAL,KSCALE,SINSCL
      REAL NRIEVL,EF,S2
      CHARACTER*80 CHARS
      LOGICAL ROTFIR
      LOGICAL SECPAR
      LOGICAL ROTF2 
      LOGICAL USEWCS

C Standard geometrical parameters set
      DOUBLE PRECISION SCALE,ROT,XSH,YSH,SCALL,SCDIS
      DOUBLE PRECISION XSH2,YSH2,ROT2,XSCALE,YSCALE
      CHARACTER*8 SHFR2,ALIGN,GEOMOD
      INTEGER PXDIM,PYDIM
      REAL PXG(PXDIM,PYDIM),PYG(PXDIM,PYDIM)
      LOGICAL DISIM

C Space for Lanczos-style look-up-tables
      INTEGER NLUT,NBOX
      PARAMETER (NLUT=2048)
      REAL LANLUT(NLUT),GINTER
      REAL SPACE,SPK,KS2
      PARAMETER (SPACE=0.01)
C--

C Some initial settings - note that the reference pixel
C is offset from the "centre":
C
      NMISS=0

C If we need a LUT calculate one here first
      IF(INTYPE.EQ.100) THEN
         CALL FILALU(3,NLUT,SPACE,LANLUT)
      ELSE IF(INTYPE.EQ.105) THEN
         CALL FILALU(5,NLUT,SPACE,LANLUT)
      ENDIF

C In the WCS case we can't use the scale to calculate the
C Jacobian so we need to do it
C
C Note that we use the centre of the image rather than the
C reference pixel as the reference here
C
C This is taken from DOBOX except for the inversion of the image
C order

C This section applies in WBLOT mode and now contains the 
C addition correction to separate the distortion induced scale change
      IF(USEWCS) THEN
         CALL UMSPUT("USEWCS true...\n",1,0,ISTAT)

         IF(ALIGN.EQ.'corner') THEN
            XCEN=DBLE(ONX/2.0)+0.5
            YCEN=DBLE(ONY/2.0)+0.5
         ELSE
            XCEN=DBLE(ONX/2.0)+1.0
            YCEN=DBLE(ONY/2.0)+1.0
         ENDIF

         XIN(1)=XCEN
         XIN(2)=XCEN
         XIN(3)=XCEN+1.0D0
         XIN(4)=XCEN+1.0D0
         YIN(1)=YCEN
         YIN(2)=YCEN+1.0D0
         YIN(3)=YCEN+1.0D0
         YIN(4)=YCEN

         CALL DRIVAL(XIN,YIN,4,ONX,ONY,DNX,DNY,.FALSE.,
     :            XSH,YSH,ROT,SCALE,ALIGN,ROTFIR,
     :            SECPAR,XSH2,YSH2,ROT2,XSCALE,YSCALE,SHFR2,ROTF2,
     :            USEWCS,WCSOUT,WCSIN,
     :            COTY,CONUM,XCO,YCO,DISIM,
     :            PXG,PYG,PXDIM,PYDIM,XOUT,YOUT,
     :            ALPHA, BETA)

         SCALL=SQRT(1.0D0/ABS(0.5D0*
     :              ((XOUT(2)-XOUT(4))*(YOUT(1)-YOUT(3)) -
     :              (XOUT(1)-XOUT(3))*(YOUT(2)-YOUT(4)))))

C Now calculate how much of this is from the geometric distortion
         XSH=0.D00
         YSH=0.D00
         ROT=0.D00
         SCALE=1.D00
         SECPAR=.FALSE.
         USEWCS=.FALSE.

         CALL DRIVAL(XIN,YIN,4,ONX,ONY,DNX,DNY,.FALSE.,
     :            XSH,YSH,ROT,SCALE,ALIGN,ROTFIR,
     :            SECPAR,XSH2,YSH2,ROT2,XSCALE,YSCALE,SHFR2,ROTF2,
     :            USEWCS,WCSOUT,WCSIN,
     :            COTY,CONUM,XCO,YCO,DISIM,
     :            PXG,PYG,PXDIM,PYDIM,
     :            XOUT,YOUT, ALPHA, BETA)

         SCDIS=SQRT(1.0D0/
     :            ABS(0.5D0*((XOUT(2)-XOUT(4))*(YOUT(1)-YOUT(3)) -
     :              (XOUT(1)-XOUT(3))*(YOUT(2)-YOUT(4)))))

         USEWCS=.TRUE.
         SCALE=SCALL/SCDIS
      ENDIF

C Image subset size
      LX=XMAX-XMIN+1
      LY=YMAX-YMIN+1

C Offsets
      DX=DBLE(XMIN-1)
      DY=DBLE(YMIN-1)

C Recalculate the area scaling factor
      S2=FLOAT(SCALE*SCALE)

C Some useful numbers
      SPK=SPACE*KSCALE
      IF(INTYPE.EQ.100) THEN
         NBOX=NINT(3.0/KSCALE)
      ELSE IF(INTYPE.EQ.105) THEN
         NBOX=NINT(5.0/KSCALE)
      ENDIF

      IF(INTYPE.GE.100) KS2=1.0/(KSCALE*KSCALE)

C Outer loop over output image pixels (X,Y)
      DO J=1,ONY
         YV=DBLE(J)
       
C Set the X and Y start positions
         XIN(1)=1.0D0
         YIN(1)=YV
         XIN(2)=0.0D0
         YIN(2)=0.0D0

C Transform this vector
         CALL DRIVAL(XIN,YIN,ONX,ONX,ONY,DNX,DNY,.TRUE.,
     :            XSH,YSH,ROT,SCALE,ALIGN,ROTFIR,
     :            SECPAR,XSH2,YSH2,ROT2,XSCALE,YSCALE,SHFR2,ROTF2,
     :            USEWCS,WCSOUT,WCSIN,
     :            COTY,CONUM,XCO,YCO,DISIM,
     :            PXG,PYG,PXDIM,PYDIM,XOUT,YOUT, ALPHA, BETA)

C Loop through the output positions and do the interpolation
         DO I=1,ONX

            XO=SNGL(XOUT(I)-DX)
            YO=SNGL(YOUT(I)-DY)

C Check it is on the input image
            IF(XO.GE.1.0 .AND. XO.LE.REAL(LX) .AND.
     :         YO.GE.1.0 .AND. YO.LE.REAL(LY)) THEN

C Check for look-up-table interpolation
               IF(INTYPE.GE.100) THEN
                  V=GINTER(XO,YO,DATA,LX,LY,LANLUT,NLUT,
     :                     SPK,NBOX,MISVAL)*KS2
               ELSE

C Do the interpolation
C and allow for stretching because of scale change
C Also, use callable version of from INTER2D.F.
C
                  V=NRIEVL(XO,YO,DATA,LX,LY,LX,INTYPE,SINSCL)
               ENDIF

               NDAT(I,J)=V*EF/S2
            ELSE

C If there is nothing for us then set the output to missing
C value flag
               NDAT(I,J)=MISVAL

C Count cases where the pixel is off the output image
               NMISS=NMISS+1
            ENDIF
         ENDDO
      ENDDO

C Report number of points which were outside the input frame
      IF(NMISS.GT.0) THEN
       WRITE(CHARS,'(''! Warning, '',I7,'' points were outside '','//
     :                '''the output image.'')') NMISS
         CALL UMSPUT(CHARS,1,0,ISTAT)
      ENDIF

C Finally we need to update the WCS using the standard routine
C modified to work in the "blot direction"
C
C Not needed for WBLOT
      IF(.NOT.USEWCS) THEN
         CALL BUPWCS(WCSIN,WCSOUT,DNX,DNY,ONX,ONY,
     :            XSH,YSH,ROT,SCALE,ALIGN,ROTFIR,
     :            SECPAR,XSH2,YSH2,ROT2,XSCALE,YSCALE,SHFR2,ROTF2,
     :            USEWCS,COTY,CONUM,XCO,YCO,DISIM,PXG,PYG,PXDIM,PYDIM,
     :            ALPHA,BETA)
      ENDIF

      RETURN
      END

      SUBROUTINE STEEP
C
C STEEP - evaluate the absolute maximum gradient around a pixel
C         by comparing with the four neighboring pixels.
C
C  This is a reimplementation of the "deriv" task in STSDAS/dither.
C
C   Richard Hook, ST-ECF/ESO, October 2002
C
      IMPLICIT NONE

      CHARACTER*80 INFILE,OUTFILE
      INTEGER ID,IDO,ISTAT,DATTYP,DIMS(7),NDIMS,NX,NY,LATEST

      INTEGER MAXLIN
      PARAMETER (MAXLIN=100000)
      REAL BUFF1(MAXLIN)
      REAL BUFF2(MAXLIN)
      REAL BUFF3(MAXLIN)
      REAL DER(MAXLIN)

      INTEGER I,J

C Get the names of the input and output
      CALL UCLGST('data',INFILE,ISTAT)
      CALL UCLGST('deriv',OUTFILE,ISTAT)
     
C Try to open them
      CALL UIMOPN(INFILE,2,ID,ISTAT)
      IF(ISTAT.NE.0) THEN
         CALL UMSPUT('! Unable to open input image file',
     :               1,0,ISTAT)
         GO TO 99
      ENDIF

C Get the size and shape
      CALL UIMGID(ID,DATTYP,NDIMS,DIMS,ISTAT)
      IF(NDIMS.NE.2) THEN
         CALL UMSPUT('! Unable to open input image file',
     :               1,0,ISTAT)
         GO TO 99
      ENDIF

      NX=DIMS(1)
      NY=DIMS(2)

C Create the output
      CALL UIMCRE(OUTFILE,6,2,DIMS,IDO,ISTAT)
      IF(ISTAT.NE.0) THEN
         CALL UMSPUT('! Unable to open input image file',
     :               1,0,ISTAT)
         GO TO 99
      ENDIF

C Initialise buffers
      CALL ZAPLIN(BUFF1,NX)
      CALL ZAPLIN(BUFF2,NX)
      CALL ZAPLIN(BUFF3,NX)
      CALL ZAPLIN(DER,NX)

C Write out the first line
      CALL UIPL2R(ID,1,DER,ISTAT)

C Read the first lines
      CALL UIGL2R(ID,1,BUFF1,ISTAT)
      CALL UIGL2R(ID,2,BUFF2,ISTAT)

      LATEST=3

C Loop through the image line by line
      DO J=3,NY-1

C Read a new line
         IF(LATEST.EQ.3) THEN
            CALL UIGL2R(ID,J,BUFF3,ISTAT)

            DO I=2,NX-1
               DER(I)=MAX(ABS(BUFF1(I)-BUFF2(I)),
     :                    ABS(BUFF3(I)-BUFF2(I)),
     :                    ABS(BUFF2(I-1)-BUFF2(I)),
     :                    ABS(BUFF2(I)-BUFF2(I+1)))
            ENDDO
            LATEST=1

         ELSE IF(LATEST.EQ.1) THEN
            CALL UIGL2R(ID,J,BUFF1,ISTAT)

            DO I=2,NX-1
               DER(I)=MAX(ABS(BUFF1(I)-BUFF3(I)),
     :                    ABS(BUFF3(I)-BUFF2(I)),
     :                    ABS(BUFF3(I-1)-BUFF3(I)),
     :                    ABS(BUFF3(I)-BUFF3(I+1)))
            ENDDO
            LATEST=2

         ELSE IF(LATEST.EQ.2) THEN
            CALL UIGL2R(ID,J,BUFF2,ISTAT)

            DO I=2,NX-1
               DER(I)=MAX(ABS(BUFF1(I)-BUFF2(I)),
     :                    ABS(BUFF3(I)-BUFF1(I)),
     :                    ABS(BUFF1(I-1)-BUFF1(I)),
     :                    ABS(BUFF1(I)-BUFF1(I+1)))
            ENDDO
            LATEST=3
         ENDIF

C Write out the buffer
         CALL UIPL2R(IDO,J-1,DER,ISTAT)
      ENDDO

C Write a final empty line
      CALL ZAPLIN(DER,NX)
      CALL UIPL2R(IDO,NY,DER,ISTAT)

C Close the images
      CALL UIMCLO(ID,ISTAT)
      CALL UIMCLO(IDO,ISTAT)

 99   CONTINUE
      RETURN
      END

      SUBROUTINE ZAPLIN(A,N)
C
C Set a one-dimensional array to 0.0
C
      IMPLICIT NONE
     
      INTEGER I,N 
      REAL A(N)

      DO I=1,N
         A(I)=0.0
      ENDDO

      END

C DRUTIL.F
C
C Utility routines for Drizzle and Blot
C
C These routines should call only themselves, without reliance on
C IRAF/STSDAS f77/vos.  Those routines will be found in 'ioutil.f'.
C   Exceptions: UIGL2R (in DOBOX)
C
C We need to revise GETGEO to read xgeoim/ygeoim images using 
C   non-IRAF f77/vos routines as needed for callable version.
C   The 'wcs' option for coeffs (reading Spitzer-style coeffs from
C   header) also needs to be implemented without using f77/vos 
C   routines.  This will probably require writing replacements for
C   the f77/vos routines to be put in 'drcall.f' that do not use f77/vos.
C
C Original version for DRIZZLE 3.3 and BLOT 3.3, December 2003
C Richard Hook, ST-ECF/ESO
C
C This version modified for callable and STSDAS DRIZZLE simultaneously 
C Warren Hack, STScI, 17-June-2004 
C
C History:
C
C The module GOLDH was transferred from drizzle as it is also
C now needed by blot.
C
C WCS routines added (XY2RD & RD2XY), September 1998
C
C Modified GTCOEF routine to also handle STIS and NICMOS,
C    January 1999
C
C Added additional code for reversing the cubic transformation added
C  June 1999
C
C Major extensions and some routines transferred from the EIS utilities
C collection (for context handling), October 2000
C
C Extensive modifications for a more flexible geometric coefficients
C scheme, changes in calling sequences, December 2000
C
C April 2003 - added code for checking overlaps with output images
C and minimising unnecessary drizzling (CHOVER).
C
C Added double precision version of several routines for more precision.
C  Richard Hook, ST-ECF/ESO/STScI, June 2003
C
C Full conversion to double precision (for geometry, not data values)
C   Richard Hook, ST-ECF/ESO/STScI, October 2003
C
C Modifications to support "refpix" contruct in distortion files
C   Richard Hook, ST-ECF/ESO/STScI, December 2003
C WCSLIN was modified to use all coefficients in the evaluation.
C Image center is calculated with floating point precision.
C   Nadia Dencheva, July 2006
C
      SUBROUTINE SETIM(A,NX,NY,V)
C
C Set a 2D array to a specified value 
C
C SINGLE PRECISION routine.
C
      IMPLICIT NONE

      INTEGER NX,NY
      REAL A(NX,NY),V

      INTEGER I,J

      DO J=1,NY
         DO I=1,NX
            A(I,J)=V
         ENDDO
      ENDDO

      RETURN
      END

      SUBROUTINE MULC(A,NX,NY,V)
C
C Multiply a 2D REAL array by a specified value
C
C SINGLE PRECISION routine.
C
      IMPLICIT NONE

      INTEGER NX,NY
      REAL A(NX,NY),V

      INTEGER I,J

      DO J=1,NY
         DO I=1,NX
            A(I,J)=A(I,J)*V
         ENDDO
      ENDDO

      RETURN
      END

      SUBROUTINE COPYIM(IN,OUT,NX,NY)
C
C Simply copy a REAL array into another
C
C SINGLE PRECISION routine.
C
      IMPLICIT NONE

      INTEGER NX,NY
      REAL IN(NX,NY),OUT(NX,NY)

      INTEGER I,J

      DO J=1,NY
         DO I=1,NX
            OUT(I,J)=IN(I,J)
         ENDDO
      ENDDO

      RETURN
      END

      DOUBLE PRECISION FUNCTION EVAL3(X,Y,CO)
C
C Evaluate a cubic geometric distortion in 2d
C
      IMPLICIT NONE

      DOUBLE PRECISION X,Y,CO(*)

      EVAL3=CO(1)+
     :      CO(2)*X+
     :      CO(3)*Y+
     :      CO(4)*X*X+
     :      CO(5)*X*Y+
     :      CO(6)*Y*Y+
     :      CO(7)*X*X*X+
     :      CO(8)*X*X*Y+
     :      CO(9)*X*Y*Y+
     :      CO(10)*Y*Y*Y 

      RETURN
      END

      DOUBLE PRECISION FUNCTION EVAL4(X,Y,CO)
C
C Evaluate a 4th order (quartic) geometric distortion in 2d
C
      IMPLICIT NONE

      DOUBLE PRECISION X,Y,CO(*)

      EVAL4=CO(1)+
     :      CO(2)*X+
     :      CO(3)*Y+
     :      CO(4)*X*X+
     :      CO(5)*X*Y+
     :      CO(6)*Y*Y+
     :      CO(7)*X*X*X+
     :      CO(8)*X*X*Y+
     :      CO(9)*X*Y*Y+
     :      CO(10)*Y*Y*Y+
     :      CO(11)*X*X*X*X+
     :      CO(12)*X*X*X*Y+
     :      CO(13)*X*X*Y*Y+
     :      CO(14)*X*Y*Y*Y+
     :      CO(15)*Y*Y*Y*Y

      RETURN
      END

      DOUBLE PRECISION FUNCTION EVAL5(X,Y,CO)
C
C Evaluate a 5th order geometric distortion in 2d
C
      IMPLICIT NONE

      DOUBLE PRECISION X,Y,CO(*)

      EVAL5=CO(1)+
     :      CO(2)*X+
     :      CO(3)*Y+
     :      CO(4)*X*X+
     :      CO(5)*X*Y+
     :      CO(6)*Y*Y+
     :      CO(7)*X*X*X+
     :      CO(8)*X*X*Y+
     :      CO(9)*X*Y*Y+
     :      CO(10)*Y*Y*Y+
     :      CO(11)*X*X*X*X+
     :      CO(12)*X*X*X*Y+
     :      CO(13)*X*X*Y*Y+
     :      CO(14)*X*Y*Y*Y+
     :      CO(15)*Y*Y*Y*Y+
     :      CO(16)*X*X*X*X*X+
     :      CO(17)*X*X*X*X*Y+
     :      CO(18)*X*X*X*Y*Y+
     :      CO(19)*X*X*Y*Y*Y+
     :      CO(20)*X*Y*Y*Y*Y+
     :      CO(21)*Y*Y*Y*Y*Y

      RETURN
      END

      DOUBLE PRECISION FUNCTION EVALN(X,Y,CO,ORDER)
C
C Evaluate the value of a general 2d polynomial in X and Y
C complete with "half" cross-terms.
C
C For orders lower than 7 it is slightly more efficient to
C use the specific (poly4 etc) routines instead.
C
C Richard Hook, ST-ECF, February 2002
C
      IMPLICIT NONE

      INTEGER ORDER
      DOUBLE PRECISION X,Y,CO(*)

      INTEGER N,M,NC
      DOUBLE PRECISION T

      T=0.0
      NC=1

      DO N=1,ORDER+1
         DO M=1,N
            T=T+CO(NC)*X**(N-M)*Y**(M-1)
            NC=NC+1
         ENDDO
      ENDDO

      EVALN=T
      RETURN
      END

      SUBROUTINE RAD3(X,Y,CO,XO,YO)
C
C Evaluate a 3rd order radial geometric distortion in 2d
C X version. Note that there is no zero order coefficient
C as this is physically meaningless.
C
      IMPLICIT NONE

      DOUBLE PRECISION X,Y,XO,YO,R,F,CO(*)

      R=DSQRT(X*X+Y*Y)

      F=1.0D0+CO(1)+CO(2)*R+CO(3)*R*R
      XO=F*X
      YO=F*Y

      RETURN
      END
      

      SUBROUTINE GETCO(LUN,LAM,COTY,COMAX,CONUM,XCO,YCO,ISTAT)
C
C Read geometric distortion coefficients in free format
C from a text file which has already been opened and return them.
C
C If there is a problem reading the numbers then the status flag will be
C returned as 1. If all is well it will be returned
C as 0.
C
C This routine caused problems with SUN SPARC SC4 compilers and was
C modified to avoid them. March 1997
C
C Modified to handle higher-order terms in addition.
C   December 2000
C
C Modified to also support the "refpix" specification at the start of the
C coefficients files to allow the reference point for the distortion to
C be decoupled from the center of the image.
C   December 2003
C
      IMPLICIT NONE

      INTEGER LUN,ISTAT,I,J
      CHARACTER*80 LINE,CHARS
      CHARACTER*1024 BUFFER
      DOUBLE PRECISION LAM,MGF2,N
      DOUBLE PRECISION A,B,C
      INTEGER COTY,COMAX,CONUM
      DOUBLE PRECISION XCO(COMAX),YCO(COMAX)

C Different reference pixel support
      LOGICAL NEWREF
      INTEGER COOFF
      PARAMETER (COOFF=100)
      DOUBLE PRECISION XDREF,YDREF

C By default no different reference point
      NEWREF=.FALSE.

C Skip blank lines and those beginning with # until we find a label
      DO WHILE(.TRUE.)
         CALL UFGLIN(LUN,LINE,ISTAT)
         IF(ISTAT.NE.0) GO TO 99

         IF(LINE.NE.' ' .AND. LINE(1:1).NE.'#') THEN

C First "Trauger" style coefficients - 60 of them
            IF(LINE(1:7).EQ.'trauger') THEN

C Now we need to calculate the coefficients which are a
C function of wavelength
               N=MGF2(LAM)

C Now we loop through extracting the coefficients, 3 per line,
C and calculating the wavelength dependence
               J=1
               DO WHILE(J.LE.20)
                  CALL UFGLIN(LUN,LINE,ISTAT)
                  IF(ISTAT.NE.0) GO TO 99

                  IF(LINE.NE.' ' .AND. LINE(1:1).NE.'#') THEN
                     READ(LINE,*,IOSTAT=ISTAT) A,B,C          
                     IF(ISTAT.NE.0) GO TO 99

                     IF(J.LE.10) THEN
                        XCO(J)=A+B*(N-1.5)+C*(N-1.5)**2
                     ELSE
                        YCO(J-10)=A+B*(N-1.5)+C*(N-1.5)**2
                     ENDIF

                     J=J+1
                  ENDIF
               ENDDO

               COTY=3
               CONUM=10
               ISTAT=0
               GO TO 99

C Next "cubic" style - 20 coefficients
            ELSE IF(LINE(1:5).EQ.'cubic' .OR. 
     :              LINE(1:5).EQ.'poly3') THEN

C Copy the rest of the file into a buffer ready for a free-format
C read operation
               CALL BFILL(LUN,BUFFER,ISTAT)

               CONUM=10
               IF(ISTAT.EQ.0) THEN
                 READ(BUFFER,*,IOSTAT=ISTAT) 
     :           (XCO(I),I=1,CONUM),(YCO(I),I=1,CONUM)
               ENDIF
               IF(ISTAT.NE.0) GO TO 99

               COTY=3
               ISTAT=0
               GO TO 99

C Now 4th order - 30 coefficients
            ELSE IF(LINE(1:5).EQ.'poly4' .OR. 
     :              LINE(1:7).EQ.'quartic') THEN

               CALL BFILL(LUN,BUFFER,ISTAT)

               CONUM=15
               IF(ISTAT.EQ.0) THEN
                 READ(BUFFER,*,IOSTAT=ISTAT) 
     :           (XCO(I),I=1,CONUM),(YCO(I),I=1,CONUM)
               ENDIF
               IF(ISTAT.NE.0) GO TO 99

               COTY=4
               ISTAT=0
               GO TO 99

C Now 5th order - 42 coefficients
            ELSE IF(LINE(1:5).EQ.'poly5' .OR. 
     :              LINE(1:7).EQ.'quintic') THEN

               CALL BFILL(LUN,BUFFER,ISTAT)

               CONUM=21
               IF(ISTAT.EQ.0) THEN
                 READ(BUFFER,*,IOSTAT=ISTAT) 
     :           (XCO(I),I=1,CONUM),(YCO(I),I=1,CONUM)
               ENDIF
               IF(ISTAT.NE.0) GO TO 99

               COTY=5
               ISTAT=0
               GO TO 99

C Higher orders (>5)
            ELSE IF(LINE(1:4).EQ.'poly') THEN

C First find the order by reading the rest of the line
               READ(LINE(5:80),*) COTY
               CONUM=(COTY+1)*(COTY+2)/2

               CALL BFILL(LUN,BUFFER,ISTAT)

               IF(ISTAT.EQ.0) THEN
                 READ(BUFFER,*,IOSTAT=ISTAT)
     :           (XCO(I),I=1,CONUM),(YCO(I),I=1,CONUM)
               ENDIF
               IF(ISTAT.NE.0) GO TO 99

               ISTAT=0
               GO TO 99

C Next third-order radial polynomial   
            ELSE IF(LINE(1:6).EQ.'radial' .OR.
     :              LINE(1:4).EQ.'rad3') THEN

C Copy the rest of the file into a buffer ready for a free-format
C read operation
               CALL BFILL(LUN,BUFFER,ISTAT)

               CONUM=3 
               IF(ISTAT.EQ.0) THEN
                 READ(BUFFER,*,IOSTAT=ISTAT)
     :           (XCO(I),I=1,CONUM)
               ENDIF
               IF(ISTAT.NE.0) GO TO 99

               COTY=-3
               ISTAT=0
               GO TO 99

C Optionally there may be a line with a different centre position
            ELSE IF(LINE(1:6).EQ.'refpix') THEN

               READ(LINE(7:80),*,IOSTAT=ISTAT) XDREF,YDREF
               IF(ISTAT.NE.0) THEN
                  CALL UMSPUT(
     : '! Invalid reference pixel specification in coefficients file',
     :                     1,0,ISTAT)
                  ISTAT=1
                  GO TO 99
               ELSE
                  NEWREF=.TRUE.
          WRITE(CHARS,
     : '(''-Using distortion reference point: ['',
     : F10.4,'','',F10.4,'']'')')
     :    XDREF,YDREF
                  CALL UMSPUT(CHARS,1,0,ISTAT)
               ENDIF

            ELSE
               CALL UMSPUT('! Unknown coefficient set type',
     :                     1,0,ISTAT)
               ISTAT=1
               GO TO 99
            ENDIF
         ENDIF
      ENDDO

99    CONTINUE

C If we have a modified reference pixel we encode this in the standard
C coefficients by adding an offset and incrementing the number of coefficients
C by one
      IF(NEWREF) THEN
         COTY=COTY+COOFF
         CONUM=CONUM+1
         XCO(CONUM)=XDREF
         YCO(CONUM)=YDREF
      ENDIF

      RETURN
      END

      DOUBLE PRECISION FUNCTION MGF2(LAM)
C
C Calculate the refractive index of MgF2 for a given
C wavelength (in nm) using the formula given by Trauger (1995)
C
      IMPLICIT NONE

      DOUBLE PRECISION LAM,SIG

      SIG=1.0D7/LAM

      MGF2=SQRT(1.0 + 2.590355D10/(5.312993D10-SIG*SIG) 
     :              + 4.4543708D9/(11.17083D9-SIG*SIG) 
     :              + 4.0838897D5/(1.766361D5-SIG*SIG))

      RETURN
      END

      SUBROUTINE PUTFIL(DAT,COU,ONX,ONY,FILVAL)
C
C Put in the missing filling value where the weight is
C zero
C
C SINGLE PRECISION routine.
C
      IMPLICIT NONE

      INTEGER ONX,ONY
      REAL DAT(ONX,ONY),COU(ONX,ONY),FILVAL

      INTEGER I,J

      DO J=1,ONY
         DO I=1,ONX
            IF(COU(I,J).EQ.0.0) DAT(I,J)=FILVAL
         ENDDO
      ENDDO
   
      RETURN
      END

      SUBROUTINE INMAT(P,Q,R,S)
C
C Invert a 2 by 2 double precision matrix
C in place. It assumes that the matrix is not
C singular.
C
      IMPLICIT NONE

      DOUBLE PRECISION P,Q,R,S
      DOUBLE PRECISION A,B,C,D,DET

      DET=P*S-Q*R

      A=S/DET
      B=-Q/DET
      C=-R/DET
      D=P/DET

      P=A
      Q=B
      R=C
      S=D

      RETURN
      END

      SUBROUTINE XY2RD(X,Y,R,D,WCS)
C
C XY2RD - convert a pixel position to an equatorial (RA,DEC)
C         position assuming a TAN projection and WCS with the
C         standard 8 elements.
C
C It is based on the xy2rd task in STSDAS
C
C Output angles are in degrees
C
C Richard Hook, STScI, 11th August 1998
C
      IMPLICIT NONE

      DOUBLE PRECISION X,Y,R,D,WCS(8)
      DOUBLE PRECISION XI,ETA,RA0,DEC0

      DOUBLE PRECISION PIBY
      PARAMETER (PIBY=3.141592653589793/180.0)

C First convert pixel coordinates to tangent plane in radians
      XI=(WCS(5)*(X-WCS(1))+WCS(7)*(Y-WCS(3)))*PIBY
      ETA=(WCS(6)*(X-WCS(1))+WCS(8)*(Y-WCS(3)))*PIBY

C And convert the reference point on the sky to radians
      RA0=WCS(2)*PIBY
      DEC0=WCS(4)*PIBY

C Now go to equatorial from tangent plane
      R=ATAN2(XI, COS(DEC0)-ETA*SIN(DEC0)) + RA0
      D=ATAN2(ETA*COS(DEC0)+SIN(DEC0),
     :        SQRT((COS(DEC0)-ETA*SIN(DEC0))**2 + XI**2))

C Convert back to degrees and check the range
      R=R/PIBY
      D=D/PIBY
      IF(R.LT.0.0) R=R+360.0

      RETURN
      END

      SUBROUTINE RD2XY(R,D,X,Y,WCS,ISTAT)
C
C RD2XY - convert an equatorial (RA,DEC) position to a pixel position
C         assuming a TAN projection and WCS with the
C         standard 8 elements.
C
C It is based on the rd2xy task in STSDAS
C
C Input angles are in degrees
C
C Richard Hook, STScI, 13th August 1998
C
      IMPLICIT NONE

      INTEGER ISTAT
      DOUBLE PRECISION X,Y,R,D,WCS(8),RA,DEC
      DOUBLE PRECISION XI,ETA,RA0,DEC0
      DOUBLE PRECISION DET,CDINV(2,2),BOTTOM
      DOUBLE PRECISION PIBY
      PARAMETER (PIBY=3.141592653589793/180.0)

C First invert the CD matrix
      DET=WCS(5)*WCS(8)-WCS(7)*WCS(6)

      IF(DET.EQ.0.0) THEN
         ISTAT=1
         RETURN
      ENDIF

      CDINV(1,1)=WCS(8)/DET
      CDINV(1,2)=-WCS(7)/DET
      CDINV(2,1)=-WCS(6)/DET
      CDINV(2,2)=WCS(5)/DET

C Translate from RA,Dec to X,Y
      RA0=WCS(2)*PIBY
      DEC0=WCS(4)*PIBY

      RA=R*PIBY
      DEC=D*PIBY

      BOTTOM=SIN(DEC)*SIN(DEC0)+COS(DEC)*COS(DEC0)*COS(RA-RA0)
      IF(BOTTOM.EQ.0) THEN
         ISTAT=1
         RETURN
      ENDIF

C Calculate tangent plane position and convert to degrees
      XI=COS(DEC)*SIN(RA-RA0)/BOTTOM/PIBY
      ETA=(SIN(DEC)*COS(DEC0)-COS(DEC)*SIN(DEC0)*COS(RA-RA0))/
     :     BOTTOM/PIBY

C Convert back to pixels using the inverse of the CD matrix
      X=CDINV(1,1)*XI+CDINV(1,2)*ETA+WCS(1)
      Y=CDINV(2,1)*XI+CDINV(2,2)*ETA+WCS(3)

      ISTAT=0
      RETURN
      END

      SUBROUTINE WCSLIN(WCSIN,WCSOUT,
     :            XCEN,YCEN,COTY,CONUM,
     :        XCO,YCO,DISIM,XG,YG,NX,NY,XC,YC,XS,YS,XT,YT)
C
C WCSLIN - derive best linear transformation coefficients to map
C          pixel positions from one world coordinate system to another.
C
C Supplied:
C
C  WCSIN - double precision 8 element array. The WCS of the input image.
C          This includes CRPIX1/2, CRVAL1/2 and a CD matrix.
C
C  WCSOUT - double precision 8 element array. The WCS of the output image.
C          This includes CRPIX1/2, CRVAL1/2 and a CD matrix.
C
C  XCEN,YCEN - double precision, the centre of the chip, for reference
C
C  COTY,CONUM - coefficients type code and number of coefficients
C
C  XCO,YCO - double arrays, the non-linear distortion coefficients
C
C DISIM,XG,YG,NX,NY - distortion image support
C
C Returned:
C
C XC,YC,XS,YS,XT,YT - doubles, linear transformation coefficients
C
C   Richard Hook, 18th September 1998
C   Modified for more general coefficients and changed calling
C   sequence, December 2000
C
C  Further modification to try to handle ACS images with big distortions
C  and offsets. January 2001.
C
C Modified for better accuracy by greater use of double precision
C values. November 2002.
C
C Modified to ignore distortion images - ie, to assume that they do
C not have a global effect.
C    Richard Hook, STScI/ECF, September 2003
C
C Added support for "refpix" offsets,
C    Richard Hook, STScI/ECF, December 2003
C
C Used a smaller range of offset for double precision version
C to minimise effects of nonlinear terms.
C   Richard Hook, STScI/ECF, January 2004
C
      IMPLICIT NONE

C Input parameters
      DOUBLE PRECISION WCSIN(8),WCSOUT(8)
      INTEGER COTY,CONUM,COOFF
      PARAMETER (COOFF=100)
      DOUBLE PRECISION XCO(CONUM),YCO(CONUM),XCEN,YCEN
      DOUBLE PRECISION XDREF,YDREF,XDOFF,YDOFF
      DOUBLE PRECISION EVAL3,EVAL4,EVAL5,EVALN

      INTEGER NX,NY
      LOGICAL DISIM,NEWREF
      REAL XG(NX,NY),YG(NX,NY)

C Output parameters
      DOUBLE PRECISION XC,YC,XS,YS,XT,YT

C Local variables
      DOUBLE PRECISION RA,DEC
      DOUBLE PRECISION XIN(4),YIN(4),XOUT(4),YOUT(4)
      DOUBLE PRECISION X0,Y0,A,B,C,D
      DOUBLE PRECISION PIBY
      DOUBLE PRECISION X(4),Y(4)
      INTEGER I,ISTAT,SCOTY

      PARAMETER (PIBY=180.0/3.14159265359)

C First check for the presence of "refpix" additional information
C in the coefficients
C If it is set a flag and offset again
      IF(COTY.GT.COOFF/2) THEN
         NEWREF=.TRUE.
         COTY=COTY-COOFF
         XDREF=XCO(CONUM)
         YDREF=YCO(CONUM)
         CONUM=CONUM-1
      ELSE
         NEWREF=.FALSE.
      ENDIF

C Set up a square at the reference pixel of the input
C image (WCSIN(1)=CRPIX1 and WCSIN(3)=CRPIX2)
      XIN(1)=WCSIN(1)    
      XIN(2)=WCSIN(1)    
      XIN(3)=WCSIN(1)+1.0D0
      XIN(4)=WCSIN(1)+1.0D0 
      YIN(1)=WCSIN(3)     
      YIN(2)=WCSIN(3)+1.0D0
      YIN(3)=WCSIN(3)+1.0D0
      YIN(4)=WCSIN(3)  
         
C Transform these points onto the sky and then back out again
C using the target WCS - all double precision
      DO I=1,4
         CALL XY2RD(XIN(I),YIN(I),RA,DEC,WCSIN)
         CALL RD2XY(RA,DEC,XOUT(I),YOUT(I),WCSOUT,ISTAT)
      ENDDO

C Check for different reference pixel
      IF(NEWREF) THEN
         XDOFF=XCEN-XDREF
         YDOFF=YCEN-YDREF
      ELSE
         XDOFF=0.0D0
         YDOFF=0.0D0
      ENDIF

C Now we apply the geometric distortion to the input points so that
C the linear transformation which we derive is appropriate after
C the distortion is corrected
C
C Just use LINEAR terms

      SCOTY=COTY

C
C  Why limit the evaluation to only linear terms???
C  This fit is only a linear fit, therefore, only linear terms
C  need to be considered.  When all terms are used, it introduces
C  slight non-orthogonality of the CD matrix after correction, as
C  well as additional offsets between the chips.  AK, WJH  1-Aug-2006
C
      IF(COTY.GT.1) COTY=1

      DO I=1,4
       IF(COTY.EQ.3) THEN
        X(I)=EVAL3(XIN(I)-XCEN+XDOFF,YIN(I)-YCEN+YDOFF,XCO)-XDOFF
        Y(I)=EVAL3(XIN(I)-XCEN+XDOFF,YIN(I)-YCEN+YDOFF,YCO)-YDOFF
       ELSE IF(COTY.EQ.4) THEN
        X(I)=EVAL4(XIN(I)-XCEN+XDOFF,YIN(I)-YCEN+YDOFF,XCO)-XDOFF
        Y(I)=EVAL4(XIN(I)-XCEN+XDOFF,YIN(I)-YCEN+YDOFF,YCO)-YDOFF
       ELSE IF(COTY.EQ.5) THEN
        X(I)=EVAL5(XIN(I)-XCEN+XDOFF,YIN(I)-YCEN+YDOFF,XCO)-XDOFF
        Y(I)=EVAL5(XIN(I)-XCEN+XDOFF,YIN(I)-YCEN+YDOFF,YCO)-YDOFF
       ELSE IF(COTY.GE.6 .OR. COTY.EQ.1 .OR. COTY.EQ.2) THEN
        X(I)=EVALN(XIN(I)-XCEN+XDOFF,YIN(I)-YCEN+YDOFF,XCO,COTY)-XDOFF
        Y(I)=EVALN(XIN(I)-XCEN+XDOFF,YIN(I)-YCEN+YDOFF,YCO,COTY)-YDOFF
       ELSE IF(COTY.EQ.-3) THEN
        CALL RAD3(XIN(I)-XCEN+XDOFF,YIN(I)-YCEN+YDOFF,XCO,X(I),Y(I))
        X(I)=X(I)-XDOFF
        Y(I)=Y(I)-YDOFF
       ELSE
        X(I)=XIN(I)-XCEN
        Y(I)=YIN(I)-YCEN
       ENDIF
      ENDDO

C Restore order
      COTY=SCOTY

C Now we have the inputs and outputs and can derive the linear
C transform between them
C This is now done in a general way using least squares
C Double precision version

      CALL FITLIN(XOUT,YOUT,X,Y,4,X0,Y0,A,B,C,D,ISTAT)

      IF(ISTAT.NE.0) THEN
         CALL UMSPUT('! Failed to determine mapping from WCS',
     :               1,0,ISTAT)
         ISTAT=1
         RETURN
      ENDIF

C We change a sign here to fit in with convention later
      B=-B 

C And now the linear offset
      XT=XOUT(1)-A*X(1)+B*Y(1)
      YT=YOUT(1)-C*X(1)-D*Y(1)

      XC=A
      YS=B
      XS=C
      YC=D

C Before returning reset the offsets, if there are any
      IF(NEWREF) THEN
         COTY=COTY+COOFF
         CONUM=CONUM+1
      ENDIF

      RETURN
      END

      SUBROUTINE SETWCS(OUTSCL,ORIENT,CRPIX1,CRVAL1,
     :                  CRPIX2,CRVAL2,WCS)
C
C SETWCS - convert a scale and orientation, along with
C          reference pixel and position on sky, to a WCS
C          including a CD matrix.
C
C Note: OUTSCL is in arcsecs/pix, ORIENT and CRVAL1/2
C       are in degrees.
C
C Richard Hook, 22nd September 1998
C
C Full double precision version - Richard Hook,ST-ECF/STScI June 2003
C
      IMPLICIT NONE

C Supplied:
      DOUBLE PRECISION OUTSCL,ORIENT
      DOUBLE PRECISION CRPIX1,CRPIX2,CRVAL1,CRVAL2

C Returned:
      DOUBLE PRECISION WCS(8)

C Local variables
      DOUBLE PRECISION PIBY,ROR,DSC
      PARAMETER (PIBY=3.14159265358979/180.0)

C Convert to radians for orientation
      ROR=ORIENT*PIBY

C and to degrees for scale
      DSC=OUTSCL/3600.0D0

C Set reference points
      WCS(1)=CRPIX1
      WCS(3)=CRPIX2
      WCS(2)=CRVAL1
      WCS(4)=CRVAL2

C and CD matrix (no skew, equal X,Y scales)
      WCS(5)=-DSC*DCOS(ROR)
      WCS(6)=DSC*DSIN(ROR)
      WCS(7)=WCS(6) 
      WCS(8)=-WCS(5)       

      RETURN
      END

      SUBROUTINE COPY1D(IN,OUT,N)
C
C Copy a 1d real array from one place to another.
C
C SINGLE PRECISION routine.
C
      IMPLICIT NONE

      INTEGER N
      REAL IN(*),OUT(*)

      INTEGER I

      DO I=1,N
         OUT(I)=IN(I)
      ENDDO
 
      RETURN
      END

      SUBROUTINE LCORN(DNX,DNY,ONX,ONY,
     :           XSH,YSH,ROT,SCALE,ALIGN,ROTFIR,
     :           SECPAR,XSH2,YSH2,ROT2,XSCALE,YSCALE,SHFR2,ROTF2,
     :           USEWCS,WCSIN,WCSOUT,
     :           COTY,CONUM,XCO,YCO,DISIM,PXG,PYG,XGDIM,YGDIM,
     :           XMIN,XMAX,YMIN,YMAX,ISTAT, ALPHA, BETA)
 
C
C LCORN - transform the range of input pixel coordinates covered
C         by an image onto the output and find the extreme values.
C
C Modified to also pass the secondary geometric parameters,
C  Richard Hook, STScI, July 2000
C
C Added SECPAR parameter, Sept 2000
C
C Added check of the border and just 5 pixel margin, October 2000
C
C Added more general coefficient support, December 2000
C
      IMPLICIT NONE

      INTEGER DNX,DNY,ONX,ONY
      DOUBLE PRECISION XSH,YSH,ROT,SCALE
      LOGICAL ROTFIR,USEWCS,SECPAR
      CHARACTER*8 ALIGN
      DOUBLE PRECISION WCSIN(8),WCSOUT(8)
      INTEGER COTY,CONUM
      INTEGER XGDIM,YGDIM
      REAL PXG(XGDIM,YGDIM),PYG(XGDIM,YGDIM)
      DOUBLE PRECISION XCO(CONUM),YCO(CONUM)
      INTEGER XMIN,XMAX,YMIN,YMAX,ISTAT,I
      DOUBLE PRECISION XIN(16),YIN(16)
      DOUBLE PRECISION XOUT(16),YOUT(16),XMA,YMA,XMI,YMI

C Secondary geometrical parameters, added in V1.5
      DOUBLE PRECISION XSH2,YSH2,ROT2,XSCALE,YSCALE
	  DOUBLE PRECISION ALPHA, BETA
      CHARACTER*8 SHFR2
      LOGICAL ROTF2,DISIM

      REAL MEMR(1)
      COMMON /MEM/MEMR

      XIN(1)=1.0
      XIN(2)=1.0
      XIN(3)=DBLE(DNX)
      XIN(4)=DBLE(DNX)
      YIN(1)=1.0
      YIN(2)=DBLE(DNY)
      YIN(3)=DBLE(DNY)
      YIN(4)=1.0
      
C Transform onto output coordinate system
      CALL DRIVAL(XIN,YIN,4,DNX,DNY,ONX,ONY,.FALSE.,
     :            XSH,YSH,ROT,SCALE,ALIGN,ROTFIR,
     :            SECPAR,XSH2,YSH2,ROT2,XSCALE,YSCALE,SHFR2,ROTF2,
     :            USEWCS,WCSIN,WCSOUT,
     :            COTY,CONUM,XCO,YCO,DISIM,
     :            PXG,PYG,XGDIM,YGDIM,XOUT,YOUT,ALPHA,BETA)

C Calculate the extreme values
      XMA=MAX(XOUT(1),XOUT(2),XOUT(3),XOUT(4))
      YMA=MAX(YOUT(1),YOUT(2),YOUT(3),YOUT(4))
      XMI=MIN(XOUT(1),XOUT(2),XOUT(3),XOUT(4))
      YMI=MIN(YOUT(1),YOUT(2),YOUT(3),YOUT(4))

C Now check a few more points on the edges
      DO I=1,4
         XIN(I)=DBLE(I)*DBLE(DNX)/5.0D0
         YIN(I)=1.0D0
         XIN(I+4)=XIN(I)
         YIN(I+4)=DBLE(DNY)
         XIN(I+8)=1.0
         YIN(I+8)=DBLE(I)*DBLE(DNY)/5.0D0
         XIN(I+12)=DBLE(DNX)
         YIN(I+12)=YIN(I+8)
      ENDDO

      CALL DRIVAL(XIN,YIN,16,DNX,DNY,ONX,ONY,.FALSE.,
     :            XSH,YSH,ROT,SCALE,ALIGN,ROTFIR,
     :            SECPAR,XSH2,YSH2,ROT2,XSCALE,YSCALE,SHFR2,ROTF2,
     :            USEWCS,WCSIN,WCSOUT,
     :            COTY,CONUM,XCO,YCO,DISIM,
     :            PXG,PYG,XGDIM,YGDIM,XOUT,YOUT, ALPHA, BETA)

      DO I=1,16
         IF(XOUT(I).GT.XMA) XMA=XOUT(I)
         IF(YOUT(I).GT.YMA) YMA=YOUT(I)
         IF(XOUT(I).LT.XMI) XMI=XOUT(I)
         IF(YOUT(I).LT.YMI) YMI=YOUT(I)
      ENDDO
 
C Calculate limits allowing for a 5 pixel margin of error
      XMAX=NINT(XMA+5.0D0)
      XMIN=NINT(XMI-5.0D0)
      YMAX=NINT(YMA+5.0D0)
      YMIN=NINT(YMI-5.0D0)

      ISTAT=0
      RETURN
      END

      SUBROUTINE DRIVAL(XIN,YIN,N,DNX,DNY,ONX,ONY,REG,
     :            XSH,YSH,ROT,SCALE,ALIGN,ROTFIR,
     :            SECPAR,XSH2,YSH2,ROT2,XSCALE,YSCALE,SHFR2,ROTF2,
     :            USEWCS,WCSIN,WCSOUT,
     :            COTY,CONUM,XCO,YCO,DISIM,XG,YG,XGDIM,YGDIM,
     :            XOUT,YOUT, ALPHA, BETA)
C
C DRIVAL - apply the standard Drizzle transformation
C          from input to output pixel coordinates.
C          This may optional include a polynomial
C          distortion solution or be specified using
C          input and output WCS. It replaces the
C          logic originally in the DOBOX routine within Drizzle.
C
C  Richard Hook, ST-ECF, 5th October 1998
C   
C Modified to include the secondary geometric transformation,
C  Richard Hook, STScI, July 2000
C
C Added SECPAR logical flag, Sept 2000
C 
C Added more general coefficients, December 2000
C Used COTY to define the transformation and remove NONLIN
C Added EVAL4/5 for higher order options
C
C Added the new "REG" parameter (logical) which decides whether
C the input X and Y are simply at steps of 1.0 in X (starting at
C the value supplied) and with Y constant at the value supplied.
C This is a new feature for Drizzle V2.7 intended to avoid some
C numerical precision problems and increase efficiency.
C   Richard Hook, ST-ECF, February 2002
C
C Added distortion image support (XG,YG), 
C    Richard Hook, ST-ECF/STScI, August 2003
C
C Added "refpix" support using higher values of COTY,
C    Richard Hook, ST-ECF/STScI, December 2003
C
C Added time dependent distortion solution based upon
C    parameters ALPHA and BETA.
C    Christopher Hanley, STSCI, September 2007

      IMPLICIT NONE
      INTEGER N,DNX,DNY,ONX,ONY,I
      LOGICAL REG
      DOUBLE PRECISION XIN(N),YIN(N),XOUT(N),YOUT(N)
      DOUBLE PRECISION XCEN,YCEN,XF,YF,XCORN,YCORN
      DOUBLE PRECISION ALPHA, BETA
      DOUBLE PRECISION XSH,YSH,ROT,SCALE
      INTEGER COTY,CONUM,COOFF,IX,IY
      PARAMETER (COOFF=100)
      LOGICAL NEWREF
      DOUBLE PRECISION XCO(CONUM),YCO(CONUM)
      INTEGER XGDIM,YGDIM
      REAL XG(XGDIM,YGDIM),YG(XGDIM,YGDIM)
      DOUBLE PRECISION XS,XC,YS,YC,X,Y,XD,YD,XDOFF,YDOFF
      DOUBLE PRECISION EVAL3,EVAL4,EVAL5,EVALN     
      DOUBLE PRECISION SINTH,COSTH,XOFF,YOFF,XT,YT,XP,YP
      LOGICAL ROTFIR,USEWCS,SECPAR,DISIM
      CHARACTER*8 ALIGN
      DOUBLE PRECISION WCSIN(8),WCSOUT(8),XDREF,YDREF

      INTEGER COMAX
      PARAMETER (COMAX=100)

C Secondary geometrical parameters, added in V1.5
      DOUBLE PRECISION XSH2,YSH2,ROT2,XSCALE,YSCALE
      CHARACTER*8 SHFR2
      LOGICAL ROTF2
      DOUBLE PRECISION XUT,YUT,XC2,XS2,YC2,YS2,XT2,YT2,XP2,YP2
      DOUBLE PRECISION SINTH2,COSTH2
      
C--
      IF(ALIGN.EQ.'corner') THEN
         XCEN=DBLE(DNX/2.0)+0.5
         YCEN=DBLE(DNY/2.0)+0.5
      ELSE
         XCEN=DBLE(DNX/2.0)+1.0
         YCEN=DBLE(DNY/2.0)+1.0
      ENDIF

C Calculate some numbers to simplify things later
      SINTH=DSIN(ROT)
      COSTH=DCOS(ROT)
 
C The shifts are in units of INPUT pixels.
      XOFF=XSH/SCALE
      YOFF=YSH/SCALE
      XF=1.0D0/SCALE
      YF=1.0D0/SCALE
 
C Some more economies
      XS=XF*SINTH
      XC=XF*COSTH
      YS=YF*SINTH
      YC=YF*COSTH

C Secondary ones
      IF(SECPAR) THEN
         SINTH2=DSIN(ROT2)
         COSTH2=DCOS(ROT2)
         XS2=SINTH2
         XC2=COSTH2
         YS2=SINTH2
         YC2=COSTH2
      ENDIF
 
      IF(ALIGN.EQ.'corner') THEN
         XP=DBLE(ONX/2.0)+0.5D0
         YP=DBLE(ONY/2.0)+0.5D0
      ELSE
         XP=DBLE(ONX/2.0)+1.0D0
         YP=DBLE(ONY/2.0)+1.0D0
      ENDIF
 
      XT=XOFF+XP
      YT=YOFF+YP

C Set the secondary ones
      IF(SECPAR) THEN
         XP2=XP
         YP2=YP
         XT2=XP2+XSH2
         YT2=YP2+YSH2
      ENDIF


C Here is some new code to support the WCS option
C first we work out a linear transformation from input to
C out
      IF(USEWCS) THEN            
         CALL WCSLIN(WCSIN,WCSOUT,
     :         XCEN,YCEN,COTY,CONUM,
     :         XCO,YCO,DISIM,XG,YG,XGDIM,YGDIM,
     :         XC,YC,XS,YS,XT,YT)

         ROTFIR=.TRUE.

      ENDIF

C Check for the presence of "refpix" additional information
C in the coefficients
C If it is, set a flag and offset again
      IF(COTY.GT.COOFF/2) THEN
         NEWREF=.TRUE.
         COTY=COTY-COOFF
         XDREF=XCO(CONUM)
         YDREF=YCO(CONUM)
         XDOFF=XCEN-XDREF
         YDOFF=YCEN-YDREF
         CONUM=CONUM-1
      ELSE
         NEWREF=.FALSE.
         XDOFF=0.0
         YDOFF=0.0
      ENDIF

C We consider the case of "regular" and not-regular separately.
C Regular means that the X positions are spaced at intervals of
C one pixel (starting at XIN(1)) and the Y's are all equal to Y(1)
C
C XIN(2) and YIN(2) are used for offsets
      IF(REG) THEN

C The case of secondary parameters is also separated
C to avoid excessive calculations

C First the case with secondary parameters
      IF(SECPAR) THEN

C Note that there is an extra -1 here because it is added again
C for the first point
       X=XSCALE*(XIN(1)-1.0D0-XCEN)
       Y=YSCALE*(YIN(1)+YIN(2)-YCEN)



       DO I=1,N
         X=X+XSCALE

         IF(COTY.EQ.3) THEN
            XCORN=EVAL3(X+XDOFF,Y+YDOFF,XCO)-XDOFF
            YCORN=EVAL3(X+XDOFF,Y+YDOFF,YCO)-YDOFF
         ELSE IF(COTY.EQ.4) THEN
            XCORN=EVAL4(X+XDOFF,Y+YDOFF,XCO)-XDOFF
            YCORN=EVAL4(X+XDOFF,Y+YDOFF,YCO)-YDOFF
         ELSE IF(COTY.EQ.5) THEN
            XCORN=EVAL5(X+XDOFF,Y+YDOFF,XCO)-XDOFF
            YCORN=EVAL5(X+XDOFF,Y+YDOFF,YCO)-YDOFF
         ELSE IF(COTY.GE.6 .OR. COTY.EQ.1 .OR. COTY.EQ.2) THEN
            XCORN=EVALN(X+XDOFF,Y+YDOFF,XCO,COTY)-XDOFF
            YCORN=EVALN(X+XDOFF,Y+YDOFF,YCO,COTY)-YDOFF
         ELSE IF(COTY.EQ.-3) THEN
            CALL RAD3(X+XDOFF,Y+YDOFF,XCO,XCORN,YCORN)
            XCORN=XCORN-XDOFF
            YCORN=YCORN-YDOFF
         ELSE
            XCORN=X
            YCORN=Y
         ENDIF

C If we have a distortion image we add here
         IF(DISIM) THEN
            IX=INT(X+XCEN)
            IY=INT(Y+YCEN)
            XCORN=XCORN+DBLE(XG(IX,IY))
            YCORN=YCORN+DBLE(YG(IX,IY))
         ENDIF
		 
	   XCORN = XCORN + BETA*(XCORN-XCEN)/XCEN +
     :                 ALPHA*(YCORN-YCEN)/YCEN
       YCORN = YCORN - BETA*(YCORN-YCEN)/YCEN +
     :                 ALPHA*(XCORN-XCEN)/XCEN

         
C Apply the linear transform
C There are two ways this can be done - shift then
C rotate or rotate then shift
         IF(ROTFIR) THEN
            XUT=XC*XCORN-YS*YCORN+XT-XP
            YUT=XS*XCORN+YC*YCORN+YT-YP
         ELSE
            XUT=XC*(XCORN+XSH)-YS*(YCORN+YSH)
            YUT=XS*(XCORN+XSH)+YC*(YCORN+YSH)
         ENDIF

C Apply the secondary transform
         IF(ROTF2) THEN
            XOUT(I)=XC2*XUT-YS2*YUT+XT2
            YOUT(I)=XS2*XUT+YC2*YUT+YT2
         ELSE
            XOUT(I)=XC2*(XUT+XSH2)-YS2*(YUT+YSH2)+XP2
            YOUT(I)=XS2*(XUT+XSH2)+YC2*(YUT+YSH2)+YP2
         ENDIF
        ENDDO

C and now without secondary parameters
      ELSE

C Note again the extra 1.0 here!
C In this case there are some tricks to force the result to be
C the same as for V1.41 - XIN(1) and YIN(2) are used for the
C offsets
C
C Note that XIN and YIN are used differently!
       X=-XCEN
       XD=XIN(1)-1.0D0
       Y=YIN(1)-YCEN
       YD=YIN(2)

       DO I=1,N
         X=X+1.0D0

         IF(COTY.EQ.3) THEN
            XCORN=EVAL3(X+XD+XDOFF,Y+YD+YDOFF,XCO)-XDOFF
            YCORN=EVAL3(X+XD+XDOFF,Y+YD+YDOFF,YCO)-YDOFF
         ELSE IF(COTY.EQ.4) THEN
            XCORN=EVAL4(X+XD+XDOFF,Y+YD+YDOFF,XCO)-XDOFF
            YCORN=EVAL4(X+XD+XDOFF,Y+YD+YDOFF,YCO)-YDOFF
         ELSE IF(COTY.EQ.5) THEN
            XCORN=EVAL5(X+XD+XDOFF,Y+YD+YDOFF,XCO)-XDOFF
            YCORN=EVAL5(X+XD+XDOFF,Y+YD+YDOFF,YCO)-YDOFF
         ELSE IF(COTY.GE.6 .OR. COTY.EQ.1 .OR. COTY.EQ.2) THEN
            XCORN=EVALN(X+XD+XDOFF,Y+YD+YDOFF,XCO,COTY)-XDOFF
            YCORN=EVALN(X+XD+XDOFF,Y+YD+YDOFF,YCO,COTY)-YDOFF
         ELSE IF(COTY.EQ.-3) THEN
            CALL RAD3(X+XD+XDOFF,Y+YD+YDOFF,XCO,XCORN,YCORN)
            XCORN=XCORN-XDOFF
            YCORN=YCORN-YDOFF
         ELSE
            XCORN=X+XD
            YCORN=Y+YD
         ENDIF

C If we have a distortion image we add here
C (missing XD,YD offsets corrected, January 2006)
C (Removed the offsets because they cause a segfault, March, 2006)
         IF(DISIM) THEN
            IX=INT(X+XCEN)
            IY=INT(Y+YCEN)
            XCORN=XCORN+DBLE(XG(IX,IY))
            YCORN=YCORN+DBLE(YG(IX,IY))
         ENDIF

	   XCORN = XCORN + BETA*(XCORN-XCEN)/XCEN +
     :                 ALPHA*(YCORN-YCEN)/YCEN
       YCORN = YCORN - BETA*(YCORN-YCEN)/YCEN +
     :                 ALPHA*(XCORN-XCEN)/XCEN

C Apply the linear transform
C There are two ways this can be done - shift then
C rotate or rotate then shift
         IF(ROTFIR) THEN
            XOUT(I)=XC*XCORN-YS*YCORN+XT
            YOUT(I)=XS*XCORN+YC*YCORN+YT
         ELSE
            XOUT(I)=XC*(XCORN+XSH)-YS*(YCORN+YSH)+XP
            YOUT(I)=XS*(XCORN+XSH)+YC*(YCORN+YSH)+YP
         ENDIF
        ENDDO
       ENDIF
      ELSE

C The case of secondary parameters is also separated
C to avoid excessive calculations

C First the case with secondary parameters
       IF(SECPAR) THEN
        DO I=1,N
         X=XSCALE*(XIN(I)-XCEN)
         Y=YSCALE*(YIN(I)-YCEN)

         IF(COTY.EQ.3) THEN
            XCORN=EVAL3(X+XDOFF,Y+YDOFF,XCO)-XDOFF
            YCORN=EVAL3(X+XDOFF,Y+YDOFF,YCO)-YDOFF
         ELSE IF(COTY.EQ.4) THEN
            XCORN=EVAL4(X+XDOFF,Y+YDOFF,XCO)-XDOFF
            YCORN=EVAL4(X+XDOFF,Y+YDOFF,YCO)-YDOFF
         ELSE IF(COTY.EQ.5) THEN
            XCORN=EVAL5(X+XDOFF,Y+YDOFF,XCO)-XDOFF
            YCORN=EVAL5(X+XDOFF,Y+YDOFF,YCO)-YDOFF
         ELSE IF(COTY.GE.6 .OR. COTY.EQ.1 .OR. COTY.EQ.2) THEN
            XCORN=EVALN(X+XDOFF,Y+YDOFF,XCO,COTY)-XDOFF
            YCORN=EVALN(X+XDOFF,Y+YDOFF,YCO,COTY)-YDOFF
         ELSE IF(COTY.EQ.-3) THEN
            CALL RAD3(X+XDOFF,Y+YDOFF,XCO,XCORN,YCORN)
            XCORN=XCORN-XDOFF
            YCORN=YCORN-YDOFF
         ELSE
            XCORN=X
            YCORN=Y
         ENDIF

C If we have a distortion image we add here
         IF(DISIM) THEN
            IX=INT(X+XCEN)
            IY=INT(Y+YCEN)
            XCORN=XCORN+DBLE(XG(IX,IY))
            YCORN=YCORN+DBLE(YG(IX,IY))
         ENDIF

	   XCORN = XCORN + BETA*(XCORN-XCEN)/XCEN +
     :                 ALPHA*(YCORN-YCEN)/YCEN
       YCORN = YCORN - BETA*(YCORN-YCEN)/YCEN +
     :                 ALPHA*(XCORN-XCEN)/XCEN

C Apply the linear transform
C There are two ways this can be done - shift then
C rotate or rotate then shift
         IF(ROTFIR) THEN
            XUT=XC*XCORN-YS*YCORN+XT-XP
            YUT=XS*XCORN+YC*YCORN+YT-YP
         ELSE
            XUT=XC*(XCORN+XSH)-YS*(YCORN+YSH)
            YUT=XS*(XCORN+XSH)+YC*(YCORN+YSH)
         ENDIF

C Apply the secondary transform
         IF(ROTF2) THEN
            XOUT(I)=XC2*XUT-YS2*YUT+XT2
            YOUT(I)=XS2*XUT+YC2*YUT+YT2
         ELSE
            XOUT(I)=XC2*(XUT+XSH2)-YS2*(YUT+YSH2)+XP2
            YOUT(I)=XS2*(XUT+XSH2)+YC2*(YUT+YSH2)+YP2
         ENDIF
        ENDDO

C and now without secondary parameters
      ELSE

       DO I=1,N
         X=XIN(I)-XCEN
         Y=YIN(I)-YCEN

         IF(COTY.EQ.3) THEN
            XCORN=EVAL3(X+XDOFF,Y+YDOFF,XCO)-XDOFF
            YCORN=EVAL3(X+XDOFF,Y+YDOFF,YCO)-YDOFF
         ELSE IF(COTY.EQ.4) THEN
            XCORN=EVAL4(X+XDOFF,Y+YDOFF,XCO)-XDOFF
            YCORN=EVAL4(X+XDOFF,Y+YDOFF,YCO)-YDOFF
         ELSE IF(COTY.EQ.5) THEN
            XCORN=EVAL5(X+XDOFF,Y+YDOFF,XCO)-XDOFF
            YCORN=EVAL5(X+XDOFF,Y+YDOFF,YCO)-YDOFF
         ELSE IF(COTY.GE.6 .OR. COTY.EQ.1 .OR. COTY.EQ.2) THEN
            XCORN=EVALN(X+XDOFF,Y+YDOFF,XCO,COTY)-XDOFF
            YCORN=EVALN(X+XDOFF,Y+YDOFF,YCO,COTY)-YDOFF
         ELSE IF(COTY.EQ.-3) THEN
            CALL RAD3(X+XDOFF,Y+YDOFF,XCO,XCORN,YCORN)
            XCORN=XCORN-XDOFF
            YCORN=YCORN-YDOFF
         ELSE
            XCORN=X
            YCORN=Y
         ENDIF


C If we have a distortion image we add here
         IF(DISIM) THEN
            IX=INT(X+XCEN)
            IY=INT(Y+YCEN)
            XCORN=XCORN+DBLE(XG(IX,IY))
            YCORN=YCORN+DBLE(YG(IX,IY))
         ENDIF
	   XCORN = XCORN + BETA*(XCORN-XCEN)/XCEN +
     :                 ALPHA*(YCORN-YCEN)/YCEN
       YCORN = YCORN - BETA*(YCORN-YCEN)/YCEN +
     :                 ALPHA*(XCORN-XCEN)/XCEN

C Apply the linear transform
C There are two ways this can be done - shift then
C rotate or rotate then shift
         IF(ROTFIR) THEN
            XOUT(I)=XC*XCORN-YS*YCORN+XT
            YOUT(I)=XS*XCORN+YC*YCORN+YT
         ELSE
            XOUT(I)=XC*(XCORN+XSH)-YS*(YCORN+YSH)+XP
            YOUT(I)=XS*(XCORN+XSH)+YC*(YCORN+YSH)+YP
         ENDIF
        ENDDO
       ENDIF
      ENDIF

C Before returning reset the offsets, if there are any
      IF(NEWREF) THEN
         COTY=COTY+COOFF
         CONUM=CONUM+1
      ENDIF

      RETURN
      END

      SUBROUTINE DERICU(X,Y,CO,DX,DY)
C
C Evaluate the derivatives of a cubic polynomial distortion with
C respect to X and Y. This is mainly for inverting the distortion
C using Newton-Raphson.
C
C Richard Hook, STScI, May 1999
C
      IMPLICIT NONE

      DOUBLE PRECISION X,Y,CO(*),DX,DY

      DX=CO(2)+
     :   2.0D0*CO(4)*X+
     :   CO(5)*Y+
     :   3.0D0*CO(7)*X*X+
     :   2.0D0*CO(8)*X*Y+
     :   CO(9)*Y*Y
 
      DY=CO(3)+
     :   CO(5)*X+
     :   2.0D0*CO(6)*Y+
     :   CO(8)*X*X+
     :   2.0D0*CO(9)*X*Y+
     :   3.0D0*CO(10)*Y*Y

      RETURN
      END

      SUBROUTINE INVECU(XOUT,YOUT,XCO,YCO,ERR,XIN,YIN)
C
C Invert a cubic distortion in 2d using Newton-Raphson
C
C Supplied:
C
C Xout,Yout - double - the output position from the geometric
C                     distortion.
C
C Xco,Yco - double arrays - the cubic distortion coefficients
C
C Err - double - the accuracy required of the inversion (in X and Y)
C
C Returned:
C
C Xin, Yin - double - the position which, when distorted, ends up
C                   at Xout,Yout to accuracy Err.
C
C This method is interative and relatively slow.
C
C Richard Hook, STScI, May 1999
C
      IMPLICIT NONE

      DOUBLE PRECISION XOUT,YOUT,XCO(*),YCO(*),XIN,YIN,ERR
      DOUBLE PRECISION DXX,DXY,DYX,DYY,XO,YO,X,Y,D
      DOUBLE PRECISION EVAL3
 
C First guess
      X=2.0D0*XOUT-EVAL3(XOUT,YOUT,XCO)
      Y=2.0D0*YOUT-EVAL3(XOUT,YOUT,YCO)

      DO WHILE(.TRUE.)

C Distort current guesses
         XO=EVAL3(X,Y,XCO)
         YO=EVAL3(X,Y,YCO)

C Check for error criterion
         IF(ABS(XOUT-XO).LT.ERR .AND.
     :   ABS(YOUT-YO).LT.ERR) GO TO 999

C Calculate derivatives - there are four of these
         CALL DERICU(X,Y,XCO,DXX,DXY)
         CALL DERICU(X,Y,YCO,DYX,DYY)

C Work out the determinant
         D=DXX*DYY-DYX*DXY

C Improve guess with Newton-Raphson
         X=X+((XOUT-XO)*DYY-(YOUT-YO)*DXY)/D
         Y=Y+((YOUT-YO)*DXX-(XOUT-XO)*DYX)/D
      ENDDO

 999  CONTINUE
      XIN=X
      YIN=Y

      RETURN
      END

      DOUBLE PRECISION FUNCTION OVER(I,J,XMIN,XMAX,YMIN,YMAX)
C
C OVER - calculate overlap between an arbitrary rectangle, aligned
C        with the axes, and a pixel.
C
C This is a simplified version of the BOXER code.
C
C Richard Hook, 6th May 1998
C
      IMPLICIT NONE

      INTEGER I,J
      DOUBLE PRECISION XMIN,XMAX,YMIN,YMAX

      DOUBLE PRECISION DX,DY

      DX=MIN(XMAX,DBLE(I)+0.5D0)-MAX(XMIN,DBLE(I)-0.5D0)
      DY=MIN(YMAX,DBLE(J)+0.5D0)-MAX(YMIN,DBLE(J)-0.5D0)

      IF(DX.GT.0 .AND. DY.GT.0) THEN
         OVER=DX*DY
      ELSE
         OVER=0.0D0
      ENDIF

      RETURN
      END

      SUBROUTINE COPY1I(IN,OUT,N)
C
C Copy a 1d integer array from one place to another.
C
      IMPLICIT NONE

      INTEGER N
      INTEGER IN(*),OUT(*)

      INTEGER I

      DO I=1,N
         OUT(I)=IN(I)
      ENDDO

      RETURN
      END

      SUBROUTINE UPCON(NCON,II,JJ,OLDCON,NEWCON,DONE,LX,LY,
     :                 INTAB,NEN,MAXIM,MAXEN,UNIQID,ISTAT)
C
C Update the context image
C
C This routine is called in the heart of Drizzle when the
C context image needs to be updated.
C
C October 2000 (from the EIS version)
C Added "bitmask" style context (16 bit), January 2001
C Converted to 32bit integers
C
      IMPLICIT NONE

      INTEGER ISTAT,K
      INTEGER MAXEN,MAXIM,NEN,ICON,NN,LX,LY
      INTEGER UNIQID,INTAB(MAXIM,MAXEN)
      INTEGER OLDCON,NEWCON
      INTEGER NEWMA(100),II,JJ
      INTEGER NCON(LX,LY)
      INTEGER DONE(LX,LY)
      LOGICAL MATCH
      CHARACTER*80 CHARS

C Look up the current context value
      ICON=NCON(II,JJ)

C If it is the same as the last one we don't need to
C go further
      IF(ICON.EQ.OLDCON) THEN
         NCON(II,JJ)=NEWCON
         GO TO 88
      ENDIF

C Combine with the new one
      IF(ICON.EQ.0) THEN
         NN=0
         NEWMA(1)=1
         NEWMA(2)=UNIQID
      ELSE
         NN=INTAB(1,ICON)

C Check for whether this image is already on this pixel
         DO K=3,NN+2
            IF(UNIQID.EQ.INTAB(K,ICON)) GO TO 88
         ENDDO

C If not create the new context by adding the current image
         NEWMA(1)=NN+1
         DO K=2,NN+1
            NEWMA(K)=INTAB(K+1,ICON)
         ENDDO

C Check for too many images at a given context
         IF(NN.GT.MAXIM-3) THEN
            CALL UMSPUT(
     :  '! Too many images - context table overloaded',
     :                  1,0,ISTAT)
            ISTAT=1
            RETURN
         ENDIF

         NEWMA(NN+2)=UNIQID
      ENDIF

C Before matching sort the context array
      IF(NN.GT.0) CALL CSORT(NN+1,NEWMA(2))

C See whether we have had this context before
      DO K=NEN,1,-1
         IF(MATCH(NEWMA,INTAB(1,K),MAXIM)) THEN
            NCON(II,JJ)=K
            GO TO 88
         ENDIF
      ENDDO

C No context match found - make a new one
      NEN=NEN+1

C Check for full table
      IF(NEN.EQ.MAXEN) THEN
         CALL UMSPUT('! Context table full',1,0,ISTAT)
         ISTAT=1
         RETURN
      ENDIF

      NCON(II,JJ)=NEN
      INTAB(1,NEN)=NEWMA(1)
      INTAB(2,NEN)=0
      DO K=3,NN+3
         INTAB(K,NEN)=NEWMA(K-1)
      ENDDO

C Tell the user about this new context
      IF(NN.LE.4) THEN
         WRITE(CHARS,'(''--New context #'',I5,
     :            '' | '',I4,'' images: '',
     :                   5I7)') NEN,(NEWMA(K),K=1,NN+2)
                  ELSE
         WRITE(CHARS,'(''--New context #'',I5,
     :            '' | '',I4,'' images: '',
     :                   5I7,''...'')') NEN,(NEWMA(K),K=1,6)

      ENDIF

      IF(NEWMA(1).EQ.1) CHARS(34:34)=' '

      CALL UMSPUT(CHARS,1,0,ISTAT)

 88   CONTINUE

C Save the old values for quick comparison
      OLDCON=ICON
      NEWCON=NCON(II,JJ)

C Lastly we update the counter
      IF(OLDCON.NE.NEWCON) THEN
         IF(OLDCON.GT.0) INTAB(2,OLDCON)=INTAB(2,OLDCON)-1
         INTAB(2,NEWCON)=INTAB(2,NEWCON)+1
      ENDIF

C Note that we have been here
      DONE(II,JJ)=1

      ISTAT=0
      RETURN
      END

      SUBROUTINE LENSTR(STRING,I1,I2)
C
C Find the start and end of a string
C
      IMPLICIT NONE

      CHARACTER*(*) STRING
      INTEGER I,I1,I2
      LOGICAL IN

      IN=.FALSE.

      DO I=1,LEN(STRING)
         IF(STRING(I:I).NE.' ' .AND.
     :      .NOT.IN) THEN
           I1=I
           IN=.TRUE.
         ENDIF

         IF(STRING(I:I).EQ.' ' .AND.
     :      IN) THEN
            I2=I-1
            GO TO 99
         ENDIF
      ENDDO

99    CONTINUE

      RETURN
      END

      SUBROUTINE SETIMI(A,NX,NY,V)
C
C Set a 2d integer image to a constant value
C
      IMPLICIT NONE

      INTEGER NX,NY
      INTEGER A(NX,NY),V
      INTEGER I,J

      DO J=1,NY
         DO I=1,NX
            A(I,J)=V
         ENDDO
      ENDDO

      RETURN
      END

      LOGICAL FUNCTION MATCH(A,B,N)
C
C Match up a context against a context table
C Note that after drizzle V0.40 (EIS) the context
C table itself has an extra second column for the
C counter.
C
      IMPLICIT NONE
      INTEGER I,N
      INTEGER A(N),B(N),AN,BN

      AN=A(1)
      BN=B(1)

      IF(AN.NE.BN) THEN
         MATCH=.FALSE.
         RETURN
      ELSE
         MATCH=.TRUE.
         DO I=2,AN+1
            IF(A(I).NE.B(I+1)) THEN
               MATCH=.FALSE.
               RETURN
            ENDIF
         ENDDO
      ENDIF

      RETURN
      END

      SUBROUTINE CSORT(N,ARR)
C
C This routine is modified from the Numerical Recipes one
C to work on INTEGER arrays.
C
C It sorts an array of integers in place.
C
      INTEGER N,M,NSTACK
      INTEGER ARR(N)
      PARAMETER (M=7,NSTACK=50)
      INTEGER I,IR,J,JSTACK,K,L,ISTACK(NSTACK)
      INTEGER A,TEMP
      jstack=0
      l=1
      ir=n
1     if(ir-l.lt.M)then
        do 12 j=l+1,ir
          a=arr(j)
          do 11 i=j-1,1,-1
            if(arr(i).le.a)goto 2
            arr(i+1)=arr(i)
11        continue
          i=0
2         arr(i+1)=a
12      continue
        if(jstack.eq.0)return
        ir=istack(jstack)
        l=istack(jstack-1)
        jstack=jstack-2
      else
        k=(l+ir)/2
        temp=arr(k)
        arr(k)=arr(l+1)
        arr(l+1)=temp
        if(arr(l+1).gt.arr(ir))then
          temp=arr(l+1)
          arr(l+1)=arr(ir)
          arr(ir)=temp
        endif
        if(arr(l).gt.arr(ir))then
          temp=arr(l)
          arr(l)=arr(ir)
          arr(ir)=temp
        endif
        if(arr(l+1).gt.arr(l))then
          temp=arr(l+1)
          arr(l+1)=arr(l)
          arr(l)=temp
        endif
        i=l+1
        j=ir
        a=arr(l)
3       continue
          i=i+1
        if(arr(i).lt.a)goto 3
4       continue
          j=j-1
        if(arr(j).gt.a)goto 4
        if(j.lt.i)goto 5
        temp=arr(i)
        arr(i)=arr(j)
        arr(j)=temp
        goto 3
5       arr(l)=arr(j)
        arr(j)=a
        jstack=jstack+2
C        if(jstack.gt.NSTACK)pause 'NSTACK too small in sort'
        if(jstack.gt.NSTACK) stop
        if(ir-i+1.ge.j-l)then
          istack(jstack)=ir
          istack(jstack-1)=i
          ir=j-1
        else
          istack(jstack)=j-1
          istack(jstack-1)=l
          l=i
        endif
      endif
      goto 1
      END

      SUBROUTINE GTGLCO(CONTAB,INTAB,MAXIM,MAXEN,NEN,ISTAT)
C
C Read a context index table from global context file
C
C Richard Hook, November 1997
C Modified to handle missing context values, March 1999
C
      IMPLICIT NONE

      INTEGER MAXIM,MAXEN
      INTEGER NEN,CN
      INTEGER INTAB(MAXIM,MAXEN)
      INTEGER I,J,K,NVAL,ISTAT
      CHARACTER*80 CONTAB
      CHARACTER*1024 BUFFER

C Try to open the context file
      OPEN(11,FILE=CONTAB,STATUS='OLD',IOSTAT=ISTAT)
      IF(ISTAT.NE.0) RETURN

C Initialise the context table
      DO J=1,MAXEN
         INTAB(1,J)=1
         DO I=2,MAXIM
            INTAB(I,J)=0
         ENDDO
      ENDDO

C Work through the lines skipping comments and blank ones
      DO WHILE(.TRUE.)
         READ(11,'(A)',END=99) BUFFER
         IF(BUFFER(1:1).NE.'#' .AND. BUFFER.NE.' ') THEN
            READ(BUFFER,*,IOSTAT=ISTAT) CN,NVAL 
            IF(ISTAT.NE.0 .OR. NVAL.GT.99 .OR. CN.GT.MAXEN) GO TO 100
            
C Check for empty contexts
            IF(NVAL.GT.0) THEN
             READ(BUFFER,*,IOSTAT=ISTAT) CN,(INTAB(K,CN),K=1,NVAL+2)
             IF(ISTAT.NE.0) GO TO 100
            ENDIF
         ENDIF
      ENDDO

 99   CONTINUE
      ISTAT=0

100   CONTINUE
      CLOSE(11)

      NEN=CN

      RETURN
      END

      SUBROUTINE PTGLCO(CONTAB,INTAB,MAXIM,MAXEN,NEN,ISTAT)
C
C Write a context index table to global context file
C
C Richard Hook, November 1997
C Modified not to write empty contexts, March 1999
C
      IMPLICIT NONE

      INTEGER MAXIM,MAXEN
      INTEGER NEN
      INTEGER INTAB(MAXIM,MAXEN)
      INTEGER I,K,ISTAT
      CHARACTER*80 CONTAB

C Open the global context file with write access - this will work
C whether or not it exists
      OPEN(12,FILE=CONTAB,IOSTAT=ISTAT)
      IF(ISTAT.NE.0) RETURN

C Write a header of sorts
      WRITE(12,'(''# GLOBAL context table'')')
      WRITE(12,'(''#'')')
      WRITE(12,'(''# Context | Nima | Npix | Unique image ids...'')')

      DO K=1,NEN
        IF(INTAB(2,K).NE.0) THEN
         WRITE(12,'(I7,I6,I10,3X,200I7)') 
     :     K,(INTAB(I,K),I=1,INTAB(1,K)+2)
        ENDIF
      ENDDO

      CLOSE(12)
      RETURN
      END


      SUBROUTINE BFILL(LUN,BUFFER,ISTAT)
C
C Read free-format numbers from an open text file and
C concatenate them into a character string buffer.
C
C This is mostly to facilitate free-format numerical
C reads from text files.
C
C Richard Hook, ST-ECF, December 2000
C
      IMPLICIT NONE

      INTEGER LUN
      CHARACTER*(*) BUFFER
      CHARACTER*256 LINE
      INTEGER ISTAT

      INTEGER IS,I1,I2

      IS=1
      BUFFER=' '

      DO WHILE(.TRUE.)
         CALL UFGLIN(LUN,LINE,ISTAT)
         IF(ISTAT.NE.0) GO TO 88

         IF(LINE.NE.' ' .AND. LINE(1:1).NE.'#') THEN
            CALL ENDS(LINE,I1,I2)
            IF(IS+I2-I1.GT.LEN(BUFFER)) THEN
               ISTAT=1
               RETURN
            ELSE
               BUFFER(IS:IS+I2-I1)=LINE(I1:I2)
               IS=IS+I2-I1+2
            ENDIF
         ENDIF
      ENDDO

88    CONTINUE
      ISTAT=0
      RETURN
      END

      SUBROUTINE ENDS(STRING,I1,I2)
C
C Find the start and end of a string
C This differs from LENSTR in that internal whitespace
C is retained rather than just the first non-white section
C being extracted.
C
      IMPLICIT NONE

      CHARACTER*(*) STRING
      INTEGER I,I1,I2

      I1=1
      I2=1

      DO I=1,LEN(STRING)
         IF(STRING(I:I).NE.' ') THEN
           I1=I
           GO TO 88
         ENDIF
      ENDDO

88    CONTINUE
      DO I=LEN(STRING),1,-1
         IF(STRING(I:I).NE.' ') THEN
           I2=I
           GO TO 99
         ENDIF
      ENDDO

99    CONTINUE

      RETURN
      END

      SUBROUTINE SET1I(A,N,V)
C
C Set a 1d array to a value
C
      IMPLICIT NONE

      INTEGER N,V,I
      INTEGER A(N)

      DO I=1,N
         A(I)=V
      ENDDO

      RETURN
      END

      SUBROUTINE FITLIN(XO,YO,X,Y,N,X0,Y0,A,B,C,D,ISTAT)
C
C Fit a linear transformation (with six parameters, equivalent
C to the linear WCS) to two sets of points.
C
C This uses the standard least-squares linear equations method.
C
C Richard Hook, ST-ECF, January 31st 2001
C
C Fully double precision version, November 2002
C
      IMPLICIT NONE

      INTEGER ISTAT,N
      DOUBLE PRECISION XO(N),YO(N),X(N),Y(N)
      DOUBLE PRECISION X0,Y0,A,B,C,D
      DOUBLE PRECISION MAT(10,10),XORG,YORG,XOORG,YOORG
      DOUBLE PRECISION DET
      DOUBLE PRECISION SIGXOX,SIGXOY,SIGXO,SIGYOX,SIGYOY,SIGYO

      INTEGER I,J

C Initialize the matrix (3x3)
      DO J=1,3
         DO I=1,3
            MAT(I,J)=0.0D0
         ENDDO
      ENDDO

C Also initialise the vectors
      SIGXOX=0.0D0
      SIGXOY=0.0D0
      SIGXO=0.0D0
      SIGYOX=0.0D0
      SIGYOY=0.0D0
      SIGYO=0.0D0

C Take off an offset
      XORG=X(1)
      YORG=Y(1)
      XOORG=XO(1)
      YOORG=YO(1)

C Setup the normal equations
      DO I=1,N
         MAT(1,1)=MAT(1,1)+(X(I)-XORG)**2
         MAT(1,2)=MAT(1,2)+(X(I)-XORG)*(Y(I)-YORG)
         MAT(1,3)=MAT(1,3)+(X(I)-XORG)
         MAT(2,2)=MAT(2,2)+(Y(I)-YORG)**2
         MAT(2,3)=MAT(2,3)+(Y(I)-YORG)
         SIGXOX=SIGXOX+(XO(I)-XOORG)*(X(I)-XORG)
         SIGXOY=SIGXOY+(XO(I)-XOORG)*(Y(I)-YORG)
         SIGXO=SIGXO+(XO(I)-XOORG)
         SIGYOX=SIGYOX+(YO(I)-YOORG)*(X(I)-XORG)
         SIGYOY=SIGYOY+(YO(I)-YOORG)*(Y(I)-YORG)
         SIGYO=SIGYO+(YO(I)-YOORG)
      ENDDO

C Use symmetry (the matrix is diagonal)
      MAT(3,3)=DBLE(N)
      MAT(2,1)=MAT(1,2)
      MAT(3,1)=MAT(1,3)
      MAT(3,2)=MAT(2,3)

C Invert the matrix (we check it isn't singular)
      CALL MATINV(MAT,3,DET)

      IF(DET.EQ.0.0D0) THEN
         CALL UMSPUT('! Linear transformation matrix is singular',
     :               1,0,ISTAT)
         ISTAT=1
         RETURN
      ENDIF

C Multiply the inverse by the vector
      A=SIGXOX*MAT(1,1)+SIGXOY*MAT(1,2)+SIGXO*MAT(1,3)
      B=SIGXOX*MAT(2,1)+SIGXOY*MAT(2,2)+SIGXO*MAT(2,3)
      X0=SIGXOX*MAT(3,1)+SIGXOY*MAT(3,2)+SIGXO*MAT(3,3)

      C=SIGYOX*MAT(1,1)+SIGYOY*MAT(1,2)+SIGYO*MAT(1,3)
      D=SIGYOX*MAT(2,1)+SIGYOY*MAT(2,2)+SIGYO*MAT(2,3)
      Y0=SIGYOX*MAT(3,1)+SIGYOY*MAT(3,2)+SIGYO*MAT(3,3)

C Note that X0 and Y0 haven't been corrected for the offsets
C Normally they are not used

      ISTAT=0
      RETURN
      END

C SUBROUTINE MATINV.F 
C
C SOURCE								       
C   BEVINGTON, PAGES 302-303.
C
C PURPOSE
C   INVERT A SYMMETRIC MATRIX AND CALCULATE ITS DETERMINANT
C
C USAGE 
C   CALL MATINV (ARRAY, NORDER, DET)
C
C DESCRIPTION OF PARAMETERS
C   ARRAY  - INPUT MATRIX WHICH IS REPLACED BY ITS INVERSE
C   NORDER - DEGREE OF MATRIX (ORDER OF DETERMINANT)
C   DET    - DETERMINANT OF INPUT MATRIX
C
C SUBROUTINES AND FUNCTION SUBPROGRAMS REQUIRED 
C   NONE
C
C COMMENT
C   DIMENSION STATEMENT VALID FOR NORDER UP TO 10
C
C This version all double precision.
C
	SUBROUTINE MATINV (ARRAY,NORDER,DET)
C
        IMPLICIT NONE

	DOUBLE PRECISION ARRAY,AMAX,SAVE,DET

        INTEGER IK,JK,I,J,K,L,NORDER
	DIMENSION ARRAY(10,10),IK(10),JK(10)
C
10	DET=1.0D0
11	DO 100 K=1,NORDER
C
C FIND LARGEST ELEMENT ARRAY(I,J) IN REST OF MATRIX
C
	AMAX=0.0D0 
21	DO 30 I=K,NORDER
	DO 30 J=K,NORDER
23	IF (DABS(AMAX)-DABS(ARRAY(I,J))) 24,24,30
24	AMAX=ARRAY(I,J) 
	IK(K)=I 
	JK(K)=J 
30	CONTINUE
C
C INTERCHANGE ROWS AND COLUMNS TO PUT AMAX IN ARRAY(K,K)
C
31	IF (AMAX) 41,32,41
32	DET=0.0D0
	GOTO 140
41	I=IK(K) 
	IF (I-K) 21,51,43
43	DO 50 J=1,NORDER
	SAVE=ARRAY(K,J) 
	ARRAY(K,J)=ARRAY(I,J)
50	ARRAY(I,J)=-SAVE
51	J=JK(K) 
	IF (J-K) 21,61,53
53	DO 60 I=1,NORDER
	SAVE=ARRAY(I,K) 
	ARRAY(I,K)=ARRAY(I,J)
60	ARRAY(I,J)=-SAVE
C
C ACCUMULATE ELEMENTS OF INVERSE MATRIX 
C
61	DO 70 I=1,NORDER
	IF (I-K) 63,70,63
63	ARRAY(I,K)=-ARRAY(I,K)/AMAX
70	CONTINUE
71	DO 80 I=1,NORDER
	DO 80 J=1,NORDER
	IF (I-K) 74,80,74
74	IF (J-K) 75,80,75
75	ARRAY(I,J)=ARRAY(I,J)+ARRAY(I,K)*ARRAY(K,J)
80	CONTINUE
81	DO 90 J=1,NORDER
	IF (J-K) 83,90,83
83	ARRAY(K,J)=ARRAY(K,J)/AMAX
90	CONTINUE
	ARRAY(K,K)=1./AMAX
100	DET=DET*AMAX
C
C RESTORE ORDERING OF MATRIX
C
101	DO 130 L=1,NORDER
	K=NORDER-L+1
	J=IK(K) 
	IF (J-K) 111,111,105
105	DO 110 I=1,NORDER
	SAVE=ARRAY(I,K) 
	ARRAY(I,K)=-ARRAY(I,J)
110	ARRAY(I,J)=SAVE 
111	I=JK(K) 
	IF (I-K) 130,130,113
113	DO 120 J=1,NORDER
	SAVE=ARRAY(K,J) 
	ARRAY(K,J)=-ARRAY(I,J)
120	ARRAY(I,J)=SAVE 
130	CONTINUE
140	RETURN
	END
    
    
      SUBROUTINE DOBOX(DATA,WEI,NDAT,NCOU,NCON,DONE,DNX,DNY,NY,
     :     YSTART,XMIN,XMAX,YMIN,YMAX,NOOVER,
     :     KERNEL,XI,XO,YI,YO,XIB,XOB,YIB,YOB,
     :     ONX,ONY,COTY,CONUM,XCO,YCO,
     :     DISIM,PXG,PYG,XGDIM,YGDIM,
     :     WTSCL,ALIGN,INCPS,EXPIN,
     :     PFRACT,SCALE,ROT,XSH,YSH,WCS,WCSOUT,ROTFIR,
     :     SECPAR,XSH2,YSH2,ROT2,XSCALE,YSCALE,SHFR2,ROTF2,
     :     CON,BITCON,INTAB,MAXIM,MAXEN,NEN,UNIQID,
     :     UPDATE,USEWEI,USEWCS,ISTAT,NMISS,NSKIP,ALPHA,BETA)
C
C This module does the actual mapping of input flux to output images using
C "boxer", a code written by Bill Sparks for FOC geometric
C distortion correction, rather than the "drizzling" approximation.
C
C This works by calculating the positions of the four corners of
C a quadrilateral on the output grid corresponding to the corners
C of the input pixel and then working out exactly how much of each
C pixel in the output is covered, or not.
C
C In V1.6 this was simplified to use the DRIVAL routine and also
C to include some limited multi-kernel support.
C
      IMPLICIT NONE

      INTEGER DNX,DNY,ONX,ONY,NP,NY
      INTEGER I,J,II,JJ,NMISS,ISTAT,NHIT,NXI,NXA,NYI,NYA,X1,X2
      INTEGER XMIN,XMAX,YMIN,YMAX,LX,LY,YSTART
      INTEGER XGDIM,YGDIM
      REAL DATA(DNX,NY),WEI(DNX,NY),W,EXPIN
      REAL NDAT(XMAX-XMIN+1,YMAX-YMIN+1)
      REAL NCOU(XMAX-XMIN+1,YMAX-YMIN+1)
      REAL PXG(XGDIM,YGDIM),PYG(XGDIM,YGDIM)
      INTEGER COTY,CONUM,NSKIP
      DOUBLE PRECISION XCO(CONUM),YCO(CONUM)
      DOUBLE PRECISION WCS(8)
      DOUBLE PRECISION WCSOUT(8)
      DOUBLE PRECISION Y,XOUT(4),YOUT(4)
      DOUBLE PRECISION XSH,YSH,DOVER,DH,XX,YY
      DOUBLE PRECISION XIN(4),YIN(4)
      DOUBLE PRECISION ROT,XF,YF,SCALE,XXI,XXA,YYI,YYA,SCALL,SCDIS
      DOUBLE PRECISION PFRACT,OFRAC
      DOUBLE PRECISION AC,JACO,DX,DY,PFO,PFO2,S2
      DOUBLE PRECISION XI(DNX,4),YI(DNX,4),XO(DNX,4),YO(DNX,4)
      DOUBLE PRECISION XIB(DNX),YIB(DNX),XOB(DNX),YOB(DNX)
      DOUBLE PRECISION R2,ES,EFAC,NSIG,XCEN,YCEN
      DOUBLE PRECISION OVER,TEM
	  DOUBLE PRECISION ALPHA, BETA

      DOUBLE PRECISION SCALE2, PRATIO
      INTEGER PINDX, NORDER, NCOEFF
	  
C Some things are still single
      REAL VC,WTSCL,D,DOW,DD

      CHARACTER*8 ALIGN,KERNEL
      LOGICAL ROTFIR,UPDATE,USEWEI,INCPS,USEWCS,NOOVER,DISIM

C Context related things
      LOGICAL CON
      LOGICAL BITCON
      INTEGER NCON(XMAX-XMIN+1,YMAX-YMIN+1)
      INTEGER DONE(XMAX-XMIN+1,YMAX-YMIN+1)
      INTEGER MAXEN,MAXIM,NEN,UNIQID
      INTEGER OLDCON,NEWCON,BV
      INTEGER INTAB(MAXIM,MAXEN)

C Space for Lanczos-style look-up-tables
      INTEGER NLUT
      PARAMETER (NLUT=512)
      REAL LANLUT(NLUT)
      REAL DEL
      PARAMETER (DEL=0.01)
      INTEGER LANORD
      INTEGER IX,IY
      DOUBLE PRECISION SDP
      
C Number of sigma to be included for gaussians
      PARAMETER (NSIG=2.5)

C Secondary geometrical parameters, added in V1.5
      LOGICAL SECPAR
      DOUBLE PRECISION XSH2,YSH2,ROT2,XSCALE,YSCALE
      CHARACTER*8 SHFR2
      LOGICAL ROTF2
C--

C Some initial settings - note that the reference pixel
C position is determined by the value of ALIGN
      OLDCON=-1


C The bitmask - trimmed to the appropriate range
      NP=(UNIQID-1)/32+1
      BV=2**(UNIQID-1-(32*(NP-1)))

C In the WCS case we can't use the scale to calculate the
C Jacobian so we need to do it
C
C Note that we use the centre of the image rather than the
C reference pixel as the reference here
      IF(USEWCS) THEN         
         IF(ALIGN.EQ.'corner') THEN
            XCEN=DBLE(DNX/2.0)+0.5
            YCEN=DBLE(DNY/2.0)+0.5
         ELSE
            XCEN=DBLE(DNX/2.0)+1.0
            YCEN=DBLE(DNY/2.0)+1.0
         ENDIF

         XIN(1)=XCEN
         XIN(2)=XCEN
         XIN(3)=XCEN+1.0D0
         XIN(4)=XCEN+1.0D0
         YIN(1)=YCEN
         YIN(2)=YCEN+1.0D0
         YIN(3)=YCEN+1.0D0
         YIN(4)=YCEN
	  
         CALL DRIVAL(XIN,YIN,4,DNX,DNY,ONX,ONY,.FALSE.,
     :            XSH,YSH,ROT,SCALE,ALIGN,ROTFIR,
     :            SECPAR,XSH2,YSH2,ROT2,XSCALE,YSCALE,SHFR2,ROTF2,
     :            USEWCS,WCS,WCSOUT,
     :            COTY,CONUM,XCO,YCO,DISIM,PXG,PYG,XGDIM,YGDIM,
     :            XOUT,YOUT, ALPHA, BETA)

         SCALL=SQRT(1.0/ABS(0.5*((XOUT(2)-XOUT(4))*(YOUT(1)-YOUT(3)) -
     :              (XOUT(1)-XOUT(3))*(YOUT(2)-YOUT(4)))))

C Now calculate how much of this is from the geometric distortion
         XSH=0.0D0
         YSH=0.0D0
         ROT=0.0D0
         SCALE=1.0D0
         SECPAR=.FALSE.
         USEWCS=.FALSE.


         CALL DRIVAL(XIN,YIN,4,DNX,DNY,ONX,ONY,.FALSE.,
     :            XSH,YSH,ROT,SCALE,ALIGN,ROTFIR,
     :            SECPAR,XSH2,YSH2,ROT2,XSCALE,YSCALE,SHFR2,ROTF2,
     :            USEWCS,WCS,WCSOUT,
     :            COTY,CONUM,XCO,YCO,DISIM,PXG,PYG,XGDIM,YGDIM,
     :            XOUT,YOUT, ALPHA, BETA)

         SCDIS=SQRT(1.0/ABS(0.5*((XOUT(2)-XOUT(4))*(YOUT(1)-YOUT(3)) -
     :              (XOUT(1)-XOUT(3))*(YOUT(2)-YOUT(4)))))

         USEWCS=.TRUE.
         SCALE=SCALL/SCDIS

      ENDIF

C Image subset size
      LX=XMAX-XMIN+1
      LY=YMAX-YMIN+1
      XF=1.0/SCALE
      YF=1.0/SCALE

      DH=0.5D0*PFRACT
      AC=1.0D0/(PFRACT*PFRACT)

C Recalculate the area scaling factor 
      S2=SCALE*SCALE

C Apply additional photometric scaling when using SIP coefficients
      IF (COTY.GT.100) THEN
          NORDER = COTY - 100
      ELSE
          NORDER = COTY
      ENDIF
      NCOEFF = (NORDER+1)*(NORDER+2)/2 + 1
      
      IF(CONUM.GT.NCOEFF) THEN
         SCALE2 = S2
         PINDX = CONUM - 1
         PRATIO = XCO(PINDX)/YCO(PINDX)
         S2 = SCALE2 * PRATIO * PRATIO
      ENDIF      
      
C Offsets
      DX=DBLE(XMIN-1)
      DY=DBLE(YMIN-1)

C Half pixfrac on output
      PFO=PFRACT/SCALE/2.0D0
      PFO2=PFO**2

C Some Gaussian related numbers
      IF(KERNEL(1:8).EQ.'gaussian') THEN
         EFAC=2.3548**2*S2*AC/2.0D0
         ES=EFAC/3.1415926
         PFO=NSIG*PFRACT/2.3548/SCALE

C Added in V2.9 - make sure this doesn't get less than 1.2
C divided by the scale so that there are never holes in the output
         IF(PFO.LT.1.2/SCALE) PFO=1.2/SCALE
      ENDIF

C Set up a look-up-table for Lanczos-style interpolation kernels
C It is assumed that the last character is an order (single digit)
      IF(KERNEL(1:7).EQ.'lanczos') THEN
         READ(KERNEL(8:8),'(I1)') LANORD
         CALL FILALU(LANORD,NLUT,DEL,LANLUT)

C Note - removed the +1 here (RNH, 21/11/2002)
         PFO=DBLE(LANORD)*PFRACT/SCALE
         SDP=SCALE/DEL/PFRACT
      ENDIF

C We skip all this if there is no overlap
      IF(.NOT.NOOVER) THEN

C This is the outer loop over all the lines in the input image

C Before we start we can fill the X arrays as they don't change
C with Y
       IF(KERNEL.EQ.'square') THEN
          XI(1,1)=1.0D0-DH
          XI(1,2)=1.0D0+DH
          XI(1,3)=1.0D0+DH
          XI(1,4)=1.0D0-DH
       ELSE
          XIB(1)=1.0D0
       ENDIF
         
C If the input image is not in CPS we need to divide by
C the exposure
       IF(.NOT.INCPS) CALL MULC(DATA,DNX,NY,1.0/EXPIN)

C Loop over input lines
       Y=DBLE(YSTART)

       DO J=1,NY
        Y=Y+1.0D0

C Check the overlap with the output
        CALL CHOVER(Y,5,DNX,DNY,ONX,ONY,
     :            XSH,YSH,ROT,SCALE,ALIGN,ROTFIR,
     :            SECPAR,XSH2,YSH2,ROT2,XSCALE,YSCALE,SHFR2,ROTF2,
     :            USEWCS,WCS,WCSOUT,COTY,CONUM,XCO,YCO,
     :            DISIM,PXG,PYG,XGDIM,YGDIM,OFRAC,X1,X2,ALPHA,BETA)

C If the line falls completely off the output then skip it
       IF(OFRAC.NE.0.0D0) THEN

C We know there are some misses
          NMISS=NMISS+DNX-(X2-X1+1)

C Fill the X arrays as they don't change with Y
          IF(KERNEL(1:6).EQ.'square') THEN
             XI(X1,1)=DBLE(X1)-DH
             XI(X1,2)=DBLE(X1)+DH
             XI(X1,3)=DBLE(X1)+DH
             XI(X1,4)=DBLE(X1)-DH
          ELSE
             XIB(X1)=DBLE(X1)
          ENDIF
       
C At this point we can handle the different kernels separately
C First the cases where we just transform a single point rather
C than four - every case except the "classic" square-pixel kernel
       IF(KERNEL(1:6).NE.'square') THEN

         YIB(X1)=Y
         YIB(X1+1)=0.0D0

C Transform onto the output grid
         CALL DRIVAL(XIB(X1),YIB(X1),X2-X1+1,DNX,DNY,ONX,ONY,
     :            .TRUE.,XSH,YSH,ROT,SCALE,ALIGN,ROTFIR,
     :            SECPAR,XSH2,YSH2,ROT2,XSCALE,YSCALE,SHFR2,ROTF2,
     :            USEWCS,WCS,WCSOUT,
     :            COTY,CONUM,XCO,YCO,DISIM,PXG,PYG,XGDIM,YGDIM,
     :            XOB(X1),YOB(X1), ALPHA, BETA)

C Now we consider the different cases, first the "point" option
C where a single pixel in the output image is affected
       IF(KERNEL(1:5).EQ.'point') THEN

C Offset within the subset
         DO I=X1,X2
            II=NINT(XOB(I)-DX)
            JJ=NINT(YOB(I)-DY)

C Check it is on the output image
            IF(II.GE.1 .AND. II.LE.LX .AND.
     :        JJ.GE.1 .AND. JJ.LE.LY) THEN

               VC=NCOU(II,JJ)

C Allow for stretching because of scale change
               D=DATA(I,J)*FLOAT(S2)

C Scale the weighting mask by the scale factor
C Note that we DON'T scale by the Jacobian as it hasn't been
C calculated
               DOW=WEI(I,J)*WTSCL

C If we are creating or modifying the context image we
C do so here
               IF(CON .AND. DOW.GT.0.0) THEN
                  IF(BITCON) THEN
                     NCON(II,JJ)=IOR(NCON(II,JJ),BV)
                  ELSE
                     IF(DONE(II,JJ).EQ.0) THEN
                        CALL UPCON(
     :                 NCON,II,JJ,OLDCON,NEWCON,DONE,LX,LY,
     :                 INTAB,NEN,MAXIM,MAXEN,UNIQID,ISTAT)
                     ENDIF
                  ENDIF
               ENDIF

C Just a simple calculation without logical tests
               IF(VC.EQ.0.0) THEN
                  NDAT(II,JJ)=D
               ELSE
                  NDAT(II,JJ)=
     :             (NDAT(II,JJ)*VC+DOW*D)/
     :             (VC+DOW)
               ENDIF
               NCOU(II,JJ)=VC+DOW
            ELSE
               NMISS=NMISS+1
            ENDIF
          ENDDO

C Next "tophat" - a circular kernel giving equal weight to
C all points within a certain radius
        ELSE IF(KERNEL(1:6).EQ.'tophat') THEN

         DO I=X1,X2

C Offset within the subset
          XX=XOB(I)-DX
          YY=YOB(I)-DY

          XXI=XOB(I)-DX-PFO
          XXA=XOB(I)-DX+PFO
          YYI=YOB(I)-DY-PFO
          YYA=YOB(I)-DY+PFO

          NXI=NINT(XXI)
          NXA=NINT(XXA)
          NYI=NINT(YYI)
          NYA=NINT(YYA)

          NHIT=0

C Allow for stretching because of scale change
          D=DATA(I,J)*FLOAT(S2)

C Scale the weighting mask by the scale factor
C and inversely by the Jacobian to ensure conservation
C of weight in the output
          DOW=WEI(I,J)*WTSCL
          DD=DOW*D

C Loop over output pixels which could be affected
          DO JJ=NYI,NYA
           DO II=NXI,NXA

C Check it is on the output image
            IF(II.GE.1 .AND. II.LE.LX .AND.
     :        JJ.GE.1 .AND. JJ.LE.LY) THEN

C Radial distance
               R2=(XX-DBLE(II))**2+(YY-DBLE(JJ))**2

C Weight is one within the specified radius and zero outside
C Note: weight isn't conserved in this case
               IF(R2.LE.PFO2) THEN

C Count the hits
                NHIT=NHIT+1

                VC=NCOU(II,JJ)

C If we are creating or modifying the context image we
C do so here
               IF(CON .AND. DOW.GT.0.0) THEN
                  IF(BITCON) THEN
                     NCON(II,JJ)=IOR(NCON(II,JJ),BV)
                  ELSE
                     IF(DONE(II,JJ).EQ.0) THEN
                        CALL UPCON(
     :                 NCON,II,JJ,OLDCON,NEWCON,DONE,LX,LY,
     :                 INTAB,NEN,MAXIM,MAXEN,UNIQID,ISTAT)
                     ENDIF
                  ENDIF
               ENDIF

C Just a simple calculation without logical tests
                IF(VC.EQ.0.0) THEN
                   NDAT(II,JJ)=D
                ELSE
                   NDAT(II,JJ)=
     :              (NDAT(II,JJ)*VC+DD)/
     :              (VC+DOW)
                ENDIF
                NCOU(II,JJ)=VC+DOW
              ENDIF
             ENDIF
           ENDDO
          ENDDO

C Count cases where the pixel is off the output image
         IF(NHIT.EQ.0) NMISS=NMISS+1

         ENDDO

C Next a gaussian weighting kernel with FWHM = pixfrac/scale
        ELSE IF(KERNEL(1:8).EQ.'gaussian') THEN
         DO I=X1,X2

C Offset within the subset
          XX=XOB(I)-DX
          YY=YOB(I)-DY

          XXI=XOB(I)-DX-PFO
          XXA=XOB(I)-DX+PFO
          YYI=YOB(I)-DY-PFO
          YYA=YOB(I)-DY+PFO

          NXI=NINT(XXI)
          NXA=NINT(XXA)
          NYI=NINT(YYI)
          NYA=NINT(YYA)

          NHIT=0

C Allow for stretching because of scale change
          D=DATA(I,J)*FLOAT(S2)

C Scale the weighting mask by the scale factor
C and inversely by the Jacobian to ensure conservation
C of weight in the output
          W=WEI(I,J)*WTSCL

C Loop over output pixels which could be affected
          DO JJ=NYI,NYA
           DO II=NXI,NXA

C Check it is on the output image
            IF(II.GE.1 .AND. II.LE.LX .AND.
     :        JJ.GE.1 .AND. JJ.LE.LY) THEN

C Radial distance
               R2=(XX-DBLE(II))**2+(YY-DBLE(JJ))**2

C Weight is a scaled gaussian function of radial distance
               DOVER=ES*EXP(-R2*EFAC)

C Count the hits
               NHIT=NHIT+1

               VC=NCOU(II,JJ)
               DOW=FLOAT(DOVER*W)

C If we are creating or modifying the context image we
C do so here
               IF(CON .AND. DOW.GT.0.0) THEN
                  IF(BITCON) THEN
                     NCON(II,JJ)=IOR(NCON(II,JJ),BV)
                  ELSE
                     IF(DONE(II,JJ).EQ.0) THEN
                        CALL UPCON(
     :                 NCON,II,JJ,OLDCON,NEWCON,DONE,LX,LY,
     :                 INTAB,NEN,MAXIM,MAXEN,UNIQID,ISTAT)
                     ENDIF
                  ENDIF
               ENDIF

C Just a simple calculation without logical tests
               IF(VC.EQ.0.0) THEN
                  NDAT(II,JJ)=D
               ELSE
                  NDAT(II,JJ)=
     :             (NDAT(II,JJ)*VC+DOW*D)/
     :             (VC+DOW)
               ENDIF
               NCOU(II,JJ)=VC+DOW
             ENDIF
           ENDDO
          ENDDO

C Count cases where the pixel is off the output image
         IF(NHIT.EQ.0) NMISS=NMISS+1

         ENDDO

C Next a Lanczos weighting kernel 
        ELSE IF(KERNEL(1:7).EQ.'lanczos') THEN
         DO I=X1,X2

C Offset within the subset
          XX=XOB(I)-DX
          YY=YOB(I)-DY

          XXI=XOB(I)-DX-PFO
          XXA=XOB(I)-DX+PFO
          YYI=YOB(I)-DY-PFO
          YYA=YOB(I)-DY+PFO

          NXI=NINT(XXI)
          NXA=NINT(XXA)
          NYI=NINT(YYI)
          NYA=NINT(YYA)

          NHIT=0

C Allow for stretching because of scale change
          D=DATA(I,J)*FLOAT(S2)

C Scale the weighting mask by the scale factor
C and inversely by the Jacobian to ensure conservation
C of weight in the output
          W=WEI(I,J)*WTSCL

C Loop over output pixels which could be affected
          DO JJ=NYI,NYA
           DO II=NXI,NXA

C Check it is on the output image
            IF(II.GE.1 .AND. II.LE.LX .AND.
     :        JJ.GE.1 .AND. JJ.LE.LY) THEN

C X and Y offsets
               IX=NINT(ABS(XX-DBLE(II))*SDP)+1
               IY=NINT(ABS(YY-DBLE(JJ))*SDP)+1

C Weight is product of Lanczos function values in X and Y
               DOVER=LANLUT(IX)*LANLUT(IY)

C Count the hits
               NHIT=NHIT+1

               VC=NCOU(II,JJ)
               DOW=FLOAT(DOVER*W)

C If we are creating or modifying the context image we
C do so here
               IF(CON .AND. DOW.GT.0.0) THEN
                  IF(BITCON) THEN
                     NCON(II,JJ)=IOR(NCON(II,JJ),BV)
                  ELSE
                     IF(DONE(II,JJ).EQ.0) THEN
                        CALL UPCON(
     :                 NCON,II,JJ,OLDCON,NEWCON,DONE,LX,LY,
     :                 INTAB,NEN,MAXIM,MAXEN,UNIQID,ISTAT)
                     ENDIF
                  ENDIF
               ENDIF

C Just a simple calculation without logical tests
               IF(VC.EQ.0.0) THEN
                  NDAT(II,JJ)=D
               ELSE

C There is an extra check here in the Lanczos case because the weight can
C be negative which means that, just occasionally, the new and existing
C weights at a given position can be have opposite signs and zero sum...
                IF(VC+DOW.EQ.0.0) THEN
                   NDAT(II,JJ)=D
                ELSE
                  NDAT(II,JJ)=
     :             (NDAT(II,JJ)*VC+DOW*D)/
     :             (VC+DOW)
                ENDIF
               ENDIF
               NCOU(II,JJ)=VC+DOW

             ENDIF
           ENDDO
          ENDDO

C Count cases where the pixel is off the output image
         IF(NHIT.EQ.0) NMISS=NMISS+1

         ENDDO

C The "turbo" option with a constant square pixfrac (as used in EIS Drizzle)
        ELSE IF(KERNEL(1:5).EQ.'turbo') THEN
         DO I=X1,X2

C Offset within the subset
          XXI=XOB(I)-DX-PFO
          XXA=XOB(I)-DX+PFO
          YYI=YOB(I)-DY-PFO
          YYA=YOB(I)-DY+PFO

          NXI=NINT(XXI)
          NXA=NINT(XXA)
          NYI=NINT(YYI)
          NYA=NINT(YYA)

          NHIT=0

C Allow for stretching because of scale change
          D=DATA(I,J)*FLOAT(S2)

C Scale the weighting mask by the scale factor
C and inversely by the Jacobian to ensure conservation
C of weight in the output
          W=WEI(I,J)*WTSCL

C Loop over output pixels which could be affected
          DO JJ=NYI,NYA
           DO II=NXI,NXA

C Check it is on the output image
            IF(II.GE.1 .AND. II.LE.LX .AND.
     :        JJ.GE.1 .AND. JJ.LE.LY) THEN

C Calculate the overlap using the simpler "aligned" box routine
              DOVER=OVER(II,JJ,XXI,XXA,YYI,YYA)

              IF(DOVER.GT.0.0) THEN

C Correct for pixfrac area factor
               DOVER=DOVER*S2*AC

C Count the hits
               NHIT=NHIT+1

               VC=NCOU(II,JJ)

               DOW=FLOAT(DOVER*W)

C If we are creating or modifying the context image we
C do so here
               IF(CON .AND. DOW.GT.0.0) THEN
                  IF(BITCON) THEN
                     NCON(II,JJ)=IOR(NCON(II,JJ),BV)
                  ELSE
                     IF(DONE(II,JJ).EQ.0) THEN
                        CALL UPCON(
     :                 NCON,II,JJ,OLDCON,NEWCON,DONE,LX,LY,
     :                 INTAB,NEN,MAXIM,MAXEN,UNIQID,ISTAT)
                     ENDIF
                  ENDIF
               ENDIF

C Just a simple calculation without logical tests
               IF(VC.EQ.0.0) THEN
                  NDAT(II,JJ)=D
               ELSE
                  NDAT(II,JJ)=
     :             (NDAT(II,JJ)*VC+DOW*D)/
     :             (VC+DOW)
               ENDIF
               NCOU(II,JJ)=VC+DOW
             ENDIF
            ENDIF
           ENDDO
          ENDDO

C Count cases where the pixel is off the output image
         IF(NHIT.EQ.0) NMISS=NMISS+1

         ENDDO

C End of the "single point" transform case statement
        ENDIF

C Next the "classic" drizzle square kernel...
C this is different because we have to transform all four corners
C of the shrunken pixel
       ELSE 

C Set the start corner positions - only in Y,
C X is already done
        YI(X1,1)=Y
        YI(X1,2)=Y
        YI(X1,3)=Y
        YI(X1,4)=Y
        YI(X1+1,1)=+DH
        YI(X1+1,2)=+DH
        YI(X1+1,3)=-DH
        YI(X1+1,4)=-DH

C Transform onto the output grid
      CALL DRIVAL(XI(X1,1),YI(X1,1),X2-X1+1,DNX,DNY,ONX,ONY,.TRUE.,
     :            XSH,YSH,ROT,SCALE,ALIGN,ROTFIR,
     :            SECPAR,XSH2,YSH2,ROT2,XSCALE,YSCALE,SHFR2,ROTF2,
     :            USEWCS,WCS,WCSOUT,
     :            COTY,CONUM,XCO,YCO,DISIM,PXG,PYG,XGDIM,YGDIM,
     :            XO(X1,1),YO(X1,1), ALPHA, BETA)

      CALL DRIVAL(XI(X1,2),YI(X1,2),X2-X1+1,DNX,DNY,ONX,ONY,.TRUE.,
     :            XSH,YSH,ROT,SCALE,ALIGN,ROTFIR,
     :            SECPAR,XSH2,YSH2,ROT2,XSCALE,YSCALE,SHFR2,ROTF2,
     :            USEWCS,WCS,WCSOUT,
     :            COTY,CONUM,XCO,YCO,DISIM,PXG,PYG,XGDIM,YGDIM,
     :            XO(X1,2),YO(X1,2), ALPHA, BETA)

      CALL DRIVAL(XI(X1,3),YI(X1,3),X2-X1+1,DNX,DNY,ONX,ONY,.TRUE.,
     :            XSH,YSH,ROT,SCALE,ALIGN,ROTFIR,
     :            SECPAR,XSH2,YSH2,ROT2,XSCALE,YSCALE,SHFR2,ROTF2,
     :            USEWCS,WCS,WCSOUT,
     :            COTY,CONUM,XCO,YCO,DISIM,PXG,PYG,XGDIM,YGDIM,
     :            XO(X1,3),YO(X1,3), ALPHA, BETA)

      CALL DRIVAL(XI(X1,4),YI(X1,4),X2-X1+1,DNX,DNY,ONX,ONY,.TRUE.,
     :            XSH,YSH,ROT,SCALE,ALIGN,ROTFIR,
     :            SECPAR,XSH2,YSH2,ROT2,XSCALE,YSCALE,SHFR2,ROTF2,
     :            USEWCS,WCS,WCSOUT,
     :            COTY,CONUM,XCO,YCO,DISIM,PXG,PYG,XGDIM,YGDIM,
     :            XO(X1,4),YO(X1,4), ALPHA, BETA)

      DO I=X1,X2

C Offset within the subset
         XOUT(1)=XO(I,1)-DX
         XOUT(2)=XO(I,2)-DX
         XOUT(3)=XO(I,3)-DX
         XOUT(4)=XO(I,4)-DX
         YOUT(1)=YO(I,1)-DY
         YOUT(2)=YO(I,2)-DY
         YOUT(3)=YO(I,3)-DY
         YOUT(4)=YO(I,4)-DY

C Work out the area of the quadrilateral on the output grid
C Note that this expression expects the points to be in
C clockwise order
          JACO=0.5*((XOUT(2)-XOUT(4))*(YOUT(1)-YOUT(3)) -
     :              (XOUT(1)-XOUT(3))*(YOUT(2)-YOUT(4)))
          IF (JACO.LT.0.0D0) THEN
             JACO = JACO*-1.0D0
             TEM=XOUT(2)
             XOUT(2)=XOUT(4)
             XOUT(4)=TEM
             TEM=YOUT(2)
             YOUT(2)=YOUT(4)
             YOUT(4)=TEM
          ENDIF

          NHIT=0

C Allow for stretching because of scale change
          D=DATA(I,J)*FLOAT(S2)

C Scale the weighting mask by the scale factor
C and inversely by the Jacobian to ensure conservation
C of weight in the output
          W=WEI(I,J)*WTSCL

C Loop over output pixels which could be affected
          DO JJ=NINT(MIN(YOUT(1),YOUT(2),YOUT(3),YOUT(4))),
     :          NINT(MAX(YOUT(1),YOUT(2),YOUT(3),YOUT(4)))

           DO II=NINT(MIN(XOUT(1),XOUT(2),XOUT(3),XOUT(4))),
     :          NINT(MAX(XOUT(1),XOUT(2),XOUT(3),XOUT(4)))
            
C Check it is on the output image
            IF(II.GE.1 .AND. II.LE.LX .AND.
     :        JJ.GE.1 .AND. JJ.LE.LY) THEN

C Call boxer to calculate overlap
              CALL BOXER(II,JJ,XOUT,YOUT,DOVER)

              IF(DOVER.GT.0.0) THEN

C Re-normalise the area overlap using the Jacobian
               DOVER=DOVER/JACO

C Count the hits
               NHIT=NHIT+1

               VC=NCOU(II,JJ)
               DOW=FLOAT(DOVER*W)

C If we are creating or modifying the context image we
C do so here
               IF(CON .AND. DOW.GT.0.0) THEN
                  IF(BITCON) THEN
                     NCON(II,JJ)=IOR(NCON(II,JJ),BV)
                  ELSE
                     IF(DONE(II,JJ).EQ.0) THEN
                        CALL UPCON(
     :                 NCON,II,JJ,OLDCON,NEWCON,DONE,LX,LY,
     :                 INTAB,NEN,MAXIM,MAXEN,UNIQID,ISTAT)
                     ENDIF
                  ENDIF
               ENDIF

C Just a simple calculation without logical tests
               IF(VC.EQ.0.0) THEN
                  NDAT(II,JJ)=D
               ELSE
                  NDAT(II,JJ)=
     :             (NDAT(II,JJ)*VC+DOW*D)/
     :             (VC+DOW)
               ENDIF
               NCOU(II,JJ)=VC+DOW
             ENDIF
            ENDIF
           ENDDO
         ENDDO

C Count cases where the pixel is off the output image
         IF(NHIT.EQ.0) NMISS=NMISS+1

         ENDDO

C End of the kernel "case" blocks
        ENDIF
       ELSE

C If we are skipping a line count it
        NSKIP=NSKIP+1
        NMISS=NMISS+DNX
       ENDIF
       ENDDO
      ELSE

C If there is no overlap at all set appropriate values
       NSKIP=DNY
       NMISS=DNX*DNY
      ENDIF

C Set good status if we get this far
      ISTAT=0

      RETURN
      END

      SUBROUTINE UPWCS(WCSIN,WCSOUT,DNX,DNY,ONX,ONY,
     :            XSH,YSH,ROT,SCALE,ALIGN,ROTFIR,
     :            SECPAR,XSH2,YSH2,ROT2,XSCALE,YSCALE,SHFR2,ROTF2,
     :            USEWCS,COTY,CONUM,XCO,YCO,DISIM,PXG,PYG,XGDIM,
     :            YGDIM,ALPHA,BETA)

C 
C Update the WCS to include the drizzling transformations
C
C This is done by applying the transform to a unit square at
C the centre pixel in the input whilst retaining the same
C reference point on the sky.
C
C    Richard Hook, ST-ECF, September 2000
C
C Modified to use double precision, Richard Hook, STScI/ST-ECF, June 2003
C
C Linear terms only used - Richard Hook, STScI/ST-ECF, January 2004
C
      IMPLICIT NONE

      INTEGER DNX,DNY,ONX,ONY,ISTAT
      DOUBLE PRECISION XSH,YSH,ROT,SCALE
      CHARACTER*8 ALIGN,SHFR2
      LOGICAL ROTFIR,SECPAR,ROTF2,USEWCS
      DOUBLE PRECISION XSH2,YSH2,ROT2,XSCALE,YSCALE
      INTEGER COTY,CONUM
      INTEGER XGDIM,YGDIM
      REAL PXG(XGDIM,YGDIM),PYG(XGDIM,YGDIM)
      DOUBLE PRECISION XCO(CONUM),YCO(CONUM)
      INTEGER COMAX,SCOTY
      PARAMETER (COMAX=100)

      DOUBLE PRECISION AM,BM,CM,DM,WCSIN(8),WCSOUT(8)
      DOUBLE PRECISION W5,W6,W7,W8
      DOUBLE PRECISION XIN(3),YIN(3),XOUT(3),YOUT(3)
      LOGICAL DISIM, OLDDIS
	  DOUBLE PRECISION ALPHA, BETA

      REAL MEMR(1)
      COMMON /MEM/MEMR

C If we have the WCS already just return
      IF(USEWCS) RETURN

C Set up a single point at the reference pixel to map the reference point
      XIN(1)=WCSIN(1)
      YIN(1)=WCSIN(3)

C Verify that Reference pixel falls within distortion correction image
C If not, turn off use of distortion correction image
      OLDDIS = DISIM
      IF (XIN(1).LT.1 .OR. 
     :    XIN(1).GT.DNX .OR.
     :    YIN(1).LT.1 .OR.
     :    YIN(1).GT.DNY) THEN
         DISIM = .FALSE.
      ENDIF
C Transform
      CALL DRIVAL(XIN,YIN,1,DNX,DNY,ONX,ONY,.FALSE.,
     :            XSH,YSH,ROT,SCALE,ALIGN,ROTFIR,
     :            SECPAR,XSH2,YSH2,ROT2,XSCALE,YSCALE,SHFR2,ROTF2,
     :            USEWCS,WCSIN,WCSOUT,
     :            COTY,CONUM,XCO,YCO,DISIM,PXG,PYG,XGDIM,YGDIM,
     :            XOUT,YOUT, ALPHA, BETA)
      DISIM = OLDDIS
C We can immediately set the reference point on the sky
      WCSOUT(1)=XOUT(1)
      WCSOUT(3)=YOUT(1)
      WCSOUT(2)=WCSIN(2)
      WCSOUT(4)=WCSIN(4)

C Set up a 1x1 box at the centre pixel (three sides only)
C to allow us to update the WCS
      XIN(2)=XIN(1)+1.0D0
      YIN(2)=YIN(1)    
      XIN(3)=XIN(1)
      YIN(3)=YIN(1)+1.0D0

C Transform
C Only use LINEAR terms and ignore distortion images

      SCOTY=COTY
      COTY=1
      OLDDIS = DISIM
      
      DISIM = .FALSE.
      CALL DRIVAL(XIN,YIN,3,DNX,DNY,ONX,ONY,.FALSE.,
     :            XSH,YSH,ROT,SCALE,ALIGN,ROTFIR,
     :            SECPAR,XSH2,YSH2,ROT2,XSCALE,YSCALE,SHFR2,ROTF2,
     :            USEWCS,WCSIN,WCSOUT,
     :            COTY,CONUM,XCO,YCO,DISIM,PXG,PYG,XGDIM,YGDIM,
     :            XOUT,YOUT, ALPHA, BETA)

C Restore order
      COTY=SCOTY
      DISIM = OLDDIS

C Now work out the effective CD matrix of the transformation
      AM=(XOUT(2)-XOUT(1))
      BM=(XOUT(3)-XOUT(1))
      CM=(YOUT(2)-YOUT(1))
      DM=(YOUT(3)-YOUT(1))

C Check the determinant for singularity
      IF(AM*DM-BM*CM.EQ.0.0D0) THEN
         CALL UMSPUT('! Matrix is singular, cannot update WCS',
     :               1,0,ISTAT)
      ELSE

C Invert the matrix
         CALL INMAT(AM,BM,CM,DM)

C Correct the CD matrix
         W5=AM*WCSIN(5)+CM*WCSIN(7)
         W6=AM*WCSIN(6)+CM*WCSIN(8)
         W7=BM*WCSIN(5)+DM*WCSIN(7)
         W8=BM*WCSIN(6)+DM*WCSIN(8)

         WCSOUT(5)=W5
         WCSOUT(6)=W6
         WCSOUT(7)=W7
         WCSOUT(8)=W8
      ENDIF

      RETURN
      END

      SUBROUTINE BOXER (IS, JS, X, Y, DAREA)
C
C BOXER -- compute area of box overlap
C
C Calculate the area common to input clockwise polygon x(n), y(n) with
C square (is, js) to (is+1, js+1).
C This version is for a quadrilateral.
C
C W.B. Sparks STScI 2-June-1990.
C Phil Hodge        20-Nov-1990  Change calling sequence; single precision.
C Richard Hook ECF  24-Apr-1996  Change coordinate origin
C                                so that centre of pixel has integer position
C                   03-Jan-2001  Removed accuracy check

      IMPLICIT NONE

      INTEGER IS, JS
      DOUBLE PRECISION X(*), Y(*)
      DOUBLE PRECISION DAREA
C--
      DOUBLE PRECISION PX(4), PY(4), SUM
      DOUBLE PRECISION SGAREA
      INTEGER I

C Set up coords relative to unit square at origin
C Note that the +0.5s were added when this code was
C included in DRIZZLE
      DO I = 1, 4
         PX(I) = X(I) - IS +0.5D0
         PY(I) = Y(I) - JS +0.5D0
      ENDDO
 
C For each line in the polygon (or at this stage, input quadrilateral)
C calculate the area common to the unit square (allow negative area for
C subsequent `vector' addition of subareas).
      SUM = 0.0D0
      DO I = 1, 3
         SUM = SUM + SGAREA (PX(I), PY(I), PX(I+1), PY(I+1), IS, JS)
      ENDDO   

      SUM = SUM + SGAREA (PX(4), PY(4), PX(1), PY(1), IS, JS)
      DAREA = SUM

      RETURN
      END

      DOUBLE PRECISION FUNCTION SGAREA (X1, Y1, X2, Y2, IS, JS)
C
C To calculate area under a line segment within unit square at origin.
C This is used by BOXER
C
      IMPLICIT NONE
      DOUBLE PRECISION X1, Y1, X2, Y2

      INTEGER IS,JS
      DOUBLE PRECISION M, C, DX
      DOUBLE PRECISION XLO, XHI, YLO, YHI, XTOP
      LOGICAL NEGDX

      DX = X2 - X1

C Trap vertical line
      IF (DX .EQ. 0.0D0) THEN
         SGAREA = 0.0D0
         GO TO 80
      ENDIF

C Order the two input points in x
      IF (X1 .LT. X2) THEN
         XLO = X1
         XHI = X2
      ELSE
         XLO = X2
         XHI = X1
      ENDIF

C And determine the bounds ignoring y for now
      IF (XLO .GE. 1.0D0) THEN
         SGAREA = 0.0D0
         GO TO 80
      ENDIF

      IF (XHI .LE. 0.0D0) THEN
         SGAREA = 0.0D0
         GO TO 80
      ENDIF

      XLO = MAX (XLO, 0.0D0)
      XHI = MIN (XHI, 1.0D0)

C Now look at y
C basic info about the line y = mx + c
      NEGDX = (DX .LT. 0.0D0)
      M     = (Y2 - Y1) / DX
      C     = Y1 - M * X1
      YLO = M * XLO + C
      YHI = M * XHI + C

C Trap segment entirely below axis
      IF (YLO .LE. 0.0D0 .AND. YHI .LE. 0.0D0) THEN
         SGAREA = 0.0D0
         GO TO 80
      ENDIF

C Adjust bounds if segment crosses axis (to exclude anything below axis)
      IF (YLO .LT. 0.0D0) THEN
         YLO = 0.0D0
         XLO = -C/M
      ENDIF
      IF (YHI .LT. 0.0D0) THEN
         YHI = 0.0D0
         XHI = -C/M
      ENDIF

C There are four possibilities: both y below 1, both y above 1
C and one of each.

      IF (YLO .GE. 1.0D0 .AND. YHI .GE. 1.0D0) THEN

C Line segment is entirely above square
         IF (NEGDX) THEN
            SGAREA = XLO - XHI
         ELSE
            SGAREA = XHI - XLO
         ENDIF
         GO TO 80
      ENDIF

      IF (YLO .LE. 1.0D0 .AND. YHI .LE. 1.0D0) THEN

C Segment is entirely within square
         IF (NEGDX) THEN
            SGAREA = 0.5D0 * (XLO-XHI) * (YHI+YLO)
         ELSE
            SGAREA = 0.5D0 * (XHI-XLO) * (YHI+YLO)
         END IF
         GO TO 80
      ENDIF

C otherwise it must cross the top of the square
      XTOP = (1.0D0 - C) / M

      IF (YLO .LT. 1.0D0) THEN
         IF (NEGDX) THEN
            SGAREA = -(0.5D0 * (XTOP-XLO) * (1.0D0+YLO) + XHI - XTOP)
         ELSE
            SGAREA = 0.5D0 * (XTOP-XLO) * (1.0D0+YLO) + XHI - XTOP
         END IF
         GO TO 80
      ENDIF

      IF (NEGDX) THEN
         SGAREA = -(0.5D0 * (XHI-XTOP) * (1.0D0+YHI) + XTOP-XLO)
      ELSE
         SGAREA = 0.5D0 * (XHI-XTOP) * (1.0D0+YHI) + XTOP-XLO
      END IF

   80 CONTINUE

      RETURN
      END


      SUBROUTINE BUPWCS(WCSIN,WCSOUT,DNX,DNY,ONX,ONY,
     :            XSH,YSH,ROT,SCALE,ALIGN,ROTFIR,
     :            SECPAR,XSH2,YSH2,ROT2,XSCALE,YSCALE,SHFR2,ROTF2,
     :            USEWCS,COTY,CONUM,XCO,YCO,DISIM,PXG,PYG,PXDIM,PYDIM,
     :            ALPHA, BETA)

C
C Update the WCS to include the drizzling transformations
C
C This version is for BLOT and works the other way around to
C UPWCS.
C
C This is done by applying the transform to a unit square at
C the reference pixel in the input whilst retaining the same
C reference point on the sky.
C
C    Richard Hook, ST-ECF, December 2001
C
      IMPLICIT NONE

      INTEGER DNX,DNY,ONX,ONY
      DOUBLE PRECISION XSH,YSH,ROT,SCALE
      CHARACTER*8 ALIGN,SHFR2
      LOGICAL ROTFIR,SECPAR,ROTF2,USEWCS
      DOUBLE PRECISION XSH2,YSH2,ROT2,XSCALE,YSCALE
      INTEGER COTY,CONUM
      DOUBLE PRECISION XCO(CONUM),YCO(CONUM)
      LOGICAL DISIM
      INTEGER PXDIM,PYDIM
      REAL PXG(PXDIM,PYDIM),PYG(PXDIM,PYDIM)

      DOUBLE PRECISION WCSIN(8),WCSOUT(8)
      DOUBLE PRECISION OFF
      DOUBLE PRECISION XIN(3),YIN(3),XOUT(3),YOUT(3)
      DOUBLE PRECISION R(3),D(3)
      DOUBLE PRECISION PI
	  DOUBLE PRECISION ALPHA, BETA
      PARAMETER (PI=3.141592653589793)

      PARAMETER (OFF=0.1D1)

C If we have the WCS already just return
      IF(USEWCS) RETURN

C Set up a 1x1 box at the centre of the output image (three sides only)
      XIN(1)=DBLE(ONX/2.0)
      YIN(1)=DBLE(ONY/2.0)
      XIN(2)=DBLE(ONX/2.0)+OFF
      YIN(2)=DBLE(ONY/2.0)
      XIN(3)=DBLE(ONX/2.0)
      YIN(3)=DBLE(ONY/2.0)+OFF

C Transform
      CALL DRIVAL(XIN,YIN,3,ONX,ONY,DNX,DNY,.FALSE.,
     :            XSH,YSH,ROT,SCALE,ALIGN,ROTFIR,
     :            SECPAR,XSH2,YSH2,ROT2,XSCALE,YSCALE,SHFR2,ROTF2,
     :            USEWCS,WCSIN,WCSOUT,
     :            COTY,CONUM,XCO,YCO,DISIM,PXG,PYG,PXDIM,PYDIM,
     :            XOUT,YOUT, ALPHA, BETA)

C Convert the output pixel position to a sky position using
C the WCS
      CALL XY2RD(XOUT(1),YOUT(1),R(1),D(1),WCSIN)
      CALL XY2RD(XOUT(2),YOUT(2),R(2),D(2),WCSIN)
      CALL XY2RD(XOUT(3),YOUT(3),R(3),D(3),WCSIN)

C We can immediately set the reference point on the sky
      WCSOUT(1)=XIN(1)
      WCSOUT(3)=YIN(1)
      WCSOUT(2)=R(1)
      WCSOUT(4)=D(1)

C Now work out the effective CD matrix of the transformation
C Note - 6,7 were swapped (I think) originally????
      WCSOUT(5)=DCOS(D(1)*PI/180.0D0)*(R(2)-R(1))/OFF
      WCSOUT(6)=(D(2)-D(1))/OFF
      WCSOUT(7)=DCOS(D(1)*PI/180.0D0)*(R(3)-R(1))/OFF
      WCSOUT(8)=(D(3)-D(1))/OFF

      RETURN
      END


      SUBROUTINE FILALU(ORDER,NPIX,DEL,LANLUT)
C
C Fill up a look-up-table of Lanczos interpolation kernel values
C for rapid weighting determination for KERNEL='lanczos3' etc.
C
C Supplied:
C
C  ORDER - integer, the order of the kernel.
C
C  NPIX - integer, the size of the look-up-table. 
C
C  DEL - real, the spacings of the sampling of the function.
C
C Returned:
C
C  LANLUT - real, 1d array of look-up values. This is a single-sided
C           Lanczos function with LANLUT(1) being the central value
C
C Note that no checking is done to see whether the values are sensible.
C
C    Richard Hook, ST-ECF/STScI, August 2002
C
C Changed to REAL rather than DOUBLE, Richard Hook, ST-ECF/STScI, Feb 2004
C
      IMPLICIT NONE

      INTEGER NPIX,ORDER
      REAL LANLUT(NPIX),DEL
      INTEGER I

      REAL FOR,POFF,PI
      PARAMETER (PI=3.141592653)

      FOR=REAL(ORDER)

C Set the first value to avoid arithmetic problems
      LANLUT(1)=1.0

      DO I=2,NPIX
         POFF=PI*(REAL(I)-1.0)*DEL

         IF(POFF.LT.PI*FOR) THEN
            LANLUT(I)=SIN(POFF)/(POFF)*SIN(POFF/FOR)/(POFF/FOR)
         ELSE
            LANLUT(I)=0.0
         ENDIF
      ENDDO

      RETURN
      END

      SUBROUTINE CHOVER(Y,MARGIN,DNX,DNY,ONX,ONY,
     :            XSH,YSH,ROT,SCALE,ALIGN,ROTFIR,
     :            SECPAR,XSH2,YSH2,ROT2,XSCALE,YSCALE,SHFR2,ROTF2,
     :            USEWCS,WCSIN,WCSOUT,COTY,CONUM,XCO,YCO,
     :            DISIM,PXG,PYG,XGDIM,YGDIM,OFRAC,X1,X2,ALPHA,BETA)
C
C Check how much of a line will overlap an output image, if any,
C after applying the standard drizzle transformation.
C
C This is intended to allow the number of points which are needlessly
C drizzled outside the output image to be minimized.
C
C Richard Hook, ST-ECF at STScI, April 2003
C
      IMPLICIT NONE

C Supplied and returned
      DOUBLE PRECISION XSH,YSH,ROT,SCALE
      LOGICAL ROTFIR,USEWCS,SECPAR
      CHARACTER*8 ALIGN
      DOUBLE PRECISION WCSIN(8),WCSOUT(8)
      INTEGER COTY,CONUM
      INTEGER XGDIM,YGDIM
      REAL PXG(XGDIM,YGDIM),PYG(XGDIM,YGDIM)
      DOUBLE PRECISION XCO(CONUM),YCO(CONUM)
      INTEGER DNX,DNY,ONX,ONY
      LOGICAL DISIM

C Secondary geometrical parameters, added in V1.5
      DOUBLE PRECISION XSH2,YSH2,ROT2,XSCALE,YSCALE
      CHARACTER*8 SHFR2
      LOGICAL ROTF2

      INTEGER NPOINT,STEP,FIRST,LAST,NHIT,NMISS
      PARAMETER (NPOINT=21)
      DOUBLE PRECISION Y,OFRAC
      DOUBLE PRECISION XVAL(NPOINT),YVAL(NPOINT)
      DOUBLE PRECISION XOUT(NPOINT),YOUT(NPOINT)
	  DOUBLE PRECISION ALPHA, BETA
      LOGICAL LOGO(NPOINT)
      INTEGER MARGIN
      INTEGER X1,X2

      REAL MEMR(1)
      COMMON /MEM/MEMR

C Local variables
      INTEGER I,NP


C Loop along line
      IF(DNX.LT.NPOINT) THEN
         STEP=1
      ELSE
         STEP=DNX/(NPOINT/2)
      ENDIF

      FIRST=0
      LAST=0

      NP=0
      DO I=1,DNX,STEP
         NP=NP+1
         XVAL(NP)=DBLE(I)
         YVAL(NP)=Y
      ENDDO 

C Check end point
      IF(XVAL(NP).LT.DBLE(DNX)) THEN
         XVAL(NP+1)=DBLE(DNX)
         YVAL(NP+1)=Y
         NP=NP+1
      ENDIF

C Transform
      CALL DRIVAL(XVAL,YVAL,NP,DNX,DNY,ONX,ONY,.FALSE.,
     :            XSH,YSH,ROT,SCALE,ALIGN,ROTFIR,
     :            SECPAR,XSH2,YSH2,ROT2,XSCALE,YSCALE,SHFR2,ROTF2,
     :            USEWCS,WCSIN,WCSOUT,COTY,CONUM,
     :            XCO,YCO,DISIM,PXG,PYG,XGDIM,YGDIM,
     :            XOUT,YOUT, ALPHA, BETA)

C Check where the overlap starts and ends
      DO I=1,NP
         LOGO(I)=.FALSE.
      ENDDO

      DO I=1,NP-1
         IF(MAX(XOUT(I),XOUT(I+1)).GE.1.0-MARGIN .AND.
     :      MIN(XOUT(I),XOUT(I+1)).LE.ONX+MARGIN .AND.
     :      MAX(YOUT(I),YOUT(I+1)).GE.1.0-MARGIN .AND.
     :      MIN(YOUT(I),YOUT(I+1)).LE.ONY+MARGIN) THEN
            LOGO(I)=.TRUE.
            LOGO(I+1)=.TRUE.
         ENDIF
      ENDDO

      NHIT=0
      DO I=1,NP
         IF(LOGO(I)) NHIT=NHIT+1
      ENDDO

      NMISS=NP-NHIT

      IF(NHIT.EQ.0) THEN
         OFRAC=0.0D0
         X1=0
         X2=0
         RETURN
      ELSE
         DO I=1,NP
            IF(LOGO(I)) THEN
               FIRST=I
               GO TO 77
            ENDIF
         ENDDO
  77     CONTINUE

         DO I=NP,1,-1
            IF(LOGO(I)) THEN
               LAST=I
               GO TO 88
            ENDIF
         ENDDO
  88     CONTINUE

         OFRAC=DBLE(NHIT)/DBLE(NHIT+NMISS)
      ENDIF

      IF(FIRST.GT.1) THEN
         X1=XVAL(FIRST-1)
      ELSE
         X1=XVAL(1)
      ENDIF

      IF(LAST.LT.NP) THEN
         X2=XVAL(LAST+1)
      ELSE
         X2=XVAL(LAST)
      ENDIF

      RETURN
      END


      REAL*4 FUNCTION GINTER(X,Y,DATA,NX,NY,LUT,NLUT,SPACE,NBOX,MISVAL)
C
C General interpolation using a lookup table
C
C The function returns the interpolated value at position X,Y
C in the array DATA.
C
C The array LUT is a one-dimensional, over-sampled, look up
C table of weights to be used for interpolating.
C
C Experimental version, Richard Hook, February 2004
C
      IMPLICIT NONE

C Supplied and returned values
      INTEGER NX,NY,NLUT,NBOX
      REAL X,Y,DATA(NX,NY)
      REAL LUT(NLUT),SPACE,MISVAL

C Local variables
      INTEGER I,J,IXS,IYS,IXE,IYE,XOFF,YOFF
      REAL LUTY,SUM

C First check for being close to the edge and if so return the missing
C value
      IXS=NINT(X)-NBOX
      IXE=NINT(X)+NBOX
      IYS=NINT(Y)-NBOX
      IYE=NINT(Y)+NBOX

      IF(IXS.LT.1 .OR.
     :   IXE.GT.NX .OR.
     :   IYS.LT.1 .OR.
     :   IYE.GT.NY) THEN
         GINTER=MISVAL
         RETURN
      ENDIF

C Loop over the box, which is assumed to be scaled appropriately
      SUM=0.0
      DO J=IYS,IYE
         YOFF=1+NINT(ABS((Y-REAL(J))/SPACE))
         LUTY=LUT(YOFF)
         DO I=IXS,IXE
            XOFF=1+NINT(ABS((X-REAL(I))/SPACE))
            SUM=SUM+DATA(I,J)*LUT(XOFF)*LUTY
         ENDDO
      ENDDO

      GINTER=SUM
      RETURN
    
      END 

      
      SUBROUTINE SET1R(A, ARR, NPIX)
C  This routine replaces the SPP routine 'amovkr', a routine which 
C  replaces the values of the 1-D array ARR with the value given 
C  as VAL, such that ARR(I) = A.  
C   NPIX is the number of elements in the array ARR
C
C  Warren Hack, 17 June 2004
C
      IMPLICIT NONE

C Supplied:
      INTEGER NPIX
      REAL A, ARR(NPIX)
   
C Local variables:
      INTEGER I
      
      DO I = 1, NPIX
         ARR(I) = A
      ENDDO

      RETURN
      END      

      SUBROUTINE WSUMR (A,B,C,NPIX,W1,W2)
C
C  WSUM - Weighted sum of 2 real vectors.
C        Replaces the call to the SPP routine 'awsur', where 
C           awsur(a,b,c,npix,k1,k2) : c(i) = k1*a(i) + k2*b(i)
C
C  Warren Hack, 15 June 2004
C
      IMPLICIT NONE

C Supplied:
      INTEGER NPIX
      REAL A(NPIX), B(NPIX), c(NPIX)
      REAL W1, W2
   
C Local variables:
      INTEGER I
      
      DO I = 1, NPIX
         C(I) = A(I) * W1 + B(I) * W2
      ENDDO

      RETURN
      END

      SUBROUTINE WMETRC 
C++
C
C WMETRIC.F V1.1 Convert X,Y pixel position to sky coordinates
C
C This task uses coefficients held in a text file to define
C geometrical distortions.
C
C This code uses the F77/VOS for IRAF i/o.
C It may be compiled and linked using a command like:
C
C xc -p stsdas wmetric.f drutil.f x_wmetric.x <dir>libiraf77.a
C
C History:
C
C First quick version from WTRAXY, 5th May 2004    
C
C Modified to use common callable code, 25th June 2004, WJH
C
C Modifed to call DRIVAL with ALPHA, BETA, 9 September 2007, CJH
C--
      IMPLICIT NONE

C Local variables
      INTEGER ISTAT,NXIN,NYIN,NXOUT,NYOUT
      INTEGER COTY,CONUM,COMAX
      PARAMETER (COMAX=100)

      DOUBLE PRECISION XCO(COMAX),YCO(COMAX)
      DOUBLE PRECISION XIN,YIN,XOUT,YOUT,X(4),Y(4),YO(4),XO(4)
      DOUBLE PRECISION RA,DEC
      INTEGER IID,DATTYP,NDIMS,DDIMS(7)
      CHARACTER*80 INIM
      CHARACTER*132 CHARS
      CHARACTER*45 VERS
      CHARACTER*8 CTYPE1,CTYPE2,ALIGN,SHFR2

C Geometrical parameters, the standard set
      DOUBLE PRECISION SCALE,ROT,XSH,YSH,LAM
      DOUBLE PRECISION XSH2,YSH2,ROT2,XSCALE,YSCALE,ALPHA,BETA
      DOUBLE PRECISION WCSIN(8),WCSOUT(8)
      DOUBLE PRECISION PAM
      CHARACTER*80 COEFFS,XGEOIM,YGEOIM,XYLIST,LINE
      INTEGER PXG,PYG,LUN,XGDIM,YGDIM
      LOGICAL DISIM

      REAL MEMR(1)
      COMMON /MEM/MEMR

      DOUBLE PRECISION PI
      PARAMETER (PI=3.141592653589793D0)

      LOGICAL ROTFIR
      LOGICAL USEWCS
      LOGICAL ROTF2
      LOGICAL SECPAR
      LOGICAL SILENT

C-- Start of executable code
      VERS='WMETRIC Version 1.1 (25th June 2004)'

C Get the noise flag
      CALL UCLGSB('silent',SILENT,ISTAT)

C First announce the version
      IF(.NOT.SILENT) CALL UMSPUT('+ '//VERS,1,0,ISTAT)

C Get all the geometrical parameters
      CALL UCLGST('coeffs',COEFFS,ISTAT)
      CALL UCLGSD('lambda',LAM,ISTAT)
      CALL UCLGST('xgeoim',XGEOIM,ISTAT)
      CALL UCLGST('ygeoim',YGEOIM,ISTAT)
      IF(XGEOIM.NE.' ' .OR. YGEOIM.NE.' ') THEN
         DISIM=.TRUE.
      ELSE 
         DISIM=.FALSE.
      ENDIF

C If so, check for image names (output is optional)
      CALL UCLGST('image',INIM,ISTAT)

C Initialisation
      USEWCS=.TRUE.
      XSH=0.0D0
      YSH=0.0D0
      ROT=0.0D0
      SECPAR=.FALSE.
      SCALE=1.0
      PXG=0
      PYG=0

C Open the files and read the WCS from the headers
      IF(INIM.EQ.' ') THEN
         CALL UMSPUT('! No input image specified',
     :                  1,0,ISTAT)
         GO TO 99
      ELSE
         CALL UIMOPN(INIM,1,IID,ISTAT)
         IF(ISTAT.NE.0) THEN
            CALL UMSPUT('! Unable to open image',
     :                     1,0,ISTAT)
            GO TO 99
         ELSE
            CALL UMSPUT('-Reading WCS from '//INIM,1,0,ISTAT)
            CALL GETWCS(IID,WCSIN,CTYPE1,CTYPE2,ISTAT)
            IF(ISTAT.NE.0) THEN
               CALL UMSPUT(
     : '! Unable to get WCS from image header',
     :                     1,0,ISTAT)
               GO TO 99
            ENDIF

C Get the dimensions and use them
            CALL UIMGID(IID,DATTYP,NDIMS,DDIMS,ISTAT)
            IF(NDIMS.NE.2) THEN
               CALL UMSPUT(
     :   '! Input image is not two dimensional',
     :                          1,0,ISTAT)
               GO TO 99
            ELSE
               NXIN=DDIMS(1)
               NYIN=DDIMS(2)
            ENDIF
         ENDIF
      ENDIF

C Get the geometric distortion coefficient information
      CALL GETGEO(COEFFS,IID,LAM,
     :            COTY,COMAX,CONUM,XCO,YCO,ISTAT)
      IF(ISTAT.NE.0) THEN
         CALL UMSPUT(
     :  '! WTRAXY: Error, failed to get distortion coefficients',
     :  1,0,ISTAT)
          GO TO 99
      ENDIF

C  Read in any distortion image corrections, if specified
C  PXG,PYG will default to 2x2 arrays when DISIM returns as FALSE.
C 
      CALL GGEOIM(XGEOIM,YGEOIM,PXG,PYG,XGDIM,YGDIM,DISIM)

C Either we have a list of X,Y positions or a single one
      CALL UCLGST('xylist',XYLIST,ISTAT)
      IF(XYLIST.NE.' ') THEN
         CALL UFOPEN(XYLIST,1,LUN,ISTAT)
         IF(ISTAT.NE.0) THEN
            CALL UMSPUT('! Unable to open xylist file',1,0,
     :                  ISTAT)
            ISTAT=1
            RETURN
         ELSE
            CALL UMSPUT('-Opening xylist file: '//XYLIST,
     :                      1,0,ISTAT)
         ENDIF
      ENDIF

C Get the X,Y pixel position to be transformed 
      IF(XYLIST.EQ.' ') THEN
         CALL UCLGSD('xin',XIN,ISTAT)
         CALL UCLGSD('yin',YIN,ISTAT)
      ENDIF

C Setup an output WCS. This is fairly arbitrary and doesn't
C affect the result. We use 50mas pixels and North at the
C top
      WCSOUT(1)=WCSIN(1)
      WCSOUT(2)=WCSIN(2)
      WCSOUT(3)=WCSIN(3)
      WCSOUT(4)=WCSIN(4)
      WCSOUT(5)=-0.05D0/3600.0D0
      WCSOUT(6)=0.0D0
      WCSOUT(7)=0.0D0
      WCSOUT(8)=0.05D0/3600.0D0
      NXOUT=4096
      NYOUT=4096

C Write column headings for the xylist mode
      IF(XYLIST.NE.' ') THEN
         CALL UMSPUT(
     : '        X   (pixels)   Y          RA   (degrees)   Dec',
     :     1,0,ISTAT)
      ENDIF

C Transform the position
C Note that this is exactly the same as that in Drizzle
C Double precision version
      DO WHILE(.TRUE.)

         IF(XYLIST.NE.' ') THEN
            CALL UFGLIN(LUN,LINE,ISTAT)
            IF(ISTAT.NE.0) GO TO 88
            READ(LINE,*) XIN,YIN
         ENDIF
         
         CALL DRIVAL(XIN,YIN,1,NXIN,NYIN,NXOUT,NYOUT,.FALSE.,
     :            XSH,YSH,ROT,SCALE,ALIGN,ROTFIR,
     :            SECPAR,XSH2,YSH2,ROT2,XSCALE,YSCALE,SHFR2,ROTF2,
     :            USEWCS,WCSIN,WCSOUT,
     :            COTY,CONUM,XCO,YCO,
     :            DISIM,MEMR(PXG),MEMR(PYG),XGDIM,YGDIM,XOUT,YOUT,
     :            ALPHA,BETA)

C Transform a unit square to calculate the pixel area
         X(1)=XIN-0.5D0
         X(2)=XIN+0.5D0
         X(3)=XIN+0.5D0
         X(4)=XIN-0.5D0
         Y(1)=YIN-0.5D0
         Y(2)=YIN-0.5D0
         Y(3)=YIN+0.5D0
         Y(4)=YIN+0.5D0

         CALL DRIVAL(X,Y,4,NXIN,NYIN,NXOUT,NYOUT,.FALSE.,
     :            0.0D0,0.0D0,0.0D0,1.0D0,ALIGN,ROTFIR,
     :            .FALSE.,0.0D0,0.0D0,0.0D0,1.0D0,1.0D0,SHFR2,ROTF2,
     :            .FALSE.,WCSIN,WCSOUT,
     :            COTY,CONUM,XCO,YCO,
     :            .FALSE.,MEMR(PXG),MEMR(PYG),XGDIM,YGDIM,XO,YO,
     :            ALPHA,BETA)

         PAM=DABS(0.5*((XO(2)-XO(4))*(YO(1)-YO(3)) -
     :              (XO(1)-XO(3))*(YO(2)-YO(4))))

C Convert to RA,Dec using the output (tangent plane) WCS
         CALL XY2RD(XOUT,YOUT,RA,DEC,WCSOUT)

C Write out the result
         IF(XYLIST.NE.' ') THEN
            WRITE(CHARS,'(4F14.7)') XIN,YIN,RA,DEC
            CALL UMSPUT(CHARS,1,0,ISTAT)
         ELSE
          IF(.NOT.SILENT) THEN
            WRITE(CHARS,
     :  '('' X,Y: '',2F10.3'' (pix), RA: '',F12.7,'' Dec: '',F12.7,
     :    '' (deg).'')')
     : XIN,YIN,RA,DEC
            CALL UMSPUT(CHARS,1,0,ISTAT)
          ENDIF
         ENDIF

         IF(XYLIST.EQ.' ') GO TO 88
      ENDDO

 88   CONTINUE

C Also write the result to the CL
      IF(XYLIST.EQ.' ') THEN
         CALL UCLPSD('ra',RA,ISTAT)
         CALL UCLPSD('dec',DEC,ISTAT)
      ELSE
         CALL UFCLOS(LUN,ISTAT)
      ENDIF

C End of main WMETRIC module
 99   CONTINUE

      RETURN
      END

C DRCALL - emulation routines for F77/VOS routines found in DRUTIL.F
C
C These routines are needed to allow the callable version of drutil to 
C link without needing F77/VOS routines. 
C
C Richard Hook, ST-ECF/STScI, September 2002

      SUBROUTINE UMSPUT(LINE,D1,D2,ISTAT)
C
C Just write a line of text to the screen. The second and
C third parameters are ignored.
C
      IMPLICIT NONE

      LOGICAL VERBOSE
      COMMON /VERBOSE/VERBOSE

      CHARACTER*(*) LINE
      INTEGER D1,D2,ISTAT

C Always write an error message (starting !), except if
C it is a warning
      IF(LINE(1:1).EQ.'!' .AND. LINE(3:5).NE.'War') THEN
         WRITE(*,'(1X,A,/)',IOSTAT=ISTAT) LINE
      ELSE
         IF(VERBOSE) WRITE(*,'(1X,A,/)',IOSTAT=ISTAT) LINE
      ENDIF

      RETURN
      END

      SUBROUTINE UFGLIN(LUN,LINE,ISTAT)
C
C Read a line of text from an already opened text file.
C
      IMPLICIT NONE
      INTEGER LUN
      CHARACTER*(*) LINE
      INTEGER ISTAT

      READ(LUN,'(A)',IOSTAT=ISTAT) LINE

      RETURN
      END

      SUBROUTINE UFOPEN(FILE,FLAG,LUN,ISTAT)
C
C Open a text file. The FLAG parameter controls the iomode.
C Only 1=readonly and 2=read-write, 4=append and 5=new are
C supported.
C
      CHARACTER*(*) FILE
      INTEGER FLAG,LUN,ISTAT

      IF(FLAG.EQ.1) THEN
         OPEN(23,FILE=FILE,STATUS='OLD',IOSTAT=ISTAT)
      ELSE IF(FLAG.EQ.2) THEN
         OPEN(23,FILE=FILE,STATUS='OLD',IOSTAT=ISTAT)
CCC      ELSE IF(FLAG.EQ.4) THEN
CCC         OPEN(23,FILE=FILE,STATUS='OLD',ACCESS='APPEND',IOSTAT=ISTAT)
      ELSE IF(FLAG.EQ.5) THEN
         OPEN(23,FILE=FILE,STATUS='NEW',IOSTAT=ISTAT)
      ELSE
         CALL UMSPUT('! Invalid file iomode specified',1,0,ISTAT)
      ENDIF

      LUN=23

      RETURN
      END

      SUBROUTINE UFCLOS(LUN,ISTAT)
C
C Close an open file on logical unit LUN
C
      IMPLICIT NONE
    
      INTEGER LUN,ISTAT

      CLOSE(LUN)

      RETURN
      END

      SUBROUTINE GETGEO(COEFFS,IDD,LAM,
     :                  COTY,COMAX,CONUM,XCO,YCO,CLEN,ISTAT)
C
C Get the geometrical distortion information, either from
C a file or the header.
C
C This new routine, October 2000
C Modified in drizzle 2.1 for more flexible coefficients
C
      IMPLICIT NONE

      INTEGER IDD
      INTEGER COTY,COMAX,CONUM
      REAL LAM,XCO(COMAX),YCO(COMAX)
      CHARACTER*80 COEFFS
      INTEGER CLEN

      INTEGER LUN,ISTAT,I
      LOGICAL NOCO

C Interpret the coefficients file name and act appropriately
      NOCO=.FALSE.
      IF(COEFFS.EQ.' ') NOCO=.TRUE.

C Now check for the special string "header"
      IF(COEFFS.EQ.'header') THEN
         CALL UMSPUT(
     : '! This version does not support the header option',
     :   1,0,ISTAT)
         ISTAT=1
         RETURN
      ENDIF

C Set default values
      IF(NOCO) THEN
         DO I=1,COMAX
            XCO(I)=0.0
            YCO(I)=0.0
         ENDDO
         CONUM=1
         COTY=0
      ELSE

C Open the coefficients file
         CALL UFOPEN(COEFFS,1,LUN,ISTAT)
         IF(ISTAT.NE.0) THEN
            CALL UMSPUT('! Unable to open coefficients file',1,0,
     :                  ISTAT)
            ISTAT=1
            RETURN
         ELSE
            CALL UMSPUT('-Opening coefficients file: '//COEFFS(1:CLEN),
     :                      1,0,ISTAT)
         ENDIF

C Read in the coefficients from the file
         CALL GETCO(LUN,LAM,COTY,COMAX,CONUM,XCO,YCO,ISTAT)
         IF(ISTAT.NE.0) THEN
            CALL UMSPUT('! Unable to read coefficients',
     :                       1,0,ISTAT)
            CALL UFCLOS(LUN,ISTAT)
            ISTAT=1
            RETURN
         ENDIF

C Close the coefficients file
         CALL UFCLOS(LUN,ISTAT)
      ENDIF

C Set a good status return
      ISTAT=0
      RETURN
      END

C IOUTIL.F
C
C I/O routines for building IRAF interfaces to Drizzle and Blot
C
C These routines should call only themselves and the 
C    STSDAS f77/vos library.
C
C Original version for DRIZZLE 3.3 and BLOT 3.3, December 2003
C Richard Hook, ST-ECF/ESO
C
C This version modified for callable and STSDAS DRIZZLE simultaneously 
C Warren Hack, STScI, 17-June-2004 
C
C Added 'BALLME' and 'BUHEAD' to support both 'wblot' and 'blot' 
C simultaneously.   WJH, STScI, 7-Oct-2005
C
C History:
C
C The module GOLDH was transferred from drizzle as it is also
C now needed by blot.
C
C WCS routines added (XY2RD & RD2XY), September 1998
C
C Modified GTCOEF routine to also handle STIS and NICMOS,
C    January 1999
C
C Added additional code for reversing the cubic transformation added
C  June 1999
C
C Major extensions and some routines transferred from the EIS utilities
C collection (for context handling), October 2000
C
C Extensive modifications for a more flexible geometric coefficients
C scheme, changes in calling sequences, December 2000
C
C April 2003 - added code for checking overlaps with output images
C and minimising unnecessary drizzling (CHOVER).
C
C Added double precision version of several routines for more precision.
C  Richard Hook, ST-ECF/ESO/STScI, June 2003
C
C Full conversion to double precision (for geometry, not data values)
C   Richard Hook, ST-ECF/ESO/STScI, October 2003
C
C Modifications to support "refpix" contruct in distortion files
C   Richard Hook, ST-ECF/ESO/STScI, December 2003
C
C Image center is calculated as float, not int
C   Nadia Dencheva July, 2006
C
      SUBROUTINE GETWCS(ID,WCS,CTYPE1,CTYPE2,ISTAT)
C
C Get the WCS header items (8 values) and CTYPE strings
C
C The image is assumed to be available with descriptor ID
C and the status flag is returned as non-zero if a parameter
C is not found
C
      IMPLICIT NONE

      INTEGER ID,ISTAT,IS
      CHARACTER*8 CTYPE1,CTYPE2
      DOUBLE PRECISION WCS(8)

      ISTAT=0

      CALL UHDGST(ID,'CTYPE1',CTYPE1,ISTAT)
      IF(ISTAT.NE.0) CALL UMSPUT(
     :   '! Warning, unable to read CTYPE1 from header',1,0,IS)
      IF(ISTAT.NE.0) RETURN

      CALL UHDGST(ID,'CTYPE2',CTYPE2,ISTAT)
      IF(ISTAT.NE.0) CALL UMSPUT(
     :   '! Warning, unable to read CTYPE2 from header',1,0,IS)
      IF(ISTAT.NE.0) RETURN

      CALL UHDGSD(ID,'CRPIX1',WCS(1),ISTAT)
      IF(ISTAT.NE.0) CALL UMSPUT(
     :   '! Warning, unable to read CRPIX1 from header',1,0,IS)
      IF(ISTAT.NE.0) RETURN  

      CALL UHDGSD(ID,'CRVAL1',WCS(2),ISTAT)
      IF(ISTAT.NE.0) CALL UMSPUT(
     :   '! Warning, unable to read CRVAL1 from header',1,0,IS)
      IF(ISTAT.NE.0) RETURN  

      CALL UHDGSD(ID,'CRPIX2',WCS(3),ISTAT)
      IF(ISTAT.NE.0) CALL UMSPUT(
     :   '! Warning, unable to read CRPIX2 from header',1,0,IS)
      IF(ISTAT.NE.0) RETURN  

      CALL UHDGSD(ID,'CRVAL2',WCS(4),ISTAT)
      IF(ISTAT.NE.0) CALL UMSPUT(
     :   '! Warning, unable to read CRVAL2 from header',1,0,IS)
      IF(ISTAT.NE.0) RETURN  

      CALL UHDGSD(ID,'CD1_1',WCS(5),ISTAT)
      IF(ISTAT.NE.0) CALL UMSPUT(
     :   '! Warning, unable to read CD1_1 from header',1,0,IS)
      IF(ISTAT.NE.0) RETURN  

      CALL UHDGSD(ID,'CD2_1',WCS(6),ISTAT)
      IF(ISTAT.NE.0) CALL UMSPUT(
     :   '! Warning, unable to read CD2_1 from header',1,0,IS)
      IF(ISTAT.NE.0) RETURN  

      CALL UHDGSD(ID,'CD1_2',WCS(7),ISTAT)
      IF(ISTAT.NE.0) CALL UMSPUT(
     :   '! Warning, unable to read CD1_2 from header',1,0,IS)
      IF(ISTAT.NE.0) RETURN  

      CALL UHDGSD(ID,'CD2_2',WCS(8),ISTAT)
      IF(ISTAT.NE.0) CALL UMSPUT(
     :   '! Warning, unable to read CD2_2 from header',1,0,IS)

      RETURN
      END

      SUBROUTINE GTPWCS(ID,PREFIX,WCS,CTYPE1,CTYPE2,ISTAT)
C
C Get the WCS header items (8 values) and CTYPE strings
C
C This version allows a prefix letter to be included
C
C The image is assumed to be available with descriptor ID
C and the status flag is returned as non-zero if a parameter
C is not found
C
      IMPLICIT NONE

      INTEGER ID,ISTAT,IS
      CHARACTER*8 CTYPE1,CTYPE2
      CHARACTER*1 PREFIX
      DOUBLE PRECISION WCS(8)

      ISTAT=0

C Note that the first two - the CTYPEs don't have prefixes
      CALL UHDGST(ID,'CTYPE1',CTYPE1,ISTAT)
      IF(ISTAT.NE.0) CALL UMSPUT(
     : '! Warning, unable to read CTYPE1 from header',
     :  1,0,IS)
      IF(ISTAT.NE.0) RETURN

      CALL UHDGST(ID,'CTYPE2',CTYPE2,ISTAT)
      IF(ISTAT.NE.0) CALL UMSPUT(
     : '! Warning, unable to read CTYPE2 from header',
     :  1,0,IS)
      IF(ISTAT.NE.0) RETURN

C Now the eight numbers which do...
      CALL UHDGSD(ID,PREFIX//'CRPIX1',WCS(1),ISTAT)
      IF(ISTAT.NE.0) CALL UMSPUT(
     : '! Warning, unable to read '//PREFIX//'CRPIX1 from header',
     :  1,0,IS)
      IF(ISTAT.NE.0) RETURN

      CALL UHDGSD(ID,PREFIX//'CRVAL1',WCS(2),ISTAT)
      IF(ISTAT.NE.0) CALL UMSPUT(
     : '! Warning, unable to read '//PREFIX//'CRVAL1 from header',
     :  1,0,IS)
      IF(ISTAT.NE.0) RETURN

      CALL UHDGSD(ID,PREFIX//'CRPIX2',WCS(3),ISTAT)
      IF(ISTAT.NE.0) CALL UMSPUT(
     : '! Warning, unable to read '//PREFIX//'CRPIX2 from header',
     :  1,0,IS)
      IF(ISTAT.NE.0) RETURN

      CALL UHDGSD(ID,PREFIX//'CRVAL2',WCS(4),ISTAT)
      IF(ISTAT.NE.0) CALL UMSPUT(
     : '! Warning, unable to read '//PREFIX//'CRVAL2 from header',
     :  1,0,IS)
      IF(ISTAT.NE.0) RETURN

      CALL UHDGSD(ID,PREFIX//'CD1_1',WCS(5),ISTAT)
      IF(ISTAT.NE.0) CALL UMSPUT(
     : '! Warning, unable to read '//PREFIX//'CD1_1 from header',
     :  1,0,IS)
      IF(ISTAT.NE.0) RETURN

      CALL UHDGSD(ID,PREFIX//'CD2_1',WCS(6),ISTAT)
      IF(ISTAT.NE.0) CALL UMSPUT(
     : '! Warning, unable to read '//PREFIX//'CD2_1 from header',
     :  1,0,IS)
      IF(ISTAT.NE.0) RETURN

      CALL UHDGSD(ID,PREFIX//'CD1_2',WCS(7),ISTAT)
      IF(ISTAT.NE.0) CALL UMSPUT(
     : '! Warning, unable to read '//PREFIX//'CD1_2 from header',
     :  1,0,IS)
      IF(ISTAT.NE.0) RETURN

      CALL UHDGSD(ID,PREFIX//'CD2_2',WCS(8),ISTAT)
      IF(ISTAT.NE.0) CALL UMSPUT(
     : '! Warning, unable to read '//PREFIX//'CD2_2 from header',
     :  1,0,IS)

      RETURN
      END

      SUBROUTINE UWCS(ID,WCS,CTYPE1,CTYPE2)
C
C Update the WCS header items using the 8 values
C supplied in WCS and the values of CTYPE1 and CTYPE2.
C
C The image is assumed to be available with descriptor ID
C and to already have all the parameters
C
C Modified to get rid of CDELT and CROTA keywords if present
C and also the PC matrix to avoid confusion. October 2000
C
      IMPLICIT NONE

      INTEGER ID,ISTAT
      CHARACTER*8 CTYPE1,CTYPE2
      DOUBLE PRECISION WCS(8)

      CALL UHDAST(ID,'CTYPE1',CTYPE1,' ',0,ISTAT)
      CALL UHDAST(ID,'CTYPE2',CTYPE2,' ',0,ISTAT)
      CALL UHDASD(ID,'CRPIX1',WCS(1),' ',0,ISTAT)
      CALL UHDASD(ID,'CRVAL1',WCS(2),' ',0,ISTAT)
      CALL UHDASD(ID,'CRPIX2',WCS(3),' ',0,ISTAT)
      CALL UHDASD(ID,'CRVAL2',WCS(4),' ',0,ISTAT)
      CALL UHDASD(ID,'CD1_1',WCS(5),' ',0,ISTAT)
      CALL UHDASD(ID,'CD2_1',WCS(6),' ',0,ISTAT)
      CALL UHDASD(ID,'CD1_2',WCS(7),' ',0,ISTAT)
      CALL UHDASD(ID,'CD2_2',WCS(8),' ',0,ISTAT)

C Delete CDELT and CROTA keywords
C and the PC matrix
      CALL UHDDSP(ID,'CDELT1',ISTAT)
      CALL UHDDSP(ID,'CDELT2',ISTAT)
      CALL UHDDSP(ID,'CROTA1',ISTAT)
      CALL UHDDSP(ID,'CROTA2',ISTAT)
      CALL UHDDSP(ID,'PC001001',ISTAT)
      CALL UHDDSP(ID,'PC002001',ISTAT)
      CALL UHDDSP(ID,'PC001002',ISTAT)
      CALL UHDDSP(ID,'PC002002',ISTAT)

      RETURN
      END

      SUBROUTINE GTCOEF(ID,COEFFS,LAMBDA,ISTAT)
C
C This routine is invoked when it has been requested that
C the coefficients file name for geometric distortion, and
C the associated wavelength is to be extracted from the
C header. 
C
C It is currently handles WFPC2, STIS and NICMOS and assumes
C coefficients in a directory drizzle$coeffs.
C
C Extended for STIS and NICMOS, January 1999
C
      IMPLICIT NONE

      INTEGER ID,ISTAT,IDET
      DOUBLE PRECISION LAMBDA,PLAM
      CHARACTER*(*) COEFFS
      CHARACTER*8 INST,DETECT
      CHARACTER*80 CHARS

C First try to get the instrument name
      CALL UHDGST(ID,'INSTRUME',INST,ISTAT)
      IF(ISTAT.NE.0) RETURN

C Check instrument can be handled
      IF(INST.EQ.'WFPC2') THEN

C Get the other keywords we need
         CALL UHDGSI(ID,'DETECTOR',IDET,ISTAT)
         IF(ISTAT.NE.0) RETURN

         IF(IDET.LT.1 .OR. IDET.GT.4) THEN
            CALL UMSPUT('! Invalid detector number in header',
     :               1,0,ISTAT)
            ISTAT=1
            RETURN
         ENDIF

         CALL UHDGSD(ID,'PHOTPLAM',PLAM,ISTAT)
         IF(ISTAT.NE.0) RETURN

C We have to convert the wavelength from Angstroms to nm
         LAMBDA=PLAM/10.0D0
         
C Now we build the full "Trauger style" name for the coefficients
C file
         IF(IDET.EQ.1) THEN
            COEFFS='drizzle$coeffs/pc1-trauger'
         ELSE IF(IDET.EQ.2) THEN
            COEFFS='drizzle$coeffs/wf2-trauger'
         ELSE IF(IDET.EQ.3) THEN
            COEFFS='drizzle$coeffs/wf3-trauger'
         ELSE IF(IDET.EQ.4) THEN
            COEFFS='drizzle$coeffs/wf4-trauger'
         ENDIF

         WRITE(CHARS,
     : '(''-Instrument: '',A8,'' Chip: '''//
     : ',I1,'' Wavelength: '',F7.2,'' (nm)'')')
     :   INST,IDET,LAMBDA
         CALL UMSPUT(CHARS,1,0,ISTAT)
      ELSE IF(INST.EQ.'NICMOS') THEN

C Get the other keywords we need
         CALL UHDGSI(ID,'CAMERA',IDET,ISTAT)
         IF(ISTAT.NE.0) RETURN

         IF(IDET.LT.1 .OR. IDET.GT.3) THEN
            CALL UMSPUT('! Invalid camera number in header',
     :               1,0,ISTAT)
            ISTAT=1
            RETURN
         ELSE
            WRITE(COEFFS,'(''drizzle$coeffs/nic-'',I1)') IDET
         ENDIF

         WRITE(CHARS,
     : '(''-Instrument: NICMOS  Camera: '',i1)') IDET
         CALL UMSPUT(CHARS,1,0,ISTAT)
      ELSE IF(INST.EQ.'STIS') THEN

C Get the other keywords we need
         CALL UHDGST(ID,'DETECTOR',DETECT,ISTAT)
         IF(DETECT.EQ.'CCD') THEN
            COEFFS='drizzle$coeffs/stis-ccd'
         ELSE IF(DETECT.EQ.'NUV-MAMA') THEN
            COEFFS='drizzle$coeffs/stis-nuv-mama'
         ELSE IF(DETECT.EQ.'FUV-MAMA') THEN
            COEFFS='drizzle$coeffs/stis-fuv-mama'
         ELSE
            CALL UMSPUT('! Invalid STIS detector name in header',
     :               1,0,ISTAT)
            ISTAT=1
            RETURN
         ENDIF

         WRITE(CHARS,
     : '(''-Instrument: STIS    Detector: '',A8)') DETECT
         CALL UMSPUT(CHARS,1,0,ISTAT)
      ELSE
         CALL UMSPUT(
     :  '! We can currently only handle WFPC2, NICMOS or STIS headers',
     :               1,0,ISTAT)
         ISTAT=1
         RETURN
      ENDIF

      RETURN
      END

      SUBROUTINE GOLDH(ID,USEWCS,IC,LASTPF,LASTSC,
     :                 LASTUN,LASTOX,LASTOY,ISTAT)
C
C This routine finds out details of the last image
C to have been drizzled onto the image with identifier
C ID and returns then for comparison with the new
C ones.
C
C This version was moved from the source code of V1.2 of
C drizzle.
C
C Small modifications to fit in with changed header scheme.
C March 2001
C
      IMPLICIT NONE

      INTEGER IC,ISTAT,ID
      LOGICAL USEWCS
      CHARACTER*8 LASTUN
      CHARACTER*4 STEM
      CHARACTER*80 BUFFER
      DOUBLE PRECISION LASTPF,LASTSC,LASTOX,LASTOY

C Before doing anything check for old-style headers and
C warn the user
      CALL UHDGST(ID,'D01VER',BUFFER,ISTAT)
      IF(ISTAT.EQ.0) THEN
         CALL UMSPUT(
     : '! Warning - there is an old-style Drizzle header present,',
     : 1,0,ISTAT)
         CALL UMSPUT(
     : '! please consult the header for full processing history',
     : 1,0,ISTAT)
      ENDIF

C First find out if there are old values
C This is very ugly
      STEM='D000'

      DO IC=1,999
         WRITE(STEM(2:4),'(I3)') IC
         IF(STEM(2:2).EQ.' ') STEM(2:2)='0'
         IF(STEM(3:3).EQ.' ') STEM(3:3)='0'
         CALL UHDGST(ID,STEM//'VER',BUFFER,ISTAT)

C Check for a status code indicating that this header
C item doesn't exist
         IF(ISTAT.EQ.40) GO TO 111
      ENDDO

111   CONTINUE
      IC=IC-1

      WRITE(STEM(2:4),'(I3)') IC
      IF(STEM(2:2).EQ.' ') STEM(2:2)='0'
      IF(STEM(3:3).EQ.' ') STEM(3:3)='0'

      CALL UHDGSD(ID,STEM//'PIXF',LASTPF,ISTAT)
      IF(ISTAT.NE.0) RETURN

      CALL UHDGST(ID,STEM//'OUUN',LASTUN,ISTAT)
      IF(ISTAT.NE.0) RETURN

      IF(.NOT.USEWCS) THEN
         CALL UHDGSD(ID,STEM//'SCAL',LASTSC,ISTAT)
         IF(ISTAT.NE.0) RETURN

         CALL UHDGSD(ID,STEM//'OUXC',LASTOX,ISTAT)
         IF(ISTAT.NE.0) RETURN

         CALL UHDGSD(ID,STEM//'OUYC',LASTOY,ISTAT)
         IF(ISTAT.NE.0) RETURN
      ENDIF

      ISTAT=0

      RETURN
      END


      SUBROUTINE GETIMR(ID,NX,NY,SUB,XMIN,XMAX,YMIN,YMAX,
     :                  BUFF,P,ISTAT)
C
C Read a subset of an already opened image into an already
C allocated memory space. This version for REAL images.
C
C A one dimensional buffer is used and must be big enough.
C
C October 2000
C
      IMPLICIT NONE

      INTEGER ID,NX,NY,XMIN,XMAX,YMIN,YMAX,ISTAT
      REAL P(XMAX-XMIN+1,YMAX-YMIN+1)
      REAL BUFF(1)
      LOGICAL SUB
      INTEGER I

C If we have a subset then read just the bit of interest
      IF(SUB) THEN
         DO I=YMIN,YMAX
            CALL UIGL2R(ID,I,BUFF,ISTAT)
            IF(ISTAT.NE.0) RETURN

C Copy the part of the line into the subset image
            CALL COPY1D(BUFF(XMIN),
     :                 P(1,I-YMIN+1),
     :                 XMAX-XMIN+1)
         ENDDO
      ELSE

C Read the whole image, line by line
         DO I=1,NY
            CALL UIGL2R(ID,I,P(1,I),ISTAT)
            IF(ISTAT.NE.0) RETURN
         ENDDO
      ENDIF

      ISTAT=0
      RETURN
      END

      SUBROUTINE GETIMI(ID,NX,NY,SUB,XMIN,XMAX,YMIN,YMAX,
     :                  BUFF,P,ISTAT)
C
C Read a subset of an already opened image into an already
C allocated memory space. This version for INTEGER images.
C
C A one dimensional buffer is used and must be big enough.
C
C October 2000
C
      IMPLICIT NONE

      INTEGER ID,NX,NY,XMIN,XMAX,YMIN,YMAX,ISTAT
      INTEGER P(XMAX-XMIN+1,YMAX-YMIN+1)
      INTEGER BUFF(1)
      LOGICAL SUB
      INTEGER I

C If we have a subset then read just the bit of interest
      IF(SUB) THEN
         DO I=YMIN,YMAX
            CALL UIGL2I(ID,I,BUFF,ISTAT)
            IF(ISTAT.NE.0) RETURN

C Copy the part of the line into the subset image
            CALL COPY1I(BUFF(XMIN),
     :                 P(1,I-YMIN+1),
     :                 XMAX-XMIN+1)
         ENDDO
      ELSE

C Read the whole image, line by line
         DO I=1,NY
            CALL UIGL2I(ID,I,P(1,I),ISTAT)
            IF(ISTAT.NE.0) RETURN
         ENDDO
      ENDIF

      ISTAT=0
      RETURN
      END

      SUBROUTINE PUTIMR(ID,NX,NY,SUB,XMIN,XMAX,YMIN,YMAX,
     :                  UPDATE,OUTCPS,FS,BUFF,P,ISTAT)
C
C Write out an output image, possibly a subset.
C
C REAL version - with image scaling if required.
C
C October 2000
C
      IMPLICIT NONE

      INTEGER ID,NX,NY,XMIN,XMAX,YMIN,YMAX,ISTAT
      REAL P(XMAX-XMIN+1,YMAX-YMIN+1)
      REAL BUFF(1),FS
      LOGICAL SUB,UPDATE,OUTCPS
      INTEGER I

C First the case of a subset image
      IF(SUB) THEN

C First we read the ranges of Y for which the drizzle
C has had no effect. This is not needed in the CPS
C case except the first time around.
       IF(.NOT.UPDATE .OR. .NOT.OUTCPS) THEN

        IF(YMIN.GT.1) THEN
         DO I=1,YMIN-1
          IF(UPDATE) THEN
           CALL UIGL2R(ID,I,BUFF,ISTAT)
           IF(FS.NE.1.0) THEN
            CALL MULC(BUFF,NX,1,FS)
           ENDIF
          ELSE
           CALL SETIM(BUFF,NX,1,0.0)
          ENDIF
          CALL UIPL2R(ID,I,BUFF,ISTAT)
         ENDDO
        ENDIF

        IF(YMAX.LT.NY) THEN
         DO I=YMAX+1,NY
          IF(UPDATE) THEN
           CALL UIGL2R(ID,I,BUFF,ISTAT)
           IF(FS.NE.1.0) THEN
            CALL MULC(BUFF,NX,1,FS)
           ENDIF
          ELSE
           CALL SETIM(BUFF,NX,1,0.0)
          ENDIF
          CALL UIPL2R(ID,I,BUFF,ISTAT)
         ENDDO
        ENDIF
       ENDIF

C Now we read in the range of lines which we have already
C processed, scale them and copy in the appropriate section
        DO I=YMIN,YMAX
         IF(UPDATE) THEN
          CALL UIGL2R(ID,I,BUFF,ISTAT)
          IF(FS.NE.1.0) THEN
             CALL MULC(BUFF,NX,1,FS)
          ENDIF
         ELSE
          CALL SETIM(BUFF,NX,1,0.0)
         ENDIF
         CALL COPY1D(P(1,I-YMIN+1),BUFF(XMIN),XMAX-XMIN+1)
         CALL UIPL2R(ID,I,BUFF,ISTAT)
        ENDDO
        IF(ISTAT.NE.0) RETURN

C and now the simple case of the whole image
      ELSE
        DO I=1,NY
         CALL UIPL2R(ID,I,P(1,I),ISTAT)
         IF(ISTAT.NE.0) RETURN
        ENDDO
      ENDIF

      ISTAT=0
      RETURN
      END

      SUBROUTINE PUTIMI(ID,NX,NY,SUB,XMIN,XMAX,YMIN,YMAX,
     :                  UPDATE,OUTCPS,FS,BUFF,P,ISTAT)
C
C Write out an output image, possibly a subset.
C
C INTEGER version.
C
C Values of FS other than 1.0 result in an error exit.
C
C October 2000
C
      IMPLICIT NONE

      INTEGER ID,NX,NY,XMIN,XMAX,YMIN,YMAX,ISTAT
      INTEGER P(XMAX-XMIN+1,YMAX-YMIN+1)
      INTEGER BUFF(1)
      REAL FS
      LOGICAL SUB,UPDATE,OUTCPS
      INTEGER I

C Check the FS value - if not 1.0 then take an error exit
C (this is only here for compatibility with the real version)
      IF(FS.NE.1.0) THEN
         ISTAT=2
         RETURN
      ENDIF

C Handle subsets first
      IF(SUB) THEN

C First we read the ranges of Y for which the drizzle
C has had no effect. This is not needed in the CPS
C case except the first time around.
       IF(.NOT.UPDATE .OR. .NOT.OUTCPS) THEN
        IF(YMIN.GT.1) THEN
          DO I=1,YMIN-1
            IF(UPDATE) THEN
             CALL UIGL2I(ID,I,BUFF,ISTAT)
            ELSE
             CALL SETIMI(BUFF,NX,1,0)
            ENDIF
            CALL UIPL2I(ID,I,BUFF,ISTAT)
          ENDDO
        ENDIF

        IF(YMAX.LT.NY) THEN
          DO I=YMAX+1,NY
            IF(UPDATE) THEN
             CALL UIGL2I(ID,I,BUFF,ISTAT)
            ELSE
             CALL SETIMI(BUFF,NX,1,0)
            ENDIF
            CALL UIPL2I(ID,I,BUFF,ISTAT)
          ENDDO
        ENDIF
       ENDIF

C Now we read in the range of lines which we have already
C processed, scale them and copy in the appropriate section
        DO I=YMIN,YMAX
         IF(UPDATE) THEN
          CALL UIGL2I(ID,I,BUFF,ISTAT)
         ELSE
          CALL SETIMI(BUFF,NX,1,0)
         ENDIF
         CALL COPY1I(P(1,I-YMIN+1),BUFF(XMIN),XMAX-XMIN+1)
         CALL UIPL2I(ID,I,BUFF,ISTAT)
        ENDDO
        IF(ISTAT.NE.0) RETURN

C and now the simple case of the whole image
      ELSE
        DO I=1,NY
         CALL UIPL2I(ID,I,P(1,I),ISTAT)
         IF(ISTAT.NE.0) RETURN
        ENDDO
      ENDIF

      ISTAT=0
      RETURN
      END

      SUBROUTINE PTCOIN(ID,CONTAB,MAXHCN,INTAB,MAXIM,MAXEN,NEN,ISTAT)
C
C Write a context index table back to an open image header
C
C Richard Hook, November 1997
C Modified, 24th Nov 97 to included a "used" logical
C           vector so that only the relevant contexts are saved.
C
C Revised for new context format and other things, Richard Hook
C                                                  March 1999
C
C Added option to write to a file if there are more than a certain
C number of entries. This added the CONTAB,MAXHCN parameters.
C  Richard Hook, July 1999
C
      IMPLICIT NONE

      INTEGER MAXIM,MAXEN,MAXHCN
      INTEGER ID,NEN
      INTEGER INTAB(MAXIM,MAXEN)
      INTEGER I,J,K,ISTAT,KWL
      CHARACTER*8 KEY
      CHARACTER*80 CHARS
      CHARACTER*80 CONTAB

C Table of letters
      CHARACTER*1 LET(26)
      LET(1)='A'
      LET(2)='B'
      LET(3)='C'
      LET(4)='D'
      LET(5)='E'
      LET(6)='F'
      LET(7)='G'
      LET(8)='H'
      LET(9)='I'
      LET(10)='J'
      LET(11)='K'
      LET(12)='L'
      LET(13)='M'
      LET(14)='N'
      LET(15)='O'
      LET(16)='P'
      LET(17)='Q'
      LET(18)='R'
      LET(19)='S'
      LET(20)='T'
      LET(21)='U'
      LET(22)='V'
      LET(23)='W'
      LET(24)='X'
      LET(25)='Y'
      LET(26)='Z'

C First we clear out all traces of an old header
C Initialise header keyword matching for CON...
      CALL UHDOKL(ID,'CON*',.TRUE.,KWL,ISTAT)

C Loop over entries until we get a bad status return
      DO WHILE(.TRUE.)

C Get a keyword
         CALL UHDGNK(KWL,KEY,ISTAT)
         IF(ISTAT.NE.0) GO TO 77
      
C Check it is meaningful - to avoid too many mistakes
         READ(KEY(4:7),'(I4)',IOSTAT=ISTAT)
         IF(ISTAT.EQ.0) CALL UHDDSP(ID,KEY,ISTAT)
      ENDDO
 
 77   CONTINUE

C Close the keyword loop
      CALL UHDCKL(KWL,ISTAT)

C Check whether we have lots of entries, if so write them
C to a file rather than to the header and record the fact in the header
C itself. Added 1/7/99
      IF(NEN.GT.MAXHCN) THEN

C Write the name of the file to the header
	 CALL UHDAST(ID,'CONFILE',CONTAB,
     :        'File containing context text table',0,ISTAT)

C Write the context information to that file
	 CALL PTGLCO(CONTAB,INTAB,MAXIM,MAXEN,NEN,ISTAT)
	 IF(ISTAT.NE.0) THEN
	    CALL UMSPUT('! Failed to write context table file',
     :                  1,0,ISTAT)
	    ISTAT=1
	    RETURN
         ELSE
            CALL UMSPUT('-Writing context table file: '//CONTAB,
     :                  1,0,ISTAT)
         ENDIF
      ELSE
	  
C Loop over the different entries
       DO I=1,NEN

C Check for empty contexts and ignore them
        IF(INTAB(2,I).GT.0) THEN

C Put together a name for the keyword
         WRITE(KEY,'(''CON'',I4)') I
         DO J=4,7
            IF(KEY(J:J).EQ.' ') KEY(J:J)='0'
         ENDDO

C Write the first line
         WRITE(CHARS,'(I3,I10,7I7)') 
     :    (INTAB(J,I),J=1,MIN(9,INTAB(1,I)+2))

C If this is the first item then label it
         IF(I.EQ.1) THEN
            CALL UHDAST(ID,KEY,CHARS,'Image context index',
     :               0,ISTAT)
         ELSE
            CALL UHDAST(ID,KEY,CHARS,' ',
     :            0,ISTAT)
         ENDIF

C Now loop over the additional lines which may be
C required
         IF(INTAB(1,I).GT.7) THEN
            DO J=2,INT((INTAB(1,I)+1)/9)+1
               WRITE(CHARS,'(9I7)') 
     :    (INTAB(K,I),K=(J-1)*9+1,MIN(J*9,INTAB(1,I)+2))

C Delete any old keyword of the same name
               CALL UHDDSP(ID,KEY//LET(J-1),ISTAT)

               CALL UHDAST(ID,KEY//LET(J-1),CHARS,' ',
     :               0,ISTAT)
               IF(ISTAT.NE.0) RETURN
            ENDDO
          ENDIF
        ENDIF
       ENDDO

       CALL UMSPUT('-Writing context table to context image header',
     :             1,0,ISTAT)

      ENDIF

      ISTAT=0
      RETURN
      END

      SUBROUTINE GTCOIN(ID,INTAB,MAXIM,MAXEN,NEN,ISTAT)
C
C Read a context index table from an open image header
C
C Richard Hook, November 1997
C Modified, Richard Hook, March 1999
C
C Modified to use the file option if the CONFILE keyword is
C present - Richard Hook, July 1999
C
      IMPLICIT NONE

      INTEGER MAXIM,MAXEN
      INTEGER ID,NEN
      INTEGER INTAB(MAXIM,MAXEN)
      INTEGER I,J,K,L,N,NR,NVAL,ISTAT,KWL
      CHARACTER*8 KEY
      CHARACTER*80 CHARS,CONTAB

C Table of letters
      CHARACTER*1 LET(26)
      LET(1)='A'
      LET(2)='B'
      LET(3)='C'
      LET(4)='D'
      LET(5)='E'
      LET(6)='F'
      LET(7)='G'
      LET(8)='H'
      LET(9)='I'
      LET(10)='J'
      LET(11)='K'
      LET(12)='L'
      LET(13)='M'
      LET(14)='N'
      LET(15)='O'
      LET(16)='P'
      LET(17)='Q'
      LET(18)='R'
      LET(19)='S'
      LET(20)='T'
      LET(21)='U'
      LET(22)='V'
      LET(23)='W'
      LET(24)='X'
      LET(25)='Y'
      LET(26)='Z'

C Initialise the array
      DO J=1,MAXEN
         INTAB(1,J)=1
         DO I=2,MAXIM
            INTAB(I,J)=0
         ENDDO
      ENDDO

C First check for a CONFILE keyword. If this is found then the
C context table is read from there and not the header
      CALL UHDGST(ID,'CONFILE',CONTAB,ISTAT)
      IF(ISTAT.EQ.0) THEN

	 CALL GTGLCO(CONTAB,INTAB,MAXIM,MAXEN,NEN,ISTAT)
	 IF(ISTAT.NE.0) THEN
	    CALL UMSPUT('! Failed to read context from table file',
     :                  1,0,ISTAT)
	    ISTAT=1
	    RETURN
         ELSE
            CALL UMSPUT('-Read context table file: '//CONTAB,
     :                  1,0,ISTAT)
         ENDIF
      ELSE

C Initialise the total in case of error
        I=0

C Initialise header keyword matching for CON...
        CALL UHDOKL(ID,'CON*',.TRUE.,KWL,ISTAT)
        IF(ISTAT.NE.0) GO TO 99

C Loop over entries until we get a bad status return
        DO WHILE(.TRUE.)

C Get a keyword
         CALL UHDGNK(KWL,KEY,ISTAT)
         IF(ISTAT.NE.0) GO TO 99

C Check keyword is valid
         READ(KEY(4:8),*,IOSTAT=ISTAT) I
         
         IF(ISTAT.EQ.0) THEN

C Read the keyword from the header
         CALL UHDGST(ID,KEY,CHARS,ISTAT)
         IF(ISTAT.NE.0) GO TO 99

C First just extract the first number which is the number of
C items
         READ(CHARS,*) NVAL
         IF(NVAL.LT.8) THEN

C Case of one row only (less than 11 values)
            NR=NVAL+2
            READ(CHARS,*) (INTAB(K,I),K=1,NR)
         ELSE

C Case for more than one row
C First read the first row
            READ(CHARS,*) (INTAB(K,I),K=1,9)

C Then work out how many remain
            NR=NVAL-7

C and loop over them in groups of 9 (if possible)
            L=0
            DO WHILE(NR.GT.0)
               N=MIN(9,NR)
               L=L+1
               CALL UHDGST(ID,KEY//LET(L),CHARS,ISTAT)
               IF(ISTAT.NE.0) GO TO 99
               READ(CHARS,*,IOSTAT=ISTAT) 
     :             (INTAB(K,I),K=L*9+1,L*9+N)
               NR=NR-N
             ENDDO
          ENDIF
         ENDIF
        ENDDO

C If we get here something must be wrong
        ISTAT=1
        RETURN

C This is the normal exit point
99     CONTINUE
  
C Close keyword list
       CALL UHDCKL(KWL,ISTAT)

       NEN=I
      ENDIF

C Check that we have successfully read some values
      IF(NEN.GT.0) THEN
         ISTAT=0
      ELSE
         ISTAT=1
      ENDIF

      RETURN
      END

      SUBROUTINE GTUNID(NAME,ID,UNIQID,ISTAT)
C
C Get a unique image id (an integer) from the header of 
C an open image. This version is for EMMI and looks for
C firstly a keyword EISID and, if that doesn't exist,
C it uses the name of the image and takes the value
C between the last _ and the first . in the filename.
C
      IMPLICIT NONE
      INTEGER I,ISTAT,UNIQID,ID,IDOT,IUND
      CHARACTER*80 NAME

C First try to get the keyword
      CALL UHDGSI(ID,'EISID',UNIQID,ISTAT)
      IF(ISTAT.EQ.0) RETURN

C Then try to find it from the image name
      IUND=0
      IDOT=0
      DO I=1,LEN(NAME)
         IF(NAME(I:I).EQ.'_') IUND=I
         IF(NAME(I:I).EQ.'.') THEN
            IDOT=I
            GO TO 88
         ENDIF
      ENDDO

 88   CONTINUE

      IF(IUND.LT.IDOT-1 .AND. IUND.GT.0) 
     :    READ(NAME(IUND+1:IDOT-1),'(I)',IOSTAT=ISTAT) UNIQID

      RETURN
      END 

      SUBROUTINE UCLGSD(PNAME,VAL,ISTAT)
C
C This is a routine to emulate the F77/VOS routine of the same
C name which seems to be missing. It gets the value as a character
C string from the CL (although the CL itself checks that it is a
C valid number) and converts it to a double precision value via
C a free-format read.
C
      IMPLICIT NONE

      CHARACTER*80 PNAME
      CHARACTER*80 CHARS
      DOUBLE PRECISION VAL
      INTEGER ISTAT

      CALL UCLGST(PNAME,CHARS,ISTAT)
      READ(CHARS,*,IOSTAT=ISTAT) VAL

      RETURN
      END

      SUBROUTINE OPCON(NAME,ONX,ONY,ID,ODCO,UNIQID,ISTAT)
C
C Open a context image in bitmap, 3d form, check
C whether there is room for the bit to be set and,
C if not, recreate a bigger one. Return the ID
C of the opened channel.
C
C It is expected that the file exists and isn't being
C created for the first time.
C
C Richard Hook, ST-ECF, January 2001
C
      IMPLICIT NONE

      CHARACTER*80 NAME
      INTEGER ID,UNIQID,ONX,ONY,IDOLD,ISTAT,J,N
      INTEGER IB
      LOGICAL ODCO

C Local variables
      INTEGER NDIMS,DIMS(7),DATTYP,I1,I2,NP
      CHARACTER*80 PNAME

C Buffer array
      INTEGER MEMI(1)
      COMMON /MEM/MEMI

C Assume we fail
      ODCO=.FALSE.

C First try to open what we have
      CALL UIMOPN(NAME,2,ID,ISTAT)
      IF(ISTAT.NE.0) THEN
         CALL UMSPUT(
     :    '! Unable to open current context image',
     :                 1,0,ISTAT)
         ISTAT=1
         RETURN
      ENDIF

C Look at its size and shape
      CALL UIMGID(ID,DATTYP,NDIMS,DIMS,ISTAT)

C Check it is the right size 
      IF(NDIMS.NE.2 .AND. NDIMS.NE.3) THEN
         CALL UMSPUT(
     :    '! Input image is not 2 or 3 dimensional',
     :                 1,0,ISTAT)
         ISTAT=1
         RETURN
      ENDIF

      IF(NDIMS.EQ.2) DIMS(3)=1

C Close the image
      CALL UIMCLO(ID,ISTAT)

C Calculate the number of planes required
      NP=(UNIQID-1)/32+1

C Check whether we need a new one
      IF(NP.GT.DIMS(3)) THEN

         CALL UMSPUT('! Creating new, more spacious, context file',
     :               1,0,ISTAT)

C Take a copy of the current one
         CALL UIMDEL('ConTemp',ISTAT)
         CALL UIMRNM(NAME,'ConTemp',ISTAT)
         IF(ISTAT.NE.0) RETURN

C Open it again
         CALL UIMOPN('ConTemp',1,IDOLD,ISTAT)
         IF(ISTAT.NE.0) THEN
           CALL UMSPUT('! Failed to re-open copy of context image',
     :                    1,0,ISTAT)
           ISTAT=1
           RETURN
         ENDIF

C Create the new one
         DIMS(3)=NP
         NDIMS=3
         CALL UIMCRE(NAME,4,3,DIMS,ID,ISTAT)
         IF(ISTAT.NE.0) THEN
            CALL UMSPUT(
     :        '! Unable to create new output context image',
     :                    1,0,ISTAT)
            ODCO=.FALSE.
            ISTAT=1
            RETURN
         ELSE
            CALL UMSPUT(
     :        '-Created new output context image: '//NAME,
     :                    1,0,ISTAT)
            ODCO=.TRUE.

C Copy the header as well
            CALL UHDCPY(IDOLD,ID,ISTAT)
            IF(ISTAT.NE.0) RETURN
         ENDIF
         
C Allocate a buffer
         CALL UDMGET(DIMS(1),4,IB,ISTAT)

C Copy the old stuff over
         DO N=1,NP-1
            DO J=1,DIMS(2)
               IF(NDIMS.EQ.2) THEN
                  CALL UIGL2I(IDOLD,J,MEMI(IB),ISTAT)
                  IF(ISTAT.NE.0) RETURN
               ELSE
                  CALL UIGL3I(IDOLD,J,N,MEMI(IB),ISTAT)
                  IF(ISTAT.NE.0) RETURN
               ENDIF

               CALL UIPL3I(ID,J,N,MEMI(IB),ISTAT)
               IF(ISTAT.NE.0) RETURN
            ENDDO
         ENDDO

C If this is the first extension (ie, there are now two planes)
C there are a few more things to add
         IF(NP.EQ.2) THEN
            CALL UHDAST(ID,'CTYPE3','CHANNEL',' ',0,ISTAT)
            CALL UHDASD(ID,'CRVAL3',0.0D0,' ',0,ISTAT)
            CALL UHDASD(ID,'CRPIX3',0.0D0,' ',0,ISTAT)
            CALL UHDASD(ID,'CD1_3',0.0D0,' ',0,ISTAT)
            CALL UHDASD(ID,'CD2_3',0.0D0,' ',0,ISTAT)
            CALL UHDASD(ID,'CD3_3',1.0D0,' ',0,ISTAT)
            CALL UHDASD(ID,'CD3_2',0.0D0,' ',0,ISTAT)
            CALL UHDASD(ID,'CD3_1',0.0D0,' ',0,ISTAT)
         ENDIF

C Close the temporary copy
         CALL UIMCLO(IDOLD,ISTAT)
         IF(ISTAT.NE.0) RETURN

C Initialise the new plane
         CALL SET1I(MEMI(IB),DIMS(1),0)

         DO J=1,DIMS(2)
            CALL UIPL3I(ID,J,NP,MEMI(IB),ISTAT)
            IF(ISTAT.NE.0) RETURN
         ENDDO

         CALL UMSPUT('-Written out new context image',1,0,ISTAT)

C Free buffer
         CALL UDMFRE(IB,4,ISTAT)

C Close the new copy
         CALL UIMCLO(ID,ISTAT)
         IF(ISTAT.NE.0) RETURN

C If we have got here all must be well so we can delete the
C old copy
         CALL UIMDEL('ConTemp',ISTAT)
         IF(ISTAT.NE.0) THEN
            CALL UMSPUT(
     : '! Warning, failed to delete copy of old context image',
     :    1,0,ISTAT)
         ENDIF
      ENDIF

      IF(NDIMS.EQ.2) THEN
         PNAME=NAME
      ELSE
         CALL LENSTR(NAME,I1,I2)
         WRITE(PNAME,'(A,''[*,*,'',I2,'']'')') NAME(I1:I2),NP
         IF(PNAME(I2+5:I2+5).EQ.' ') PNAME(I2+5:I2+5)='0'
      ENDIF

      CALL UIMOPN(PNAME,2,ID,ISTAT)      
      IF(ISTAT.NE.0) THEN
         CALL UMSPUT(
     : '! Unable to open context image'//PNAME,
     :                    1,0,ISTAT)
         ODCO=.FALSE.
         ISTAT=1
         RETURN
      ELSE
         CALL UMSPUT('-Opening extant context image: '//PNAME,
     :   1,0,ISTAT)
         ODCO=.TRUE.
      ENDIF

      RETURN
      END

      SUBROUTINE UHEAD(ID,VERS,DATA,WEIGHT,EXPTIM,WTSCL,OUTDAT,
     :                 OUTCOU,CONTIM,COEFFS,XGEOIM,YGEOIM,
     :                 SHFTUN,PFRACT,
     :                 LAM,SCALE,ROT,SHFTFR,ALIGN,KERNEL,EXPKEY,
     :                 FILSTR,INUN,OUTUN,
     :                 SECPAR,XSH2,YSH2,ROT2,XSCALE,YSCALE,SHFR2,
     :                 USEWCS,XSH,YSH,DNX,DNY,ONX,ONY)
C
C Update the header of the output image with all the
C parameters of the current DRIZZLE run.
C
C Added Kernel value and context file name, October 2000
C
C Added exposure time, January 2001
C
C Corrected bug in CONTIM output, March 2001
C
C Modified to be a little more intelligent and not to write
C out irrelevant information, March 2001
C
C Modified to include the align parameter even for wdrizzle
C to allow correct matching of distortions, October 2003
C
      IMPLICIT NONE

      INTEGER ID,DNX,DNY,ONX,ONY,ISTAT,I
      CHARACTER*80 DATA,WEIGHT
      CHARACTER*80 OUTDAT,OUTCOU,CONTIM,COEFFS,SHFTUN
      CHARACTER*80 BUFFER,FILSTR
      CHARACTER*80 XGEOIM,YGEOIM 
      CHARACTER*40 VERS
      CHARACTER*8 EXPKEY,INUN,OUTUN,ALIGN
      CHARACTER*4 STEM
      CHARACTER*8 SHFTFR,KERNEL
      DOUBLE PRECISION PFRACT,LAM,SCALE,ROT
      REAL EXPTIM
      DOUBLE PRECISION DROT,XSH,YSH,XSHI,YSHI,OFF
      REAL WTSCL
      LOGICAL USEWCS

C Secondary geometrical parameters, added in V1.5
      DOUBLE PRECISION XSH2,YSH2,ROT2,XSCALE,YSCALE
      CHARACTER*8 SHFR2
      LOGICAL SECPAR

      STEM='D000'

C First find out if there are old values
C This is very ugly
      DO I=1,999
         WRITE(STEM(2:4),'(I3)') I
         IF(STEM(2:2).EQ.' ') STEM(2:2)='0'
         IF(STEM(3:3).EQ.' ') STEM(3:3)='0'
         CALL UHDGST(ID,STEM//'VER',BUFFER,ISTAT)

C Check for a status code indicating that this header
C item doesn't exist
         IF(ISTAT.EQ.40) GO TO 111
      ENDDO

111   CONTINUE

C First update the number of images on this output
      IF(I.EQ.1) THEN
         CALL UHDASI(ID,'NDRIZIM',I,
     :  'Drizzle, number of images drizzled onto this output',
     :  0,ISTAT)
      ELSE
         CALL UHDPSI(ID,'NDRIZIM',I,ISTAT)
      ENDIF

C Then the version information
      CALL UHDAST(ID,STEM//'VER',VERS,
     :            'Drizzle, task version',0,ISTAT)

C Then the source of the geometric information
      IF(USEWCS) THEN
         CALL UHDAST(ID,STEM//'GEOM','Header WCS',
     :            'Drizzle, source of geometric information',0,ISTAT)
      ELSE
         CALL UHDAST(ID,STEM//'GEOM','User parameters',
     :            'Drizzle, source of geometric information',0,ISTAT)
      ENDIF
      
C Now we continue to add the other items using the same
C "stem"
      CALL UHDAST(ID,STEM//'DATA',DATA(1:64),
     :            'Drizzle, input data image',0,ISTAT)

      CALL UHDASR(ID,STEM//'DEXP',EXPTIM,
     :   'Drizzle, input image exposure time (s)',0,ISTAT)

      CALL UHDAST(ID,STEM//'OUDA',OUTDAT(1:64),
     :            'Drizzle, output data image',0,ISTAT)

      CALL UHDAST(ID,STEM//'OUWE',OUTCOU(1:64),
     :            'Drizzle, output weighting image',0,ISTAT)

      CALL UHDAST(ID,STEM//'OUCO',CONTIM(1:64),
     :            'Drizzle, output context image',0,ISTAT)

      CALL UHDAST(ID,STEM//'MASK',WEIGHT(1:64),
     :            'Drizzle, input weighting image',
     :            0,ISTAT)

      CALL UHDASR(ID,STEM//'WTSC',WTSCL,
     :  'Drizzle, weighting factor for input image',0,ISTAT)

      CALL UHDAST(ID,STEM//'KERN',KERNEL,
     :            'Drizzle, form of weight distribution kernel',0,ISTAT)

      CALL UHDASD(ID,STEM//'PIXF',PFRACT,
     :  'Drizzle, linear size of drop',0,ISTAT)

      CALL UHDAST(ID,STEM//'COEF',COEFFS(1:64),
     :            'Drizzle, coefficients file name ',0,ISTAT)

      CALL UHDAST(ID,STEM//'XGIM',XGEOIM(1:64),
     :            'Drizzle, X distortion image name ',0,ISTAT)

      CALL UHDAST(ID,STEM//'YGIM',YGEOIM(1:64),
     :            'Drizzle, Y distortion image name ',0,ISTAT)

      CALL UHDASD(ID,STEM//'LAM',LAM,
     : 'Drizzle, wavelength applied for transformation (nm)',
     :  0,ISTAT)

C Only put the next entries is we are NOT using WCS
      IF(.NOT.USEWCS) THEN
         CALL UHDASD(ID,STEM//'SCAL',SCALE,
     :    'Drizzle, scale (pixel size) of output image',0,ISTAT)

C Convert the rotation angle back to degrees
         DROT=ROT/3.1415926535897*180.0
         CALL UHDASD(ID,STEM//'ROT',DROT,
     :  'Drizzle, rotation angle, degrees anticlockwise',0,ISTAT)

C Check the SCALE and units
C The units are INPUT pixels on entry to this routine
         IF(SHFTUN.EQ.'output') THEN
            XSHI=XSH/SCALE
            YSHI=YSH/SCALE
         ELSE
            XSHI=XSH
            YSHI=YSH
         ENDIF

         CALL UHDASD(ID,STEM//'XSH',XSHI,
     :     'Drizzle, X shift applied',0,ISTAT)

         CALL UHDASD(ID,STEM//'YSH',YSHI,
     :     'Drizzle, Y shift applied',0,ISTAT)

         CALL UHDAST(ID,STEM//'SFTU',SHFTUN,
     :    'Drizzle, units used for shifts (output or input pixels)',
     :            0,ISTAT)

         CALL UHDAST(ID,STEM//'SFTF',SHFTFR,
     :    'Drizzle, frame in which shifts were applied',
     :            0,ISTAT)
      ENDIF

      CALL UHDAST(ID,STEM//'EXKY',EXPKEY,
     :  'Drizzle, exposure keyword name in input image',0,ISTAT)

      CALL UHDAST(ID,STEM//'INUN',INUN,
     :  'Drizzle, units of input image - counts or cps',0,ISTAT)

      CALL UHDAST(ID,STEM//'OUUN',OUTUN,
     :  'Drizzle, units of output image - counts or cps',0,ISTAT)

      CALL UHDAST(ID,STEM//'FVAL',FILSTR,
     :  'Drizzle, fill value for zero weight output pixels',
     :  0,ISTAT)

      IF(ALIGN.EQ.'corner') THEN
         OFF=0.5D0
      ELSE
         OFF=1.0D0
      ENDIF

      CALL UHDASD(ID,STEM//'INXC',DBLE(DNX/2.0)+OFF,
     :     'Drizzle, reference center of input image (X)',0,ISTAT)

      CALL UHDASD(ID,STEM//'INYC',DBLE(DNY/2.0)+OFF,
     :     'Drizzle, reference center of input image (Y)',0,ISTAT)

      CALL UHDASD(ID,STEM//'OUXC',DBLE(ONX/2.0)+OFF,
     :     'Drizzle, reference center of output image (X)',0,ISTAT)

      CALL UHDASD(ID,STEM//'OUYC',DBLE(ONY/2.0)+OFF,
     :     'Drizzle, reference center of output image (Y)',0,ISTAT)

C If there are secondary parameters add these too
      IF(SECPAR) THEN
         CALL UHDASB(ID,STEM//'SECP',.TRUE.,
     :  'Drizzle, there are secondary geometric parameters',0,ISTAT)

         CALL UHDASD(ID,STEM//'XSCL',XSCALE,
     :  'Drizzle, Secondary X scale applied',0,ISTAT)

         CALL UHDASD(ID,STEM//'YSCL',YSCALE,
     :  'Drizzle, Secondary Y scale applied',0,ISTAT)

         CALL UHDASD(ID,STEM//'XSH2',XSH2,
     :  'Drizzle, Secondary X shift applied',0,ISTAT)

         CALL UHDASD(ID,STEM//'YSH2',YSH2,
     :  'Drizzle, Secondary Y shift applied',0,ISTAT)

C Convert the rotation angle back to degrees
         DROT=ROT2/3.1415926535897*180.0
         CALL UHDASD(ID,STEM//'ROT2',DROT,
     :  'Drizzle, secondary rotation angle, degrees anticlockwise',
     :   0,ISTAT)
   
         CALL UHDAST(ID,STEM//'SFF2',SHFR2,
     : 'Drizzle, frame in which secondary shifts were applied',
     :            0,ISTAT)

      ELSE
         CALL UHDASB(ID,STEM//'SECP',.FALSE.,
     :  'Drizzle, there are no secondary geometric parameters',0,ISTAT)
      ENDIF

      RETURN
      END

      SUBROUTINE GETPAR(GEOMOD,KERNEL,PFRACT,COEFFS,LAM,XGEOIM,YGEOIM,
     :                  SCALE,ROT,XSH,YSH,SHFTFR,SHFTUN,ALIGN,
     :                  XSCALE,YSCALE,XSH2,YSH2,ROT2,SHFR2,
     :                  EXPKEY,WTSTR,FILSTR,INUN,OUTUN,
     :                  DATA,WEIGHT,OUTDAT,OUTCOU,CONTIM,ONX,ONY,
     :                  OUTSCL,RACEN,DECCEN,XREFP,YREFP,ORIENT)
C
C Read all the parameter values needed by Drizzle. 
C
C In this version they are obtained from the IRAF CL.
C There is no error checking as these routines should
C always succeed.
C
C This separate routine, October 2000
C
C Modified for WCS option  - STScI, November 2000
C
C Modified so that the geometrical parameters are obtained
C from another, general purpose, routine.
C  December 2001
C 
C Added reference pixel, Richard Hook, ST-ECF/STScI, June 2003
C
C Added XGEOIM,YGEOIM, Richard Hook, ST-ECF/STScI, August 2003
C
      IMPLICIT NONE

C The parameters
      CHARACTER*8 KERNEL,GEOMOD,EXPKEY,SHFTFR,INUN,OUTUN,ALIGN
      CHARACTER*80 COEFFS,SHFTUN,WTSTR,FILSTR,XGEOIM,YGEOIM
      CHARACTER*80 DATA,WEIGHT,OUTDAT,OUTCOU,CONTIM
      DOUBLE PRECISION SCALE,ROT,PFRACT,XSH,YSH,LAM
      DOUBLE PRECISION XSH2,YSH2,ROT2,XSCALE,YSCALE
      DOUBLE PRECISION RACEN,DECCEN,XREFP,YREFP
      DOUBLE PRECISION ORIENT,OUTSCL
      CHARACTER*8 SHFR2
      INTEGER ONX,ONY

C Local variables
      INTEGER ISTAT

C First the mode parameter - this is the WDRIZZLE change
      IF(GEOMOD.NE.'user') CALL UCLGST('geomode',GEOMOD,ISTAT)

C Now all the drizzle related parameters

C Kernel shape and size
      CALL UCLGST('kernel',KERNEL,ISTAT)
      CALL UCLGSD('pixfrac',PFRACT,ISTAT)

C Exposure time, weighting and data scaling related keywords
      CALL UCLGST('expkey',EXPKEY,ISTAT)
      CALL UCLGST('wt_scl',WTSTR,ISTAT)
      CALL UCLGST('fillval',FILSTR,ISTAT)
      CALL UCLGST('in_un',INUN,ISTAT)
      CALL UCLGST('out_un',OUTUN,ISTAT)

C Data array names
      CALL UCLGST('data',DATA,ISTAT)
      CALL UCLGST('in_mask',WEIGHT,ISTAT)
      CALL UCLGST('outdata',OUTDAT,ISTAT)
      CALL UCLGST('outweig',OUTCOU,ISTAT)
      CALL UCLGST('outcont',CONTIM,ISTAT)

C Output array sizes
      CALL UCLGSI('outnx',ONX,ISTAT)
      CALL UCLGSI('outny',ONY,ISTAT)

C Get all the geometrical parameters
      CALL GTGEPA(GEOMOD,COEFFS,LAM,XGEOIM,YGEOIM,
     :             SCALE,ROT,XSH,YSH,SHFTFR,SHFTUN,ALIGN,
     :             XSCALE,YSCALE,XSH2,YSH2,ROT2,SHFR2,
     :             OUTSCL,RACEN,DECCEN,XREFP,YREFP,ORIENT)

      RETURN
      END

      SUBROUTINE GTGEPA(GEOMOD,COEFFS,LAM,XGEOIM,YGEOIM,
     :                  SCALE,ROT,XSH,YSH,SHFTFR,SHFTUN,ALIGN,
     :                  XSCALE,YSCALE,XSH2,YSH2,ROT2,SHFR2,
     :                  OUTSCL,RACEN,DECCEN,XREFP,YREFP,ORIENT)
C
C Get all the Drizzle-related geometric parameters from the CL.
C
C This is a general routine for all the tasks related to drizzle.
C
C The primary and secondary linear transformations are read as
C well as the name of the coefficients file and the wavelength.
C
C The secondary parameters are obtained from the pset dr2gpar.
C
C Note that the value of the logical GEOMOD which is supplied
C is used to decide whether or not the WCS parameters are also
C read.
C
C Richard Hook, ST-ECF, December 2001
C
C Added XGEOIM,YGEOIM for image distortion option.
C  Richard Hook, ST-ECF/STScI, August 2003
C
      IMPLICIT NONE

      DOUBLE PRECISION SCALE,ROT,XSH,YSH,LAM
      DOUBLE PRECISION XSH2,YSH2,ROT2,XSCALE,YSCALE
      DOUBLE PRECISION RACEN,DECCEN,XREFP,YREFP
      DOUBLE PRECISION ORIENT,OUTSCL
      CHARACTER*80 COEFFS,SHFTUN,XGEOIM,YGEOIM
      CHARACTER*8 SHFR2,SHFTFR,ALIGN,GEOMOD
      INTEGER ISTAT

C The name of the geometric distortion coefficients file
C and wavelength for the Trauger (WFPC2) case
      CALL UCLGST('coeffs',COEFFS,ISTAT)
      CALL UCLGSD('lambda',LAM,ISTAT)

C Get the image geometry file names
      CALL UCLGST('xgeoim',XGEOIM,ISTAT)
      CALL UCLGST('ygeoim',YGEOIM,ISTAT)

C Primary linear transformation parameters
      CALL UCLGSD('scale',SCALE,ISTAT)
      CALL UCLGSD('rot',ROT,ISTAT)
      CALL UCLGSD('xsh',XSH,ISTAT)
      CALL UCLGSD('ysh',YSH,ISTAT)
      CALL UCLGST('shft_fr',SHFTFR,ISTAT)
      CALL UCLGST('shft_un',SHFTUN,ISTAT)
      CALL UCLGST('align',ALIGN,ISTAT)

C Secondary transformation parameters - these come
C from a specific pset and are hence the same for
C all routines
      CALL UCLGSD('dr2gpar.xscale',XSCALE,ISTAT)
      CALL UCLGSD('dr2gpar.yscale',YSCALE,ISTAT)
      CALL UCLGSD('dr2gpar.xsh',XSH2,ISTAT)
      CALL UCLGSD('dr2gpar.ysh',YSH2,ISTAT)
      CALL UCLGSD('dr2gpar.rot',ROT2,ISTAT)
      CALL UCLGST('dr2gpar.shft_fr',SHFR2,ISTAT)

C WCS mode parameters of the output
C - only in the case where GEOMOD is set appropriately
      IF(GEOMOD.EQ.'wcs') THEN
         CALL UCLGSD('outscl',OUTSCL,ISTAT)
         CALL UCLGSD('raref',RACEN,ISTAT)
         CALL UCLGSD('decref',DECCEN,ISTAT)
         CALL UCLGSD('xrefpix',XREFP,ISTAT)
         CALL UCLGSD('yrefpix',YREFP,ISTAT)
         CALL UCLGSD('orient',ORIENT,ISTAT)
      ENDIF

      RETURN
      END

      SUBROUTINE ALLMEM(DNX,DNY,ONX,NSX,NSY,CON,BITCON,
     :   PDATA,PWEI,PNDAT,PNCOU,PNCON,PCDON,PBUFF,PIBUFF,
     :   PXI,PYI,PXO,PYO,PXIB,PYIB,PXOB,PYOB,ISTAT)
C
C Allocate the dynamic memory arrays needed for drizzle.
C
C This routine was added and the corresponding calls removed from
C the main module, October 2000
C
C Added BITCON flag for PCDON array - January 2001
C
      IMPLICIT NONE

      INTEGER DNX,DNY,ONX,NSX,NSY
      INTEGER PDATA,PWEI,PNDAT,PNCOU,PNCON,PCDON,PBUFF,PIBUFF
      INTEGER PXI,PYI,PXO,PYO
      INTEGER PXIB,PYIB,PXOB,PYOB,ISTAT
      LOGICAL CON
      LOGICAL BITCON

C Set all the pointers to zero to start with - if they stay that
C way we can assume the allocation has failed
      PDATA=0
      PWEI=0
      PNDAT=0
      PNCOU=0
      PNCON=0
      PCDON=0
      PBUFF=0
      PIBUFF=0
      PXI=0
      PYI=0
      PXO=0
      PYO=0
      PXIB=0
      PYIB=0
      PXOB=0
      PYOB=0

C Allocate the memory arrays and return the pointers, check for
C error status

C Single line buffers for input data and weight images
      CALL UDMGET(DNX,6,PDATA,ISTAT)
      IF(ISTAT.NE.0) RETURN

      CALL UDMGET(DNX,6,PWEI,ISTAT)
      IF(ISTAT.NE.0) RETURN

C Note that the next three, as they are subsets of the output
C are of a different size
      CALL UDMGET(NSX*NSY,6,PNDAT,ISTAT)
      IF(ISTAT.NE.0) RETURN

      CALL UDMGET(NSX*NSY,6,PNCOU,ISTAT)
      IF(ISTAT.NE.0) RETURN

C This one, the context image, is optional
      IF(CON) THEN
         CALL UDMGET(NSX*NSY,4,PNCON,ISTAT)
         IF(ISTAT.NE.0) RETURN
         IF(.NOT.BITCON) THEN
            CALL UDMGET(NSX*NSY,4,PCDON,ISTAT)
            IF(ISTAT.NE.0) RETURN
         ENDIF
      ENDIF

C Scratch buffer space - the larger of the input and output 
      IF(DNX.GT.ONX) THEN
         CALL UDMGET(DNX,6,PBUFF,ISTAT) 
         CALL UDMGET(DNX,4,PIBUFF,ISTAT) 
      ELSE
         CALL UDMGET(ONX,6,PBUFF,ISTAT)
         CALL UDMGET(ONX,4,PIBUFF,ISTAT)
      ENDIF
      IF(ISTAT.NE.0) RETURN

      CALL UDMGET(DNX*4,7,PXI,ISTAT)
      IF(ISTAT.NE.0) RETURN

      CALL UDMGET(DNX*4,7,PYI,ISTAT)
      IF(ISTAT.NE.0) RETURN

      CALL UDMGET(DNX*4,7,PXO,ISTAT)
      IF(ISTAT.NE.0) RETURN

      CALL UDMGET(DNX*4,7,PYO,ISTAT)
      IF(ISTAT.NE.0) RETURN

      CALL UDMGET(DNX,7,PXIB,ISTAT)
      IF(ISTAT.NE.0) RETURN

      CALL UDMGET(DNX,7,PYIB,ISTAT)
      IF(ISTAT.NE.0) RETURN

      CALL UDMGET(DNX,7,PXOB,ISTAT)
      IF(ISTAT.NE.0) RETURN

      CALL UDMGET(DNX,7,PYOB,ISTAT)      
      IF(ISTAT.NE.0) RETURN
      

C If we get here all is well
      ISTAT=0
      RETURN
      END

      SUBROUTINE FREMEM(PDATA,PWEI,PNDAT,PNCOU,PNCON,PCDON,PBUFF,PIBUFF,
     :   PXI,PYI,PXO,PYO,PXIB,PYIB,PXOB,PYOB)
C
C Free all allocated memory arrays. 
C
C Successful allocations will have non-zero pointers.
C
C Added October 2000.
C
      IMPLICIT NONE

      INTEGER PDATA,PWEI,PNDAT,PNCOU,PNCON,PCDON,PBUFF,PIBUFF
      INTEGER PXI,PYI,PXO,PYO
      INTEGER PXIB,PYIB,PXOB,PYOB,ISTAT

      IF(PDATA.NE.0) CALL UDMFRE(PDATA,6,ISTAT)
      IF(PWEI.NE.0) CALL UDMFRE(PWEI,6,ISTAT)
      IF(PNDAT.NE.0) CALL UDMFRE(PNDAT,6,ISTAT)
      IF(PNCOU.NE.0) CALL UDMFRE(PNCOU,6,ISTAT)
      IF(PNCON.NE.0) CALL UDMFRE(PNCON,4,ISTAT)
      IF(PCDON.NE.0) CALL UDMFRE(PCDON,4,ISTAT)
      IF(PIBUFF.NE.0) CALL UDMFRE(PIBUFF,4,ISTAT)
      IF(PXI.NE.0) CALL UDMFRE(PXI,7,ISTAT)
      IF(PYI.NE.0) CALL UDMFRE(PYI,7,ISTAT)
      IF(PXO.NE.0) CALL UDMFRE(PXO,7,ISTAT)
      IF(PYO.NE.0) CALL UDMFRE(PYO,7,ISTAT)
      IF(PXIB.NE.0) CALL UDMFRE(PXIB,7,ISTAT)
      IF(PYIB.NE.0) CALL UDMFRE(PYIB,7,ISTAT)
      IF(PXOB.NE.0) CALL UDMFRE(PXOB,7,ISTAT)
      IF(PYOB.NE.0) CALL UDMFRE(PYOB,7,ISTAT)

      RETURN
      END
      
      
      SUBROUTINE GETGEO(COEFFS,IDD,LAM,
     :                  COTY,COMAX,CONUM,XCO,YCO,ISTAT)
C
C Get the geometrical distortion information, either from
C a file or the header.
C
C This new routine, October 2000
C Modified in drizzle 2.1 for more flexible coefficients
C
C Added distortion image support, Richard Hook, ST-ECF/STScI, August 2003
C Moved distortion image support to GGEOIM, W. Hack, June 2004
C
C
      IMPLICIT NONE

      INTEGER IDD
      INTEGER COTY,COMAX,CONUM
      DOUBLE PRECISION LAM,XCO(COMAX),YCO(COMAX)
      CHARACTER*80 COEFFS
      INTEGER LUN,ISTAT,I
      LOGICAL NOCO

C Interpret the coefficients file name and act appropriately
      NOCO=.FALSE.
      IF(COEFFS.EQ.' ') NOCO=.TRUE.

C Now check for the special string "header"
      IF(COEFFS.EQ.'header') THEN

C and try to read these from the input header
         CALL GTCOEF(IDD,COEFFS,LAM,ISTAT)
         IF(ISTAT.NE.0) THEN
            CALL UMSPUT(
     : '! Cannot deduce image distortion information from header',
     :      1,0,ISTAT)
            ISTAT=1
            RETURN
         ENDIF
      ENDIF

C Set default values
      IF(NOCO) THEN
         DO I=1,COMAX
            XCO(I)=0.0D0
            YCO(I)=0.0D0
         ENDDO
C To avoid problems later set the linear terms to the identity, not
C just zero (added, Richard Hook, July 2005)
         XCO(2)=1.0D0 
         YCO(3)=1.0D0
         CONUM=1
         COTY=0
      ELSE

C Check for WCS coefficients - Spitzer format in image
C header
         IF(COEFFS.EQ.'wcs') THEN
           CALL GTSPCO(IDD,COTY,CONUM,XCO,YCO,ISTAT)

C Additional check here
           IF(ISTAT.NE.0) RETURN

           CALL UMSPUT('-Reading non-linear WCS coefficients',
     :                 1,0,ISTAT)
           RETURN

         ELSE
C Open the coefficients file
           CALL UFOPEN(COEFFS,1,LUN,ISTAT)
           IF(ISTAT.NE.0) THEN
            CALL UMSPUT('! Unable to open coefficients file',1,0,
     :                  ISTAT)
            ISTAT=1
            RETURN
           ELSE
            CALL UMSPUT('-Opening coefficients file: '//COEFFS,
     :                      1,0,ISTAT)
           ENDIF
         ENDIF

C Read in the coefficients from the file
         CALL GETCO(LUN,LAM,COTY,COMAX,CONUM,XCO,YCO,ISTAT)
         IF(ISTAT.NE.0) THEN
            CALL UMSPUT('! Unable to read coefficients',
     :                       1,0,ISTAT)
            CALL UFCLOS(LUN,ISTAT)
            ISTAT=1
            RETURN
         ENDIF

C Close the coefficients file
         CALL UFCLOS(LUN,ISTAT)
      ENDIF
      
C Set a good status return
      ISTAT=0
      RETURN 
      END


      SUBROUTINE GGEOIM(XGEOIM,YGEOIM,PXG,PYG,XGDIM,YGDIM,DISIM)
C
C Read the distortion image arrays from distortion images
C   Dynamically allocates space for arrays PXG, PYG based on size 
C   of arrays as read from image header using 'UIMGID'.
C
C If no images are read in, XGDIM and YGDIM default to values of 1.
C
C
C Code was moved from 'GETGEO'.  W. Hack, June 2004
C

      CHARACTER*80 XGEOIM,YGEOIM,CHARS
      INTEGER DATTYP,DDIMS(7),NDIMS,IXG,IYG
      INTEGER ISTAT,PXG,PYG
      LOGICAL DISIM
      INTEGER XGDIM,YGDIM

      REAL MEMR(1)
      COMMON /MEM/MEMR

      DISIM=.FALSE.
      XGDIM = 2
      YGDIM = 2
      
C Check we have both distortion images
      IF(XGEOIM.NE.' ' .AND. YGEOIM.EQ.' ' .OR.
     :   XGEOIM.EQ.' ' .AND. YGEOIM.NE.' ') THEN
         CALL UMSPUT('! Must have both X and Y distortion images',
     :               1,0,ISTAT)
         ISTAT=1
                          
         RETURN
      ENDIF
         
C Try to open the distortion images
C allocate space and read them in...
      PXG=0
      PYG=0
C X first
      IF(XGEOIM.NE.' ') THEN
         CALL UIMOPN(XGEOIM,1,IXG,ISTAT)
         IF(ISTAT.NE.0) THEN
            CALL UMSPUT('! Failed to open X-shift distortion image',
     :                  1,0,ISTAT)
            ISTAT=1
         ELSE
            CHARS='-Opening X-shift distortion image: '//XGEOIM
            CALL UMSPUT(CHARS,1,0,ISTAT)
         ENDIF

C Get the array size and shape
         IF(ISTAT.EQ.0) THEN
            CALL UIMGID(IXG,DATTYP,NDIMS,DDIMS,ISTAT)
            XGDIM = DDIMS(1)
            YGDIM = DDIMS(2)

C Allocate space
            IF (ISTAT .EQ. 0) THEN
               CALL UDMGET(DDIMS(1)*DDIMS(2),6,PXG,ISTAT)
               IF(ISTAT.NE.0) THEN
                  CALL UMSPUT('! Failed to allocate X-shift space',
     :                     1,0,ISTAT)
                  ISTAT=1
               ENDIF

C Read the image
               IF(ISTAT.EQ.0) THEN
                  CALL RIMR(IXG,DDIMS(1),DDIMS(2),MEMR(PXG),ISTAT)
                  IF(ISTAT.NE.0) THEN
                     CALL UMSPUT('! Failed to read X-shift image',
     :                          1,0,ISTAT)
                     ISTAT=1
                  ENDIF
               ENDIF
            ENDIF
         ENDIF

C Close the image
         CALL UIMCLO(IXG,ISTAT)
      ENDIF
      
      IF(ISTAT.NE.0) THEN
C Initialize default arrays upon error.
         DISIM=.FALSE.
         XGDIM = 2
         YGDIM = 2
         CALL UDMGET(XGDIM*YGDIM,6,PXG,ISTAT)
         CALL UDMGET(XGDIM*YGDIM,6,PYG,ISTAT)
         RETURN
      ENDIF
C Y next 
      IF(YGEOIM.NE.' ') THEN
         CALL UIMOPN(YGEOIM,1,IYG,ISTAT)
         IF(ISTAT.NE.0) THEN
            CALL UMSPUT('! Failed to open Y-shift distortion image',
     :                  1,0,ISTAT)
            ISTAT=1
         ELSE
            CHARS='-Opening Y-shift distortion image: '//YGEOIM
            CALL UMSPUT(CHARS,1,0,ISTAT)
         ENDIF

C Get the array size and shape
         IF (ISTAT .EQ. 0) THEN
            CALL UIMGID(IYG,DATTYP,NDIMS,DDIMS,ISTAT)

            IF (XGDIM .LT. 0 .AND. YGDIM .LT. 0) THEN
               XGDIM = DDIMS(1)
               YGDIM = DDIMS(2)
            ENDIF
C Allocate space
            IF (ISTAT .EQ. 0) THEN
               CALL UDMGET(DDIMS(1)*DDIMS(2),6,PYG,ISTAT)

               IF(ISTAT.NE.0) THEN
                  CALL UMSPUT('! Failed to allocate Y-shift space',
     :                    1,0,ISTAT)
                  ISTAT=1
               ENDIF

C Read the image
               IF (ISTAT .EQ. 0) THEN
                  CALL RIMR(IYG,DDIMS(1),DDIMS(2),MEMR(PYG),ISTAT)

                  IF(ISTAT.NE.0) THEN
                     CALL UMSPUT('! Failed to read Y-shift image',
     :                        1,0,ISTAT)
                     ISTAT=1
                  ENDIF
               ENDIF
            ENDIF
         ENDIF

C Close the image
         CALL UIMCLO(IYG,ISTAT)

         DISIM=.TRUE.
      ENDIF
      IF(ISTAT.NE.0) THEN
C Initialize default arrays upon error.
         DISIM=.FALSE.
         XGDIM = 2
         YGDIM = 2
         CALL UDMGET(XGDIM*YGDIM,6,PXG,ISTAT)
         CALL UDMGET(XGDIM*YGDIM,6,PYG,ISTAT)
         RETURN
      ENDIF

C Set a good status return
      ISTAT=0
      RETURN
      END

      SUBROUTINE COPHED(IDI,IDO,COPALL,ISTAT)
C
C Copy over some important header items from the first
C drizzled input image to the newly created output images.
C
C Richard Hook, March 2001
C
      IMPLICIT NONE

      INTEGER IDI,IDO,ISTAT
      LOGICAL COPALL

      CHARACTER*80 BUFFER

C If we are to copy everything just do it directly
      IF(COPALL) THEN
         CALL UHDCPY(IDI,IDO,ISTAT)
      ELSE

C Just copy a few things

C First equinox and radesys - as strings
         CALL UHDGST(IDI,'EQUINOX',BUFFER,ISTAT)
         IF(ISTAT.EQ.0) 
     : CALL UHDAST(IDO,'EQUINOX',BUFFER,' ',0,ISTAT)
         CALL UHDGST(IDI,'RADESYS',BUFFER,ISTAT)
         IF(ISTAT.EQ.0) 
     : CALL UHDAST(IDO,'RADESYS',BUFFER,' ',0,ISTAT)

C Now instrument related things
         CALL UHDGST(IDI,'INSTRUME',BUFFER,ISTAT)
         IF(ISTAT.EQ.0) 
     : CALL UHDAST(IDO,'INSTRUME',BUFFER,' ',0,ISTAT)
         CALL UHDGST(IDI,'DETECTOR',BUFFER,ISTAT)
         IF(ISTAT.EQ.0) 
     : CALL UHDAST(IDO,'DETECTOR',BUFFER,' ',0,ISTAT)
         CALL UHDGST(IDI,'CAMERA',BUFFER,ISTAT)
         IF(ISTAT.EQ.0) 
     : CALL UHDAST(IDO,'CAMERA',BUFFER,' ',0,ISTAT)
         CALL UHDGST(IDI,'PHOTPLAM',BUFFER,ISTAT)
         IF(ISTAT.EQ.0) 
     : CALL UHDAST(IDO,'PHOTPLAM',BUFFER,' ',0,ISTAT)
      ENDIF

      RETURN
      END

      SUBROUTINE DUPWCS(WCSIN,WCSOUT,DNX,DNY,COEFFS,
     :                  XGEOIM,YGEOIM,PXG,PYG,ID,ISTAT)
C
C Update the WCS of an image to allow for the distortion
C of a coefficients file.
C
C This is a wrapper for UPWCS when all the geometric parameters
C are null.
C
C Written for WCS2DR.
C
C  Richard Hook, May 2002, STScI
C
C Updated for the distortion images, August 2003
C
      IMPLICIT NONE

      DOUBLE PRECISION WCSIN(8),WCSOUT(8)
      CHARACTER*80 XGEOIM,YGEOIM
      CHARACTER*(*) COEFFS
      INTEGER DNX,DNY,ID,ISTAT,I

      INTEGER COTY,CONUM,COMAX
      PARAMETER (COMAX=100)

      DOUBLE PRECISION XCO(COMAX),YCO(COMAX)

      REAL MEMR(1)
      COMMON /MEM/MEMR

C Geometrical parameters, the standard set
      DOUBLE PRECISION SCALE,ROT,XSH,YSH,LAM
      DOUBLE PRECISION XSH2,YSH2,ROT2,XSCALE,YSCALE
      CHARACTER*80 SHFTUN
      CHARACTER*8 SHFR2,SHFTFR,ALIGN,GEOMOD
      INTEGER PXG,PYG,XGDIM,YGDIM
      LOGICAL DISIM

      LOGICAL SECPAR,ROTFIR,USEWCS,ROTF2

C Set default values
      XSH=0.0D0
      YSH=0.0D0
      SCALE=1.0D0
      ROT=0.0D0
      SHFTFR="output"
      SHFTUN="output"
      GEOMOD="user"
      SECPAR=.FALSE.
      ROTFIR=.TRUE.
      ALIGN="center"

C If no coefficients then just return after copying
      IF(COEFFS.EQ.' ') THEN
         DO I=1,8
            WCSOUT(I)=WCSIN(I)
         ENDDO
         CONUM=1
         COTY=0
      ENDIF

C Get the lambda parameter
      CALL UCLGSD('lambda',LAM,ISTAT)

C Get the geometric distortion coefficient information
      CALL GETGEO(COEFFS,ID,LAM,
     :      COTY,COMAX,CONUM,XCO,YCO,ISTAT)

      IF(ISTAT.NE.0) THEN
         CALL UMSPUT(
     :     '! Error, failed to get geometric distortion coefficients',
     :     1,0,ISTAT)
           ISTAT=1
         RETURN
      ENDIF

C  Read in any distortion image corrections, if specified
C  PXG,PYG will default to 2x2 arrays when DISIM returns as FALSE.
C 
      CALL GGEOIM(XGEOIM,YGEOIM,PXG,PYG,XGDIM,YGDIM,DISIM)

C Update the WCS
      CALL UPWCS(WCSIN,WCSOUT,DNX,DNY,DNX,DNY,
     :            XSH,YSH,ROT,SCALE,ALIGN,ROTFIR,
     :            SECPAR,XSH2,YSH2,ROT2,XSCALE,YSCALE,SHFR2,ROTF2,
     :            USEWCS,COTY,CONUM,XCO,YCO,
     :            DISIM,PXG,PYG,ALPHA,BETA)

      ISTAT=0
      RETURN
      END

      SUBROUTINE RIMR(ID,NX,NY,D,ISTAT)
C
C Read an open, real image into a pre-allocated space
C
      IMPLICIT NONE

      INTEGER ID,NX,NY,ISTAT
      REAL D(NX,NY)

      INTEGER J

      DO J=1,NY
         CALL UIGL2R(ID,J,D(1,J),ISTAT)
      ENDDO

      END

      SUBROUTINE GTSPCO(ID,COTY,CONUM,XCO,YCO,ISTAT)
C
C Read Spitzer-format WCS distortion coefficients from an
C image header and populate the distortion arrays.
C
C Experimental first implementation, Richard Hook, March 2004
C Relies heavily on STSDAS f77/vos routines...
C
      IMPLICIT NONE

      INTEGER COTY,ID,CONUM,ISTAT,IS,XORD,YORD,ORDER,N,M
      INTEGER COOFF,NC
      PARAMETER (COOFF=100)

      CHARACTER*12 CTYPE1,CTYPE2
      CHARACTER*5 KEY
      DOUBLE PRECISION CRPIX1,CRPIX2,XCO(*),YCO(*)
      DOUBLE PRECISION PSCALE, CD11, CD12, CD21, CD22
      DOUBLE PRECISION RSCALE
      INTEGER PINDX

C First try to get the CTYPE keywords and confirm they are as
C expected
      CALL UHDGST(ID,'CTYPE1',CTYPE1,ISTAT)

      IF(ISTAT.NE.0) CALL UMSPUT(
     :   '! Warning, unable to read CTYPE1 from header',1,0,IS)
      IF(ISTAT.NE.0) RETURN

      IF(CTYPE1.NE.'RA---TAN-SIP') THEN
         CALL UMSPUT('! SIP-style CTYPE not found',1,0,IS)
         ISTAT=1
         RETURN
      ENDIF

      CALL UHDGST(ID,'CTYPE2',CTYPE2,ISTAT)

      IF(ISTAT.NE.0) CALL UMSPUT(
     :   '! Warning, unable to read CTYPE2 from header',1,0,IS)
      IF(ISTAT.NE.0) RETURN

      IF(CTYPE2.NE.'DEC--TAN-SIP') THEN
         CALL UMSPUT('! SIP-style CTYPE not found',1,0,IS)
         ISTAT=1
         RETURN
      ENDIF

C Get the reference pixel
      CALL UHDGSD(ID,'CRPIX1',CRPIX1,ISTAT)
      IF(ISTAT.NE.0) THEN
         CALL UMSPUT(
     :   '! Unable to read CRPIX1 from header',1,0,IS)
         
         RETURN
      ENDIF

      CALL UHDGSD(ID,'CRPIX2',CRPIX2,ISTAT)
      IF(ISTAT.NE.0) THEN
         CALL UMSPUT(
     :   '! Unable to read CRPIX2 from header',1,0,IS)
         ISTAT=1
         RETURN
      ENDIF

C Now look for the order in X and Y
      CALL UHDGSI(ID,'A_ORDER',XORD,ISTAT)
      IF(ISTAT.NE.0) THEN
         CALL UMSPUT(
     :   '! Unable to find X polynomial order in header',1,0,IS)
         ISTAT=1
         RETURN
      ENDIF

      CALL UHDGSI(ID,'B_ORDER',YORD,ISTAT)
      IF(ISTAT.NE.0) THEN
         CALL UMSPUT(
     :   '! Unable to find Y polynomial order in header',1,0,IS)
         ISTAT=1
         RETURN
      ENDIF

C Now read in the photometric scaling parameter
      CALL UHDGSD(ID,'PAMSCALE',PSCALE, ISTAT)
      IF(ISTAT.NE.0) THEN
          ISTAT=0
          CALL UHDGSD(ID,'IDCSCALE',PSCALE, ISTAT)
      ENDIF
      IF(ISTAT.NE.0) THEN
         CALL UMSPUT(
     :   '! Unable to find photometric scale in header',1,0,IS)
         ISTAT=1
         RETURN
      ENDIF
C Get the CD matrix values to compute the area of the ref pixel
      CALL UHDGSD(ID,'CD1_1',CD11, ISTAT)
      CALL UHDGSD(ID,'CD1_2',CD12, ISTAT)
      CALL UHDGSD(ID,'CD2_1',CD21, ISTAT)
      CALL UHDGSD(ID,'CD2_2',CD22, ISTAT)
      RSCALE = SQRT(ABS(CD11*CD22 - CD21*CD12))*3600.
      
C Set the order to the higher
      ORDER=MAX(XORD,YORD)

C Offset to show we have an explicit refpix
      COTY=COOFF+ORDER
C Add an additional 1 to CONUM to accomodate 
C    photometric scaling terms
      CONUM=(ORDER+1)*(ORDER+2)/2+1+1

C Initialize the photometric scaling terms with default values
      PINDX = CONUM-1
      XCO(PINDX)= RSCALE
      YCO(PINDX)= PSCALE
      
C and set the refpix to the CRPIXs
      XCO(CONUM)=CRPIX1
      YCO(CONUM)=CRPIX2

C Read all the coefficients and set any omitted ones to zero

C X first
      NC=1
      DO N=1,ORDER+1
         DO M=1,N
            WRITE(KEY,'(''A_'',I1,''_'',I1)') N-M,M-1
            CALL UHDGSD(ID,KEY,XCO(NC),ISTAT)
            IF(ISTAT.NE.0) XCO(NC)=0.0D0
            NC=NC+1
         ENDDO
      ENDDO

C and Y
      NC=1
      DO N=1,ORDER+1
         DO M=1,N
            WRITE(KEY,'(''B_'',I1,''_'',I1)') N-M,M-1
            CALL UHDGSD(ID,KEY,YCO(NC),ISTAT)
            IF(ISTAT.NE.0) YCO(NC)=0.0D0
            NC=NC+1
         ENDDO
      ENDDO

C The Spitzer coefficients are offsets so we need to add
C an extra X and Y
      XCO(2)=XCO(2)+1.0D0
      YCO(3)=YCO(3)+1.0D0

      ISTAT=0
      RETURN
      END
      SUBROUTINE BUHEAD(ID,VERS,DATA,OUTDAT,COEFFS,XGEOIM,YGEOIM,
     :      SHFTUN,MISVAL,
     :      EXPKEY,EXPSTR,ALIGN,INUN,OUTUN,
     :      SHFTFR,INTERP,LAM,SCALE,ROT,XSH,YSH,
     :      SECPAR,XSH2,YSH2,ROT2,XSCALE,YSCALE,SHFR2,OUTNX,OUTNY)
C
C Update the header of the output image with all the
C parameters of the current BLOT run.
C
C Updated in December 2001 to include the secondary geometric parameters
C
      IMPLICIT NONE

      INTEGER ID,OUTNX,OUTNY,ISTAT
      CHARACTER*80 DATA
      CHARACTER*80 OUTDAT,COEFFS,XGEOIM,YGEOIM
      CHARACTER*7 INTERP
      CHARACTER*8 SHFTFR,SHFTUN,EXPKEY,ALIGN,INUN,OUTUN
      CHARACTER*80 EXPSTR
      CHARACTER*(*) VERS
      DOUBLE PRECISION LAM,SCALE,ROT
      DOUBLE PRECISION DROT,XSH,YSH,XSHI,YSHI
      REAL MISVAL

C Secondary geometrical parameters, added in V1.5
      DOUBLE PRECISION XSH2,YSH2,ROT2,XSCALE,YSCALE
      CHARACTER*8 SHFR2
      LOGICAL SECPAR

C Constants
      DOUBLE PRECISION PI
      PARAMETER (PI=3.1415926536)

      CALL UHDAST(ID,'BLOTVER',VERS,
     :            'Blot, task version',0,ISTAT)
      
      CALL UHDAST(ID,'BLOTDATA',DATA(1:64),
     :            'Blot, input data image',0,ISTAT)

      CALL UHDAST(ID,'BLOTOUTDA',OUTDAT(1:64),
     :            'Blot, output data image',0,ISTAT)

      CALL UHDAST(ID,'BLOTCOEFF',COEFFS(1:64),
     :            'Blot, coefficients file name ',0,ISTAT)

      CALL UHDAST(ID,'BLOTXGIM',XGEOIM(1:64),
     :            'Blot, X distortion image name ',0,ISTAT)

      CALL UHDAST(ID,'BLOTYGIM',YGEOIM(1:64),
     :            'Blot, Y distortion image name ',0,ISTAT)

      CALL UHDASD(ID,'BLOTLAM',LAM,
     : 'Blot, wavelength applied for transformation (nm)',
     :  0,ISTAT)

      CALL UHDASD(ID,'BLOTSCALE',SCALE,
     : 'Blot, scale (pixel size) of input image',0,ISTAT)

C Convert the rotation angle back to degrees
      DROT=ROT/PI*180.0D0

      CALL UHDASD(ID,'BLOTROT',DROT,
     :  'Blot, rotation angle, degrees clockwise',0,ISTAT)

C Check the SCALE and units
      IF(SHFTUN.EQ.'input') THEN
         XSHI=XSH/SCALE
         YSHI=YSH/SCALE
      ELSE
         XSHI=XSH
         YSHI=YSH
      ENDIF

      CALL UHDASD(ID,'BLOTXSH',XSHI,
     :  'Blot, X shift applied',0,ISTAT)

      CALL UHDASD(ID,'BLOTYSH',YSHI,
     :  'Blot, Y shift applied',0,ISTAT)

      CALL UHDAST(ID,'BLOTSHFU',SHFTUN,
     : 'Blot, units used for shifts (output or input pixels)',
     :            0,ISTAT)

      CALL UHDAST(ID,'BLOTINUN',INUN,
     : 'Blot, units of input image (counts or cps)',
     :            0,ISTAT)

      CALL UHDAST(ID,'BLOTOUUN',OUTUN,
     : 'Blot, units for output image (counts or cps)',
     :            0,ISTAT)

      CALL UHDAST(ID,'BLOTSHFF',SHFTFR,
     : 'Blot, frame in which shifts were applied',0,ISTAT)

      CALL UHDASI(ID,'BLOTONX',OUTNX,
     :  'Blot, X size of output image',0,ISTAT)

      CALL UHDASI(ID,'BLOTONY',OUTNY,
     :  'Blot, Y size of output image',0,ISTAT)

      CALL UHDAST(ID,'BLOTINT',INTERP,
     :  'Blot, interpolation method used',0,ISTAT)

      CALL UHDASR(ID,'BLOTFILVA',MISVAL,
     :  'Blot, value assigned to invalid pixels',0,ISTAT)

      CALL UHDAST(ID,'BLOTEXKY',EXPKEY,
     :  'Blot, exposure time keyword in input header',0,ISTAT)

      CALL UHDAST(ID,'BLOTEXOU',EXPSTR,
     :  'Blot, exposure time for output image',0,ISTAT)

C If there are secondary parameters add these too
      IF(SECPAR) THEN
         CALL UHDASB(ID,'BLOTSECP',.TRUE.,
     :  'Blot, there are secondary geometric parameters',0,ISTAT)

         CALL UHDASD(ID,'BLOTXSCL',XSCALE,
     :  'Blot, Secondary X scale applied',0,ISTAT)

         CALL UHDASD(ID,'BLOTYSCL',YSCALE,
     :  'Blot, Secondary Y scale applied',0,ISTAT)

         CALL UHDASD(ID,'BLOTXSH2',XSH2,
     :  'Blot, Secondary X shift applied',0,ISTAT)

         CALL UHDASD(ID,'BLOTYSH2',YSH2,
     :  'Blot, Secondary Y shift applied',0,ISTAT)

C Convert the rotation angle back to degrees
         DROT=ROT2/PI*180.0D0

         CALL UHDASD(ID,'BLOTROT2',DROT,
     :  'Blot, secondary rotation angle, degrees anticlockwise',
     :   0,ISTAT)
  
         CALL UHDAST(ID,'BLOTSFF2',SHFR2,
     : 'Blot, frame in which secondary shifts were applied',
     :            0,ISTAT)

      ELSE
         CALL UHDASB(ID,'BLOTSECP',.FALSE.,
     :  'Blot, there are no secondary geometric parameters',0,ISTAT)
      ENDIF

      RETURN
      END

      SUBROUTINE BALLME(DNX,DNY,ONX,ONY,NSX,NSY,PBUFF,
     :            PDATA,PNDAT,PXIN,PYIN,PXOUT,PYOUT,ISTAT)
C
C Allocate the dynamic memory arrays needed for Blot.
C
C This routine was added and the corresponding calls removed from
C the main module, December 2002
C
      IMPLICIT NONE

      INTEGER DNX,DNY,ONX,ONY,NSX,NSY
      INTEGER PDATA,PNDAT,PBUFF
      INTEGER PXIN,PYIN,PXOUT,PYOUT
      INTEGER ISTAT

C Set all the pointers to zero to start with - if they stay that
C way we can assume the allocation has failed
      PDATA=0
      PNDAT=0
      PBUFF=0
      PXIN=0
      PYIN=0
      PXOUT=0
      PYOUT=0

C Allocate the memory arrays and return the pointers, check for
C error status
      CALL UDMGET(NSX*NSY,6,PDATA,ISTAT)
      IF(ISTAT.NE.0) RETURN

      CALL UDMGET(ONX*ONY,6,PNDAT,ISTAT)
      IF(ISTAT.NE.0) RETURN

      CALL UDMGET(DNX,6,PBUFF,ISTAT)

      CALL UDMGET(ONX*4,7,PXIN,ISTAT)
      IF(ISTAT.NE.0) RETURN

      CALL UDMGET(ONX*4,7,PYIN,ISTAT)
      IF(ISTAT.NE.0) RETURN

      CALL UDMGET(ONX*4,7,PXOUT,ISTAT)
      IF(ISTAT.NE.0) RETURN

      CALL UDMGET(ONX*4,7,PYOUT,ISTAT)
      IF(ISTAT.NE.0) RETURN
      
      ISTAT=0
      RETURN
      END

      SUBROUTINE WBA
C++
C
C WBA.F Version 0.1
C
C This code implements a simple "weighted block averaging"
C method. It is intended to be used on outputs from the DRIZZLE task.
C task.
C
C There are two inputs, a data array and a "weight" array.
C The latter records how many images contributed to each
C point in the data, ie, a weighting. When the input is block
C averaged this weighting is taken into account and written to
C an output count image.
C
C It is based on an idea of Andy Fruchter.
C
C This code uses the F77/VOS for IRAF i/o.
C
C History:
C
C First try, Richard Hook, ST-ECF, November 1995 
C
C Tidied up a little (V0.1) and changed parameter names, 
C    Richard Hook, ST-ECF/STScI, March 2004
C
C--
      IMPLICIT NONE

C Iraf global storage (real in this program)
      REAL MEMR(1) !I
      COMMON /MEM/MEMR         !I

C Local variables
      INTEGER ISTAT
      INTEGER NDIMS,DNX,DNY,ONX,ONY,DDIMS(7),ODIMS(7),DATTYP
      INTEGER IDD,IDC,IDND,IDNC
      INTEGER PDATA,PNDAT,PNCOU,PCOU
      INTEGER BX,BY
      CHARACTER*80 DATA,COU,NEWDAT,NEWCOU
      LOGICAL VERBOSE
      CHARACTER*40 VERS

C-- Start of executable code

      VERBOSE=.TRUE.
      VERS='WBA Version 0.1 (March 4th 2004)'

C Write out the version
      CALL UMSPUT('+ '//VERS,1,0,ISTAT)

C Get the name of the input data image
      CALL UCLGST('data',DATA,ISTAT)
      CALL UIMOPN(DATA,1,IDD,ISTAT)
      IF(ISTAT.NE.0) THEN
         CALL UMSPUT('! Unable to open data image',
     :                    1,0,ISTAT)
         GO TO 99
      ELSE
         IF(VERBOSE) CALL UMSPUT('-Opening data file: '//DATA,
     :                   1,0,ISTAT)
      ENDIF

C Get the array size and shape
      CALL UIMGID(IDD,DATTYP,NDIMS,DDIMS,ISTAT)
      IF(NDIMS.NE.2) THEN
         CALL UMSPUT('! Input image is not two dimensional',
     :                    1,0,ISTAT)
         GO TO 99
      ELSE
         DNX=DDIMS(1)
         DNY=DDIMS(2)
      ENDIF

C We must also have a weight image
      CALL UCLGST('weight',COU,ISTAT)
      IF(COU.EQ.' ') THEN
         CALL UMSPUT('! There must be a weight image as well',
     :               1,0,ISTAT)
         GO TO 99
      ENDIF

      CALL UIMOPN(COU,1,IDC,ISTAT)
      IF(ISTAT.NE.0) THEN
         CALL UMSPUT('! Unable to open old weight image',
     :                    1,0,ISTAT)
         GO TO 99
      ELSE
         IF(VERBOSE) CALL UMSPUT(
     :      '-Opening old weight image: '//COU,
     :                   1,0,ISTAT)
      ENDIF

C Get the array size and shape of counts image frame
      CALL UIMGID(IDC,DATTYP,NDIMS,DDIMS,ISTAT)
      IF(NDIMS.NE.2) THEN
       CALL UMSPUT('! Input weight image is not two dimensional',
     :                    1,0,ISTAT)
         GO TO 99
      ELSE IF(DDIMS(1).NE.DNX .OR. DDIMS(2).NE.DNY) THEN
       CALL UMSPUT('! Weight image is not same size as data',
     :                    1,0,ISTAT)
         GO TO 99
      ENDIF

C Get the block averaging factors for X and Y
      CALL UCLGSI('xblock',BX,ISTAT)
      CALL UCLGSI('yblock',BY,ISTAT)

C Warn if there may be edge effects
      IF(MOD(DNX,BX).NE.0 .OR. MOD(DNY,BY).NE.0) THEN
         CALL UMSPUT('! Warning input array size not a multiple '//
     :         'of blocking factor - there may be edge effects',
     :               1,0,ISTAT)
      ENDIF 

C and calculate the size of the outputs
      ONX=DNX/BX
      ODIMS(1)=ONX
      ONY=DNY/BY
      ODIMS(2)=ONY

C Now we need to get the names for the output images - there
C are always both data and "count" images. Note there is no "update"
C of the inputs
      CALL UCLGST('outdata',NEWDAT,ISTAT)
      CALL UIMCRE(NEWDAT,6,2,ODIMS,IDND,ISTAT)
      IF(ISTAT.NE.0) THEN
         CALL UMSPUT(
     :     '! Unable to create output data image',
     :                 1,0,ISTAT)
         GO TO 99
      ENDIF

      CALL UCLGST('outweig',NEWCOU,ISTAT)
      CALL UIMCRE(NEWCOU,6,2,ODIMS,IDNC,ISTAT)
      IF(ISTAT.NE.0) THEN
         CALL UMSPUT(
     :     '! Unable to create output weight image',
     :                 1,0,ISTAT)
         GO TO 99
      ENDIF

C Now we allocate space for all the arrays we will need, note that they
C are all real
      CALL UDMGET(DNX*DNY,6,PDATA,ISTAT)
      IF(ISTAT.NE.0) THEN
         CALL UMSPUT(
     :          '! Unable to allocate memory for data array',
     :                 1,0,ISTAT)
         GO TO 99
      ENDIF

      CALL UDMGET(ONX*ONY,6,PNCOU,ISTAT)
      IF(ISTAT.NE.0) THEN
         CALL UMSPUT(
     :  '! Unable to allocate memory for output weight array',
     :                 1,0,ISTAT)
         GO TO 99
      ENDIF

      CALL UDMGET(ONX*ONY,6,PNDAT,ISTAT)
      IF(ISTAT.NE.0) THEN
         CALL UMSPUT(
     : '! Unable to allocate memory for output data array',
     :                 1,0,ISTAT)
         GO TO 99
      ENDIF

C Now some space for the input arrays, if there are any
      CALL UDMGET(DNX*DNY,6,PCOU,ISTAT)
      IF(ISTAT.NE.0) THEN
      CALL UMSPUT(
     :'! Unable to allocate memory for input weight array',
     :   1,0,ISTAT)
         GO TO 99
      ENDIF

C Now we can actually read the data into the arrays
      CALL UIGS2R(IDD,1,DNX,1,DNY,MEMR(PDATA),ISTAT)
      IF(ISTAT.NE.0) THEN
         CALL UMSPUT(
     :      '! Failed to read input data image',
     :                   1,0,ISTAT)
         GO TO 99
      ENDIF
 
      CALL UIGS2R(IDC,1,DNX,1,DNY,MEMR(PCOU),ISTAT)
      IF(ISTAT.NE.0) THEN
         CALL UMSPUT(
     :     '! Failed to read input weight image',
     :      1,0,ISTAT)
         GO TO 99
      ENDIF

C Before we start averaging we need to drain out the output arrays
      CALL ZARRAY(MEMR(PNDAT),ONX,ONY)
      CALL ZARRAY(MEMR(PNCOU),ONX,ONY)

C Now do the averaging 
      CALL DWBA(MEMR(PDATA),MEMR(PCOU),
     :              MEMR(PNDAT),MEMR(PNCOU),DNX,DNY,
     :              ONX,ONY,BX,BY)

C Write out the two new images
      IF(VERBOSE)
     :   CALL UMSPUT('-Writing output averaged image: '//
     :               NEWDAT,1,0,ISTAT)
         
      CALL UIPS2R(IDND,1,ONX,1,ONY,MEMR(PNDAT),ISTAT)
      CALL UIMCLO(IDND,ISTAT)

      IF(VERBOSE)
     :   CALL UMSPUT('-Writing output weight image: '//
     :               NEWCOU,1,0,ISTAT)
         
      CALL UIPS2R(IDNC,1,ONX,1,ONY,MEMR(PNCOU),ISTAT)
      CALL UIMCLO(IDNC,ISTAT)
 
C Close down everything and exit

 99   CONTINUE
      END

      SUBROUTINE ZARRAY(A,NX,NY)
C
C Zero a 2d array
C
      IMPLICIT NONE

      INTEGER NX,NY
      REAL A(NX,NY)

      INTEGER I,J

      DO J=1,NY
         DO I=1,NX
            A(I,J)=0.0
         ENDDO
      ENDDO

      RETURN
      END

      SUBROUTINE DWBA(DATA,COU,NDAT,NCOU,DNX,DNY,ONX,ONY,BX,BY)
C
C Block averaging with weighting
C
      IMPLICIT NONE

      INTEGER DNX,DNY,ONX,ONY,BX,BY
      INTEGER I,J,IB,JB
      REAL DATA(DNX,DNY),COU(DNX,DNY),NDAT(ONX,ONY),NCOU(ONX,ONY)
      REAL NC,ND,CC

      DO J=1,ONY
         DO I=1,ONX
            NC=0.0
            ND=0.0
            DO JB=(J-1)*BY+1,J*BY
               DO IB=(I-1)*BX+1,I*BX
                  CC=COU(IB,JB)
                  NC=NC+CC
                  ND=ND+CC*DATA(IB,JB)
               ENDDO
            ENDDO

            IF(NC.EQ.0) THEN
               NCOU(I,J)=0.0
               NDAT(I,J)=0.0
            ELSE
               NDAT(I,J)=ND/NC
               NCOU(I,J)=NC
            ENDIF
         ENDDO
      ENDDO

      RETURN
      END

      REAL FUNCTION TWDRIZ(DATA,WEI,NDAT,NCOU,YSTART,
     : NX,NY,DNY,ONX,ONY,WCS,WCSOUT,PXG,PYG,XGDIM,YGDIM,
     : PFRACT,KERNEL,COEFFS,FILSTR,VFLAG,CLEN,NMISS,NSKIP,VERS)
C
C Call Wdrizzle without use of IRAF interfaces.
C
C Supplied:
C
C   DATA - a 2d REAL array with dimensions (NX,NY): the input
C          data.
C
C   WEI - a 2d REAL array with dimensions (NX,NY): the input
C          weight array.
C
C   NDAT - a 2d REAL array with dimensions (ONX,ONY): the output
C          data array which is updated. It should be initialised
C          the first time around.
C
C   NCOU - a 2d REAL array with dimensions (ONX,ONY): the output
C          weight array which is updated. It should be initialised
C          the first time around.
C
C   NX,NY,ONX,ONY - INTEGERs: the dimensions of the arrays described
C                   above.
C
C   WCS,WCSOUT - double precision arrays, 8 elements in each.
C                Input and output WCS.
C
C   PFRACT - REAL: the drizzle "pixfrac" parameter.
C
C   KERNEL - CHARACTER*8 f77 character string: the type of kernel
C            used to distribute weight onto the output. Currently
C            supports "square","gaussian","tophat","point","turbo",
C            "lanczos2" and "lanczos3".
C
C   COEFFS - CHARACTER*80 f77 character string: the name of the
C            text file containing distortion correction coefficients.
C
C Returned: 
C
C    a REAL status is returned: the status return of the DOBOX
C    routine
C
C This was developed as a simple interface to the lower-level
C drizzle utilities which could be invoked without the need for
C an IRAF environment.
C
C If it is intended to be called from IDL the following applies:
C
C All parameters are passed from IDL using the "call external"
C mechanism. The intermediate file is idldriz.f. The linking looks
C something like this on Solaris 8:
C
C  f77 -c idlwdriz.f tdriz.f drutil.f drcall.f -pic -G
C  f77 -o idlwdriz.so drcall.o drutil.o idldriz.o tdriz.o -G -lF77 -lM77 -lsunmath -lm -lc
C
C If just being called directly from some f77 application it is
C only necessary to link in the following:
C
C  f77 -o app app.f twdriz.f drutil.f drcall.f
C
C where "app" is the top-level application.
C
C Notes:
C
C  - Some parameters, not included in the calling sequence, are hardcoded
C below in the section marked below.
C
C  - Secondary parameters are not supported at present
C
C  - All the weighting information must be supplied in the WEI array.
C    Ie, wt_scl=1.0.
C
C  - Context images are not currently supported
C
C  Test version, Richard Hook, ST-ECF, STScI, September 2002
C  Improved documentation, Richard Hook, ST-ECF, STScI, November 2002
C
C Modified to run under Linux, Richard Hook, ST-ECF, STScI, April 2003
C
C Wdrizzle version, ST-ECF, STScI, September 2003
C Added VFLAG for verbosity, STScI/ECF, October 2003
C
      IMPLICIT NONE

      INTEGER NX,NY,ONX,ONY,DNY
      INTEGER IDD,ISTAT,XMIN,YMIN,XMAX,YMAX,YSTART
      INTEGER VFLAG
      INTEGER NMISS,NSKIP

C Distortion coefficients and related
      INTEGER COTY,COMAX,CONUM
      PARAMETER (COMAX=100)
      REAL LAM,XCO(COMAX),YCO(COMAX)
      CHARACTER*80 COEFFS, FILSTR
      INTEGER CLEN

C Distortion image arrays
      REAL PXG(XGDIM,YGDIM), PYG(XGDIM,YGDIM)
      INTEGER XGDIM,YGDIM
      LOGICAL DISIM

C Verbose flag
      LOGICAL VERBOSE
      COMMON /VERBOSE/VERBOSE

C Maximum size (in X) of the input image
      INTEGER MAXNX
      PARAMETER (MAXNX=100000) 

      REAL DATA(NX,DNY),WEI(NX,DNY)
      REAL NDAT(ONX,ONY),NCOU(ONX,ONY)

      DOUBLE PRECISION WCS(8)
      DOUBLE PRECISION WCSOUT(8)

      REAL XI(MAXNX,4),YI(MAXNX,4),XO(MAXNX,4),YO(MAXNX,4)
      REAL XIB(MAXNX),YIB(MAXNX),XOB(MAXNX),YOB(MAXNX)
      REAL XSH,YSH,ROT,DROT,SCALE
      REAL WTSCL,EXPIN,PFRACT,FILVAL
      INTEGER NEN,UNIQID

C Context related things
      LOGICAL CON
      LOGICAL BITCON
      LOGICAL FILL

C We give these minimal dimensions
      INTEGER NCON(1,1)  
      INTEGER DONE(1,1)  
      INTEGER MAXEN,MAXIM
      PARAMETER (MAXIM=100,MAXEN=100)
      INTEGER INTAB(MAXIM,MAXEN)

      CHARACTER*8 ALIGN,KERNEL
      LOGICAL ROTFIR,UPDATE,USEWEI,INCPS,USEWCS,NOOVER

C Secondary geometrical parameters, added in V1.5
      LOGICAL SECPAR
      DOUBLE PRECISION XSH2,YSH2,ROT2,XSCALE,YSCALE,ALPHA,BETA
      CHARACTER*8 SHFR2
      LOGICAL ROTF2
      CHARACTER*50 VERS

C Check for verbose
      IF(VFLAG.EQ.1) THEN
         VERBOSE=.TRUE.
      ELSE
         VERBOSE=.FALSE.
      ENDIF

C Define Version ID
      VERS = 'Callable WDRIZZLE Version 0.5 (25rd June 2004)'
C Announce
      CALL UMSPUT(VERS,1,0,ISTAT)

C Get geometric distortion coefficients
      IDD = 0
      CALL GETGEO(COEFFS,IDD,LAM,COTY,COMAX,CONUM,
     :                  XCO,YCO,CLEN,ISTAT)
      IF(ISTAT.NE.0) CALL EXIT(1)

C Set DISIM logical based on whether distortion images have
C  been passed in for use or not.
      IF (XGDIM .EQ. 2 .AND. YGDIM .EQ. 2) THEN
         DISIM = .FALSE.
      ELSE
         DISIM = .TRUE.
      ENDIF
      
C Setup reasonable defaults for the drizzling
      XMIN=1
      XMAX=ONX
      YMIN=1
      YMAX=ONY
      NOOVER=.FALSE.

C All weighting is done by the weight array
      WTSCL=1.0
      INCPS=.TRUE.

C Input exposure assumed to be 1.0s
      EXPIN=1.0
      ROTFIR=.FALSE.

C Convert the rotation to radians
      ROT=DROT*3.141592653/180.0

C Secondary parameters are not currently supported
      SECPAR=.FALSE.
      UPDATE=.TRUE.
      USEWEI=.TRUE.

C Wdrizzle, hence...
      USEWCS=.TRUE.
      CON=.FALSE.
      UNIQID = 1

C Do the drizzling
      CALL DOBOX(DATA,WEI,NDAT,NCOU,NCON,DONE,NX,NY,DNY,
     :     YSTART,XMIN,XMAX,YMIN,YMAX,NOOVER,
     :     KERNEL,XI,XO,YI,YO,XIB,XOB,YIB,YOB,
     :     ONX,ONY,COTY,CONUM,XCO,YCO,DISIM,PXG,PYG,XGDIM,YGDIM,
     :     WTSCL,ALIGN,INCPS,EXPIN,
     :     PFRACT,SCALE,ROT,XSH,YSH,WCS,WCSOUT,ROTFIR,
     :     SECPAR,XSH2,YSH2,ROT2,XSCALE,YSCALE,SHFR2,ROTF2,
     :     CON,BITCON,INTAB,MAXIM,MAXEN,NEN,UNIQID,
     :     UPDATE,USEWEI,USEWCS,ISTAT,NMISS,NSKIP,ALPHA,BETA)

C The arrays NDAT and NCOU will have been updated
C Check for meaningful values
      IF(FILSTR(1:5).NE.'INDEF'.AND.FILSTR(1:5).NE.'indef') THEN
         READ(FILSTR,*,IOSTAT=ISTAT) FILVAL
         IF(ISTAT.NE.0) THEN
            CALL UMSPUT('! Invalid filling value specified',
     :                  1,0,ISTAT)
            FILL=.FALSE.
         ELSE
            FILL=.TRUE.
         ENDIF
      ELSE
         FILL=.FALSE.
      ENDIF
      
C Put in the fill values (if defined)
      IF (FILL) CALL PUTFIL(NDAT,NCOU,XMAX-XMIN+1,
     :    YMAX-YMIN+1,FILVAL)

C Return the value of status
      TWDRIZ=FLOAT(ISTAT)

      END

      REAL FUNCTION TDRIZ(DATA,WEI,NDAT,NCOU,NCON,UNIQID,YSTART,XMIN,
     : YMIN,NX,NY,DNY,ONX,ONY,XSH,YSH,SHFTFR,SHFTUN,DROT,SCALE,
     : XSH2,YSH2,XSCALE,YSCALE,ROT2, SHFR2,
     : PXG,PYG,XGDIM,YGDIM,ALIGN,
     : PFRACT,KERNEL,COEFFS,INUN,EXPIN,WTSCL,FILSTR,
     : WCS,VFLAG,CLEN,NMISS,NSKIP,VERS,ALPHA,BETA)
C
C Call Drizzle without use of IRAF interfaces.
C
C Supplied:
C
C   DATA - a 2d REAL array with dimensions (NX,NY): the input
C          data.
C
C   WEI - a 2d REAL array with dimensions (NX,NY): the input
C          weight array.
C
C   NDAT - a 2d REAL array with dimensions (ONX,ONY): the output
C          data array which is updated. It should be initialised
C          the first time around.
C
C   NCOU - a 2d REAL array with dimensions (ONX,ONY): the output
C          weight array which is updated. It should be initialised
C          the first time around.
C
C   NCON - a 2d INTEGER array with dimensions (ONX,ONY): the output
C          context array which is updated. It should be initialised
C          the first time around.
C
C   UNIQID - INTEGER: the unique processing ID for the input data
C
C   YSTART - INTEGER: index of the starting line for input data array
C                    relative to the entire image. 
C
C   NX,NY  - INTEGER: dimensions of the full input image 
C
C   DNY     - INTEGER: *Actual* number of rows in the input data array
C
C   ONX,ONY - INTEGERs: the dimensions of the output array
C
C   PXG,PYG - 2d REAL arrays with dimensions (XGDIM,YGDIM): the 
C           distortion image arrays. If no images are used, they
C           should default to blank 2x2 arrays.  
C
C   XSH,YSH,DROT,SCALE - REALs: the standard linear drizzle user
C                        parameters. DROT is in degrees.
C
C   SHFTFR - CHARACTER*8 f77 character string: WCS frame for shifts:
C            "input" (default) or "output"
C
C   SHFTUN - CHARACTER*8 f77 character string: specifies whether the
C            shift units are in terms of 
C            "input" (default) or "output" pixels
C
C   ALIGN  - CHARACTER*8 f77 character string: takes the values
C            'corner' or 'center' to determine the position of the
C            reference point for rotation.
C
C   PFRACT - REAL: the drizzle "pixfrac" parameter.
C
C   KERNEL - CHARACTER*8 f77 character string: the type of kernel
C            used to distribute weight onto the output. Currently
C            supports "square","gaussian","tophat","point","turbo",
C            "lanczos2" and "lanczos3".
C
C   COEFFS - CHARACTER*80 f77 character string: the name of the
C            text file containing distortion correction coefficients.
C
C   INUN   - CHARACTER*8 f77 character string: the units for the input
C            image: "cps" or "counts" (default)
C
C   EXPIN  - REAL: exposure time for input image, to allow scaling
C            of data to counts/sec.
C
C   WTSCL  - REAL: scaling factor applied to input weighting image
C
C   FILSTR - CHARACTER*80: pixel value to use for filling empty output pixels
C            'INDEF' (default) or str(float value).  If 'INDEF', do not fill.
C
C   WCS    - DOUBLE PRECISION: input WCS (corrected in-place by UPWCS)
C
C   VFLAG  - INTEGER: 1=verbose, anything else not.
C
C Returned: 
C
C    a REAL status is returned: the status return of the DOBOX
C    routine
C
C This was developed as a simple interface to the lower-level
C drizzle utilities which could be invoked without the need for
C an IRAF environment.
C
C If it is intended to be called from IDL the following applies:
C
C All parameters are passed from IDL using the "call external"
C mechanism. The intermediate file is idldriz.f. The linking looks
C something like this on Solaris 8:
C
C  f77 -c idldriz.f tdriz.f drutil.f drcall.f -pic -G
C  f77 -o idldriz.so drcall.o drutil.o idldriz.o tdriz.o -G -lF77 -lM77 -lsunmath -lm -lc
C
C If just being called directly from some f77 application it is
C only necessary to link in the following:
C
C  f77 -o app app.f tdriz.f drutil.f drcall.f
C
C where "app" is the top-level application.
C
C Notes:
C
C  - Some parameters, not included in the calling sequence, are hardcoded
C below in the section marked below.
C
C  - Secondary paramFILSTReters are not supported at present
C
C  - All the weighting information must be supplied in the WEI array.
C    Ie, wt_scl=1.0.
C
C  - Context images FILSTRare not currently supported
C
C  Test version, Richard Hook, ST-ECF, STScI, September 2002
C  Improved documentation, Richard Hook, ST-ECF, STScI, November 2002
C
C Modified to run under Linux, Richard Hook, ST-ECF, STScI, April 2003
C
C F2PY control codes added by WJH, 18 Dec 2003
C
C
Cf2py integer intent(hide),depend(data) :: nx = shape(data,0)
Cf2py integer intent(hide),depend(data) :: ny = shape(data,1)
Cf2py integer intent(hide),depend(ndat) :: onx = shape(ndat,0)
Cf2py integer intent(hide),depend(ndat) :: ony = shape(ndat,1)
Cf2py real intent(in,c) :: data, wei
Cf2py real intent(in,out):: ndat,ncou
Cf2py real intent(in) :: xsh, ysh, drot, scale, pfract
Cf2py real intent(in) :: wtscl, expin
Cf2py character*8 intent(in) :: align
Cf2py character*8 intent(in) :: kernel
Cf2py character*80 :: coeffs
Cf2py integer intent(in) :: vflag
C
      IMPLICIT NONE

      INTEGER VFLAG 

      LOGICAL VERBOSE
      COMMON /VERBOSE/VERBOSE

      INTEGER NX,NY,ONX,ONY,DNY
      INTEGER IDD,ISTAT,XMIN,YMIN,XMAX,YMAX,YSTART
      INTEGER NMISS,NSKIP

C Distortion coefficients and related
      INTEGER COTY,COMAX,CONUM
      PARAMETER (COMAX=100)
      DOUBLE PRECISION LAM,XCO(COMAX),YCO(COMAX)
      CHARACTER*80 COEFFS, FILSTR
      INTEGER CLEN

C Maximum size (in X) of the input image
      INTEGER MAXNX
      PARAMETER (MAXNX=100000) 

      REAL DATA(NX,DNY),WEI(NX,DNY)
      REAL NDAT(ONX,ONY),NCOU(ONX,ONY)
      INTEGER NCON(ONX,ONY)
    
C Distortion image arrays
      REAL PXG(XGDIM,YGDIM), PYG(XGDIM,YGDIM)
      INTEGER XGDIM,YGDIM
      LOGICAL DISIM

      DOUBLE PRECISION WCS(8)
      DOUBLE PRECISION WCSOUT(8)

      DOUBLE PRECISION  XI(MAXNX,4),YI(MAXNX,4),XO(MAXNX,4),YO(MAXNX,4)
      DOUBLE PRECISION  XIB(MAXNX),YIB(MAXNX),XOB(MAXNX),YOB(MAXNX)
      DOUBLE PRECISION  XSH,YSH,ROT,DROT,SCALE,PFRACT
      REAL WTSCL,EXPIN,FILVAL
      INTEGER NEN,UNIQID

C Context related things
      LOGICAL CON
      LOGICAL BITCON
      LOGICAL FILL

C We give these minimal dimensions  
      INTEGER DONE(1,1)  
      INTEGER MAXEN,MAXIM
      PARAMETER (MAXIM=100,MAXEN=100)
      INTEGER INTAB(MAXIM,MAXEN)

      CHARACTER*8 ALIGN,KERNEL,INUN,SHFTFR,SHFTUN
      LOGICAL ROTFIR,UPDATE,USEWEI,INCPS,USEWCS,NOOVER

C Secondary geometrical parameters
      LOGICAL SECPAR
      DOUBLE PRECISION XSH2,YSH2,ROT2,XSCALE,YSCALE,ALPHA,BETA
      CHARACTER*8 SHFR2
      LOGICAL ROTF2
      CHARACTER*50 VERS

C Keep quiet
      IF(VFLAG.EQ.1) THEN
         VERBOSE=.TRUE.
      ELSE
         VERBOSE=.FALSE.
      ENDIF

C Define Version ID
      VERS = 'Callable DRIZZLE Version 0.7 (4th Apr 2005)'
C Announce
      CALL UMSPUT(VERS,1,0,ISTAT)

C Get geometric distortion coefficients
C
      IDD = 0
      

      CALL GETGEO(COEFFS,IDD,LAM,COTY,COMAX,CONUM,
     :                  XCO,YCO,CLEN,ISTAT)
      IF(ISTAT.NE.0) CALL EXIT(1)

C Set DISIM logical based on whether distortion images have
C  been passed in for use or not.
      IF (XGDIM .EQ. 2 .AND. YGDIM .EQ. 2) THEN
         DISIM = .FALSE.
      ELSE
         DISIM = .TRUE.
      ENDIF
      
C Setup reasonable defaults for the drizzling
C      XMIN=1
      XMAX=ONX
C      YMIN=1
      YMAX=ONY
      NOOVER=.FALSE.
      
C All weighting is done by the weight array
C      WTSCL=1.0
C      INCPS=.FALSE.
C Check the switch value for whether to read in CPS or
C counts (latter is the default)
      IF(INUN(1:3).EQ.'cps') THEN
         INCPS=.TRUE.
      ELSE
         INCPS=.FALSE.
      ENDIF

C Input exposure assumed to be 1.0s
C      EXPIN=1.0
C      ROTFIR=.TRUE.
C Check the parameter specifying which frames shifts are applied
      IF(SHFTFR(1:5).EQ.'input') THEN
         ROTFIR=.FALSE.
      ELSE
         ROTFIR=.TRUE.
      ENDIF
      
C Convert the shift units if necessary
      IF(SHFTUN(1:6).EQ.'output') THEN
         XSH=XSH*SCALE
         YSH=YSH*SCALE
      ENDIF

C Convert the rotation to radians
      ROT=DROT*3.141592653/180.0

C Convert the secondary parameters into suitable units
      ROT2=ROT2*3.14159265358979D0/180.0D0
      IF(SHFR2(1:5).eq.'input') THEN
         ROTF2=.FALSE.
      ELSE
         ROTF2=.TRUE.
      ENDIF

C Give a warning message if secondary parameters will have an effect
      IF(XSCALE.NE.1.0D0 .OR. YSCALE.NE.1.0D0 .OR.
     :   XSH2.NE.0.0D0 .OR. YSH2.NE.0.0D0 .OR. ROT2.NE.0.0D0) THEN
       CALL UMSPUT(
     : '! Warning, secondary geometric transform is being used',
     :               1,0,ISTAT)
        SECPAR=.TRUE.
      ELSE
        SECPAR=.FALSE.
      ENDIF


      UPDATE=.TRUE.
      USEWEI=.TRUE.
      USEWCS=.FALSE.
      CON=.TRUE.
      BITCON = .TRUE.

C Do the drizzling
      CALL DOBOX(DATA,WEI,NDAT,NCOU,NCON,DONE,NX,NY,DNY,
     :     YSTART,XMIN,XMAX,YMIN,YMAX,NOOVER,
     :     KERNEL,XI,XO,YI,YO,XIB,XOB,YIB,YOB,
     :     ONX,ONY,COTY,CONUM,XCO,YCO,DISIM,PXG,PYG,XGDIM,YGDIM,
     :     WTSCL,ALIGN,INCPS,EXPIN,
     :     PFRACT,SCALE,ROT,XSH,YSH,WCS,WCSOUT,ROTFIR,
     :     SECPAR,XSH2,YSH2,ROT2,XSCALE,YSCALE,SHFR2,ROTF2,
     :     CON,BITCON,INTAB,MAXIM,MAXEN,NEN,UNIQID,
     :     UPDATE,USEWEI,USEWCS,ISTAT,NMISS,NSKIP,ALPHA,BETA)

C Check for meaningful values
      IF(FILSTR(1:5).NE.'INDEF'.AND.FILSTR(1:5).NE.'indef') THEN
         READ(FILSTR,*,IOSTAT=ISTAT) FILVAL
         IF(ISTAT.NE.0) THEN
            CALL UMSPUT('! Invalid filling value specified',
     :                  1,0,ISTAT)
            FILL=.FALSE.
         ELSE
            FILL=.TRUE.
         ENDIF
      ELSE
         FILL=.FALSE.
      ENDIF
      
C Put in the fill values (if defined)
      IF (FILL) CALL PUTFIL(NDAT,NCOU,XMAX-XMIN+1,
     :    YMAX-YMIN+1,FILVAL)

C The arrays NDAT and NCOU will have been updated
C Update the WCS, if it needs to be updated.
C  Only need to do once per image, not once per section.
      IF (YSTART .EQ. 0) THEN
      CALL UPWCS(WCS,WCS,NX,NY,ONX,ONY,
     :            XSH,YSH,ROT,SCALE,ALIGN,ROTFIR,
     :            SECPAR,XSH2,YSH2,ROT2,XSCALE,YSCALE,SHFR2,ROTF2,
     :            USEWCS,COTY,CONUM,XCO,YCO,DISIM,PXG,PYG,XGDIM,
     :            YGDIM,ALPHA,BETA)
      ENDIF

C Return the value of status
      TDRIZ=FLOAT(ISTAT)
          
      END

      SUBROUTINE DRIZZE
C++
C
C DRIZZLE.F Version 3.4 - Variable Pixel Linear Reconstruction
C
C Also widely known as "drizzling"
C
C This task implements a simple method for transforming one image
C onto the pixel grid of another. The method calculates where the
C input pixels map on the output grid and performs an optimal weighted
C combination of the input and output. Another image records the weighting
C at a given pixel.
C
C It is based largely on ideas of Andy Fruchter and was coded by Richard Hook. 
C (Contacts: rhook@eso.org & fruchter@stsci.edu)
C
C This task uses coefficients held in a text file to define
C geometrical distortions.
C
C This code uses the F77/VOS for IRAF i/o.
C It may be compiled and linked using a command like:
C
C xc -p stsdas (-z) drizzle.f drutil.f x_drizzle.x <dir>libiraf77.a
C
C Note that the optional -z switch (which tells IRAF to create a static 
C executable which doesn't use the IRAF sharable library) may be
C necessary to avoid a virtual memory use limitation of around 167MB in
C IRAF versions up to 2.10.4.
C
C History:
C
C First try, Richard Hook, ST-ECF, October 1995 
C Generalised coefficients added, RNH, Nov 95
C Working on V0.2, RNH, Nov 1995 (including "small|large" pixels)
C Modified again for continuously variable input pixel area, 29/11/95
C Modified again for X,Y position processing, 1/12/95
C Started work on V0.3 including "update" option, more header
C information and WCS, 12/12/95
C V0.3 released, 15th December 1995
C V0.31 modifications following comments from STScI, 27/12/95
C V0.32 modifications, 29/12/95
C V0.33 modifications, STScI, 5th Jan 1996
C V0.34 modifications, try to minimise memory use, 7th Jan 1996
C V0.35 tidyup and a few enhancements, 9th January 1996
C V0.36 correct rotation angle in output and also case
C       where outdat=olddat, 8th February 1996
C V0.37 correct silly rotation angle multiplication error
C       29th February 1996
C V0.40 first pre-release version, tidied up and corrected WCS
C       bug with CTYPE header items. 25th March 1996
C V0.5  started to incorporate the "boxer" code for linear
C       combination by precise area weighting rather than by the
C       drizzling approximation. The "boxer" code was originally
C       written by Bill Sparks, STScI, 19th April 1996
C V0.9  many simpifications and improvements for a pre-release
C       version. This removes drizzling and the XY option as well
C       as many options which weren't used. 16th May 1996
C V0.91 corrected typo when shunits=output. 21st May 1996     
C V0.92 changed parameter names and removed "olddata" option. 22nd May 1996
C V0.93 changed to separate coeffients files for each coefficients
C       set. 22nd May 1996
C V0.94 changed access to coefficients file to use IRAF filenames via
C       (hidden) F77 VOS calls and also put in a scale for the weights
C       image and changed the names. ST-ECF, 30th May 1996
C V0.95 bug fix in error message within SGAREA, format statement syntax
C       error. ST-ECF, 20th June 1996
C V0.96 name change to DRIZZLE. ST-ECF, 5th July 1996
C V0.97 added exposure time keyword handling. ST-ECF, 9th July 1996
C V0.98 added ability NOT to store output counts image, 16th July 1996
C V0.99 added flag for scaling by exposure time, 16th July 1996
C V0.991 added "fillval" parameter, option for wt_scl=exptime, 29th July 1996
C V0.992 slight change to fillval interpretation, 31st July 1996
C V0.993 small bugfix when reading coefficients, 28th August 1996
C
C V1.0 release. 17th September 1996.
C
C V1.01 - some bug fixes after first release, 19th September 1996
C V1.02 - same as V1.01 except permissions of tar file altered, 3rd October 1996
C V1.03 - small change to WCS logic to avoid crashes, 25th October 1996
C V1.08 - collection of several small changes, 5th December 1996
C         (including a change in the definition of the centres and the
C         addition of the out_typ parameter))
C V1.09 - correct scaling of offsets bug, 16th December 1996
C V1.091 - introduce Jacobian for weights, 10th January 1997
C V1.092 - correct header update bug, 21st January 1997
C V1.093 - put utility routines in separate file (drutil.f), 4th February 1997
C V1.094 - change disk access to minimise memory use, 10th February 1997
C V1.095 - introduced automatic coeffs/lambda from header, 7th March 1997
C V1.096 - added tidier memory management in error cases, 10th March 1997
C          also better file closure on error trapping.
C V1.097 - bugfix to V1.096, 12th March 1997
C V1.098 - pre-release version incorporating EXPSQ weighting, modified
C          error messages and a maximum of 999 images, 22nd April 1997
C
C V1.1 - second public release. 12th May 1997, STScI
C
C V1.2 - first release within STSDAS dither package, this version uses
C        the in_un and out_un system for defining whether input/outputs
C        are in count or counts/s. The old parameter exp_sc has been
C        removed. 20th February 1998.
C
C V1.3 - added support for WCS-driven geometrical mapping. 18th September 1998
C
C V1.4 - added image and memory sub-setting to reduce i/o and memory usage.
C        5th October 1998.
C
C V1.41 - version of V1.4 without WCS option and returning to the parameter
C         file of V1.2 for compatibility. 13th January 1999.
C
C V1.5D - development version, July 2000
C         secondary linear transforms added as a test, 24th July 2000
C
C V1.6D - some restructuring of the code and the addition of multiple
C         kernel support at a low level, September 2000
C
C V1.7D - continuing code restructuring and additions, October 2000
C
C V1.8D - adding context image code, October 2000
C
C V2.0beta - test version of V2.0 release - October 16th 2000
C
C V2.1beta - starting further modifications for ACS including
C            other possible distortion representations.
C            December 19th 2000
C
C V2.2beta - including "bitmask" style contexts, January 2001
C            convert all integer arrays to *4
C
C V2.3test - version for ACS pipeline. Includes better WCS handling
C            and some bug fixes for problems related to ACS.
C                    Richard Hook, STScI, 15th February 2001
C
C V2.4test - correct bugs, in particular related to secondary
C            geometric parameters. 
C            21st March 2001
C
C V2.5test - make copying all of the header of the first image to the
C            output optional (currently it IS copied). May 2001
C
C V2.5beta - transfer all auxiliary routines to drutil.f, change to
C            V2.5beta for more extensive testing.
C               Richard Hook, ST-ECF, 24th May 2001
C
C V2.6 - renamed to Drizzle again for release at STScI.
C               Richard Hook, ST-ECF, 16th October 2001
C
C V2.62 - modified the UPWCS logic in drutil.f to correct
C         a long-standing problem with the WCS update
C               Richard Hook, ST-ECF, 29th January 2002
C
C V2.7 - new option and calling sequence for DRIVAL to allow "regular" mode
C        for better precision and speed.
C        Also reverted to previous logic for UPWCS.
C               Richard Hook, ST-ECF, 27th February 2002
C
C V2.8 - new "lanczos" optimal interpolation kernel support added
C          Richard Hook, ST-ECF/STScI, 6th August 2002
C
C V2.81 - modified order of memory freeing and file closing to
C         allow working with very large mosaics. Also corrected bug
C         when updating subsets of large weight and context maps.
C          Richard Hook, ST-ECF/STScI, 5th September 2002
C
C V2.9 - more accurate WCS use in wdrizzle mode.
C          Richard Hook, ST-ECF/STScI, 5th November 2002
C
C V2.91 - change to the "gaussian" kernel box size to avoid
C         holes and smaller "lanczos" working box for improved
C         performance.
C
C V2.92 - added check for zero input exposure time.
C          Richard Hook, ST-ECF/STScI, 30th January 2003
C
C V2.93 - added checks for lines of input image falling outside
C         the output image and for partial overlaps
C          Richard Hook, ST-ECF/STScI, 2nd April 2003
C
C V2.94 - modified the logic for calculating the output WCS
C         to try to correct some inaccuracy found in earlier
C         versions. If COTY>0 (ie, polynomial distortion) then
C         the linear part is now combined with the input CD to
C         create the output.
C
C V3.0 - went back to old way of doing WCS calculation for drizzle
C        but using double precision. Added reference pixel specification
C        and changed the parameter names.
C          Richard Hook, ST-ECF/STScI, 13th June 2003
C
C V3.03 - corrected logic for wdrizzle photometric correction.
C
C V3.1 - new geometric distortion image support
C
C V3.2 - extra output header information
C
C V3.2D - double precision version for tests and UDF,
C               Richard Hook, ST-ECF/STScI, 21st October 2003
C
C V3.3 - added support for "refpix" in coefficients files so that the
C        the origin of the distortion is decoupled from the center of the
C        chip.
C               Richard Hook, ST-ECF/STScI, 4th December 2003
C
C V3.4 - modified distortion images to be passed as arrays instead of 
C        as pointers, and modified the code to use the same routines for
C        both the callable interface and STSDAS interface. Based on 
C        Version 3.32 from Richard.
C              Warren Hack, STScI, 25th June 2004
C
C V3.4.1 - removed use of distortion images from UPWCS WJH/RH, 20th Dec 2004
C
C V3.4.2 - Image center is calculated in floting point precision, not int
C        This was changed in an attempt to achieve agreement between pydrizzle
C        and wdrizzle
C--
      IMPLICIT NONE

C Iraf global storage (real in this program)
      REAL MEMR(1) !I
      DOUBLE PRECISION MEMD(1) !I
      INTEGER MEMI(1) !I
      COMMON /MEM/MEMR         !I
      EQUIVALENCE (MEMR,MEMI)  !I
      EQUIVALENCE (MEMR,MEMD)  !I

C Local variables
      INTEGER ISTAT,I,J,JNY,NMISS,NSKIP
      INTEGER XMIN,XMAX,YMIN,YMAX,YSTART
      INTEGER NDIMS,DNX,DNY,ONX,ONY,DDIMS(7),ODIMS(7),DATTYP
      INTEGER IDD,IDW,IDND,IDNC,IDCO,IC
      INTEGER PDATA,PWEI,PNDAT,PNCOU,PNCON,PCDON,PBUFF,PIBUFF
      INTEGER PXI,PXO,PYI,PYO
      INTEGER PXIB,PXOB,PYIB,PYOB
      INTEGER COTY,CONUM,COMAX,PXG,PYG,XGDIM,YGDIM
      PARAMETER (COMAX=100)
      DOUBLE PRECISION XCO(COMAX),YCO(COMAX),XSH,YSH,LAM
      DOUBLE PRECISION SCALE,ROT,PFRACT
      REAL EXPIN,EXPOUT,EXPCUR,FILVAL,FS
      DOUBLE PRECISION LASTPF,LASTSC,LASTOX,LASTOY,OX,OY
      DOUBLE PRECISION OUTSCL,ORIENT
      DOUBLE PRECISION WCS(8)
      DOUBLE PRECISION WCSOUT(8),RACEN,DECCEN,XREFP,YREFP
      REAL WTSCL
      CHARACTER*80 DATA,WEIGHT,OUTDAT,OUTCOU,CHARS,XGEOIM,YGEOIM
      CHARACTER*80 COEFFS,SHFTUN,WTSTR,FILSTR
      CHARACTER*45 VERS
      CHARACTER*8 CTYPE1,CTYPE2,LASTUN,CT1,CT2
      CHARACTER*8 EXPKEY,SHFTFR,INUN,OUTUN,ALIGN
      CHARACTER*8 GEOMOD
      CHARACTER*8 KERNEL

C Context related variables and parameters
      CHARACTER*80 CONTIM,CONTAB
      INTEGER NEN,I1,I2
      INTEGER UNIQID

C This parameter controls the maximum number of entries in
C the context table. This value is rather arbitrary
      INTEGER MAXEN
      PARAMETER (MAXEN=1000)

C The following parameter controls the number of images which
C may be combined when contexts are in use. 
      INTEGER MAXIM
      PARAMETER (MAXIM=128)

C This parameter controls the context style
      LOGICAL BITCON
      PARAMETER (BITCON=.TRUE.)

C This parameter is the maximum number of contexts which are stored
C in the header of the context image. If there are more then they are
C written to a separate file
      INTEGER MAXHCN
      PARAMETER (MAXHCN=20)

      INTEGER INTAB(MAXIM,MAXEN)
      LOGICAL CON

C The maximum desirable array size (for about 64Mb memory use)
      INTEGER MAXPIX
      PARAMETER (MAXPIX=2e7)

C Logical flags
      LOGICAL VERBOSE
      LOGICAL USEWEI
      LOGICAL USEWCS
      LOGICAL UPDATE
      LOGICAL GOTWCS
      LOGICAL WRIWEI
      LOGICAL FILL
      LOGICAL ROTFIR
      LOGICAL INCPS
      LOGICAL OUTCPS
      LOGICAL CURCPS
      LOGICAL SUB
      LOGICAL NOOVER
      LOGICAL ODD
      LOGICAL ODW
      LOGICAL ODND
      LOGICAL ODNC
      LOGICAL ODCO
      LOGICAL DISIM

C Secondary geometrical parameters
      DOUBLE PRECISION XSH2,YSH2,ROT2,XSCALE,YSCALE,ALPHA,BETA
      CHARACTER*8 SHFR2
      LOGICAL SECPAR
      LOGICAL ROTF2
      LOGICAL COPALL

C-- Start of executable code

C First initialise the logical flags
      VERBOSE=.TRUE.
      ODCO=.FALSE.
      ODNC=.FALSE.
      ODND=.FALSE.
      COPALL=.TRUE.

      VERS='DRIZZLE Version 3.4.2 (July 3rd 2006)'

C Announce the version
      CALL UMSPUT('+ '//VERS,1,0,ISTAT)

C Do force geomode to be user (this is the only difference between
C WDRIZZLE and DRIZZLE, apart from the name)
      GEOMOD='user'
CCC      GEOMOD=' '

C Get all the parameter values without verifying
      CALL GETPAR(GEOMOD,KERNEL,PFRACT,COEFFS,LAM,XGEOIM,YGEOIM,
     :                  SCALE,ROT,XSH,YSH,SHFTFR,SHFTUN,ALIGN,
     :                  XSCALE,YSCALE,XSH2,YSH2,ROT2,SHFR2,
     :                  EXPKEY,WTSTR,FILSTR,INUN,OUTUN,
     :                  DATA,WEIGHT,OUTDAT,OUTCOU,CONTIM,ONX,ONY,
     :                  OUTSCL,RACEN,DECCEN,XREFP,YREFP,ORIENT)

C Find out whether we are using WCS to define the geometry
      IF(GEOMOD.EQ.'wcs') THEN
         USEWCS=.TRUE.
      ELSE
         USEWCS=.FALSE.
      ENDIF

C Check for small values and zero values
      IF(PFRACT.LT.0.001D0) KERNEL='point'
      IF(KERNEL.EQ.'point') PFRACT=0.001D0

C Check the switch value for whether to read in CPS or
C counts (latter is the default)
      IF(INUN.EQ.'cps') THEN
         INCPS=.TRUE.
      ELSE
         INCPS=.FALSE.
      ENDIF

C Check the switch value for whether to write out in CPS or
C counts (latter is the default)
      IF(OUTUN.EQ.'cps') THEN
         OUTCPS=.TRUE.
      ELSE
         OUTCPS=.FALSE.
      ENDIF

C Check the parameter specifying which frames shifts are applied
      IF(SHFTFR.EQ.'input') THEN
         ROTFIR=.FALSE.
      ELSE
         ROTFIR=.TRUE.
      ENDIF

C Check for meaningful values
      IF(FILSTR.NE.'INDEF'.AND.FILSTR.NE.'indef') THEN
         READ(FILSTR,*,IOSTAT=ISTAT) FILVAL
         IF(ISTAT.NE.0) THEN
            CALL UMSPUT('! Invalid filling value specified',
     :                  1,0,ISTAT)
            GO TO 99
         ENDIF
         FILL=.TRUE.
      ELSE
         FILL=.FALSE.
      ENDIF

C Check for invalid scale
      IF(SCALE.EQ.0.0D0) THEN
         CALL UMSPUT('! Invalid scale',1,0,ISTAT)
         GO TO 99
      ENDIF

C Convert the rot to radians
      ROT=ROT*3.14159265358979D0/180.0D0

C Convert the shift units if necessary
      IF(SHFTUN.EQ.'output') THEN
         XSH=XSH*SCALE
         YSH=YSH*SCALE
      ENDIF

C Note that the shifts we now have are INPUT ones

C Convert the secondary parameters into suitable units
      ROT2=ROT2*3.14159265358979D0/180.0D0
      IF(SHFR2.eq.'input') THEN
         ROTF2=.FALSE.
      ELSE
         ROTF2=.TRUE.
      ENDIF

C Give a warning message if secondary parameters will have an effect
      IF(XSCALE.NE.1.0D0 .OR. YSCALE.NE.1.0D0 .OR.
     :   XSH2.NE.0.0D0 .OR. YSH2.NE.0.0D0 .OR. ROT2.NE.0.0D0) THEN
       CALL UMSPUT(
     : '! Warning, secondary geometric transform is being used',
     :               1,0,ISTAT)
        SECPAR=.TRUE.
      ELSE
        SECPAR=.FALSE.
      ENDIF

C Check for compatible requests
      IF(EXPKEY.EQ.' ') THEN
         CALL UMSPUT('! No exposure time keyword has been given',
     :  1,0,ISTAT)
         GO TO 99
      ENDIF

C Try to access the input data image
      CALL UIMOPN(DATA,1,IDD,ISTAT)
      IF(ISTAT.NE.0) THEN
         CALL UMSPUT('! Unable to open data image',
     :                    1,0,ISTAT)
         ODD=.FALSE.
         GO TO 99
      ELSE
         IF(VERBOSE) CALL UMSPUT(
     :  '-Opening input data image: '//DATA,
     :                   1,0,ISTAT)
         ODD=.TRUE.
      ENDIF

C Get the array size and shape
      CALL UIMGID(IDD,DATTYP,NDIMS,DDIMS,ISTAT)

      IF(NDIMS.NE.2) THEN
         CALL UMSPUT('! Input image is not two dimensional',
     :                    1,0,ISTAT)
         GO TO 99
      ELSE
         DNX=DDIMS(1)
         DNY=DDIMS(2)
      ENDIF

C Get the geometric distortion coefficient information
      CALL GETGEO(COEFFS,IDD,LAM,
     :            COTY,COMAX,CONUM,XCO,YCO,ISTAT)
      IF(ISTAT.NE.0) THEN
         CALL UMSPUT(
     :  '! Error, failed to get geometric distortion coefficients',
     :  1,0,ISTAT)
          GO TO 99
      ENDIF

C  Read in any distortion image corrections, if specified
C  PXG,PYG will default to 2x2 arrays when DISIM returns as FALSE.
C 
      CALL GGEOIM(XGEOIM,YGEOIM,PXG,PYG,XGDIM,YGDIM,DISIM)

C Get the input exposure time from the header
      CALL UHDGSR(IDD,EXPKEY,EXPIN,ISTAT)
      IF(ISTAT.NE.0) THEN
         CALL UMSPUT(
     :    '! Error, unable to read exposure time keyword value',
     :         1,0,ISTAT)
         CALL UMSPUT(
     :    '! Please add one to the image header and try again.',
     :         1,0,ISTAT)
         GO TO 99
      ENDIF

C Check for zero exposure time (yes, it does happen)
      IF(EXPIN.LE.0.0) THEN
         CALL UMSPUT(
     : '! Warning, exposure time <= 0 - setting to 1.0',1,0,ISTAT)
         EXPIN=1.0
      ENDIF

C The scale is read as a string as it might be "exptime"
C in which case we use the exposure time - if we have it
C We also can have weighting by exposure time squared (eg,
C for read-noise dominated images)
      IF(WTSTR.EQ.'exptime' .OR. WTSTR.EQ.'EXPTIME') THEN
         WTSCL=EXPIN
      ELSE IF(WTSTR.EQ.'expsq' .OR. WTSTR.EQ.'EXPSQ') THEN
         WTSCL=EXPIN**2
      ELSE
         READ(WTSTR,*,IOSTAT=ISTAT) WTSCL
         IF(ISTAT.NE.0) THEN
            CALL UMSPUT('! Weighting scale is not a number',
     :                  1,0,ISTAT)
            GO TO 99
         ENDIF
      ENDIF

      IF(WEIGHT.EQ.' ') THEN
         USEWEI=.FALSE.
         ODW=.FALSE.
      ELSE
         CALL UIMOPN(WEIGHT,1,IDW,ISTAT)
         IF(ISTAT.NE.0) THEN
            CALL UMSPUT('! Unable to open mask image',
     :                       1,0,ISTAT)
            ODW=.FALSE.
            GO TO 99
         ELSE
            IF(VERBOSE) CALL UMSPUT(
     :   '-Opening mask image: '//WEIGHT,
     :                      1,0,ISTAT)
            ODW=.TRUE.

C Get the array size and shape of the mask image - must
C be the same as the data
            CALL UIMGID(IDW,DATTYP,NDIMS,DDIMS,ISTAT)
            IF(NDIMS.NE.2 .OR. DDIMS(1).NE.DNX .OR.
     :         DDIMS(2).NE.DNY) THEN
               CALL UMSPUT('! Mask image is not the same shape '//
     :          'and size as data',1,0,ISTAT)
               GO TO 99
            ENDIF

            USEWEI=.TRUE.
         ENDIF
      ENDIF

C If the output weighting image is null we just don't
C create anything and don't write anything out
      IF(OUTCOU.EQ.' ') THEN
         WRIWEI=.FALSE.
      ELSE
         WRIWEI=.TRUE.
      ENDIF

C Similarly for the context image
      IF(CONTIM.EQ.' ') THEN
         CON=.FALSE.
      ELSE

C Prepare a context table file name, just in case we need it later
         CALL LENSTR(CONTIM,I1,I2)
         CONTAB=CONTIM(I1:I2)//'.CON'
         CON=.TRUE.
      ENDIF

C It may be that the "new" image currently exists and we
C want to update it by drizzling the new data on top
      IF(OUTDAT.EQ.' ') THEN
         CALL UMSPUT(
     :       '! No output data array name specified',
     :                   1,0,ISTAT)
           GO TO 99
      ENDIF

C We try to open it with update access
      CALL UIMOPN(OUTDAT,2,IDND,ISTAT)
      IF(ISTAT.NE.0) THEN
         ODND=.FALSE.
         UPDATE=.FALSE.

         ODIMS(1)=ONX
         ODIMS(2)=ONY

C If not updating and using WCS... 
         IF(USEWCS) THEN

C Now convert these into WCS style representation
            CALL SETWCS(OUTSCL,ORIENT,XREFP,RACEN,
     :                  YREFP,DECCEN,WCSOUT)
         ENDIF
      ELSE

         CALL UMSPUT(
     :    '-Opening extant data image: '//OUTDAT,
     :                1,0,ISTAT)
         ODND=.TRUE.
 
C Now we try to open the corresponding weighting image
         CALL UIMOPN(OUTCOU,2,IDNC,ISTAT)
         IF(ISTAT.NE.0) THEN
            CALL UMSPUT(
     :     '! Unable to open extant weighting image',
     :                 1,0,ISTAT)
            ODNC=.FALSE.
            GO TO 99
         ENDIF

         CALL UMSPUT(
     :       '-Opening extant weighting image: '//OUTCOU,
     :                   1,0,ISTAT)
         ODNC=.TRUE.

C We are doing well and probably can use the existing
C images however we need to do a little more...
C Get the array size and shape of old data frame
         CALL UIMGID(IDND,DATTYP,NDIMS,ODIMS,ISTAT)

         IF(ISTAT.NE.0) THEN
            CALL UMSPUT(
     : '! A problem was encountered accessing existing image: '//
     : OUTDAT,1,0,ISTAT)
            CALL UMSPUT(
     : '! Please delete or recreate it and try again',
     :      1,0,ISTAT)
            GO TO 99
         ENDIF

         IF(NDIMS.NE.2) THEN
            CALL UMSPUT('! Extant image is not two dimensional',
     :                       1,0,ISTAT)
            GO TO 99
         ELSE
            ONX=ODIMS(1)
            ONY=ODIMS(2)
         ENDIF

C Also check that the extant weighting image is the same size
         CALL UIMGID(IDNC,DATTYP,NDIMS,ODIMS,ISTAT)

         IF(ISTAT.NE.0) THEN
            CALL UMSPUT(
     : '! A problem was encountered accessing existing image: '//
     : OUTDAT,1,0,ISTAT)
            CALL UMSPUT(
     : '! Please delete or recreate it and try again',
     :      1,0,ISTAT)
            GO TO 99
         ENDIF

         IF(NDIMS.NE.2) THEN
            CALL UMSPUT(
     :   '! Current weighting image is not two dimensional',
     :                    1,0,ISTAT)
            GO TO 99
         ELSE IF(ODIMS(1).NE.ONX .OR. ODIMS(2).NE.ONY) THEN
            CALL UMSPUT('! Weighting image not the same size as data',
     :                    1,0,ISTAT)
            GO TO 99
         ENDIF

C We can now set the update flag
         UPDATE=.TRUE.
         WRIWEI=.TRUE.

         IF(USEWCS) THEN

C Try to get the WCS of the current image
            CALL GETWCS(IDND,WCSOUT,CT1,CT2,ISTAT)
            IF(ISTAT.NE.0) THEN
               CALL UMSPUT('! Unable to get WCS from extant image',
     :         1,0,ISTAT)
               GO TO 99
            ENDIF

            CALL UMSPUT(
     : '! Note: using WCS of extant image to define geometry',
     :                  1,0,ISTAT)
            SHFTUN='output'
            SHFTFR='output'
         ENDIF

C Get the current exposure time from the header
         CALL UHDGSR(IDND,EXPKEY,EXPCUR,ISTAT)
         IF(ISTAT.NE.0) THEN
            CALL UMSPUT(
     : '! Warning, failed to get exposure time keyword value',
     :      1,0,ISTAT)
            GO TO 99
         ENDIF              

C Check for zero exposure time (yes, it does happen)
         IF(EXPCUR.LE.0.0) THEN
            CALL UMSPUT(
     : '! Warning, exposure time <= 0 - setting to 1.0',1,0,ISTAT)
            EXPCUR=1.0
         ENDIF

C We now get some of the previous drizzle information from
C the header of the current image and check for funny
C combinations
         CALL GOLDH(IDND,USEWCS,IC,LASTPF,LASTSC,
     :                 LASTUN,LASTOX,LASTOY,ISTAT)
         IF(ISTAT.NE.0) THEN
            CALL UMSPUT(
     : '! Warning, unable to read old drizzle header keywords',
     :      1,0,ISTAT)
            CALL UMSPUT('! assuming current image is in counts',
     :      1,0,ISTAT)
            CURCPS=.FALSE.
         ELSE
            IF(LASTUN.EQ.'counts' .OR. LASTUN.EQ.'COUNTS') THEN
               CURCPS=.FALSE.
            ELSE
               CURCPS=.TRUE.
            ENDIF

            IF(LASTPF.NE.PFRACT) THEN
               CALL UMSPUT(
     : '! Warning, current pixfrac does not match previous one',
     :         1,0,ISTAT)
            ENDIF

            IF(LASTSC.NE.SCALE .AND. .NOT.USEWCS) THEN
               CALL UMSPUT(
     : '! Warning, current scale does not match previous one',
     :         1,0,ISTAT)
            ENDIF

            IF(ALIGN.EQ.'corner') THEN
               OX=DBLE(ONX/2.0)+0.5D0
               OY=DBLE(ONY/2.0)+0.5D0
            ELSE
               OX=DBLE(ONX/2.0)+1.0D0
               OY=DBLE(ONY/2.0)+1.0D0
            ENDIF

            IF(.NOT.USEWCS) THEN
               IF(LASTOX.NE.OX .OR. LASTOY.NE.OY) THEN
                  CALL UMSPUT(
     : '! Warning, current reference pixel alignment '//
     : 'does not match previous one',
     :            1,0,ISTAT)
               ENDIF
            ENDIF
         ENDIF 
      ENDIF

C Set a reasonable running image number
      IF(.NOT.UPDATE) IC=0

C If we are using the context we need to get the unique image
C identifier from the data file
      IF(CON) THEN

C The image ID is the same as the count of images drizzled
            UNIQID=IC+1

C Open the context image and create a bigger one if necessary
         IF(UPDATE) THEN
            CALL OPCON(CONTIM,ONX,ONY,IDCO,ODCO,UNIQID,ISTAT)
            IF(ISTAT.NE.0) THEN
               CALL UMSPUT('! Failed to open context image',
     :         1,0,ISTAT)
               GO TO 99
            ENDIF
         ENDIF

C If we have a 32 bit context image then check this is in
C range
         IF(.NOT.BITCON) THEN
            IF(UNIQID.LT.1 .OR. UNIQID.GT.MAXIM) THEN
               CALL UMSPUT(
     :  '! Image id number out of range for context',
     :         1,0,ISTAT)
               GO TO 99
            ENDIF
         ENDIF
      ENDIF
 
C Also try to get the header items for the WCS, note that
C this is not the full WCS but just 8 header items commonly used
C for HST images plus CTYPE1 & CTYPE2
      GOTWCS=.FALSE.
      CALL GETWCS(IDD,WCS,CTYPE1,CTYPE2,ISTAT)
      IF(ISTAT.EQ.0) THEN
         GOTWCS=.TRUE.
      ELSE
         IF(.NOT.UPDATE) THEN
            CALL UMSPUT(
     :    '! Warning, unable to read WCS information from header',
     :    1,0,ISTAT)
         ENDIF
      ENDIF
 
C Here we set the WCS matrix to something sensible anyway
      IF(.NOT.GOTWCS) THEN
         CTYPE1='PIXELS'
         CTYPE2='PIXELS'
 
         DO I=1,8
            WCS(I)=0.0D0
         ENDDO

C These were added in V1.5D so that a sensible matrix for inversion
C was available for later - although a fictional one
         WCS(5)=-1.0D0
         WCS(8)=1.0D0
      ENDIF

C Calculate the range of pixels in the output which are affected
C by the input image - this is the new subsetting code which was
C added in V1.4
      CALL LCORN(DNX,DNY,ONX,ONY,
     :           XSH,YSH,ROT,SCALE,ALIGN,ROTFIR,
     :           SECPAR,XSH2,YSH2,ROT2,XSCALE,YSCALE,SHFR2,ROTF2,
     :           USEWCS,WCS,WCSOUT,
     :           COTY,CONUM,XCO,YCO,
     :           DISIM,MEMR(PXG),MEMR(PYG),XGDIM,YGDIM,
     :           XMIN,XMAX,YMIN,YMAX,ISTAT,ALPHA,BETA)
 
C Assume we are using the whole frame unless set otherwise
      SUB=.FALSE.
      NOOVER=.FALSE.

C Announce which image this is
      IF(IC.EQ.0) THEN
         CALL UMSPUT(
     : '-This is the first image to be drizzled onto this output',
     :   1,0,ISTAT)
      ELSE
         WRITE(CHARS,
     : '(''-This is image # '',I3,
     :   '' to be drizzled onto this output'''
     :    //')') IC+1
         CALL UMSPUT(CHARS,1,0,ISTAT)
      ENDIF
 
C Check for no-overlap
      IF(XMAX.LT.1 .OR. YMAX.LT.1 .OR.
     :      XMIN.GT.ONX .OR. YMIN.GT.ONY) THEN
         CALL UMSPUT(
     : '! Warning, there is no overlap with the output image',
     :  1,0,ISTAT)
            WRITE(CHARS,
     : '(''! Output pixel range would be: ['',I7,'':'',I7,
     :      '','',I7,'':'',I7,'']'')') XMIN,XMAX,YMIN,YMAX
         CALL UMSPUT(CHARS,1,0,ISTAT)
 
         NOOVER=.TRUE.
         XMIN=1
         XMAX=1
         YMIN=1
         YMAX=1
         SUB=.TRUE.
      ELSE
         XMIN=MAX(1,XMIN)
         XMAX=MIN(ONX,XMAX)
         YMIN=MAX(1,YMIN)
         YMAX=MIN(ONY,YMAX)

C Check to see whether we really should use the subset or
C whether it makes more sense to work on the full frame.
C These criteria are a little arbitrary at this stage
         IF(DBLE(YMAX-YMIN+1)/DBLE(ONY).GT.0.5 .AND.
     :      ONX*ONY.LT.MAXPIX .OR.
     :      (XMIN.EQ.1 .AND. XMAX.EQ.ONX .AND. 
     :      YMIN.EQ.1 .AND. YMAX.EQ.ONY)) THEN

            SUB=.FALSE.
            WRITE(CHARS,
     : '(''-Drizzling onto full output image. Kernel: '',A8)')
     :      KERNEL

            XMIN=1
            YMIN=1
            XMAX=ONX
            YMAX=ONY
            SUB=.FALSE.
         ELSE
            WRITE(CHARS,
     : '(''-Drizzling onto subset: ['',I5,'':'',I5,
     :      '','',I5,'':'',I5,''] ('',F6.2,''%). Kernel: '',A8)') 
     :       XMIN,XMAX,YMIN,YMAX,
     :       100.0*DBLE((XMAX-XMIN+1)*(YMAX-YMIN+1))/
     :       DBLE(ONX*ONY),KERNEL
            SUB=.TRUE.
         ENDIF

         CALL UMSPUT(CHARS,1,0,ISTAT)
      ENDIF

C If there is no extant output image
C we will have to create output data and weighting images anyway
C so we need to find out their dimensions
C If there is no overlap we don't do this
      IF(NOOVER) THEN
         CALL UMSPUT('! No overlap - no drizzling',1,0,ISTAT)
         GO TO 99
      ELSE
       IF(.NOT.UPDATE) THEN

C If we are not updating we need to create the output images
         CALL UIMCRE(OUTDAT,6,2,ODIMS,IDND,ISTAT)
         IF(ISTAT.NE.0) THEN
            CALL UMSPUT(
     :        '! Unable to create output data image',
     :                    1,0,ISTAT)
            ODND=.FALSE.
            GO TO 99
         ELSE
            CALL UMSPUT(
     :        '-Created new output data image: '//OUTDAT,
     :                    1,0,ISTAT)
            ODND=.TRUE.
         ENDIF

C If we are going to store the counts image we must create it
         IF(WRIWEI) THEN
            CALL UIMCRE(OUTCOU,6,2,ODIMS,IDNC,ISTAT)
            IF(ISTAT.NE.0) THEN
               CALL UMSPUT(
     :        '! Unable to create output weighting image',
     :                    1,0,ISTAT)
               ODNC=.FALSE.
               GO TO 99
            ELSE
               CALL UMSPUT(
     :        '-Created new output weighting image: '//OUTCOU,
     :                    1,0,ISTAT)

               ODNC=.TRUE.
            ENDIF
         ELSE
            CALL UMSPUT(
     : '! Warning, output weighting image will not be saved',
     :      1,0,ISTAT)
         ENDIF

C If we are going to store the context image we must create it
         IF(CON) THEN

C We create a file with initially just one plane
C We will expand if needed later. 
            CALL UIMCRE(CONTIM,4,2,ODIMS,IDCO,ISTAT)
            IF(ISTAT.NE.0) THEN
               CALL UMSPUT(
     :        '! Unable to create output context image',
     :                    1,0,ISTAT)
               ODCO=.FALSE.
               GO TO 99
            ELSE
               CALL UMSPUT(
     :        '-Created new output context image: '//CONTIM,
     :                    1,0,ISTAT)

               ODCO=.TRUE.
            ENDIF
         ELSE
            CALL UMSPUT(
     : '! Warning, output context image will not be saved',
     :      1,0,ISTAT)
         ENDIF
      ENDIF

C If this is a new output then we need to copy some of the
C old header over
      IF(.NOT.UPDATE) THEN
         CALL COPHED(IDD,IDND,COPALL,ISTAT)
         IF(WRIWEI) CALL COPHED(IDD,IDNC,COPALL,ISTAT)
         IF(CON) CALL COPHED(IDD,IDCO,COPALL,ISTAT)
      ENDIF

C Update the exposure times in the outputs
       IF(UPDATE) THEN
         EXPOUT=EXPIN+EXPCUR
       ELSE
         EXPOUT=EXPIN
       ENDIF
      ENDIF

C Now we allocate space for all the arrays we will need, note that they
C are a mixture of real and double precision except for the optional 
C context image which is INTEGER
      CALL ALLMEM(DNX,DNY,ONX,XMAX-XMIN+1,YMAX-YMIN+1,CON,BITCON,
     :            PDATA,PWEI,PNDAT,PNCOU,PNCON,PCDON,PBUFF,PIBUFF,
     :            PXI,PYI,PXO,PYO,PXIB,PYIB,PXOB,PYOB,ISTAT)
      IF(ISTAT.NE.0) THEN
         CALL UMSPUT('! Unable to allocate required memory arrays',
     :               1,0,ISTAT)
         GO TO 99
      ENDIF
      YSTART = 0
      
C Optional weights array initialize
      IF(.NOT.USEWEI) CALL SETIM(MEMR(PWEI),DNX,1,1.0)

C If we are updating we read in the extant "new" images
      IF(UPDATE) THEN

C First the data image
         CALL GETIMR(IDND,ONX,ONY,SUB,XMIN,XMAX,YMIN,YMAX,
     :                  MEMR(PBUFF),MEMR(PNDAT),ISTAT)
         IF(ISTAT.NE.0) THEN
            CALL UMSPUT(
     :         '! Failed to read extant data image',
     :                      1,0,ISTAT)
            GO TO 99
         ENDIF

C Scale by exposure time
         IF(.NOT.CURCPS) THEN
            CALL MULC(MEMR(PNDAT),XMAX-XMIN+1,YMAX-YMIN+1,
     :                1.0/EXPCUR)
         ENDIF

C Weighting image
        CALL GETIMR(IDNC,ONX,ONY,SUB,XMIN,XMAX,YMIN,YMAX,
     :                  MEMR(PBUFF),MEMR(PNCOU),ISTAT)

         IF(ISTAT.NE.0) THEN
            CALL UMSPUT(
     :         '! Failed to read current weighting image',
     :                      1,0,ISTAT)
            GO TO 99
         ENDIF

C Context image (integers)
         IF(CON) THEN

            CALL GETIMI(IDCO,ONX,ONY,SUB,XMIN,XMAX,YMIN,YMAX,
     :                  MEMI(PIBUFF),MEMI(PNCON),ISTAT)
            IF(ISTAT.NE.0) THEN
               CALL UMSPUT(
     :         '! Failed to read extant context image',
     :                      1,0,ISTAT)
              GO TO 99
            ENDIF
         ENDIF
      ELSE

C The final case is where the output is empty.
C Before we start drizzling we need to drain out the output arrays
C if there are no old arrays 
         CALL SETIM(MEMR(PNDAT),XMAX-XMIN+1,YMAX-YMIN+1,0.0)
         CALL SETIM(MEMR(PNCOU),XMAX-XMIN+1,YMAX-YMIN+1,0.0)
         IF(CON) THEN
            CALL SETIMI(MEMI(PNCON),XMAX-XMIN+1,YMAX-YMIN+1,0)
         ENDIF
      ENDIF

C If we are using a context array we need to either read its
C current values from the global context file, or, if the
C context is new, initialise it with something sensible
C
C This is read from the header of the context
C image not from an external file
C
C This is only needed for the EIS style context
      IF(CON .AND. .NOT.BITCON) THEN

         CALL SETIMI(MEMI(PCDON),XMAX-XMIN+1,YMAX-YMIN+1,0)
         IF(UPDATE) THEN
            CALL GTCOIN(IDCO,INTAB,MAXIM,MAXEN,NEN,ISTAT)

            IF(ISTAT.NE.0) THEN
               CALL UMSPUT(
     : '! Note: Valid context table not found in context image header',
     :                     1,0,ISTAT)
               NEN=0
            ENDIF
         ELSE
            NEN=0
         ENDIF
      ENDIF

C
C
C
      NMISS = 0
      NSKIP = 0
      DO J=1,DNY
C
C Read in one row of data
          CALL UIGL2R(IDD,J,MEMR(PDATA),ISTAT)
          IF(ISTAT.NE.0) THEN
             CALL UMSPUT('! Failed to read data image',
     :                1,0,ISTAT)
             RETURN
          ENDIF
C If there is one, read in a line of the mask image
          IF(USEWEI) THEN
             CALL UIGL2R(IDW,J,MEMR(PWEI),ISTAT)
             IF(ISTAT.NE.0) THEN
               CALL UMSPUT('! Failed to read mask image',
     :                1,0,ISTAT)
               RETURN
             ENDIF
          ENDIF
         
C Set JNY to 1 since only 1 line at a time will ever get
C  passed into DOBOX
          JNY = 1
C Now do the actual combination using BOXER 
C We can skip this if there is no overlap
         IF(.NOT.NOOVER) THEN

          CALL DOBOX(MEMR(PDATA),MEMR(PWEI),
     :      MEMR(PNDAT),MEMR(PNCOU),MEMI(PNCON),MEMI(PCDON),DNX,DNY,JNY,
     :      J-1,XMIN,XMAX,YMIN,YMAX,NOOVER,
     :      KERNEL,MEMD(PXI),MEMD(PXO),MEMD(PYI),MEMD(PYO),
     :      MEMD(PXIB),MEMD(PXOB),MEMD(PYIB),MEMD(PYOB),
     :      ONX,ONY,COTY,CONUM,XCO,YCO,
     :      DISIM,MEMR(PXG),MEMR(PYG),XGDIM,YGDIM,
     :      WTSCL,ALIGN,INCPS,EXPIN,
     :      PFRACT,SCALE,ROT,XSH,YSH,WCS,WCSOUT,ROTFIR,
     :      SECPAR,XSH2,YSH2,ROT2,XSCALE,YSCALE,SHFR2,ROTF2,
     :      CON,BITCON,INTAB,MAXIM,MAXEN,NEN,UNIQID,
     :      UPDATE,USEWEI,USEWCS,ISTAT,NMISS,NSKIP,ALPHA,BETA)

C Check the exit status
           IF(ISTAT.NE.0) GO TO 99
         ENDIF
C End loop over lines
      ENDDO
C Report number of points which were outside the output frame
      IF(NMISS.GT.0) THEN
         WRITE(CHARS,'(''! Warning, '',I9,'' points were '','//
     :        '''outside the output image.'')') NMISS
         CALL UMSPUT(CHARS,1,0,ISTAT)

C Also report the number of skipped lines
         IF(NSKIP.GT.0) THEN
            WRITE(CHARS,
     : '(''! Note, '',I5,'' input lines were skipped completely.'')')
     :    NSKIP
            CALL UMSPUT(CHARS,1,0,ISTAT)
         ENDIF
      ENDIF

C Close the input images
      IF(ODD) THEN
         CALL UIMCLO(IDD,ISTAT)
         ODD=.FALSE.
      ENDIF

      IF(ODW) THEN
         CALL UIMCLO(IDW,ISTAT)
         ODW=.FALSE.
      ENDIF

      IF(NOOVER) THEN
         CALL UMSPUT('! No overlap, not writing anything out',
     :               1,0,ISTAT)
      ELSE

C Write out the exposure time
         IF(UPDATE) THEN
            CALL UHDPSR(IDND,EXPKEY,EXPOUT,ISTAT)
            IF(WRIWEI) CALL UHDPSR(IDNC,EXPKEY,EXPOUT,ISTAT)
            IF(CON) CALL UHDPSR(IDCO,EXPKEY,EXPOUT,ISTAT)
         ELSE
            CALL UHDASR(IDND,EXPKEY,EXPOUT,
     : 'Drizzle, effective output exposure time',0,ISTAT)
            IF(WRIWEI) CALL UHDASR(IDNC,EXPKEY,EXPOUT,
     : 'Drizzle, effective output exposure time',0,ISTAT)
            IF(CON) CALL UHDASR(IDCO,EXPKEY,EXPOUT,
     : 'Drizzle, effective output exposure time',0,ISTAT)
         ENDIF

C Update the WCS
         CALL UPWCS(WCS,WCS,DNX,DNY,ONX,ONY,
     :            XSH,YSH,ROT,SCALE,ALIGN,ROTFIR,
     :            SECPAR,XSH2,YSH2,ROT2,XSCALE,YSCALE,SHFR2,ROTF2,
     :            USEWCS,COTY,CONUM,XCO,YCO,
     :            DISIM,MEMR(PXG),MEMR(PYG),XGDIM,YGDIM,ALPHA,BETA)

C Scale the output if not CPS output
         FS=1.0
         IF(.NOT.OUTCPS) THEN
            CALL MULC(MEMR(PNDAT),XMAX-XMIN+1,YMAX-YMIN+1,EXPOUT)
            IF(UPDATE) FS=EXPOUT/EXPCUR
         ENDIF

C Put in the fill values (if defined)
         IF(FILL) CALL PUTFIL(MEMR(PNDAT),MEMR(PNCOU),
     :         XMAX-XMIN+1,YMAX-YMIN+1,FILVAL)
      
C Write out the two new images
         IF(VERBOSE)
     :      CALL UMSPUT('-Writing output drizzled image: '//
     :               OUTDAT,1,0,ISTAT)

C Update the header
         CALL UHEAD(IDND,VERS,DATA,WEIGHT,EXPIN,WTSCL,OUTDAT,
     :                 OUTCOU,CONTIM,COEFFS,XGEOIM,YGEOIM,
     :                 SHFTUN,PFRACT,
     :                 LAM,SCALE,ROT,SHFTFR,ALIGN,KERNEL,
     :                 EXPKEY,FILSTR,INUN,OUTUN,
     :                 SECPAR,XSH2,YSH2,ROT2,XSCALE,YSCALE,SHFR2,
     :                 USEWCS,XSH,YSH,DNX,DNY,ONX,ONY)

C If we are not updating (ie, this is the first drizzle
C onto this output) then we modify the WCS
         IF((.NOT.UPDATE).AND.GOTWCS) THEN
            IF(USEWCS) THEN
               CALL UWCS(IDND,WCSOUT,CTYPE1,CTYPE2)
            ELSE
               CALL UWCS(IDND,WCS,CTYPE1,CTYPE2)
            ENDIF
         ENDIF
      ENDIF

C Free as much memory as possible at this stage
       CALL UDMFRE(PDATA,6,ISTAT)
       PDATA=0
       CALL UDMFRE(PWEI,6,ISTAT)
       PWEI=0
       CALL UDMFRE(PXI,7,ISTAT)
       PXI=0
       CALL UDMFRE(PYI,7,ISTAT)
       PYI=0
       CALL UDMFRE(PXO,7,ISTAT)
       PXO=0
       CALL UDMFRE(PYO,7,ISTAT)
       PYO=0
       CALL UDMFRE(PXIB,7,ISTAT)
       PXIB=0
       CALL UDMFRE(PYIB,7,ISTAT)
       PYIB=0
       CALL UDMFRE(PXOB,7,ISTAT)
       PXOB=0
       CALL UDMFRE(PYOB,7,ISTAT)
       PYOB=0

C Now write out the appropriate part (or whole) data image
      IF(.NOT.NOOVER) THEN
         CALL PUTIMR(IDND,ONX,ONY,SUB,XMIN,XMAX,YMIN,YMAX,
     :            UPDATE,OUTCPS,FS,MEMR(PBUFF),MEMR(PNDAT),ISTAT)
         IF(ISTAT.NE.0) THEN
            CALL UMSPUT('! Failed to write output data image',
     :               1,0,ISTAT)
            GO TO 99
         ENDIF
      ENDIF

C Close this output image
      IF(ODND) THEN
         CALL UIMCLO(IDND,ISTAT)
         ODND=.FALSE.
      ENDIF

C Now write out the weights array, if there is one
      IF(.NOT.NOOVER) THEN

         IF(WRIWEI) THEN
            IF(VERBOSE)
     :         CALL UMSPUT('-Writing output weighting image: '//
     :               OUTCOU,1,0,ISTAT)
         
C First update the header
            CALL UHEAD(IDNC,VERS,DATA,WEIGHT,EXPIN,WTSCL,OUTDAT,
     :                 OUTCOU,CONTIM,COEFFS,XGEOIM,YGEOIM,
     :                 SHFTUN,PFRACT,
     :                 LAM,SCALE,ROT,SHFTFR,ALIGN,KERNEL,
     :                 EXPKEY,FILSTR,INUN,OUTUN,
     :                 SECPAR,XSH2,YSH2,ROT2,XSCALE,YSCALE,SHFR2,
     :                 USEWCS,XSH,YSH,DNX,DNY,ONX,ONY)

            IF((.NOT.UPDATE).AND.GOTWCS) THEN
               IF(USEWCS) THEN
                  CALL UWCS(IDNC,WCSOUT,CTYPE1,CTYPE2)
               ELSE
                  CALL UWCS(IDNC,WCS,CTYPE1,CTYPE2)
               ENDIF
            ENDIF
         ENDIF
      ENDIF

C Clear some more space
      CALL UDMFRE(PNDAT,6,ISTAT)
      PNDAT=0

C Now write out the appropriate part (or whole) weights image
C note that there is never any re-scaling here
      IF(WRIWEI) THEN
         IF(.NOT.NOOVER) THEN
            CALL PUTIMR(IDNC,ONX,ONY,SUB,XMIN,XMAX,YMIN,YMAX,
     :             UPDATE,.TRUE.,1.0,MEMR(PBUFF),MEMR(PNCOU),ISTAT)
            IF(ISTAT.NE.0) THEN
               CALL UMSPUT('! Failed to write output weight image',
     :               1,0,ISTAT)
               GO TO 99
            ENDIF
         ENDIF
      ENDIF

C Close this
      IF(ODNC) THEN
        CALL UIMCLO(IDNC,ISTAT)
        ODNC=.FALSE.
      ENDIF

C Finally write the context array, which is INTEGER, if we have
C one
      IF(.NOT.NOOVER) THEN
         IF(CON) THEN
            IF(VERBOSE)
     :         CALL UMSPUT('-Writing output context image: '//
     :               CONTIM,1,0,ISTAT)

C First update the header
             CALL UHEAD(IDCO,VERS,DATA,WEIGHT,EXPIN,WTSCL,OUTDAT,
     :                 OUTCOU,CONTIM,COEFFS,XGEOIM,YGEOIM,
     :                 SHFTUN,PFRACT,
     :                 LAM,SCALE,ROT,SHFTFR,ALIGN,KERNEL,
     :                 EXPKEY,FILSTR,INUN,OUTUN,
     :                 SECPAR,XSH2,YSH2,ROT2,XSCALE,YSCALE,SHFR2,
     :                 USEWCS,XSH,YSH,DNX,DNY,ONX,ONY)

C If we are not updating (ie, this is the first drizzle
C onto this output) then we modify the WCS
            IF((.NOT.UPDATE).AND.GOTWCS) THEN
               IF(USEWCS) THEN
                  CALL UWCS(IDCO,WCSOUT,CTYPE1,CTYPE2)
               ELSE
                  CALL UWCS(IDCO,WCS,CTYPE1,CTYPE2)
               ENDIF
            ENDIF
         ENDIF
      ENDIF

C Clear some more space
      CALL UDMFRE(PNCOU,6,ISTAT)
      PNCOU=0

C Now write out the appropriate part (or whole) context image
C No scaling needed here either
      IF(CON) THEN
       IF(.NOT.NOOVER) THEN
          CALL PUTIMI(IDCO,ONX,ONY,SUB,XMIN,XMAX,YMIN,YMAX,
     :             UPDATE,.TRUE.,1.0,MEMI(PIBUFF),MEMI(PNCON),ISTAT)
          IF(ISTAT.NE.0) THEN
            CALL UMSPUT('! Failed to write output weight image',
     :               1,0,ISTAT)
            GO TO 99
          ENDIF

C Now update the global context table in header
          IF(.NOT.BITCON) THEN
            CALL PTCOIN(IDCO,CONTAB,MAXHCN,INTAB,MAXIM,MAXEN,NEN,ISTAT)
            IF(ISTAT.NE.0) THEN
               CALL UMSPUT('! Failed to update context in header',
     :                    1,0,ISTAT)
               GO TO 99
            ENDIF
          ENDIF
       ENDIF
      ENDIF

C General error abort point
 99   CONTINUE

C Free up all allocated memory arrays
      CALL FREMEM(PDATA,PWEI,PNDAT,PNCOU,PNCON,PCDON,PBUFF,PIBUFF,
     : PXI,PYI,PXO,PYO,PXIB,PYIB,PXOB,PYOB)

C If the distortion images have been used free that too
      IF(PXG.NE.0) CALL UDMFRE(PXG,6,ISTAT)
      IF(PYG.NE.0) CALL UDMFRE(PYG,6,ISTAT)

C Close all the files which are still open
      IF(ODD) CALL UIMCLO(IDD,ISTAT)
      IF(ODW) CALL UIMCLO(IDW,ISTAT)
      IF(ODND) CALL UIMCLO(IDND,ISTAT)
      IF(ODNC) CALL UIMCLO(IDNC,ISTAT)
      IF(ODCO) CALL UIMCLO(IDCO,ISTAT)

C End of main DRIZZLE module
      END

      SUBROUTINE WBLOT
C++
C
C WBLOT.F Version 3.4   "Reverse drizzling" 
C
C It is based on ideas of Andy Fruchter and was coded by Richard Hook. 
C
C This task uses coefficients held in a text file to define
C geometrical distortions.
C
C This code uses the F77/VOS for IRAF i/o.
C It may be compiled and linked using a command like:
C
C xc -p stsdas (-z) blot.f drutil.f x_blot.x <dir>libiraf77.a <dir>libiminterp.a
C
C Note that the optional -z switch (which tells IRAF to create a static
C executable which doesn't use the IRAF sharable library) may be
C necessary to avoid a virtual memory use limitations. 
C
C History:
C
C Created first try (V0.1) from DRIZZLE.F V0.97, 9th July 1996
C Modified for new origin of coordinates etc (V0.2), 17th July 1996
C Modified to match up with DRIZZLE V1.05, 14th November 1996
C (rotfir parameter added, few bug fixes, change coordinate origin)
C Match up to Drizzle 1.08 - V0.4 of BLOT, 6th December 1996
C Correct shift units bug, V0.41, 16th December 1996
C Add ALIGN option, V0.42, 16th January 1997
C Use "drutil.f" utilities, no -z, 4th February 1997
C Prepared V0.5 for release, matches V1.097 of Drizzle, 17th March 1997
C
C First public release of Blot, 12th May 1997
C
C Added in_un/out_un switches for compatibility with V1.2 of Drizzle.
C This was for the first release of drizzle/blot in the dither package
C within STSDAS. 25th February 1998.
C
C Added automatic output image size selection, 27th February 1998
C
C Modified calling sequences to match the drutil.f with Drizzle 2.6,
C  December 2001
C
C V1.0 with full geometric support (via the routines in drutil.f)
C  December 2001.
C
C V1.1 with use of new DRIVAL call
C   Richard Hook, ST-ECF, 27th February 2002
C
C V1.3 with cleaner access to coefficients,
C   Richard Hook, ST-ECF, 11th March 2002
C
C V2.0: image subsetting to allow working with very large mosaics,
C       also wblot form for working with WCS. Also additional sinc
C       interpolation kernels.
C        Richard Hook, ST-ECF at STScI, December 2002
C
C V2.01: added test for zero exposure time input.
C        Richard Hook, ST-ECF at STScI, January 2003
C
C V3.0: compatibility with Drizzle 3.0, June 2003.
C
C V3.01: small modification to correctly get output dimensions
C        correctly in all cases,  ST-ECF at STScI, July 2003
C
C V3.1: updated for image distortion arrays.
C         Richard Hook, ST-ECF at STScI, August 2003
C
C V3.2: double precision version.
C         Richard Hook, ST-ECF at STScI, October 2003
C
C V3.32: added support for more kernels, through new interface
C        and scaling for kernel to support experiments.
C            Richard Hook, ST-ECF at STScI, January 2004
C
C V3.3.3 support for Spitzer style header polynomials.
C            Richard Hook, ST-ECF at STScI, March 2004
C
C V3.4:  modified to use common callable code.
C            Warren Hack, STScI, 25th June 2004
C        moved ballme and buhead to ioutil for use with wblot.
C            WJH, STScI, 7 Oct 2005
C
C
C--
      IMPLICIT NONE

C Iraf global storage (real in this program)
      REAL MEMR(1) !I
      DOUBLE PRECISION MEMD(1) !I
      COMMON /MEM/MEMR         !I
      EQUIVALENCE (MEMR,MEMD)  !I

C Local variables
      INTEGER ISTAT,I
      INTEGER NDIMS,DNX,DNY,ONX,ONY,DDIMS(7),ODIMS(7),DATTYP
      INTEGER IDD,IRD,IDND
      INTEGER PDATA,PNDAT,PBUFF
      INTEGER PXIN,PYIN,PXOUT,PYOUT
      INTEGER INTYPE,IC
      INTEGER XMIN,XMAX,YMIN,YMAX
      REAL EF,EXPIN,EXPOUT,EXPREF
      DOUBLE PRECISION LASTPF,LASTSC,LASTOX,LASTOY
      DOUBLE PRECISION WCSIN(8),WCSOUT(8),XREFP,YREFP
      CHARACTER*80 DATA,OUTDAT,REFIMA,CHARS
      CHARACTER*8 CTYPE1,CTYPE2
      CHARACTER*8 EXPKEY,INUN,OUTUN,LASTUN
      CHARACTER*80 EXPSTR
      CHARACTER*45 VERS
      CHARACTER*20 INTERP
      REAL KSCALE,SINSCL
      INTEGER COTY,COMAX,CONUM
      PARAMETER (COMAX=100)
      DOUBLE PRECISION XCO(COMAX),YCO(COMAX)
      REAL MISVAL

      INTEGER MAXPIX
      PARAMETER (MAXPIX=2E7)

C Geometrical parameters, the standard set
      DOUBLE PRECISION SCALE,ROT,XSH,YSH,LAM
      DOUBLE PRECISION XSH2,YSH2,ROT2,XSCALE,YSCALE,ALPHA,BETA
      DOUBLE PRECISION RACEN,DECCEN
      DOUBLE PRECISION ORIENT,OUTSCL
      CHARACTER*80 COEFFS,SHFTUN,XGEOIM,YGEOIM
      INTEGER PXG,PYG,XGDIM,YGDIM
      LOGICAL DISIM
      CHARACTER*8 SHFR2,SHFTFR,ALIGN,GEOMOD

C Constants
      DOUBLE PRECISION PI
      PARAMETER (PI=3.1415926536D0)

C Logical flags
      LOGICAL VERBOSE
      LOGICAL GOTWCS
      LOGICAL ROTFIR
      LOGICAL INCPS
      LOGICAL OUTCPS
      LOGICAL USEWCS
      LOGICAL ROTF2
      LOGICAL SECPAR
      LOGICAL SUB
      LOGICAL NOOVER

C-- Start of executable code

C First announce the version
      VERS='WBLOT Version 3.4 (25th June 2004)'

      CALL UMSPUT('+ '//VERS,1,0,ISTAT)

      VERBOSE=.TRUE.

C This line controls whether or not we can have WCS defined geometry
C This line needs to be changed to convert WBLOT to BLOT
CCC      GEOMOD='user'
      GEOMOD=' '

C Get the geomode
      IF(GEOMOD.EQ.' ') CALL UCLGST('geomode',GEOMOD,ISTAT)

C Get all the geometrical parameters
      CALL GTGEPA(GEOMOD,COEFFS,LAM,XGEOIM,YGEOIM,
     :             SCALE,ROT,XSH,YSH,SHFTFR,SHFTUN,ALIGN,
     :             XSCALE,YSCALE,XSH2,YSH2,ROT2,SHFR2,
     :             OUTSCL,RACEN,DECCEN,XREFP,YREFP,ORIENT)

C Get the output dimensions, although these may be overwritten
C by a reference image size if present (3.01 modification)
      CALL UCLGSI('outnx',ONX,ISTAT)
      CALL UCLGSI('outny',ONY,ISTAT)

C Find out whether we are using WCS to define the geometry
      IF(GEOMOD.EQ.'wcs') THEN
         USEWCS=.TRUE.
      ELSE
         USEWCS=.FALSE.
      ENDIF

C Get the exposure related parameters
      CALL UCLGST('expkey',EXPKEY,ISTAT)
      CALL UCLGST('expout',EXPSTR,ISTAT)

C Convert the parameters supplied to the output WCS if needed
C If using WCS...
      IF(USEWCS .OR. COEFFS.EQ.'wcs') THEN

C If we have a reference image we need to try to get its WCS for
C use as the output
         CALL UCLGST('refimage',REFIMA,ISTAT)
         IF(REFIMA.NE.' ') THEN
            CALL UIMOPN(REFIMA,1,IRD,ISTAT)
            IF(ISTAT.NE.0) THEN
               CALL UMSPUT('! Unable to open reference image',
     :                     1,0,ISTAT)
               GO TO 99
            ELSE
               CALL UMSPUT('-Reading WCS from '//REFIMA,1,0,ISTAT)
            ENDIF

            CALL GETWCS(IRD,WCSOUT,CTYPE1,CTYPE2,ISTAT)
            IF(ISTAT.NE.0) THEN
               CALL UMSPUT(
     : '! Unable to get WCS from reference image',
     :                     1,0,ISTAT)
               GO TO 99
            ENDIF

C Get the dimensions and use them
            CALL UIMGID(IRD,DATTYP,NDIMS,DDIMS,ISTAT)
            IF(NDIMS.NE.2) THEN
               CALL UMSPUT(
     :   '! Reference image is not two dimensional',
     :                          1,0,ISTAT)
               GO TO 99
            ELSE
               ONX=DDIMS(1)
               ONY=DDIMS(2)
               WRITE(CHARS,
     :  '(''-Blotted image will be '',I6,'' by '',I6)') ONX,ONY
               CALL UMSPUT(CHARS,1,0,ISTAT)
            ENDIF

C Get the reference image exposure time
            CALL UHDGSR(IRD,EXPKEY,EXPREF,ISTAT)
            IF(ISTAT.NE.0) EXPREF=0.0

C Close the image
            CALL UIMCLO(IRD,ISTAT)
         ELSE

C Now convert these into WCS style representation
            CALL SETWCS(OUTSCL,ORIENT,XREFP,RACEN,
     :               YREFP,DECCEN,WCSOUT)
         ENDIF
      ENDIF

C Get reference frame for shifts - specifying whether shifts are done before
C or after rotation
      IF(SHFTFR.EQ.'output') THEN
         ROTFIR=.FALSE.
      ELSE
         ROTFIR=.TRUE.
      ENDIF

C Convert the secondary parameters into suitable units
      ROT2=ROT2*PI/180.0D0
      IF(SHFR2.EQ.'input') THEN
         ROTF2=.FALSE.
      ELSE
         ROTF2=.TRUE.
      ENDIF

C Give a warning message if secondary parameters will have an effect
      IF(XSCALE.NE.1.0D0 .OR. YSCALE.NE.1.0D0 .OR.
     :   XSH2.NE.0.0D0 .OR. YSH2.NE.0.0D0 .OR. ROT2.NE.0.0D0) THEN
       CALL UMSPUT(
     : '! Warning, secondary geometric transform is being used',
     :               1,0,ISTAT)
        SECPAR=.TRUE.
      ELSE
        SECPAR=.FALSE.
      ENDIF

C Get the switch value for whether to read in CPS or
C counts (latter is the default)
      CALL UCLGST('in_un',INUN,ISTAT)
      IF(INUN.EQ.'cps') THEN
         INCPS=.TRUE.
      ELSE
         INCPS=.FALSE.
      ENDIF

C Get the switch value for whether to write out in CPS or
C counts (latter is the default)
      CALL UCLGST('out_un',OUTUN,ISTAT)
      IF(OUTUN.EQ.'cps') THEN
         OUTCPS=.TRUE.
      ELSE
         OUTCPS=.FALSE.
      ENDIF

C Check for invalid scale
      IF(SCALE.EQ.0.0D0) THEN
         CALL UMSPUT('! Invalid scale',1,0,ISTAT)
         GO TO 99
      ENDIF

C Convert the rot to radians
      ROT=ROT*PI/180.0D0

      IF(SHFTUN.EQ.'input') THEN
         XSH=XSH*SCALE
         YSH=YSH*SCALE
      ENDIF

C Note that the shifts are in INPUT pixel units

C Get the missing value flag
      CALL UCLGSR('fillval',MISVAL,ISTAT)

C Get the name of the input data image
      CALL UCLGST('data',DATA,ISTAT)

C Try to access the input data image
      CALL UIMOPN(DATA,1,IDD,ISTAT)
      IF(ISTAT.NE.0) THEN
         CALL UMSPUT('! Unable to open data image',
     :                    1,0,ISTAT)
         GO TO 99
      ELSE
         IF(VERBOSE) CALL UMSPUT(
     :  '-Opening input data image: '//DATA,
     :                   1,0,ISTAT)
      ENDIF

C Get the array size and shape
      CALL UIMGID(IDD,DATTYP,NDIMS,DDIMS,ISTAT)
      IF(NDIMS.NE.2) THEN
         CALL UMSPUT('! Input image is not two dimensional',
     :                    1,0,ISTAT)
         GO TO 99
      ELSE
         DNX=DDIMS(1)
         DNY=DDIMS(2)
      ENDIF

C We now get some of the previous drizzle information from
C the header of the current image and check for funny
C combinations
      CALL GOLDH(IDD,USEWCS,IC,LASTPF,LASTSC,
     :           LASTUN,LASTOX,LASTOY,ISTAT)

C Check for incompatibilities
      IF(INCPS) THEN
         IF(LASTUN.EQ.'counts' .OR.
     :                LASTUN.EQ.'COUNTS') THEN
          CALL UMSPUT('! Warning input image header gives units',
     :               1,0,ISTAT)
          CALL UMSPUT('! as counts NOT cps! Assuming cps',
     :               1,0,ISTAT)
         ENDIF
      ELSE
         IF(LASTUN.EQ.'cps' .OR.
     :                LASTUN.EQ.'CPS') THEN
          CALL UMSPUT('! Warning input image header gives units',
     :               1,0,ISTAT)
          CALL UMSPUT('! as cps NOT counts! Assuming counts',
     :               1,0,ISTAT)
         ENDIF
      ENDIF

C Get the geometric distortion coefficient information
C If we have a reference image we use that
      IF(COEFFS.EQ.'wcs') THEN
         CALL GETGEO(COEFFS,IRD,LAM,
     :            COTY,COMAX,CONUM,XCO,YCO,ISTAT)
      ELSE
         CALL GETGEO(COEFFS,IDD,LAM,
     :            COTY,COMAX,CONUM,XCO,YCO,ISTAT)
      ENDIF

      IF(ISTAT.NE.0) THEN
         CALL UMSPUT(
     :  '! Error, failed to get geometric distortion coefficients',
     :  1,0,ISTAT)
          GO TO 99
      ENDIF

C  Read in any distortion image corrections, if specified
C  PXG,PYG will default to 2x2 arrays when DISIM returns as FALSE.
C 
      CALL GGEOIM(XGEOIM,YGEOIM,PXG,PYG,XGDIM,YGDIM,DISIM)
        
C We get the name of the output image here
      CALL UCLGST('outdata',OUTDAT,ISTAT)

C Check that a name is specified
      IF(OUTDAT.EQ.' ') THEN
         CALL UMSPUT(
     :       '! No output data array name specified',
     :                   1,0,ISTAT)
           GO TO 99
      ENDIF

C Set the output dimensions, these may be the values from
C the CL or from the reference image
      ODIMS(1)=ONX
      ODIMS(2)=ONY

      IDND=0

C Create the output image
      CALL UIMCRE(OUTDAT,6,2,ODIMS,IDND,ISTAT)

C This call sometimes returns a good status when it should not
C - hence the second test
      IF(ISTAT.NE.0 .OR. IDND.EQ.0) THEN
         CALL UMSPUT(
     :     '! Unable to create output data image',
     :                 1,0,ISTAT)
         GO TO 99
      ELSE
         CALL UMSPUT(
     :     '-Created new output data image: '//OUTDAT,
     :              1,0,ISTAT)
      ENDIF

C Copy the header to the output, this also transfers the exposure 
C time information
      CALL UHDCPY(IDD,IDND,ISTAT)

C Also try to get the header items for the WCS, note that
C this is not the full WCS but just 8 header items commonly used
C for HST images plus CTYPE1 & CTYPE2 
      CALL GETWCS(IDD,WCSIN,CTYPE1,CTYPE2,ISTAT)
      IF(ISTAT.EQ.0) THEN
         GOTWCS=.TRUE.
      ELSE
         CALL UMSPUT(
     :    '! Warning, unable to read WCS information from header',
     :    1,0,ISTAT)
      ENDIF

C Here we set the WCS matrix to something sensible anyway
      IF(.NOT.GOTWCS) THEN
         CTYPE1='PIXELS'
         CTYPE2='PIXELS'

         DO I=1,8
            WCSIN(I)=0.0D0
         ENDDO

         WCSIN(5)=-1.0D0
         WCSIN(8)=1.0D0
      ENDIF

C Calculate the range of pixels in the input which are accessed
C when blotting 
      CALL LCORN(ONX,ONY,DNX,DNY,
     :           XSH,YSH,ROT,SCALE,ALIGN,ROTFIR,
     :           SECPAR,XSH2,YSH2,ROT2,XSCALE,YSCALE,SHFR2,ROTF2,
     :           USEWCS,WCSOUT,WCSIN,
     :           COTY,CONUM,XCO,YCO,
     :           DISIM,MEMR(PXG),MEMR(PYG),XGDIM,YGDIM,
     :           XMIN,XMAX,YMIN,YMAX,ISTAT,ALPHA,BETA)

C Assume we are using the whole frame unless set otherwise
      SUB=.FALSE.
      NOOVER=.FALSE.

C Check for no-overlap
      IF(XMAX.LT.1 .OR. YMAX.LT.1 .OR.
     :      XMIN.GT.DNX .OR. YMIN.GT.DNY) THEN
         CALL UMSPUT(
     : '! Warning, there is no overlap of the input image',
     :  1,0,ISTAT)
            WRITE(CHARS,
     : '(''! Input pixel range would be: ['',I7,'':'',I7,
     :      '','',I7,'':'',I7,'']'')') XMIN,XMAX,YMIN,YMAX
         CALL UMSPUT(CHARS,1,0,ISTAT)

         NOOVER=.TRUE.
         XMIN=1
         XMAX=1
         YMIN=1
         YMAX=1
         SUB=.TRUE.
      ELSE
         XMIN=MAX(1,XMIN)
         XMAX=MIN(DNX,XMAX)
         YMIN=MAX(1,YMIN)
         YMAX=MIN(DNY,YMAX)

C Check to see whether we really should use the subset or
C whether it makes more sense to work on the full frame.
C These criteria are a little arbitrary at this stage
         IF(DBLE(YMAX-YMIN+1)/DBLE(DNY).GT.0.5D0 .AND.
     :      DNX*DNY.LT.MAXPIX .OR.
     :      (XMIN.EQ.1 .AND. XMAX.EQ.DNX .AND.
     :      YMIN.EQ.1 .AND. YMAX.EQ.DNY)) THEN

            SUB=.FALSE.
            WRITE(CHARS,'(''-Blotting from full input image.'')')

            XMIN=1
            YMIN=1
            XMAX=DNX
            YMAX=DNY
            SUB=.FALSE.
         ELSE
            WRITE(CHARS,
     : '(''-Blotting from subset: ['',I5,'':'',I5,
     :      '','',I5,'':'',I5,''] ('',F6.2,''%).'')')
     :       XMIN,XMAX,YMIN,YMAX,
     :       100.0*DBLE((XMAX-XMIN+1)*(YMAX-YMIN+1))/
     :       DBLE(DNX*DNY)
            SUB=.TRUE.
         ENDIF

         CALL UMSPUT(CHARS,1,0,ISTAT)
      ENDIF

C Now we have the subarray sorted out we can allocate memory
C arrays and read in the data
      CALL BALLME(DNX,DNY,ONX,ONY,XMAX-XMIN+1,YMAX-YMIN+1,
     :        PBUFF,PDATA,PNDAT,PXIN,PYIN,PXOUT,PYOUT,ISTAT)

C Read in the data array subset
      CALL GETIMR(IDD,DNX,DNY,SUB,XMIN,XMAX,YMIN,YMAX,
     :                  MEMR(PBUFF),MEMR(PDATA),ISTAT)
      IF(ISTAT.NE.0) THEN
         CALL UMSPUT(
     :      '! Failed to read input data image',
     :                   1,0,ISTAT)
         GO TO 99
      ENDIF

C Get the exposure time from the header, if possible
      CALL UHDGSR(IDD,EXPKEY,EXPIN,ISTAT)
      IF(ISTAT.NE.0) THEN
         CALL UMSPUT(
     : '! Warning, failed to get exposure time keyword value',
     :      1,0,ISTAT)
            GO TO 99
      ENDIF

C Check for zero exposure time (yes, it does happen)
      IF(EXPIN.LE.0.0) THEN
         CALL UMSPUT(
     : '! Warning, exposure time <= 0 - setting to 1.0',1,0,ISTAT)
         EXPIN=1.0
      ENDIF

C Check for the "input" value for the output exposure,
C this is the standard behaviour
      IF(EXPSTR.EQ.'INPUT' .OR. EXPSTR.EQ.'input') THEN
         EXPOUT=EXPIN
      ELSE IF(
     :   EXPSTR.EQ.'REFERENCE' .OR. EXPSTR.EQ.'reference') THEN
         IF(EXPREF.EQ.0.0) THEN
            CALL UMSPUT(
     : '! Error - no reference image exposure time found',1,0,ISTAT)
            GO TO 99
         ELSE
            CALL UMSPUT(
     :  '-Using exposure time of reference image for output',
     :                  1,0,ISTAT)
            EXPOUT=EXPREF
         ENDIF
      ELSE
         READ(EXPSTR,*,IOSTAT=ISTAT) EXPOUT
         IF(ISTAT.NE.0) THEN
            CALL UMSPUT('! Invalid output exposure value',
     :                  1,0,ISTAT)
            GO TO 99
         ENDIF
      ENDIF

C Now we re-scale depends on the units, there are four cases
      IF(INCPS) THEN
         IF(OUTCPS) THEN
            EF=1.0
         ELSE
            EF=EXPOUT
         ENDIF
      ELSE
         IF(OUTCPS) THEN
            EF=1.0/EXPIN
         ELSE
            EF=EXPOUT/EXPIN
         ENDIF
      ENDIF

      CALL UHDPSR(IDND,EXPKEY,EXPOUT,ISTAT)
      WRITE(CHARS,
     :    '(''-Input exposure: '',F10.3,'' Output exposure: '''//
     :    'F10.3)') EXPIN,EXPOUT
      CALL UMSPUT(CHARS,1,0,ISTAT)

C Close the data array now we have it
      CALL UIMCLO(IDD,ISTAT)
 
C The final case is where the output is empty.
C Before we start blotting we need to drain out the output arrays
C if there are no old arrays 
      CALL SETIM(MEMR(PNDAT),ONX,ONY,0.0)

C Before we start also get the interpolation type and convert
C to a numerical code
      CALL UCLGST('interpol',INTERP,ISTAT)
      IF(INTERP.EQ.'nearest') THEN
         INTYPE=1
      ELSE IF(INTERP.EQ.'linear') THEN
         INTYPE=2
      ELSE IF(INTERP.EQ.'poly3') THEN
         INTYPE=3
      ELSE IF(INTERP.EQ.'poly5') THEN
         INTYPE=4
      ELSE IF(INTERP.EQ.'spline3') THEN
         INTYPE=5
      ELSE IF(INTERP.EQ.'sinc') THEN
         INTYPE=6
      ELSE IF(INTERP.EQ.'lsinc') THEN
         INTYPE=7
      ELSE IF(INTERP.EQ.'drizzle') THEN
         INTYPE=8
      ELSE IF(INTERP(1:4).EQ.'lan3') THEN
         INTYPE=100
      ELSE IF(INTERP(1:4).EQ.'lan5') THEN
         INTYPE=105
      ELSE
         CALL UMSPUT('! Invalid interpolant specified',
     :               1,0,ISTAT)
         GO TO 99
      ENDIF 

C Try to read a kernel scaling factor
      IF(INTYPE.GE.100) THEN
         READ(INTERP(5:),*,IOSTAT=ISTAT) KSCALE
         IF(ISTAT.NE.0) THEN
            KSCALE=1.0
         ELSE
            WRITE(CHARS,'(''-Using kernel scale of: '',F10.4)')
     :            KSCALE
            CALL UMSPUT(CHARS,1,0,ISTAT)
         ENDIF
      ENDIF  

C Get the sinc stretch
      CALL UCLGSR('sinscl',SINSCL,ISTAT)

C Now do the actual combination using interpolation
      CALL DOBLOT(MEMR(PDATA),MEMR(PNDAT),INTYPE,SINSCL,KSCALE,MISVAL,
     :      XMIN,XMAX,YMIN,YMAX,DNX,DNY,
     :      ROTFIR,EF,ALIGN,ONX,ONY,COTY,CONUM,XCO,YCO,
     :      DISIM,MEMR(PXG),MEMR(PYG),XGDIM,YGDIM,
     :      MEMD(PXIN),MEMD(PYIN),MEMD(PXOUT),MEMD(PYOUT),
     :      SCALE,ROT,XSH,YSH,USEWCS,WCSIN,WCSOUT,
     :      GEOMOD,SECPAR,XSH2,YSH2,ROT2,XSCALE,YSCALE,SHFR2,ROTF2,
     :      ALPHA,BETA)

C Write out the new image
      IF(VERBOSE)
     :   CALL UMSPUT('-Writing output blotted image: '//
     :               OUTDAT,1,0,ISTAT)
         
      CALL UIPS2R(IDND,1,ONX,1,ONY,MEMR(PNDAT),ISTAT)

C Update the header
      CALL BUHEAD(IDND,VERS,DATA,OUTDAT,COEFFS,XGEOIM,YGEOIM,
     :     SHFTUN,MISVAL,
     :     EXPKEY,EXPSTR,ALIGN,INUN,OUTUN,
     :     SHFTFR,INTERP,LAM,SCALE,ROT,XSH,YSH,
     :     SECPAR,XSH2,YSH2,ROT2,XSCALE,YSCALE,SHFR2,ONX,ONY)

      IF(GOTWCS) THEN
         CALL UWCS(IDND,WCSOUT,CTYPE1,CTYPE2)
      ENDIF

      CALL UIMCLO(IDND,ISTAT)
      CALL UDMFRE(PNDAT,6,ISTAT)

C Close down everything and exit
      CALL UDMFRE(PDATA,6,ISTAT)

C If the distortion images have been used free that too
      IF(PXG.NE.0) CALL UDMFRE(PXG,6,ISTAT)
      IF(PYG.NE.0) CALL UDMFRE(PYG,6,ISTAT)

 99   CONTINUE
      END

      SUBROUTINE WTRANK 
C++
C
C WTRANBACK.F V2.22 Convert X,Y positions in drizzle output frames
C                 back to input positions in the initial frames
C
C This is a version of tranback which also supports WCS control.
C
C This task uses coefficients held in a text file to define
C geometrical distortions.
C
C This code uses the F77/VOS for IRAF i/o.
C It may be compiled and linked using a command like:
C
C xc -p stsdas wtranback.f drutil.f x_wtranback.x <dir>libiraf77.a
C
C Where <dir> is the location of the STSDAS f77/vos library.
C
C History:
C
C First quick version (V0.1), 7th May 1999 (Richard Hook, STScI)
C Bug fixes and tests for release of V0.2 in the IRAF stecf package
C 17th December 1999, Richard Hook
C
C Bugfix for different calling sequences, Richard Hook, November 2001
C
C V1.0, December 2001, using the full geometrical options and a general
C       simple inversion scheme based on successively improving guesses.
C
C V1.1, January 2002, bug fix for shft_un=output case and change
C       accuracy back to 3 decimal places.
C
C V1.3, March 2002, use packaged coefficient file access
C
C V1.4, August 2003, added distortion image support
C
C V1.4 of WTRANBACK created from TRANBACK. October 2003.
C
C V1.8, double precision version, brought number into line with WTRAXY.
C         Richard Hook, ST-ECF @ STScI, October 2003
C
C V1.9, included refpix options in coefficients files.
C         Richard Hook, ST-ECF @ STScI, 5th December 2003
C
C V2.2, added xylist support.
C         Richard Hook, ST-ECF @ STScI, 29th March 2004.
C
C V2.3, added ALPHA, BETA to DRIVAL call
C         Chris Hanley, STScI, 9 Sept. 2007
C--
      IMPLICIT NONE

C Local variables
      INTEGER ISTAT,NXIN,NYIN,NXOUT,NYOUT
      INTEGER COTY,CONUM,COMAX,I
      PARAMETER (COMAX=100)

      INTEGER IID,IRD,DATTYP,NDIMS,DDIMS(7)
      CHARACTER*80 INIM,OUTIM
      CHARACTER*8 CTYPE1,CTYPE2
      DOUBLE PRECISION XCO(COMAX),YCO(COMAX)
      DOUBLE PRECISION XIN,YIN,XOUT,YOUT,X(3),Y(3),XO(3),YO(3)
      DOUBLE PRECISION ERR
      DOUBLE PRECISION DX1,DY1,DX2,DY2
      DOUBLE PRECISION DELX,DELY,XOLD,YOLD,EV
      CHARACTER*132 CHARS
      CHARACTER*45 VERS

C Geometrical parameters, the standard set
      DOUBLE PRECISION SCALE,ROT,XSH,YSH,LAM
      DOUBLE PRECISION XSH2,YSH2,ROT2,XSCALE,YSCALE,ALPHA,BETA
      DOUBLE PRECISION RACEN,DECCEN,XREFP,YREFP,WCSIN(8),WCSOUT(8)
      DOUBLE PRECISION ORIENT,OUTSCL
      CHARACTER*80 COEFFS,SHFTUN,XGEOIM,YGEOIM,XYLIST,LINE
      CHARACTER*8 SHFR2,SHFTFR,ALIGN,GEOMOD
      INTEGER PXG,PYG,LUN,XGDIM,YGDIM
      LOGICAL DISIM

      REAL MEMR(1)
      COMMON /MEM/MEMR

      DOUBLE PRECISION PI
      PARAMETER (PI=3.141592653589793D0)

      LOGICAL VERBOSE
      LOGICAL ROTFIR
      LOGICAL USEWCS
      LOGICAL ROTF2
      LOGICAL SECPAR

C-- Start of executable code
      VERS='WTRANBACK Version 2.22 (25th February 2005)'

C First announce the version
      CALL UMSPUT('+ '//VERS,1,0,ISTAT)

C Acceptable position error for iterative search
      ERR=0.000001
      VERBOSE=.TRUE.

C This version will accept WCS, so
      CALL UCLGST('geomode',GEOMOD,ISTAT)

C Get all the geometrical parameters
      CALL GTGEPA(GEOMOD,COEFFS,LAM,XGEOIM,YGEOIM,
     :             SCALE,ROT,XSH,YSH,SHFTFR,SHFTUN,ALIGN,
     :             XSCALE,YSCALE,XSH2,YSH2,ROT2,SHFR2,
     :             OUTSCL,RACEN,DECCEN,XREFP,YREFP,ORIENT)

C If so, check for image names (output is optional)
      CALL UCLGST('inimage',INIM,ISTAT)
      CALL UCLGST('refim',OUTIM,ISTAT)

      IF(GEOMOD.EQ.'wcs') THEN
         USEWCS=.TRUE.
      ELSE
         USEWCS=.FALSE.
      ENDIF

C Open the files and read the WCS from the headers
      IF(USEWCS .OR. COEFFS.EQ.'wcs') THEN
         IF(INIM.EQ.' ') THEN
            CALL UMSPUT('! No input image specified',
     :                  1,0,ISTAT)
            GO TO 99
         ELSE
            CALL UIMOPN(INIM,1,IID,ISTAT)
            IF(ISTAT.NE.0) THEN
               CALL UMSPUT('! Unable to open input image',
     :                     1,0,ISTAT)
               GO TO 99
            ELSE
               CALL UMSPUT('-Reading WCS from '//INIM,1,0,ISTAT)
            ENDIF

            CALL GETWCS(IID,WCSIN,CTYPE1,CTYPE2,ISTAT)
            IF(ISTAT.NE.0) THEN
               CALL UMSPUT(
     : '! Unable to get WCS from reference image',
     :                     1,0,ISTAT)
               GO TO 99
            ENDIF

C Get the dimensions and use them
            CALL UIMGID(IID,DATTYP,NDIMS,DDIMS,ISTAT)
            IF(NDIMS.NE.2) THEN
               CALL UMSPUT(
     :   '! Input image is not two dimensional',
     :                          1,0,ISTAT)
               GO TO 99
            ELSE
               NXIN=DDIMS(1)
               NYIN=DDIMS(2)
            ENDIF
         ENDIF
      ENDIF

      IF(USEWCS) THEN

C If we have a reference image we need to try to get its WCS for
C use as the output
         IF(OUTIM.NE.' ') THEN
            CALL UIMOPN(OUTIM,1,IRD,ISTAT)
            IF(ISTAT.NE.0) THEN
               CALL UMSPUT('! Unable to open output image',
     :                     1,0,ISTAT)
               GO TO 99
            ELSE
               CALL UMSPUT('-Reading WCS from '//OUTIM,1,0,ISTAT)
            ENDIF

            CALL GETWCS(IRD,WCSOUT,CTYPE1,CTYPE2,ISTAT)
            IF(ISTAT.NE.0) THEN
               CALL UMSPUT(
     : '! Unable to get WCS from reference image',
     :                     1,0,ISTAT)
               GO TO 99
            ENDIF

C Get the dimensions and use them
            CALL UIMGID(IRD,DATTYP,NDIMS,DDIMS,ISTAT)
            IF(NDIMS.NE.2) THEN
               CALL UMSPUT(
     :   '! Reference image is not two dimensional',
     :                          1,0,ISTAT)
               GO TO 99
            ELSE
               NXOUT=DDIMS(1)
               NYOUT=DDIMS(2)
            ENDIF
         ELSE

C If there is no output image then we read the output WCS from the
C user supplied values and convert to a WCS representation
            CALL SETWCS(OUTSCL,ORIENT,XREFP,RACEN,
     :                  YREFP,DECCEN,WCSOUT)
            CALL UMSPUT(
     : '-Defining output WCS from user-specified parameters',
     :      1,0,ISTAT)

         ENDIF
      ENDIF

C Convert the secondary parameters into suitable units
      ROT2=ROT2*PI/180.0D0

      IF(SHFR2.eq.'input') THEN
         ROTF2=.FALSE.
      ELSE
         ROTF2=.TRUE.
      ENDIF

C Give a warning message if secondary parameters will have an effect
      IF(XSCALE.NE.1.0D0 .OR. YSCALE.NE.1.0D0 .OR.
     :   XSH2.NE.0.0D0 .OR. YSH2.NE.0.0D0 .OR. ROT2.NE.0.0D0) THEN
       CALL UMSPUT(
     : '! Warning, secondary geometric transform is being used',
     :               1,0,ISTAT)
        SECPAR=.TRUE.
      ELSE
        SECPAR=.FALSE.
      ENDIF

      IF(SHFTFR.EQ.'input') THEN
         ROTFIR=.FALSE.
      ELSE
         ROTFIR=.TRUE.
      ENDIF

      IF(SHFTUN.EQ.'output') THEN
         XSH=XSH*SCALE
         YSH=YSH*SCALE
      ENDIF

C Get the geometric distortion coefficient information
C Note that if no input image is available coeff="header" 
C or coeffs='wcs' will fail
      CALL GETGEO(COEFFS,IRD,LAM,
     :            COTY,COMAX,CONUM,XCO,YCO,ISTAT)
      IF(ISTAT.NE.0) THEN
         CALL UMSPUT(
     :  '! Error, failed to get geometric distortion coefficients',
     :  1,0,ISTAT)
          GO TO 99
      ENDIF

C  Read in any distortion image corrections, if specified
C  PXG,PYG will default to 2x2 arrays when DISIM returns as FALSE.
C 
      CALL GGEOIM(XGEOIM,YGEOIM,PXG,PYG,XGDIM,YGDIM,DISIM)

C Get the X,Y pixel position to be transformed
      CALL UCLGSD('xout',XOUT,ISTAT)
      CALL UCLGSD('yout',YOUT,ISTAT)

C Also get the chip size - in and out
      IF(.NOT.USEWCS .AND. OUTIM.EQ.' ') THEN
         CALL UCLGSI('nxout',NXOUT,ISTAT)
         CALL UCLGSI('nyout',NYOUT,ISTAT)
      ENDIF

      IF(.NOT.USEWCS) THEN
         CALL UCLGSI('nxin',NXIN,ISTAT)
         CALL UCLGSI('nyin',NYIN,ISTAT)
      ENDIF

C Convert to radians
      ROT=ROT*PI/180.0D0

C Either we have a list of X,Y positions or a single one
      CALL UCLGST('xylist',XYLIST,ISTAT)
      IF(XYLIST.NE.' ') THEN
         CALL UFOPEN(XYLIST,1,LUN,ISTAT)
         IF(ISTAT.NE.0) THEN
            CALL UMSPUT('! Unable to open xylist file',1,0,
     :                  ISTAT)
            ISTAT=1
            RETURN
         ELSE
            CALL UMSPUT('-Opening xylist file: '//XYLIST,
     :                      1,0,ISTAT)
         ENDIF
      ENDIF

C Get the X,Y pixel position to be transformed
      IF(XYLIST.EQ.' ') THEN
         CALL UCLGSD('xout',XIN,ISTAT)
         CALL UCLGSD('yout',YIN,ISTAT)
      ENDIF

C Loop around (only once if there is just a position, not a list)
      DO WHILE(.TRUE.)

         IF(XYLIST.NE.' ') THEN
            CALL UFGLIN(LUN,LINE,ISTAT)
            IF(ISTAT.NE.0) GO TO 89
            READ(LINE,*) XOUT,YOUT
         ENDIF

C We now need to find the position we want by iterative
C improvement of an initial guess - the centre of the chip
C
C The method is to derive an "effective CD matrix" and use that
C to apply a correction until we are close enough (as defined by
C the ERR variable)

C First guess - centre
         X(1)=DBLE(NXIN/2)
         Y(1)=DBLE(NYIN/2)

C Loop around until we are close enough
         DO I=1,20       

            X(2)=X(1)+1.0D0
            Y(2)=Y(1)
            X(3)=X(1)
            Y(3)=Y(1)+1.0D0

C Transform the position
C Note that this is exactly the same as that in Drizzle
C First check that the point is within the bounds
            IF(NINT(X(1)).GT.1 .AND. NINT(X(1)).LT.NXIN-1 .AND.
     :         NINT(Y(1)).GT.1 .AND. NINT(Y(1)).LT.NYIN-1) THEN

              CALL DRIVAL(X,Y,3,NXIN,NYIN,NXOUT,NYOUT,.FALSE.,
     :         XSH,YSH,ROT,SCALE,ALIGN,ROTFIR,
     :         SECPAR,XSH2,YSH2,ROT2,XSCALE,YSCALE,SHFR2,ROTF2,
     :         USEWCS,WCSIN,WCSOUT,
     :         COTY,CONUM,XCO,YCO,DISIM,MEMR(PXG),MEMR(PYG),
     :         XGDIM,YGDIM,XO,YO,ALPHA,BETA)

            ELSE
              CALL DRIVAL(X,Y,3,NXIN,NYIN,NXOUT,NYOUT,.FALSE.,
     :         XSH,YSH,ROT,SCALE,ALIGN,ROTFIR,
     :         SECPAR,XSH2,YSH2,ROT2,XSCALE,YSCALE,SHFR2,ROTF2,
     :         USEWCS,WCSIN,WCSOUT,
     :         COTY,CONUM,XCO,YCO,.FALSE.,MEMR(PXG),MEMR(PYG),
     :         XGDIM,YGDIM,XO,YO,ALPHA,BETA)
            ENDIF

            DX1=XO(2)-XO(1)
            DY1=YO(2)-YO(1)
            DX2=XO(3)-XO(1)
            DY2=YO(3)-YO(1)

C Invert the matrix
            CALL INMAT(DX1,DX2,DY1,DY2)

C The error in out position
            DELX=XOUT-XO(1)
            DELY=YOUT-YO(1)

C Record the old position
            XOLD=X(1)
            YOLD=Y(1)

C Update the position
            X(1)=XOLD+DELX*DX1+DELY*DX2
            Y(1)=YOLD+DELX*DY1+DELY*DY2

C Work out the error vector length
            EV=SQRT((X(1)-XOLD)**2+(Y(1)-YOLD)**2)
            IF(EV.LT.ERR) GO TO 88
         ENDDO
      
 88      CONTINUE

         XIN=X(1)
         YIN=Y(1)

C Write out the result
         WRITE(CHARS,
     :  '('' Xin,Yin: '',2F12.5,'' Xout,Yout: '',2F12.5)')
     : XIN,YIN,XOUT,YOUT
         CALL UMSPUT(CHARS,1,0,ISTAT)

         IF(XYLIST.EQ.' ') GO TO 89
      ENDDO

 89   CONTINUE

C Also write the result to the CL
      IF(XYLIST.EQ.' ') THEN
         CALL UCLPSD('xin',XIN,ISTAT)
         CALL UCLPSD('yin',YIN,ISTAT)
      ELSE
         CALL UFCLOS(LUN,ISTAT)
      ENDIF

C End of main TRANBACK module
 99   CONTINUE

C If allocated, free the distortion image memory
      IF(PXG.NE.0) CALL UDMFRE(PXG,6,ISTAT)
      IF(PYG.NE.0) CALL UDMFRE(PYG,6,ISTAT)

      RETURN
      END

      real function nrievl (x, y, datain, nxpix, nypix, lendan, intere,
     *  scale)

C NRIEVAL -- Procedure to evaluate the 2D interpolant at a given value
C of x and y. NRIEVAL allows the interpolation of a few interpolated
C points without the computing time and storage required for the
C sequential version. The routine assumes that 1 <= x <= nxpix and
C 1 <= y <= nypix.
C
C This is a modified version to allow for a stretch factor (the scale
C parameter) in the SINC case.
C
C Modifications: Richard Hook, ST-ECF@STScI, December 2003
C
C This version supports most options, with the exception of SPLINE3. 
C
C Richard Hook modified it, September 2002
C Warren Hack, June 2004
C
      IMPLICIT NONE

      integer nxpix, nypix
      integer lendan
      integer intere
      real scale
      real x, y
      real datain(lendan,*)
      integer nx, ny
      real hold21, hold12, hold22
      real sx, sy, tx, ty
      real xval, yval
      real value
      real coeff(16 +3,16 +3)
      integer nterms
      integer rowleh
      integer xindex, yindex, firstw, lastrw
      integer i, j
C  Used for SPLINE3 option
C      integer kx, ky
C      real tmp(19*19)
C  Used for SINC option
      real taper(15), ac(15), ar(15)
      integer nconv
      
      nconv = 15

C Define common terms
         nx = int(x)
         ny = int(y)
   

C Nearest neighbour
      nrievl = 0.
      IF(INTERE.EQ.1) THEN
         nrievl = (datain(int (x+0.5), int (y+0.5)))

C Bilinear
      ELSE IF(INTERE.EQ.2) THEN
         sx = x - nx
         tx = 1. - sx
         sy = y - ny
         ty = 1. - sy
         if (nx .ge. nxpix) THEN      
            hold21 = 2. * datain(nx,ny) - datain(nx-1,ny)
         ELSE     
            hold21 = datain(nx+1,ny)
         ENDIF    

         if (ny .ge. nypix) THEN     
            hold12 = 2. * datain(nx,ny) - datain(nx,ny-1)
         ELSE    
            hold12 = datain(nx,ny+1)
         ENDIF    

         if (nx .ge. nxpix .and. ny .ge. nypix) THEN
            hold22 = 2. * hold21 - (2. * datain(nx,ny-1) - 
     *         datain(nx-1,ny-1))
         ELSE IF (nx .ge. nxpix) THEN
            hold22 = 2. * hold12 - datain(nx-1,ny+1)
         ELSE IF (ny .ge. nypix) THEN     
               hold22 = 2. * hold21 - datain(nx+1,ny-1)
         ELSE     
               hold22 = datain(nx+1,ny+1)
         ENDIF    

         value = tx * ty * datain(nx,ny) + sx * ty * hold21 + sy * tx
     *    * hold12 + sx * sy * hold22

         nrievl = value
         
C Bicubic polynomial: 'poly3'
      ELSE IF(INTERE.EQ.3) THEN
         rowleh = 16 + 3
         nterms = 4
         yindex = 1

C	    major problem is that near the edge the interior polynomial
C	    must be defined
C
C	    use boundary projection to extend the data rows
         DO j = ny-1, ny+2

C		check that the data row is defined
            IF (j .ge.1 .and. j .le. nypix ) THEN

C		         extend the rows
               xindex = 1
               DO i=nx-1, nx+2 
                  IF (i .lt. 1) THEN
                     coeff(xindex,yindex) = 2. * datain(1,j) - 
     *                     datain(2-i,j)
                  ELSE IF (i .gt. nxpix) THEN
                     coeff(xindex,yindex) = 2. * datain(nxpix,j) - 
     *                     datain(2*nxpix-i,j)
                  ELSE
                     coeff(xindex,yindex) = datain(i,j)
                  ENDIF
                  xindex = xindex + 1
               ENDDO

            ELSE IF (j .eq. (ny + 2)) THEN
C		         extend the rows
               xindex = 1
               DO i=nx-1, nx+2
                  IF (i .lt. 1) THEN
                     coeff(xindex,yindex) = 2. * datain(1,nypix-2) - 
     *                   datain(2-i,nypix-2)
                  ELSE if (i .gt. nxpix) THEN
                     coeff(xindex,yindex) = 2. * datain(nxpix,nypix-2)
     *                   - datain(2*nxpix-i,nypix-2)
                  ELSE
                     coeff(xindex,yindex) = datain(i,nypix-2)
                  ENDIF
                  xindex = xindex + 1
               ENDDO
            ENDIF
            yindex = yindex + 1
         ENDDO
C End of loop over rows (j)
C	 project columns
C
C  awsur -- Weighted sum of 2 real vectors.
C           awsur(a,b,c,npix,k1,k2) : c(i) = k1*a(i) + k2*b(i)

         firstw = max (1, 3 - ny)
         IF (firstw .gt. 1) THEN
            DO j= 1, firstw 
               call WSUMR (coeff(1, firstw), coeff(1, 2*firstw-j), 
     *            coeff(1,j), nterms, 2., -1.)
            ENDDO
         ENDIF

         lastrw = min (nterms, nypix - ny + 2)
         IF (lastrw .lt. nterms) THEN
            DO j= lastrw + 1, nterms - 1
               call WSUMR (coeff(1,lastrw), coeff(1,2*lastrw-j), 
     *            coeff(1,j), nterms, 2., -1.)
            ENDDO
         ELSE if (lastrw .eq. 2) THEN
            call WSUMR (coeff(1,lastrw), coeff(1,4), coeff(1,4), 
     *         nterms, 2., -1.)

         ELSE
            call WSUMR (coeff(1,lastrw), coeff(1,2*lastrw-4), 
     *         coeff(1,4), nterms, 2., -1.)
         ENDIF

C  center the x value and call evaluation routine
         xval = 2 + (x - nx)
         yval = 2 + (y - ny)
         call iibip3 (coeff, 0, rowleh, xval, yval, value, 1)

         nrievl = (value)

C BIPOLY5 case: 'poly5'      
      ELSE IF (INTERE.EQ.4) THEN
         rowleh = 16 + 3
         nterms = 6

C	     major problem is to define interior polynomial near the edge
C
C	     loop over the rows of data
         yindex = 1
         DO j = ny - 2, ny+3
C		select the  rows containing data
            if (j .ge. 1 .and. j .le. nypix) THEN
            
C		         extend the rows
               xindex = 1
               DO i = nx - 2, nx+3
                  if (i .lt. 1) THEN
                     coeff(xindex,yindex) = 2. * datain(1,j) - 
     *                     datain(2-i,j)
                  ELSE if (i .gt. nxpix) THEN
                     coeff(xindex,yindex) = 2. * datain(nxpix,j) - 
     *                     datain(2*nxpix-i,j)
                  ELSE
                     coeff(xindex,yindex) = datain(i,j)
                  ENDIF
                  xindex = xindex + 1
               ENDDO

            ELSE if (j .eq. (ny + 3)) THEN
C		         extend the rows
               xindex = 1
               DO i = nx - 2, nx + 3
                  IF (i .lt. 1) THEN
                     coeff(xindex,yindex) = 2. * datain(1,nypix-3) - 
     *                     datain(2-i,nypix-3)
                  ELSE if (i .gt. nxpix) THEN
                     coeff(xindex,yindex) = 2. * datain(nxpix,nypix-3) 
     *                   - datain(2*nxpix-i,nypix-3)
                  ELSE
                     coeff(xindex,yindex) = datain(i,nypix-3)
                  ENDIF

                  xindex = xindex + 1
               ENDDO
            ENDIF

C     End of loop of 'j'
            yindex = yindex + 1
         ENDDO
C	   project columns

         firstw = max (1, 4 - ny)
         if (firstw .gt. 1) THEN
            DO j = 1, firstw
               call WSUMR (coeff(1,firstw), coeff(1,2*firstw-j), 
     *            coeff(1,j), nterms, 2., -1.)
            ENDDO
         ENDIF

         lastrw = min (nterms, nypix - ny + 3)
         if (lastrw .lt. nterms) THEN
            DO j = lastrw + 1, nterms - 1 
               call WSUMR (coeff(1,lastrw), coeff(1,2*lastrw-j),
     *            coeff(1,j), nterms, 2., -1.)
            ENDDO
         ELSE if (lastrw .eq. 3) THEN
            call WSUMR (coeff(1,lastrw), coeff(1,6), coeff(1,6), 
     *            nterms, 2., -1.)
         ELSE
            call WSUMR (coeff(1,lastrw), coeff(1,2*lastrw-6), 
     *            coeff(1,6), nterms, 2., -1.)
         ENDIF
C	     call evaluation routine
         xval = 3 + (x - nx)
         yval = 3 + (y - ny)
         call iibip5 (coeff, 0, rowleh, xval, yval, value, 1)

         nrievl = (value)
C End of 'poly5' case
C
C  Spline case not implemented due to requirement of 'iispld',
C  derived from ii_spline2d.x, to dynamically allocate a working
C  array for the computation.
C
C      ELSE IF (INTERE.EQ.5) THEN
C         rowleh = 16 + 3
C         ky = 0
C         DO 510 j = ny - 16 /2 + 1, ny + 16 /2
C            if (.not.(j .lt. 1 .or. j .gt. nypix)) THEN
C               ky = ky + 1
C                if (ky .eq. 1) THEN
C                   yindex = ny - j + 1
C                ENDIF
C 
C                kx = 0
C                DO 540 i = nx - 16 /2 + 1, nx + 16 /2
C                   if (.not.(i .lt. 1 .or. i .gt. nxpix)) THEN
C                      kx = kx + 1
C                      if (kx .eq. 1) THEN
C                         xindex = nx - i + 1
C                      ENDIF
C                      coeff(kx+1,ky+1) = datain(i,j)
C                   ENDIF
C 
C 540            ENDDO
C                coeff(1,ky+1) = 0.
C                coeff(kx+2,ky+1) = 0.
C                coeff(kx+3,ky+1) = 0.
C             ENDIF
C 510      ENDDO
C             
C          call SET1R (0., coeff(1,1), kx+3)
C          call SET1R (0., coeff(1,ky+2), kx+3)
C          call SET1R (0., coeff(1,ky+3),kx+3)
C          call iispld (coeff, tmp, kx, ky+2, rowleh, rowleh)
C          call iispld (tmp, coeff, ky, kx+2, rowleh, rowleh)
C          xval = xindex + 1 + (x - nx)
C          yval = yindex + 1 + (y - ny)
C         call iibis3 (coeff, 0, rowleh, xval, yval, value, 1)
C         nrievl = (value)
      ELSE IF (INTERE.EQ.6 .OR. INTERE.EQ.7) THEN

C      subroutine iinisc (coeff, firstt, lencof, lenary, x, y, zfit, 
C    * npts, nconv, taper, ac, ar, mindx, mindy, scale)
C      where
C      nconv = 2 * nsinc + 1 and nsinc = sinc truncation length   

      call iinisc (datain, 0, lendan, nypix, x, y, value, 1, nconv, 
     *      taper, ac, ar, 0.001, 0.001, scale)
         nrievl = (value)
                  
      ENDIF

      end
